/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/arrays","vs/base/common/buffer","vs/platform/files/common/files","vs/base/node/pfs","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","os","vs/base/common/process","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","fs","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/map","vs/platform/telemetry/common/telemetry","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/server/node/serverEnvironmentService","vs/base/common/codicons","child_process","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/performance","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/iterator","vs/base/common/marshalling","vs/editor/common/core/range","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/base/common/semver/semver","vs/workbench/api/node/uriTransformer","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","url","vs/platform/shell/node/shellEnv","vs/server/node/remoteLanguagePacks","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/processes","vs/base/common/normalization","vs/base/common/console","vs/base/common/glob","vs/base/common/htmlContent","vs/base/common/labels","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/localizations/node/localizations","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/server/node/extensionHostStatusService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/severity","vs/base/node/decoder","vs/base/node/languagePacks","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteAgentEnvironmentImpl","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/common/remoteConsoleUtil","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","graceful-fs","https","yauzl","yazl","vs/server/node/server.main"],ve=function(ee){for(var e=[],k=0,n=ee.length;k<n;k++)e[k]=me[ee[k]];return e};define(me[117],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class k{static get(){const w=new Map,I=new Map,_=new Map,D=new Map;function v(b,u){b.has(u.detail)||b.set(u.detail,-u.timestamp)}function P(b,u){let S=b.get(u.detail);!S||S>=0||b.set(u.detail,S+u.timestamp)}const A=ee.getStats().slice(0).sort((b,u)=>b.timestamp-u.timestamp);for(const b of A)switch(b.type){case 10:v(w,b);break;case 11:case 12:P(w,b);break;case 21:v(I,b);break;case 22:P(I,b);break;case 33:v(_,b);break;case 34:P(_,b);break;case 31:v(D,b);break;case 32:P(D,b);break}let T=0;_.forEach(b=>T+=b);function E(b){let u=[];return b.forEach((S,f)=>u.push([f,S])),u}return{amdLoad:E(w),amdInvoke:E(I),nodeRequire:E(_),nodeEval:E(D),nodeRequireTotal:T}}static toMarkdownTable(w,I){let _="",D=[];return w.forEach((v,P)=>{D[P]=v.length}),I.forEach(v=>{v.forEach((P,A)=>{typeof P=="undefined"&&(P=v[A]="-");const T=P.toString().length;D[A]=Math.max(T,D[A])})}),w.forEach((v,P)=>{_+=`| ${v+" ".repeat(D[P]-v.toString().length)} `}),_+=`|
`,w.forEach((v,P)=>{_+=`| ${"-".repeat(D[P])} `}),_+=`|
`,I.forEach(v=>{v.forEach((P,A)=>{typeof P!="undefined"&&(_+=`| ${P+" ".repeat(D[A]-P.toString().length)} `)}),_+=`|
`}),_}}e.LoaderStats=k}),define(me[118],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(n,w){if(!n)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=k}),define(me[38],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(_){return _?_.replace(/\$\((.*?)\)/g,(D,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=k;class n{constructor(D,v,P){this.id=D,this.definition=v,this.description=P,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function w(_,D){const v=["codicon","codicon-"+_];return D&&v.push("codicon-modifier-"+D),v}e.getClassNamesArray=w;var I;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function v(T){if(T instanceof n)return["codicon","codicon-"+T.id];const E=D.exec(T.id);if(!E)return v(n.error);let[,b,u]=E;const S=["codicon","codicon-"+b];return u&&S.push("codicon-modifier-"+u.substr(1)),S}_.asClassNameArray=v;function P(T){return v(T).join(" ")}_.asClassName=P;function A(T){return"."+v(T).join(".")}_.asCSSSelector=A})(I=e.CSSIcon||(e.CSSIcon={}))}),define(me[73],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(_){return(D,v,P)=>{let A=null,T=null;if(typeof P.value=="function"?(A="value",T=P.value):typeof P.get=="function"&&(A="get",T=P.get),!T)throw new Error("not supported");P[A]=_(T,v)}}e.createDecorator=k;function n(_,D,v){let P=null,A=null;if(typeof v.value=="function"?(P="value",A=v.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(P="get",A=v.get),!A)throw new Error("not supported");const T=`$memoize$${D}`;v[P]=function(...E){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,E)}),this[T]}}e.memoize=n;function w(_,D,v){return k((P,A)=>{const T=`$debounce$${A}`,E=`$debounce$result$${A}`;return function(...b){this[E]||(this[E]=v?v():void 0),clearTimeout(this[T]),D&&(this[E]=D(this[E],...b),b=[this[E]]),this[T]=setTimeout(()=>{P.apply(this,b),this[E]=v?v():void 0},_)}})}e.debounce=w;function I(_,D,v){return k((P,A)=>{const T=`$throttle$timer$${A}`,E=`$throttle$result$${A}`,b=`$throttle$lastRun$${A}`,u=`$throttle$pending$${A}`;return function(...S){if(this[E]||(this[E]=v?v():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),D&&(this[E]=D(this[E],...S)),this[u])return;const f=this[b]+_;f<=Date.now()?(this[b]=Date.now(),P.apply(this,[this[E]]),this[E]=v?v():void 0):(this[u]=!0,this[T]=setTimeout(()=>{this[u]=!1,this[b]=Date.now(),P.apply(this,[this[E]]),this[E]=v?v():void 0},f-Date.now()))}})}e.throttle=I}),define(me[9],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(o=>{o(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=k,e.errorHandler=new k;function n(y){e.errorHandler.setUnexpectedErrorHandler(y)}e.setUnexpectedErrorHandler=n;function w(y){v(y)||e.errorHandler.onUnexpectedError(y)}e.onUnexpectedError=w;function I(y){v(y)||e.errorHandler.onUnexpectedExternalError(y)}e.onUnexpectedExternalError=I;function _(y){if(y instanceof Error){let{name:c,message:o}=y;const l=y.stacktrace||y.stack;return{$isError:!0,name:c,message:o,stack:l}}return y}e.transformErrorForSerialization=_;const D="Canceled";function v(y){return y instanceof P?!0:y instanceof Error&&y.name===D&&y.message===D}e.isCancellationError=v;class P extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=P;function A(){const y=new Error(D);return y.name=y.message,y}e.canceled=A;function T(y){return y?new Error(`Illegal argument: ${y}`):new Error("Illegal argument")}e.illegalArgument=T;function E(y){return y?new Error(`Illegal state: ${y}`):new Error("Illegal state")}e.illegalState=E;function b(y){return y?new Error(`readonly property '${y} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function u(y){const c=new Error(`${y} has been disposed`);return c.name="DISPOSED",c}e.disposed=u;function S(y){return y?y.message?y.message:y.stack?y.stack.split(`
`)[0]:String(y):"Error"}e.getErrorMessage=S;class f extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}e.NotImplementedError=f;class h extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}e.NotSupportedError=h;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;class d extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(c){if(c&&c instanceof Error){const o=new d;return o.name=c.name,o.message=c.message,o.stack=c.stack,o}return new d(c)}}e.ErrorNoTelemetry=d}),define(me[16],ve([0,1,9]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(O,V=0){return O[O.length-(1+V)]}e.tail=n;function w(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=w;function I(O,V,J=(ae,ge)=>ae===ge){if(O===V)return!0;if(!O||!V||O.length!==V.length)return!1;for(let ae=0,ge=O.length;ae<ge;ae++)if(!J(O[ae],V[ae]))return!1;return!0}e.equals=I;function _(O,V,J){let ae=0,ge=O.length-1;for(;ae<=ge;){const he=(ae+ge)/2|0,le=J(O[he],V);if(le<0)ae=he+1;else if(le>0)ge=he-1;else return he}return-(ae+1)}e.binarySearch=_;function D(O,V){let J=0,ae=O.length;if(ae===0)return 0;for(;J<ae;){const ge=Math.floor((J+ae)/2);V(O[ge])?ae=ge:J=ge+1}return J}e.findFirstInSorted=D;function v(O,V,J){if(O=O|0,O>=V.length)throw new TypeError("invalid index");let ae=V[Math.floor(V.length*Math.random())],ge=[],he=[],le=[];for(let pe of V){const Q=J(pe,ae);Q<0?ge.push(pe):Q>0?he.push(pe):le.push(pe)}return O<ge.length?v(O,ge,J):O<ge.length+le.length?le[0]:v(O-(ge.length+le.length),he,J)}e.quickSelect=v;function P(O,V){const J=[];let ae;for(const ge of O.slice(0).sort(V))!ae||V(ae[0],ge)!==0?(ae=[ge],J.push(ae)):ae.push(ge);return J}e.groupBy=P;function A(O,V,J){const ae=[];function ge(pe,Q,B){if(Q===0&&B.length===0)return;const x=ae[ae.length-1];x&&x.start+x.deleteCount===pe?(x.deleteCount+=Q,x.toInsert.push(...B)):ae.push({start:pe,deleteCount:Q,toInsert:B})}let he=0,le=0;for(;;){if(he===O.length){ge(he,0,V.slice(le));break}if(le===V.length){ge(he,O.length-he,[]);break}const pe=O[he],Q=V[le],B=J(pe,Q);B===0?(he+=1,le+=1):B<0?(ge(he,1,[]),he+=1):B>0&&(ge(he,0,[Q]),le+=1)}return ae}e.sortedDiff=A;function T(O,V,J){const ae=A(O,V,J),ge=[],he=[];for(const le of ae)ge.push(...O.slice(le.start,le.start+le.deleteCount)),he.push(...le.toInsert);return{removed:ge,added:he}}e.delta=T;function E(O,V,J){if(J===0)return[];const ae=O.slice(0,J).sort(V);return u(O,V,ae,J,O.length),ae}e.top=E;function b(O,V,J,ae,ge){return J===0?Promise.resolve([]):new Promise((he,le)=>{(async()=>{const pe=O.length,Q=O.slice(0,J).sort(V);for(let B=J,x=Math.min(J+ae,pe);B<pe;B=x,x=Math.min(x+ae,pe)){if(B>J&&await new Promise(X=>setTimeout(X)),ge&&ge.isCancellationRequested)throw(0,k.canceled)();u(O,V,Q,B,x)}return Q})().then(he,le)})}e.topAsync=b;function u(O,V,J,ae,ge){for(const he=J.length;ae<ge;ae++){const le=O[ae];if(V(le,J[he-1])<0){J.pop();const pe=D(J,Q=>V(le,Q)<0);J.splice(pe,0,le)}}}function S(O){return O.filter(V=>!!V)}e.coalesce=S;function f(O){let V=0;for(let J=0;J<O.length;J++)O[J]&&(O[V]=O[J],V+=1);O.length=V}e.coalesceInPlace=f;function h(O,V,J){O.splice(J,0,O.splice(V,1)[0])}e.move=h;function g(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=g;function d(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=d;function y(O,V=J=>J){const J=new Set;return O.filter(ae=>{const ge=V(ae);return J.has(ge)?!1:(J.add(ge),!0)})}e.distinct=y;function c(O){const V=new Set;return J=>{const ae=O(J);return V.has(ae)?!1:(V.add(ae),!0)}}e.uniqueFilter=c;function o(O,V){const J=l(O,V);if(J!==-1)return O[J]}e.findLast=o;function l(O,V){for(let J=O.length-1;J>=0;J--){const ae=O[J];if(V(ae))return J}return-1}e.lastIndex=l;function i(O,V){return O.length>0?O[0]:V}e.firstOrDefault=i;function t(O,V){return O.length>0?O[O.length-1]:V}e.lastOrDefault=t;function r(O,V,J=(ae,ge)=>ae===ge){let ae=0;for(let ge=0,he=Math.min(O.length,V.length);ge<he&&J(O[ge],V[ge]);ge++)ae++;return ae}e.commonPrefixLength=r;function s(O){return[].concat(...O)}e.flatten=s;function a(O,V){let J=typeof V=="number"?O:0;typeof V=="number"?J=O:(J=0,V=O);const ae=[];if(J<=V)for(let ge=J;ge<V;ge++)ae.push(ge);else for(let ge=J;ge>V;ge--)ae.push(ge);return ae}e.range=a;function m(O,V,J){return O.reduce((ae,ge)=>(ae[V(ge)]=J?J(ge):ge,ae),Object.create(null))}e.index=m;function p(O,V){return O.push(V),()=>R(O,V)}e.insert=p;function R(O,V){const J=O.indexOf(V);if(J>-1)return O.splice(J,1),V}e.remove=R;function F(O,V,J){const ae=O.slice(0,V),ge=O.slice(V);return ae.concat(J,ge)}e.arrayInsert=F;function U(O,V){let J;if(typeof V=="number"){let ae=V;J=()=>{const ge=Math.sin(ae++)*179426549;return ge-Math.floor(ge)}}else J=Math.random;for(let ae=O.length-1;ae>0;ae-=1){const ge=Math.floor(J()*(ae+1)),he=O[ae];O[ae]=O[ge],O[ge]=he}}e.shuffle=U;function G(O,V){const J=O.indexOf(V);J>-1&&(O.splice(J,1),O.unshift(V))}e.pushToStart=G;function C(O,V){const J=O.indexOf(V);J>-1&&(O.splice(J,1),O.push(V))}e.pushToEnd=C;function z(O,V){for(const J of V)O.push(J)}e.pushMany=z;function M(O,V){return Array.isArray(O)?O.map(V):V(O)}e.mapArrayOrNot=M;function q(O){return Array.isArray(O)?O:[O]}e.asArray=q;function Z(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=Z;function j(O,V){for(const J of O){const ae=V(J);if(ae!==void 0)return ae}}e.mapFind=j;function $(O,V,J){const ae=Y(O,V),ge=O.length,he=J.length;O.length=ge+he;for(let le=ge-1;le>=ae;le--)O[le+he]=O[le];for(let le=0;le<he;le++)O[le+ae]=J[le]}e.insertInto=$;function W(O,V,J,ae){const ge=Y(O,V),he=O.splice(ge,J);return $(O,ge,ae),he}e.splice=W;function Y(O,V){return V<0?Math.max(V+O.length,0):Math.min(V,O.length)}function ie(O,V){return(J,ae)=>V(O(J),O(ae))}e.compareBy=ie;const re=(O,V)=>O-V;e.numberComparator=re;function oe(O,V){if(O.length===0)return;let J=O[0];for(let ae=1;ae<O.length;ae++){const ge=O[ae];V(ge,J)>0&&(J=ge)}return J}e.findMaxBy=oe;function ue(O,V){if(O.length===0)return;let J=O[0];for(let ae=1;ae<O.length;ae++){const ge=O[ae];V(ge,J)>=0&&(J=ge)}return J}e.findLastMaxBy=ue;function de(O,V){return oe(O,(J,ae)=>-V(J,ae))}e.findMinBy=de;class H{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let J=this.firstIdx;for(;J<this.items.length&&V(this.items[J]);)J++;const ae=J===this.firstIdx?null:this.items.slice(this.firstIdx,J);return this.firstIdx=J,ae}takeFromEndWhile(V){let J=this.lastIdx;for(;J>=0&&V(this.items[J]);)J--;const ae=J===this.lastIdx?null:this.items.slice(J+1,this.lastIdx+1);return this.lastIdx=J,ae}peek(){return this.items[this.firstIdx]}dequeue(){const V=this.items[this.firstIdx];return this.firstIdx++,V}takeCount(V){const J=this.items.slice(this.firstIdx,this.firstIdx+V);return this.firstIdx+=V,J}}e.ArrayQueue=H}),define(me[74],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(n){const w=this;let I=!1,_;return function(){return I||(I=!0,_=n.apply(w,arguments)),_}}e.once=k}),define(me[49],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(n){function w(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=w;const I=Object.freeze([]);function _(){return I}n.empty=_;function*D(c){yield c}n.single=D;function v(c){return c||I}n.from=v;function P(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=P;function A(c){return c[Symbol.iterator]().next().value}n.first=A;function T(c,o){for(const l of c)if(o(l))return!0;return!1}n.some=T;function E(c,o){for(const l of c)if(o(l))return l}n.find=E;function*b(c,o){for(const l of c)o(l)&&(yield l)}n.filter=b;function*u(c,o){let l=0;for(const i of c)yield o(i,l++)}n.map=u;function*S(...c){for(const o of c)for(const l of o)yield l}n.concat=S;function*f(c){for(const o of c)for(const l of o)yield l}n.concatNested=f;function h(c,o,l){let i=l;for(const t of c)i=o(i,t);return i}n.reduce=h;function*g(c,o,l=c.length){for(o<0&&(o+=c.length),l<0?l+=c.length:l>c.length&&(l=c.length);o<l;o++)yield c[o]}n.slice=g;function d(c,o=Number.POSITIVE_INFINITY){const l=[];if(o===0)return[l,c];const i=c[Symbol.iterator]();for(let t=0;t<o;t++){const r=i.next();if(r.done)return[l,n.empty()];l.push(r.value)}return[l,{[Symbol.iterator](){return i}}]}n.consume=d;function y(c,o,l=(i,t)=>i===t){const i=c[Symbol.iterator](),t=o[Symbol.iterator]();for(;;){const r=i.next(),s=t.next();if(r.done!==s.done)return!1;if(r.done)return!0;if(!l(r.value,s.value))return!1}}n.equals=y})(k=e.Iterable||(e.Iterable={}))}),define(me[59],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(o){o.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function _(o,l=!1){let i=0,t=o.length,r="",s=0,a=16,m=0;function p(M){let q=0,Z=0;for(;q<M;){const j=o.charCodeAt(i);if(j>=48&&j<=57)Z=Z*16+j-48;else if(j>=65&&j<=70)Z=Z*16+j-65+10;else if(j>=97&&j<=102)Z=Z*16+j-97+10;else break;i++,q++}return q<M&&(Z=-1),Z}function R(M){i=M,r="",s=0,a=16,m=0}function F(){const M=i;if(o.charCodeAt(i)===48)i++;else for(i++;i<o.length&&P(o.charCodeAt(i));)i++;if(i<o.length&&o.charCodeAt(i)===46)if(i++,i<o.length&&P(o.charCodeAt(i)))for(i++;i<o.length&&P(o.charCodeAt(i));)i++;else return m=3,o.substring(M,i);let q=i;if(i<o.length&&(o.charCodeAt(i)===69||o.charCodeAt(i)===101))if(i++,(i<o.length&&o.charCodeAt(i)===43||o.charCodeAt(i)===45)&&i++,i<o.length&&P(o.charCodeAt(i))){for(i++;i<o.length&&P(o.charCodeAt(i));)i++;q=i}else m=3;return o.substring(M,q)}function U(){let M="",q=i;for(;;){if(i>=t){M+=o.substring(q,i),m=2;break}const Z=o.charCodeAt(i);if(Z===34){M+=o.substring(q,i),i++;break}if(Z===92){if(M+=o.substring(q,i),i++,i>=t){m=2;break}switch(o.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const $=p(4);$>=0?M+=String.fromCharCode($):m=4;break}default:m=5}q=i;continue}if(Z>=0&&Z<=31)if(v(Z)){M+=o.substring(q,i),m=2;break}else m=6;i++}return M}function G(){if(r="",m=0,s=i,i>=t)return s=t,a=17;let M=o.charCodeAt(i);if(D(M)){do i++,r+=String.fromCharCode(M),M=o.charCodeAt(i);while(D(M));return a=15}if(v(M))return i++,r+=String.fromCharCode(M),M===13&&o.charCodeAt(i)===10&&(i++,r+=`
`),a=14;switch(M){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,r=U(),a=10;case 47:{const q=i-1;if(o.charCodeAt(i+1)===47){for(i+=2;i<t&&!v(o.charCodeAt(i));)i++;return r=o.substring(q,i),a=12}if(o.charCodeAt(i+1)===42){i+=2;const Z=t-1;let j=!1;for(;i<Z;){if(o.charCodeAt(i)===42&&o.charCodeAt(i+1)===47){i+=2,j=!0;break}i++}return j||(i++,m=1),r=o.substring(q,i),a=13}return r+=String.fromCharCode(M),i++,a=16}case 45:if(r+=String.fromCharCode(M),i++,i===t||!P(o.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),a=11;default:for(;i<t&&C(M);)i++,M=o.charCodeAt(i);if(s!==i){switch(r=o.substring(s,i),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(M),i++,a=16}}function C(M){if(D(M)||v(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let M;do M=G();while(M>=12&&M<=15);return M}return{setPosition:R,getPosition:()=>i,scan:l?z:G,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>m}}e.createScanner=_;function D(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function v(o){return o===10||o===13||o===8232||o===8233}function P(o){return o>=48&&o<=57}var A;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(A||(A={}));function T(o,l){const i=[],t=new Object;let r;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function m(p,R,F,U){s.value=p,s.offset=R,s.length=F,s.type=U,s.colonOffset=void 0,r=s}try{d(o,{onObjectBegin:(p,R)=>{if(l<=p)throw t;r=void 0,a=l>p,i.push("")},onObjectProperty:(p,R,F)=>{if(l<R||(m(p,R,F,"property"),i[i.length-1]=p,l<=R+F))throw t},onObjectEnd:(p,R)=>{if(l<=p)throw t;r=void 0,i.pop()},onArrayBegin:(p,R)=>{if(l<=p)throw t;r=void 0,i.push(0)},onArrayEnd:(p,R)=>{if(l<=p)throw t;r=void 0,i.pop()},onLiteralValue:(p,R,F)=>{if(l<R||(m(p,R,F,c(p)),l<=R+F))throw t},onSeparator:(p,R,F)=>{if(l<=R)throw t;if(p===":"&&r&&r.type==="property")r.colonOffset=R,a=!1,r=void 0;else if(p===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(a=!0,i[i.length-1]=""),r=void 0}}})}catch(p){if(p!==t)throw p}return{path:i,previousNode:r,isAtPropertyKey:a,matches:p=>{let R=0;for(let F=0;R<p.length&&F<i.length;F++)if(p[R]===i[F]||p[R]==="*")R++;else if(p[R]!=="**")return!1;return R===p.length}}}e.getLocation=T;function E(o,l=[],i=I.DEFAULT){let t=null,r=[];const s=[];function a(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}return d(o,{onObjectBegin:()=>{const p={};a(p),s.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const p=[];a(p),s.push(r),r=p,t=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:a,onError:(p,R,F)=>{l.push({error:p,offset:R,length:F})}},i),r[0]}e.parse=E;function b(o,l=[],i=I.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){t.type==="property"&&(t.length=p-t.offset,t=t.parent)}function s(p){return t.children.push(p),p}d(o,{onObjectBegin:p=>{t=s({type:"object",offset:p,length:-1,parent:t,children:[]})},onObjectProperty:(p,R,F)=>{t=s({type:"property",offset:R,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:p,offset:R,length:F,parent:t})},onObjectEnd:(p,R)=>{t.length=p+R-t.offset,t=t.parent,r(p+R)},onArrayBegin:(p,R)=>{t=s({type:"array",offset:p,length:-1,parent:t,children:[]})},onArrayEnd:(p,R)=>{t.length=p+R-t.offset,t=t.parent,r(p+R)},onLiteralValue:(p,R,F)=>{s({type:c(p),offset:R,length:F,parent:t,value:p}),r(R+F)},onSeparator:(p,R,F)=>{t.type==="property"&&(p===":"?t.colonOffset=R:p===","&&r(R))},onError:(p,R,F)=>{l.push({error:p,offset:R,length:F})}},i);const m=t.children[0];return m&&delete m.parent,m}e.parseTree=b;function u(o,l){if(!o)return;let i=o;for(let t of l)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===t){i=s.children[1],r=!0;break}if(!r)return}else{const r=t;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=u;function S(o){if(!o.parent||!o.parent.children)return[];const l=S(o.parent);if(o.parent.type==="property"){const i=o.parent.children[0].value;l.push(i)}else if(o.parent.type==="array"){const i=o.parent.children.indexOf(o);i!==-1&&l.push(i)}return l}e.getNodePath=S;function f(o){switch(o.type){case"array":return o.children.map(f);case"object":{const l=Object.create(null);for(let i of o.children){const t=i.children[1];t&&(l[i.children[0].value]=f(t))}return l}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=f;function h(o,l,i=!1){return l>=o.offset&&l<o.offset+o.length||i&&l===o.offset+o.length}e.contains=h;function g(o,l,i=!1){if(h(o,l,i)){const t=o.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=l;r++){const s=g(t[r],l,i);if(s)return s}return o}}e.findNodeAtOffset=g;function d(o,l,i=I.DEFAULT){const t=_(o,!1);function r(ue){return ue?()=>ue(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(ue){return ue?de=>ue(de,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=r(l.onObjectBegin),m=s(l.onObjectProperty),p=r(l.onObjectEnd),R=r(l.onArrayBegin),F=r(l.onArrayEnd),U=s(l.onLiteralValue),G=s(l.onSeparator),C=r(l.onComment),z=s(l.onError),M=i&&i.disallowComments,q=i&&i.allowTrailingComma;function Z(){for(;;){const ue=t.scan();switch(t.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:M||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(ue){case 12:case 13:M?j(10):C();break;case 16:j(1);break;case 15:case 14:break;default:return ue}}}function j(ue,de=[],H=[]){if(z(ue),de.length+H.length>0){let O=t.getToken();for(;O!==17;){if(de.indexOf(O)!==-1){Z();break}else if(H.indexOf(O)!==-1)break;O=Z()}}}function $(ue){const de=t.getTokenValue();return ue?U(de):m(de),Z(),!0}function W(){switch(t.getToken()){case 11:{let ue=0;try{ue=JSON.parse(t.getTokenValue()),typeof ue!="number"&&(j(2),ue=0)}catch{j(2)}U(ue);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return Z(),!0}function Y(){return t.getToken()!==10?(j(3,[],[2,5]),!1):($(!1),t.getToken()===6?(G(":"),Z(),oe()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function ie(){a(),Z();let ue=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ue||j(4,[],[]),G(","),Z(),t.getToken()===2&&q)break}else ue&&j(6,[],[]);Y()||j(4,[],[2,5]),ue=!0}return p(),t.getToken()!==2?j(7,[2],[]):Z(),!0}function re(){R(),Z();let ue=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ue||j(4,[],[]),G(","),Z(),t.getToken()===4&&q)break}else ue&&j(6,[],[]);oe()||j(4,[],[4,5]),ue=!0}return F(),t.getToken()!==4?j(8,[4],[]):Z(),!0}function oe(){switch(t.getToken()){case 3:return re();case 1:return ie();case 10:return $(!0);default:return W()}}return Z(),t.getToken()===17?i.allowEmptyContent?!0:(j(4,[],[]),!1):oe()?(t.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=d;function y(o,l){let i=_(o),t=[],r,s=0,a;do switch(a=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:s!==a&&t.push(o.substring(s,a)),l!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,l)),s=i.getPosition();break}while(r!==17);return t.join("")}e.stripComments=y;function c(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(me[119],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new k(()=>w(this.getValue()))}}e.Lazy=k}),define(me[2],ve([0,1,74,49]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const w=!1;let I=null;function _(r){I=r}if(e.setDisposableTracker=_,w){const r="__is_disposable_tracked__";_(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==g.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==g.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function D(r){return I?.trackDisposable(r),r}function v(r){I?.markAsDisposed(r)}function P(r,s){I?.setParent(r,s)}function A(r,s){if(!!I)for(const a of r)I.setParent(a,s)}function T(r){return I?.markAsSingleton(r),r}e.markAsSingleton=T;class E extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=E;function b(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=b;function u(r){if(n.Iterable.is(r)){let s=[];for(const a of r)if(a)try{a.dispose()}catch(m){s.push(m)}if(s.length===1)throw s[0];if(s.length>1)throw new E(s);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=u;function S(...r){const s=f(()=>u(r));return A(r,s),s}e.combinedDisposable=S;function f(r){const s=D({dispose:(0,k.once)(()=>{v(s),r()})});return s}e.toDisposable=f;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return P(s,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new h,D(this),P(this._store,this)}dispose(){v(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&P(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&P(s,null),s}}e.MutableDisposable=d;class y{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=y;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(s){let a=s;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,v(this))},this}}e.SafeDisposable=c;class o{constructor(){this.references=new Map}acquire(s,...a){let m=this.references.get(s);m||(m={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,m));const{object:p}=m,R=(0,k.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(s,m.object),this.references.delete(s))});return m.counter++,{object:p,dispose:R}}}e.ReferenceCollection=o;class l{constructor(s){this.referenceCollection=s}async acquire(s,...a){const m=this.referenceCollection.acquire(s,...a);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(p){throw m.dispose(),p}}}e.AsyncReferenceCollection=l;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function t(r){const s=new h;try{r(s)}finally{s.dispose()}}e.disposeOnReturn=t}),define(me[120],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(I){this.element=I,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class n{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let I=this._first;for(;I!==k.Undefined;){const _=I.next;I.prev=k.Undefined,I.next=k.Undefined,I=_}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,_){const D=new k(I);if(this._first===k.Undefined)this._first=D,this._last=D;else if(_){const P=this._last;this._last=D,D.prev=P,P.next=D}else{const P=this._first;this._first=D,D.next=P,P.prev=D}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(D))}}shift(){if(this._first!==k.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==k.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==k.Undefined&&I.next!==k.Undefined){const _=I.prev;_.next=I.next,I.next.prev=_}else I.prev===k.Undefined&&I.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):I.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):I.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==k.Undefined;)yield I.element,I=I.next}}e.LinkedList=n}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(me[121],ve([1]),e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(he,le){for(var pe=0;pe<le.length;pe++){var Q=le[pe];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(he,Q.key,Q)}}function k(he,le,pe){return le&&e(he.prototype,le),pe&&e(he,pe),Object.defineProperty(he,"prototype",{writable:!1}),he}function n(he,le){if(!!he){if(typeof he=="string")return w(he,le);var pe=Object.prototype.toString.call(he).slice(8,-1);if(pe==="Object"&&he.constructor&&(pe=he.constructor.name),pe==="Map"||pe==="Set")return Array.from(he);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return w(he,le)}}function w(he,le){(le==null||le>he.length)&&(le=he.length);for(var pe=0,Q=new Array(le);pe<le;pe++)Q[pe]=he[pe];return Q}function I(he,le){var pe=typeof Symbol!="undefined"&&he[Symbol.iterator]||he["@@iterator"];if(pe)return(pe=pe.call(he)).next.bind(pe);if(Array.isArray(he)||(pe=n(he))||le&&he&&typeof he.length=="number"){pe&&(he=pe);var Q=0;return function(){return Q>=he.length?{done:!0}:{done:!1,value:he[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=_();function D(he){ee.defaults=he}var v=/[&<>"']/,P=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(le){return E[le]};function u(he,le){if(le){if(v.test(he))return he.replace(P,b)}else if(A.test(he))return he.replace(T,b);return he}var S=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(he){return he.replace(S,function(le,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(he,le){he=he.source||he,le=le||"";var pe={replace:function(B,x){return x=x.source||x,x=x.replace(h,"$1"),he=he.replace(B,x),pe},getRegex:function(){return new RegExp(he,le)}};return pe}var d=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(he,le,pe){if(he){var Q;try{Q=decodeURIComponent(f(pe)).replace(d,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}le&&!y.test(pe)&&(pe=r(le,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var o={},l=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(he,le){o[" "+he]||(l.test(he)?o[" "+he]=he+"/":o[" "+he]=p(he,"/",!0)),he=o[" "+he];var pe=he.indexOf(":")===-1;return le.substring(0,2)==="//"?pe?le:he.replace(i,"$1")+le:le.charAt(0)==="/"?pe?le:he.replace(t,"$1")+le:he+le}var s={exec:function(){}};function a(he){for(var le=1,pe,Q;le<arguments.length;le++){pe=arguments[le];for(Q in pe)Object.prototype.hasOwnProperty.call(pe,Q)&&(he[Q]=pe[Q])}return he}function m(he,le){var pe=he.replace(/\|/g,function(x,X,fe){for(var ye=!1,ke=X;--ke>=0&&fe[ke]==="\\";)ye=!ye;return ye?"|":" |"}),Q=pe.split(/ \|/),B=0;if(Q[0].trim()||Q.shift(),Q[Q.length-1].trim()||Q.pop(),Q.length>le)Q.splice(le);else for(;Q.length<le;)Q.push("");for(;B<Q.length;B++)Q[B]=Q[B].trim().replace(/\\\|/g,"|");return Q}function p(he,le,pe){var Q=he.length;if(Q===0)return"";for(var B=0;B<Q;){var x=he.charAt(Q-B-1);if(x===le&&!pe)B++;else if(x!==le&&pe)B++;else break}return he.substr(0,Q-B)}function R(he,le){if(he.indexOf(le[1])===-1)return-1;for(var pe=he.length,Q=0,B=0;B<pe;B++)if(he[B]==="\\")B++;else if(he[B]===le[0])Q++;else if(he[B]===le[1]&&(Q--,Q<0))return B;return-1}function F(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(he,le){if(le<1)return"";for(var pe="";le>1;)le&1&&(pe+=he),le>>=1,he+=he;return pe+he}function G(he,le,pe,Q){var B=le.href,x=le.title?u(le.title):null,X=he[1].replace(/\\([\[\]])/g,"$1");if(he[0].charAt(0)!=="!"){Q.state.inLink=!0;var fe={type:"link",raw:pe,href:B,title:x,text:X,tokens:Q.inlineTokens(X,[])};return Q.state.inLink=!1,fe}else return{type:"image",raw:pe,href:B,title:x,text:u(X)}}function C(he,le){var pe=he.match(/^(\s+)(?:```)/);if(pe===null)return le;var Q=pe[1];return le.split(`
`).map(function(B){var x=B.match(/^\s+/);if(x===null)return B;var X=x[0];return X.length>=Q.length?B.slice(Q.length):B}).join(`
`)}var z=function(){function he(pe){this.options=pe||ee.defaults}var le=he.prototype;return le.space=function(Q){var B=this.rules.block.newline.exec(Q);if(B&&B[0].length>0)return{type:"space",raw:B[0]}},le.code=function(Q){var B=this.rules.block.code.exec(Q);if(B){var x=B[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:B[0],codeBlockStyle:"indented",text:this.options.pedantic?x:p(x,`
`)}}},le.fences=function(Q){var B=this.rules.block.fences.exec(Q);if(B){var x=B[0],X=C(x,B[3]||"");return{type:"code",raw:x,lang:B[2]?B[2].trim():B[2],text:X}}},le.heading=function(Q){var B=this.rules.block.heading.exec(Q);if(B){var x=B[2].trim();if(/#$/.test(x)){var X=p(x,"#");(this.options.pedantic||!X||/ $/.test(X))&&(x=X.trim())}var fe={type:"heading",raw:B[0],depth:B[1].length,text:x,tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},le.hr=function(Q){var B=this.rules.block.hr.exec(Q);if(B)return{type:"hr",raw:B[0]}},le.blockquote=function(Q){var B=this.rules.block.blockquote.exec(Q);if(B){var x=B[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:B[0],tokens:this.lexer.blockTokens(x,[]),text:x}}},le.list=function(Q){var B=this.rules.block.list.exec(Q);if(B){var x,X,fe,ye,ke,Re,Ne,Ue,se,we,Ee,Ae,Fe=B[1].trim(),je=Fe.length>1,We={type:"list",raw:"",ordered:je,start:je?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=je?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=je?Fe:"[*+-]");for(var He=new RegExp("^( {0,3}"+Fe+")((?: [^\\n]*)?(?:\\n|$))");Q&&(Ae=!1,!(!(B=He.exec(Q))||this.rules.block.hr.test(Q)));){if(x=B[0],Q=Q.substring(x.length),Ue=B[2].split(`
`,1)[0],se=Q.split(`
`,1)[0],this.options.pedantic?(ye=2,Ee=Ue.trimLeft()):(ye=B[2].search(/[^ ]/),ye=ye>4?1:ye,Ee=Ue.slice(ye),ye+=B[1].length),Re=!1,!Ue&&/^ *$/.test(se)&&(x+=se+`
`,Q=Q.substring(se.length+1),Ae=!0),!Ae)for(var Ke=new RegExp("^ {0,"+Math.min(3,ye-1)+"}(?:[*+-]|\\d{1,9}[.)])");Q&&(we=Q.split(`
`,1)[0],Ue=we,this.options.pedantic&&(Ue=Ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!Ke.test(Ue));){if(Ue.search(/[^ ]/)>=ye||!Ue.trim())Ee+=`
`+Ue.slice(ye);else if(!Re)Ee+=`
`+Ue;else break;!Re&&!Ue.trim()&&(Re=!0),x+=we+`
`,Q=Q.substring(we.length+1)}We.loose||(Ne?We.loose=!0:/\n *\n *$/.test(x)&&(Ne=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(Ee),X&&(fe=X[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:x,task:!!X,checked:fe,loose:!1,text:Ee}),We.raw+=x}We.items[We.items.length-1].raw=x.trimRight(),We.items[We.items.length-1].text=Ee.trimRight(),We.raw=We.raw.trimRight();var ne=We.items.length;for(ke=0;ke<ne;ke++){this.lexer.state.top=!1,We.items[ke].tokens=this.lexer.blockTokens(We.items[ke].text,[]);var be=We.items[ke].tokens.filter(function(Le){return Le.type==="space"}),Pe=be.every(function(Le){for(var Me=Le.raw.split(""),Ve=0,ze=I(Me),qe;!(qe=ze()).done;){var Xe=qe.value;if(Xe===`
`&&(Ve+=1),Ve>1)return!0}return!1});!We.loose&&be.length&&Pe&&(We.loose=!0,We.items[ke].loose=!0)}return We}},le.html=function(Q){var B=this.rules.block.html.exec(Q);if(B){var x={type:"html",raw:B[0],pre:!this.options.sanitizer&&(B[1]==="pre"||B[1]==="script"||B[1]==="style"),text:B[0]};return this.options.sanitize&&(x.type="paragraph",x.text=this.options.sanitizer?this.options.sanitizer(B[0]):u(B[0]),x.tokens=[],this.lexer.inline(x.text,x.tokens)),x}},le.def=function(Q){var B=this.rules.block.def.exec(Q);if(B){B[3]&&(B[3]=B[3].substring(1,B[3].length-1));var x=B[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:x,raw:B[0],href:B[2],title:B[3]}}},le.table=function(Q){var B=this.rules.block.table.exec(Q);if(B){var x={type:"table",header:m(B[1]).map(function(Ne){return{text:Ne}}),align:B[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:B[3]?B[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(x.header.length===x.align.length){x.raw=B[0];var X=x.align.length,fe,ye,ke,Re;for(fe=0;fe<X;fe++)/^ *-+: *$/.test(x.align[fe])?x.align[fe]="right":/^ *:-+: *$/.test(x.align[fe])?x.align[fe]="center":/^ *:-+ *$/.test(x.align[fe])?x.align[fe]="left":x.align[fe]=null;for(X=x.rows.length,fe=0;fe<X;fe++)x.rows[fe]=m(x.rows[fe],x.header.length).map(function(Ne){return{text:Ne}});for(X=x.header.length,ye=0;ye<X;ye++)x.header[ye].tokens=[],this.lexer.inlineTokens(x.header[ye].text,x.header[ye].tokens);for(X=x.rows.length,ye=0;ye<X;ye++)for(Re=x.rows[ye],ke=0;ke<Re.length;ke++)Re[ke].tokens=[],this.lexer.inlineTokens(Re[ke].text,Re[ke].tokens);return x}}},le.lheading=function(Q){var B=this.rules.block.lheading.exec(Q);if(B){var x={type:"heading",raw:B[0],depth:B[2].charAt(0)==="="?1:2,text:B[1],tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},le.paragraph=function(Q){var B=this.rules.block.paragraph.exec(Q);if(B){var x={type:"paragraph",raw:B[0],text:B[1].charAt(B[1].length-1)===`
`?B[1].slice(0,-1):B[1],tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},le.text=function(Q){var B=this.rules.block.text.exec(Q);if(B){var x={type:"text",raw:B[0],text:B[0],tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},le.escape=function(Q){var B=this.rules.inline.escape.exec(Q);if(B)return{type:"escape",raw:B[0],text:u(B[1])}},le.tag=function(Q){var B=this.rules.inline.tag.exec(Q);if(B)return!this.lexer.state.inLink&&/^<a /i.test(B[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(B[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(B[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(B[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:B[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):u(B[0]):B[0]}},le.link=function(Q){var B=this.rules.inline.link.exec(Q);if(B){var x=B[2].trim();if(!this.options.pedantic&&/^</.test(x)){if(!/>$/.test(x))return;var X=p(x.slice(0,-1),"\\");if((x.length-X.length)%2==0)return}else{var fe=R(B[2],"()");if(fe>-1){var ye=B[0].indexOf("!")===0?5:4,ke=ye+B[1].length+fe;B[2]=B[2].substring(0,fe),B[0]=B[0].substring(0,ke).trim(),B[3]=""}}var Re=B[2],Ne="";if(this.options.pedantic){var Ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);Ue&&(Re=Ue[1],Ne=Ue[3])}else Ne=B[3]?B[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(x)?Re=Re.slice(1):Re=Re.slice(1,-1)),G(B,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},B[0],this.lexer)}},le.reflink=function(Q,B){var x;if((x=this.rules.inline.reflink.exec(Q))||(x=this.rules.inline.nolink.exec(Q))){var X=(x[2]||x[1]).replace(/\s+/g," ");if(X=B[X.toLowerCase()],!X||!X.href){var fe=x[0].charAt(0);return{type:"text",raw:fe,text:fe}}return G(x,X,x[0],this.lexer)}},le.emStrong=function(Q,B,x){x===void 0&&(x="");var X=this.rules.inline.emStrong.lDelim.exec(Q);if(!!X&&!(X[3]&&x.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=X[1]||X[2]||"";if(!fe||fe&&(x===""||this.rules.inline.punctuation.exec(x))){var ye=X[0].length-1,ke,Re,Ne=ye,Ue=0,se=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,B=B.slice(-1*Q.length+ye);(X=se.exec(B))!=null;)if(ke=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!ke){if(Re=ke.length,X[3]||X[4]){Ne+=Re;continue}else if((X[5]||X[6])&&ye%3&&!((ye+Re)%3)){Ue+=Re;continue}if(Ne-=Re,!(Ne>0)){if(Re=Math.min(Re,Re+Ne+Ue),Math.min(ye,Re)%2){var we=Q.slice(1,ye+X.index+Re);return{type:"em",raw:Q.slice(0,ye+X.index+Re+1),text:we,tokens:this.lexer.inlineTokens(we,[])}}var Ee=Q.slice(2,ye+X.index+Re-1);return{type:"strong",raw:Q.slice(0,ye+X.index+Re+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}}}}},le.codespan=function(Q){var B=this.rules.inline.code.exec(Q);if(B){var x=B[2].replace(/\n/g," "),X=/[^ ]/.test(x),fe=/^ /.test(x)&&/ $/.test(x);return X&&fe&&(x=x.substring(1,x.length-1)),x=u(x,!0),{type:"codespan",raw:B[0],text:x}}},le.br=function(Q){var B=this.rules.inline.br.exec(Q);if(B)return{type:"br",raw:B[0]}},le.del=function(Q){var B=this.rules.inline.del.exec(Q);if(B)return{type:"del",raw:B[0],text:B[2],tokens:this.lexer.inlineTokens(B[2],[])}},le.autolink=function(Q,B){var x=this.rules.inline.autolink.exec(Q);if(x){var X,fe;return x[2]==="@"?(X=u(this.options.mangle?B(x[1]):x[1]),fe="mailto:"+X):(X=u(x[1]),fe=X),{type:"link",raw:x[0],text:X,href:fe,tokens:[{type:"text",raw:X,text:X}]}}},le.url=function(Q,B){var x;if(x=this.rules.inline.url.exec(Q)){var X,fe;if(x[2]==="@")X=u(this.options.mangle?B(x[0]):x[0]),fe="mailto:"+X;else{var ye;do ye=x[0],x[0]=this.rules.inline._backpedal.exec(x[0])[0];while(ye!==x[0]);X=u(x[0]),x[1]==="www."?fe="http://"+X:fe=X}return{type:"link",raw:x[0],text:X,href:fe,tokens:[{type:"text",raw:X,text:X}]}}},le.inlineText=function(Q,B){var x=this.rules.inline.text.exec(Q);if(x){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):u(x[0]):x[0]:X=u(this.options.smartypants?B(x[0]):x[0]),{type:"text",raw:x[0],text:X}}},he}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:s,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=g(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=g(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=g(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=g(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=g(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=g(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=a({},M),M.gfm=a({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=g(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=g(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=a({},M.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:s,paragraph:g(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:s,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:s,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=g(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=g(M._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=g(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=g(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=g(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=g(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=g(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=g(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=g(q.reflink).replace("label",q._label).replace("ref",M._label).getRegex(),q.nolink=g(q.nolink).replace("ref",M._label).getRegex(),q.reflinkSearch=g(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=a({},q),q.pedantic=a({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=a({},q.normal,{escape:g(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=g(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=a({},q.gfm,{br:g(q.br).replace("{2,}","*").getRegex(),text:g(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Z(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(he){var le="",pe,Q,B=he.length;for(pe=0;pe<B;pe++)Q=he.charCodeAt(pe),Math.random()>.5&&(Q="x"+Q.toString(16)),le+="&#"+Q+";";return le}var $=function(){function he(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||ee.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:M.normal,inline:q.normal};this.options.pedantic?(Q.block=M.pedantic,Q.inline=q.pedantic):this.options.gfm&&(Q.block=M.gfm,this.options.breaks?Q.inline=q.breaks:Q.inline=q.gfm),this.tokenizer.rules=Q}he.lex=function(Q,B){var x=new he(B);return x.lex(Q)},he.lexInline=function(Q,B){var x=new he(B);return x.inlineTokens(Q)};var le=he.prototype;return le.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Q,this.tokens);for(var B;B=this.inlineQueue.shift();)this.inlineTokens(B.src,B.tokens);return this.tokens},le.blockTokens=function(Q,B){var x=this;B===void 0&&(B=[]),this.options.pedantic&&(Q=Q.replace(/^ +$/gm,""));for(var X,fe,ye,ke;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(X=Ne.call({lexer:x},Q,B))?(Q=Q.substring(X.raw.length),B.push(X),!0):!1}))){if(X=this.tokenizer.space(Q)){Q=Q.substring(X.raw.length),X.raw.length===1&&B.length>0?B[B.length-1].raw+=`
`:B.push(X);continue}if(X=this.tokenizer.code(Q)){Q=Q.substring(X.raw.length),fe=B[B.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+X.raw,fe.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):B.push(X);continue}if(X=this.tokenizer.fences(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.heading(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.hr(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.blockquote(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.list(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.html(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.def(Q)){Q=Q.substring(X.raw.length),fe=B[B.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+X.raw,fe.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.lheading(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(ye=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,Ue=Q.slice(1),se=void 0;x.options.extensions.startBlock.forEach(function(we){se=we.call({lexer:this},Ue),typeof se=="number"&&se>=0&&(Ne=Math.min(Ne,se))}),Ne<1/0&&Ne>=0&&(ye=Q.substring(0,Ne+1))}(),this.state.top&&(X=this.tokenizer.paragraph(ye))){fe=B[B.length-1],ke&&fe.type==="paragraph"?(fe.raw+=`
`+X.raw,fe.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):B.push(X),ke=ye.length!==Q.length,Q=Q.substring(X.raw.length);continue}if(X=this.tokenizer.text(Q)){Q=Q.substring(X.raw.length),fe=B[B.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+X.raw,fe.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):B.push(X);continue}if(Q){var Re="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,B},le.inline=function(Q,B){this.inlineQueue.push({src:Q,tokens:B})},le.inlineTokens=function(Q,B){var x=this;B===void 0&&(B=[]);var X,fe,ye,ke=Q,Re,Ne,Ue;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)se.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Re.index)+"["+U("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"["+U("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(Ne||(Ue=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(X=Ee.call({lexer:x},Q,B))?(Q=Q.substring(X.raw.length),B.push(X),!0):!1}))){if(X=this.tokenizer.escape(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.tag(Q)){Q=Q.substring(X.raw.length),fe=B[B.length-1],fe&&X.type==="text"&&fe.type==="text"?(fe.raw+=X.raw,fe.text+=X.text):B.push(X);continue}if(X=this.tokenizer.link(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(X.raw.length),fe=B[B.length-1],fe&&X.type==="text"&&fe.type==="text"?(fe.raw+=X.raw,fe.text+=X.text):B.push(X);continue}if(X=this.tokenizer.emStrong(Q,ke,Ue)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.codespan(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.br(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.del(Q)){Q=Q.substring(X.raw.length),B.push(X);continue}if(X=this.tokenizer.autolink(Q,j)){Q=Q.substring(X.raw.length),B.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(Q,j))){Q=Q.substring(X.raw.length),B.push(X);continue}if(ye=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,Ae=Q.slice(1),Fe=void 0;x.options.extensions.startInline.forEach(function(je){Fe=je.call({lexer:this},Ae),typeof Fe=="number"&&Fe>=0&&(Ee=Math.min(Ee,Fe))}),Ee<1/0&&Ee>=0&&(ye=Q.substring(0,Ee+1))}(),X=this.tokenizer.inlineText(ye,Z)){Q=Q.substring(X.raw.length),X.raw.slice(-1)!=="_"&&(Ue=X.raw.slice(-1)),Ne=!0,fe=B[B.length-1],fe&&fe.type==="text"?(fe.raw+=X.raw,fe.text+=X.text):B.push(X);continue}if(Q){var we="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return B},k(he,null,[{key:"rules",get:function(){return{block:M,inline:q}}}]),he}(),W=function(){function he(pe){this.options=pe||ee.defaults}var le=he.prototype;return le.code=function(Q,B,x){var X=(B||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(Q,X);fe!=null&&fe!==Q&&(x=!0,Q=fe)}return Q=Q.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+u(X,!0)+'">'+(x?Q:u(Q,!0))+`</code></pre>
`:"<pre><code>"+(x?Q:u(Q,!0))+`</code></pre>
`},le.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},le.html=function(Q){return Q},le.heading=function(Q,B,x,X){return this.options.headerIds?"<h"+B+' id="'+this.options.headerPrefix+X.slug(x)+'">'+Q+"</h"+B+`>
`:"<h"+B+">"+Q+"</h"+B+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Q,B,x){var X=B?"ol":"ul",fe=B&&x!==1?' start="'+x+'"':"";return"<"+X+fe+`>
`+Q+"</"+X+`>
`},le.listitem=function(Q){return"<li>"+Q+`</li>
`},le.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Q){return"<p>"+Q+`</p>
`},le.table=function(Q,B){return B&&(B="<tbody>"+B+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+B+`</table>
`},le.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},le.tablecell=function(Q,B){var x=B.header?"th":"td",X=B.align?"<"+x+' align="'+B.align+'">':"<"+x+">";return X+Q+"</"+x+`>
`},le.strong=function(Q){return"<strong>"+Q+"</strong>"},le.em=function(Q){return"<em>"+Q+"</em>"},le.codespan=function(Q){return"<code>"+Q+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Q){return"<del>"+Q+"</del>"},le.link=function(Q,B,x){if(Q=c(this.options.sanitize,this.options.baseUrl,Q),Q===null)return x;var X='<a href="'+u(Q)+'"';return B&&(X+=' title="'+B+'"'),X+=">"+x+"</a>",X},le.image=function(Q,B,x){if(Q=c(this.options.sanitize,this.options.baseUrl,Q),Q===null)return x;var X='<img src="'+Q+'" alt="'+x+'"';return B&&(X+=' title="'+B+'"'),X+=this.options.xhtml?"/>":">",X},le.text=function(Q){return Q},he}(),Y=function(){function he(){}var le=he.prototype;return le.strong=function(Q){return Q},le.em=function(Q){return Q},le.codespan=function(Q){return Q},le.del=function(Q){return Q},le.html=function(Q){return Q},le.text=function(Q){return Q},le.link=function(Q,B,x){return""+x},le.image=function(Q,B,x){return""+x},le.br=function(){return""},he}(),ie=function(){function he(){this.seen={}}var le=he.prototype;return le.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Q,B){var x=Q,X=0;if(this.seen.hasOwnProperty(x)){X=this.seen[Q];do X++,x=Q+"-"+X;while(this.seen.hasOwnProperty(x))}return B||(this.seen[Q]=X,this.seen[x]=0),x},le.slug=function(Q,B){B===void 0&&(B={});var x=this.serialize(Q);return this.getNextSafeSlug(x,B.dryrun)},he}(),re=function(){function he(pe){this.options=pe||ee.defaults,this.options.renderer=this.options.renderer||new W,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ie}he.parse=function(Q,B){var x=new he(B);return x.parse(Q)},he.parseInline=function(Q,B){var x=new he(B);return x.parseInline(Q)};var le=he.prototype;return le.parse=function(Q,B){B===void 0&&(B=!0);var x="",X,fe,ye,ke,Re,Ne,Ue,se,we,Ee,Ae,Fe,je,We,He,Ke,ne,be,Pe,Le=Q.length;for(X=0;X<Le;X++){if(Ee=Q[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(Pe=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){x+=Pe||"";continue}switch(Ee.type){case"space":continue;case"hr":{x+=this.renderer.hr();continue}case"heading":{x+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,f(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{x+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(se="",Ue="",ke=Ee.header.length,fe=0;fe<ke;fe++)Ue+=this.renderer.tablecell(this.parseInline(Ee.header[fe].tokens),{header:!0,align:Ee.align[fe]});for(se+=this.renderer.tablerow(Ue),we="",ke=Ee.rows.length,fe=0;fe<ke;fe++){for(Ne=Ee.rows[fe],Ue="",Re=Ne.length,ye=0;ye<Re;ye++)Ue+=this.renderer.tablecell(this.parseInline(Ne[ye].tokens),{header:!1,align:Ee.align[ye]});we+=this.renderer.tablerow(Ue)}x+=this.renderer.table(se,we);continue}case"blockquote":{we=this.parse(Ee.tokens),x+=this.renderer.blockquote(we);continue}case"list":{for(Ae=Ee.ordered,Fe=Ee.start,je=Ee.loose,ke=Ee.items.length,we="",fe=0;fe<ke;fe++)He=Ee.items[fe],Ke=He.checked,ne=He.task,We="",He.task&&(be=this.renderer.checkbox(Ke),je?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=be+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=be+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:be}):We+=be),We+=this.parse(He.tokens,je),we+=this.renderer.listitem(We,ne,Ke);x+=this.renderer.list(we,Ae,Fe);continue}case"html":{x+=this.renderer.html(Ee.text);continue}case"paragraph":{x+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(we=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;X+1<Le&&Q[X+1].type==="text";)Ee=Q[++X],we+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);x+=B?this.renderer.paragraph(we):we;continue}default:{var Me='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return x},le.parseInline=function(Q,B){B=B||this.renderer;var x="",X,fe,ye,ke=Q.length;for(X=0;X<ke;X++){if(fe=Q[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(ye=this.options.extensions.renderers[fe.type].call({parser:this},fe),ye!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){x+=ye||"";continue}switch(fe.type){case"escape":{x+=B.text(fe.text);break}case"html":{x+=B.html(fe.text);break}case"link":{x+=B.link(fe.href,fe.title,this.parseInline(fe.tokens,B));break}case"image":{x+=B.image(fe.href,fe.title,fe.text);break}case"strong":{x+=B.strong(this.parseInline(fe.tokens,B));break}case"em":{x+=B.em(this.parseInline(fe.tokens,B));break}case"codespan":{x+=B.codespan(fe.text);break}case"br":{x+=B.br();break}case"del":{x+=B.del(this.parseInline(fe.tokens,B));break}case"text":{x+=B.text(fe.text);break}default:{var Re='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return x},he}();function oe(he,le,pe){if(typeof he=="undefined"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof le=="function"&&(pe=le,le=null),le=a({},oe.defaults,le||{}),F(le),pe){var Q=le.highlight,B;try{B=$.lex(he,le)}catch(ye){return pe(ye)}var x=function(ke){var Re;if(!ke)try{le.walkTokens&&oe.walkTokens(B,le.walkTokens),Re=re.parse(B,le)}catch(Ne){ke=Ne}return le.highlight=Q,ke?pe(ke):pe(null,Re)};if(!Q||Q.length<3||(delete le.highlight,!B.length))return x();var X=0;oe.walkTokens(B,function(ye){ye.type==="code"&&(X++,setTimeout(function(){Q(ye.text,ye.lang,function(ke,Re){if(ke)return x(ke);Re!=null&&Re!==ye.text&&(ye.text=Re,ye.escaped=!0),X--,X===0&&x()})},0))}),X===0&&x();return}try{var fe=$.lex(he,le);return le.walkTokens&&oe.walkTokens(fe,le.walkTokens),re.parse(fe,le)}catch(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+u(ye.message+"",!0)+"</pre>";throw ye}}oe.options=oe.setOptions=function(he){return a(oe.defaults,he),D(oe.defaults),oe},oe.getDefaults=_,oe.defaults=ee.defaults,oe.use=function(){for(var he=arguments.length,le=new Array(he),pe=0;pe<he;pe++)le[pe]=arguments[pe];var Q=a.apply(void 0,[{}].concat(le)),B=oe.defaults.extensions||{renderers:{},childTokens:{}},x;le.forEach(function(X){if(X.extensions&&(x=!0,X.extensions.forEach(function(ye){if(!ye.name)throw new Error("extension name required");if(ye.renderer){var ke=B.renderers?B.renderers[ye.name]:null;ke?B.renderers[ye.name]=function(){for(var Re=arguments.length,Ne=new Array(Re),Ue=0;Ue<Re;Ue++)Ne[Ue]=arguments[Ue];var se=ye.renderer.apply(this,Ne);return se===!1&&(se=ke.apply(this,Ne)),se}:B.renderers[ye.name]=ye.renderer}if(ye.tokenizer){if(!ye.level||ye.level!=="block"&&ye.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");B[ye.level]?B[ye.level].unshift(ye.tokenizer):B[ye.level]=[ye.tokenizer],ye.start&&(ye.level==="block"?B.startBlock?B.startBlock.push(ye.start):B.startBlock=[ye.start]:ye.level==="inline"&&(B.startInline?B.startInline.push(ye.start):B.startInline=[ye.start]))}ye.childTokens&&(B.childTokens[ye.name]=ye.childTokens)})),X.renderer&&function(){var ye=oe.defaults.renderer||new W,ke=function(Ue){var se=ye[Ue];ye[Ue]=function(){for(var we=arguments.length,Ee=new Array(we),Ae=0;Ae<we;Ae++)Ee[Ae]=arguments[Ae];var Fe=X.renderer[Ue].apply(ye,Ee);return Fe===!1&&(Fe=se.apply(ye,Ee)),Fe}};for(var Re in X.renderer)ke(Re);Q.renderer=ye}(),X.tokenizer&&function(){var ye=oe.defaults.tokenizer||new z,ke=function(Ue){var se=ye[Ue];ye[Ue]=function(){for(var we=arguments.length,Ee=new Array(we),Ae=0;Ae<we;Ae++)Ee[Ae]=arguments[Ae];var Fe=X.tokenizer[Ue].apply(ye,Ee);return Fe===!1&&(Fe=se.apply(ye,Ee)),Fe}};for(var Re in X.tokenizer)ke(Re);Q.tokenizer=ye}(),X.walkTokens){var fe=oe.defaults.walkTokens;Q.walkTokens=function(ye){X.walkTokens.call(this,ye),fe&&fe.call(this,ye)}}x&&(Q.extensions=B),oe.setOptions(Q)})},oe.walkTokens=function(he,le){for(var pe=function(){var X=B.value;switch(le.call(oe,X),X.type){case"table":{for(var fe=I(X.header),ye;!(ye=fe()).done;){var ke=ye.value;oe.walkTokens(ke.tokens,le)}for(var Re=I(X.rows),Ne;!(Ne=Re()).done;)for(var Ue=Ne.value,se=I(Ue),we;!(we=se()).done;){var Ee=we.value;oe.walkTokens(Ee.tokens,le)}break}case"list":{oe.walkTokens(X.items,le);break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[X.type]?oe.defaults.extensions.childTokens[X.type].forEach(function(Ae){oe.walkTokens(X[Ae],le)}):X.tokens&&oe.walkTokens(X.tokens,le)}},Q=I(he),B;!(B=Q()).done;)pe()},oe.parseInline=function(he,le){if(typeof he=="undefined"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");le=a({},oe.defaults,le||{}),F(le);try{var pe=$.lexInline(he,le);return le.walkTokens&&oe.walkTokens(pe,le.walkTokens),re.parseInline(pe,le)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+u(Q.message+"",!0)+"</pre>";throw Q}},oe.Parser=re,oe.parser=re.parse,oe.Renderer=W,oe.TextRenderer=Y,oe.Lexer=$,oe.lexer=$.lex,oe.Tokenizer=z,oe.Slugger=ie,oe.parse=oe;var ue=oe.options,de=oe.setOptions,H=oe.use,O=oe.walkTokens,V=oe.parseInline,J=oe,ae=re.parse,ge=$.lex;ee.Lexer=$,ee.Parser=re,ee.Renderer=W,ee.Slugger=ie,ee.TextRenderer=Y,ee.Tokenizer=z,ee.getDefaults=_,ee.lexer=ge,ee.marked=oe,ee.options=ue,ee.parse=J,ee.parseInline=V,ee.parser=ae,ee.setOptions=de,ee.use=H,ee.walkTokens=O,Object.defineProperty(ee,"__esModule",{value:!0})}),function(){function ee(w){const I=[];typeof w=="number"&&I.push("code/timeOrigin",w);function _(v){I.push(v,Date.now())}function D(){const v=[];for(let P=0;P<I.length;P+=2)v.push({name:I[P],startTime:I[P+1]});return v}return{mark:_,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const _ of performance.getEntriesByType("mark"))I.push({name:_.name,startTime:Math.round(w+_.startTime)});return I}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function k(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=k(n))}(),define(me[3],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let n=!1,w=!1,I=!1,_=!1,D=!1,v=!1,P=!1,A=!1,T=!1,E,b=k,u,S;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const h=typeof f?.versions?.electron=="string",g=h&&f?.type==="renderer";if(e.isElectronSandboxed=g&&f?.sandboxed,typeof navigator=="object"&&!g){S=navigator.userAgent,n=S.indexOf("Windows")>=0,w=S.indexOf("Macintosh")>=0,A=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=S.indexOf("Linux")>=0,v=!0,E=navigator.language,b=E;const s=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),a=s&&s.getAttribute("data-settings");if(a)try{const m=JSON.parse(a);E=m.locale,u=m._translationsConfigFile,b=m.availableLanguages["*"]||k}catch{}}else if(typeof f=="object"){n=f.platform==="win32",w=f.platform==="darwin",I=f.platform==="linux",_=I&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,P=h,T=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=k,b=k;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const a=JSON.parse(s),m=a.availableLanguages["*"];E=a.locale,b=m||k,u=a._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var d;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function y(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let c=0;w?c=1:n?c=3:I&&(c=2),e.isWindows=n,e.isMacintosh=w,e.isLinux=I,e.isLinuxSnap=_,e.isNative=D,e.isElectron=P,e.isWeb=v,e.isWebWorker=v&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isCI=T,e.platform=c,e.userAgent=S,e.language=b;var o;(function(s){function a(){return e.language}s.value=a;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=m;function p(){return e.language==="en"}s.isDefault=p})(o=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=u,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let p=0,R=s.length;p<R;p++){const F=s[p];if(F.id===m.data.vscodeScheduleAsyncWork){s.splice(p,1),F.callback();return}}});let a=0;return m=>{const p=++a;s.push({id:p,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:p},"*")}}return s=>setTimeout(s)})();var l;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=w||A?2:n?1:3;let i=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(me[25],ve([0,1,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const w=k.globals.vscode.process;n={get platform(){return w.platform},get arch(){return w.arch},get env(){return w.env},cwd(){return w.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(me[5],ve([0,1,25]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,w=97,I=90,_=122,D=46,v=47,P=92,A=58,T=63;class E extends Error{constructor(y,c,o){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const i=y.indexOf(".")!==-1?"property":"argument";let t=`The "${y}" ${i} ${l} of type ${c}`;t+=`. Received type ${typeof o}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function b(d,y){if(typeof d!="string")throw new E(y,"string",d)}function u(d){return d===v||d===P}function S(d){return d===v}function f(d){return d>=n&&d<=I||d>=w&&d<=_}function h(d,y,c,o){let l="",i=0,t=-1,r=0,s=0;for(let a=0;a<=d.length;++a){if(a<d.length)s=d.charCodeAt(a);else{if(o(s))break;s=v}if(o(s)){if(!(t===a-1||r===1))if(r===2){if(l.length<2||i!==2||l.charCodeAt(l.length-1)!==D||l.charCodeAt(l.length-2)!==D){if(l.length>2){const m=l.lastIndexOf(c);m===-1?(l="",i=0):(l=l.slice(0,m),i=l.length-1-l.lastIndexOf(c)),t=a,r=0;continue}else if(l.length!==0){l="",i=0,t=a,r=0;continue}}y&&(l+=l.length>0?`${c}..`:"..",i=2)}else l.length>0?l+=`${c}${d.slice(t+1,a)}`:l=d.slice(t+1,a),i=a-t-1;t=a,r=0}else s===D&&r!==-1?++r:r=-1}return l}function g(d,y){if(y===null||typeof y!="object")throw new E("pathObject","Object",y);const c=y.dir||y.root,o=y.base||`${y.name||""}${y.ext||""}`;return c?c===y.root?`${c}${o}`:`${c}${d}${o}`:o}e.win32={resolve(...d){let y="",c="",o=!1;for(let l=d.length-1;l>=-1;l--){let i;if(l>=0){if(i=d[l],b(i,"path"),i.length===0)continue}else y.length===0?i=k.cwd():(i=k.env[`=${y}`]||k.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==y.toLowerCase()&&i.charCodeAt(2)===P)&&(i=`${y}\\`));const t=i.length;let r=0,s="",a=!1;const m=i.charCodeAt(0);if(t===1)u(m)&&(r=1,a=!0);else if(u(m))if(a=!0,u(i.charCodeAt(1))){let p=2,R=p;for(;p<t&&!u(i.charCodeAt(p));)p++;if(p<t&&p!==R){const F=i.slice(R,p);for(R=p;p<t&&u(i.charCodeAt(p));)p++;if(p<t&&p!==R){for(R=p;p<t&&!u(i.charCodeAt(p));)p++;(p===t||p!==R)&&(s=`\\\\${F}\\${i.slice(R,p)}`,r=p)}}}else r=1;else f(m)&&i.charCodeAt(1)===A&&(s=i.slice(0,2),r=2,t>2&&u(i.charCodeAt(2))&&(a=!0,r=3));if(s.length>0)if(y.length>0){if(s.toLowerCase()!==y.toLowerCase())continue}else y=s;if(o){if(y.length>0)break}else if(c=`${i.slice(r)}\\${c}`,o=a,a&&y.length>0)break}return c=h(c,!o,"\\",u),o?`${y}\\${c}`:`${y}${c}`||"."},normalize(d){b(d,"path");const y=d.length;if(y===0)return".";let c=0,o,l=!1;const i=d.charCodeAt(0);if(y===1)return S(i)?"\\":d;if(u(i))if(l=!0,u(d.charCodeAt(1))){let r=2,s=r;for(;r<y&&!u(d.charCodeAt(r));)r++;if(r<y&&r!==s){const a=d.slice(s,r);for(s=r;r<y&&u(d.charCodeAt(r));)r++;if(r<y&&r!==s){for(s=r;r<y&&!u(d.charCodeAt(r));)r++;if(r===y)return`\\\\${a}\\${d.slice(s)}\\`;r!==s&&(o=`\\\\${a}\\${d.slice(s,r)}`,c=r)}}}else c=1;else f(i)&&d.charCodeAt(1)===A&&(o=d.slice(0,2),c=2,y>2&&u(d.charCodeAt(2))&&(l=!0,c=3));let t=c<y?h(d.slice(c),!l,"\\",u):"";return t.length===0&&!l&&(t="."),t.length>0&&u(d.charCodeAt(y-1))&&(t+="\\"),o===void 0?l?`\\${t}`:t:l?`${o}\\${t}`:`${o}${t}`},isAbsolute(d){b(d,"path");const y=d.length;if(y===0)return!1;const c=d.charCodeAt(0);return u(c)||y>2&&f(c)&&d.charCodeAt(1)===A&&u(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let y,c;for(let i=0;i<d.length;++i){const t=d[i];b(t,"path"),t.length>0&&(y===void 0?y=c=t:y+=`\\${t}`)}if(y===void 0)return".";let o=!0,l=0;if(typeof c=="string"&&u(c.charCodeAt(0))){++l;const i=c.length;i>1&&u(c.charCodeAt(1))&&(++l,i>2&&(u(c.charCodeAt(2))?++l:o=!1))}if(o){for(;l<y.length&&u(y.charCodeAt(l));)l++;l>=2&&(y=`\\${y.slice(l)}`)}return e.win32.normalize(y)},relative(d,y){if(b(d,"from"),b(y,"to"),d===y)return"";const c=e.win32.resolve(d),o=e.win32.resolve(y);if(c===o||(d=c.toLowerCase(),y=o.toLowerCase(),d===y))return"";let l=0;for(;l<d.length&&d.charCodeAt(l)===P;)l++;let i=d.length;for(;i-1>l&&d.charCodeAt(i-1)===P;)i--;const t=i-l;let r=0;for(;r<y.length&&y.charCodeAt(r)===P;)r++;let s=y.length;for(;s-1>r&&y.charCodeAt(s-1)===P;)s--;const a=s-r,m=t<a?t:a;let p=-1,R=0;for(;R<m;R++){const U=d.charCodeAt(l+R);if(U!==y.charCodeAt(r+R))break;U===P&&(p=R)}if(R!==m){if(p===-1)return o}else{if(a>m){if(y.charCodeAt(r+R)===P)return o.slice(r+R+1);if(R===2)return o.slice(r+R)}t>m&&(d.charCodeAt(l+R)===P?p=R:R===2&&(p=3)),p===-1&&(p=0)}let F="";for(R=l+p+1;R<=i;++R)(R===i||d.charCodeAt(R)===P)&&(F+=F.length===0?"..":"\\..");return r+=p,F.length>0?`${F}${o.slice(r,s)}`:(o.charCodeAt(r)===P&&++r,o.slice(r,s))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const y=e.win32.resolve(d);if(y.length<=2)return d;if(y.charCodeAt(0)===P){if(y.charCodeAt(1)===P){const c=y.charCodeAt(2);if(c!==T&&c!==D)return`\\\\?\\UNC\\${y.slice(2)}`}}else if(f(y.charCodeAt(0))&&y.charCodeAt(1)===A&&y.charCodeAt(2)===P)return`\\\\?\\${y}`;return d},dirname(d){b(d,"path");const y=d.length;if(y===0)return".";let c=-1,o=0;const l=d.charCodeAt(0);if(y===1)return u(l)?d:".";if(u(l)){if(c=o=1,u(d.charCodeAt(1))){let r=2,s=r;for(;r<y&&!u(d.charCodeAt(r));)r++;if(r<y&&r!==s){for(s=r;r<y&&u(d.charCodeAt(r));)r++;if(r<y&&r!==s){for(s=r;r<y&&!u(d.charCodeAt(r));)r++;if(r===y)return d;r!==s&&(c=o=r+1)}}}}else f(l)&&d.charCodeAt(1)===A&&(c=y>2&&u(d.charCodeAt(2))?3:2,o=c);let i=-1,t=!0;for(let r=y-1;r>=o;--r)if(u(d.charCodeAt(r))){if(!t){i=r;break}}else t=!1;if(i===-1){if(c===-1)return".";i=c}return d.slice(0,i)},basename(d,y){y!==void 0&&b(y,"ext"),b(d,"path");let c=0,o=-1,l=!0,i;if(d.length>=2&&f(d.charCodeAt(0))&&d.charCodeAt(1)===A&&(c=2),y!==void 0&&y.length>0&&y.length<=d.length){if(y===d)return"";let t=y.length-1,r=-1;for(i=d.length-1;i>=c;--i){const s=d.charCodeAt(i);if(u(s)){if(!l){c=i+1;break}}else r===-1&&(l=!1,r=i+1),t>=0&&(s===y.charCodeAt(t)?--t==-1&&(o=i):(t=-1,o=r))}return c===o?o=r:o===-1&&(o=d.length),d.slice(c,o)}for(i=d.length-1;i>=c;--i)if(u(d.charCodeAt(i))){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1);return o===-1?"":d.slice(c,o)},extname(d){b(d,"path");let y=0,c=-1,o=0,l=-1,i=!0,t=0;d.length>=2&&d.charCodeAt(1)===A&&f(d.charCodeAt(0))&&(y=o=2);for(let r=d.length-1;r>=y;--r){const s=d.charCodeAt(r);if(u(s)){if(!i){o=r+1;break}continue}l===-1&&(i=!1,l=r+1),s===D?c===-1?c=r:t!==1&&(t=1):c!==-1&&(t=-1)}return c===-1||l===-1||t===0||t===1&&c===l-1&&c===o+1?"":d.slice(c,l)},format:g.bind(null,"\\"),parse(d){b(d,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return y;const c=d.length;let o=0,l=d.charCodeAt(0);if(c===1)return u(l)?(y.root=y.dir=d,y):(y.base=y.name=d,y);if(u(l)){if(o=1,u(d.charCodeAt(1))){let p=2,R=p;for(;p<c&&!u(d.charCodeAt(p));)p++;if(p<c&&p!==R){for(R=p;p<c&&u(d.charCodeAt(p));)p++;if(p<c&&p!==R){for(R=p;p<c&&!u(d.charCodeAt(p));)p++;p===c?o=p:p!==R&&(o=p+1)}}}}else if(f(l)&&d.charCodeAt(1)===A){if(c<=2)return y.root=y.dir=d,y;if(o=2,u(d.charCodeAt(2))){if(c===3)return y.root=y.dir=d,y;o=3}}o>0&&(y.root=d.slice(0,o));let i=-1,t=o,r=-1,s=!0,a=d.length-1,m=0;for(;a>=o;--a){if(l=d.charCodeAt(a),u(l)){if(!s){t=a+1;break}continue}r===-1&&(s=!1,r=a+1),l===D?i===-1?i=a:m!==1&&(m=1):i!==-1&&(m=-1)}return r!==-1&&(i===-1||m===0||m===1&&i===r-1&&i===t+1?y.base=y.name=d.slice(t,r):(y.name=d.slice(t,i),y.base=d.slice(t,r),y.ext=d.slice(i,r))),t>0&&t!==o?y.dir=d.slice(0,t-1):y.dir=y.root,y},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let y="",c=!1;for(let o=d.length-1;o>=-1&&!c;o--){const l=o>=0?d[o]:k.cwd();b(l,"path"),l.length!==0&&(y=`${l}/${y}`,c=l.charCodeAt(0)===v)}return y=h(y,!c,"/",S),c?`/${y}`:y.length>0?y:"."},normalize(d){if(b(d,"path"),d.length===0)return".";const y=d.charCodeAt(0)===v,c=d.charCodeAt(d.length-1)===v;return d=h(d,!y,"/",S),d.length===0?y?"/":c?"./":".":(c&&(d+="/"),y?`/${d}`:d)},isAbsolute(d){return b(d,"path"),d.length>0&&d.charCodeAt(0)===v},join(...d){if(d.length===0)return".";let y;for(let c=0;c<d.length;++c){const o=d[c];b(o,"path"),o.length>0&&(y===void 0?y=o:y+=`/${o}`)}return y===void 0?".":e.posix.normalize(y)},relative(d,y){if(b(d,"from"),b(y,"to"),d===y||(d=e.posix.resolve(d),y=e.posix.resolve(y),d===y))return"";const c=1,o=d.length,l=o-c,i=1,t=y.length-i,r=l<t?l:t;let s=-1,a=0;for(;a<r;a++){const p=d.charCodeAt(c+a);if(p!==y.charCodeAt(i+a))break;p===v&&(s=a)}if(a===r)if(t>r){if(y.charCodeAt(i+a)===v)return y.slice(i+a+1);if(a===0)return y.slice(i+a)}else l>r&&(d.charCodeAt(c+a)===v?s=a:a===0&&(s=0));let m="";for(a=c+s+1;a<=o;++a)(a===o||d.charCodeAt(a)===v)&&(m+=m.length===0?"..":"/..");return`${m}${y.slice(i+s)}`},toNamespacedPath(d){return d},dirname(d){if(b(d,"path"),d.length===0)return".";const y=d.charCodeAt(0)===v;let c=-1,o=!0;for(let l=d.length-1;l>=1;--l)if(d.charCodeAt(l)===v){if(!o){c=l;break}}else o=!1;return c===-1?y?"/":".":y&&c===1?"//":d.slice(0,c)},basename(d,y){y!==void 0&&b(y,"ext"),b(d,"path");let c=0,o=-1,l=!0,i;if(y!==void 0&&y.length>0&&y.length<=d.length){if(y===d)return"";let t=y.length-1,r=-1;for(i=d.length-1;i>=0;--i){const s=d.charCodeAt(i);if(s===v){if(!l){c=i+1;break}}else r===-1&&(l=!1,r=i+1),t>=0&&(s===y.charCodeAt(t)?--t==-1&&(o=i):(t=-1,o=r))}return c===o?o=r:o===-1&&(o=d.length),d.slice(c,o)}for(i=d.length-1;i>=0;--i)if(d.charCodeAt(i)===v){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1);return o===-1?"":d.slice(c,o)},extname(d){b(d,"path");let y=-1,c=0,o=-1,l=!0,i=0;for(let t=d.length-1;t>=0;--t){const r=d.charCodeAt(t);if(r===v){if(!l){c=t+1;break}continue}o===-1&&(l=!1,o=t+1),r===D?y===-1?y=t:i!==1&&(i=1):y!==-1&&(i=-1)}return y===-1||o===-1||i===0||i===1&&y===o-1&&y===c+1?"":d.slice(y,o)},format:g.bind(null,"/"),parse(d){b(d,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return y;const c=d.charCodeAt(0)===v;let o;c?(y.root="/",o=1):o=0;let l=-1,i=0,t=-1,r=!0,s=d.length-1,a=0;for(;s>=o;--s){const m=d.charCodeAt(s);if(m===v){if(!r){i=s+1;break}continue}t===-1&&(r=!1,t=s+1),m===D?l===-1?l=s:a!==1&&(a=1):l!==-1&&(a=-1)}if(t!==-1){const m=i===0&&c?1:i;l===-1||a===0||a===1&&l===t-1&&l===i+1?y.base=y.name=d.slice(m,t):(y.name=d.slice(m,l),y.base=d.slice(m,t),y.ext=d.slice(l,t))}return i>0?y.dir=d.slice(0,i-1):c&&(y.dir="/"),y},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[60],ve([0,1,5]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(T){T.text="text/plain",T.binary="application/octet-stream",T.unknown="application/unknown",T.markdown="text/markdown",T.latex="text/latex",T.uriList="text/uri-list"})(n=e.Mimes||(e.Mimes={}));const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function _(T){const E=(0,k.extname)(T),b=w[E.toLowerCase()];return b!==void 0?b:D(T)}e.getMediaOrTextMime=_;function D(T){const E=(0,k.extname)(T);return I[E.toLowerCase()]}e.getMediaMime=D;function v(T){for(const E in I)if(I[E]===T)return E}e.getExtensionForMimeType=v;const P=/^(.+)\/(.+?)(;.+)?$/;function A(T,E){const b=P.exec(T);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:T}e.normalizeMimeType=A}),define(me[75],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var n;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function w(I,..._){const D=_.reduce((A,T)=>(A[T]=!0,A),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(I).filter(A=>!D[A]).forEach(A=>{for(let T=0;T<v.length;T++)if(A.search(v[T])!==-1){delete I[A];break}})}e.sanitizeProcessEnvironment=w}),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var n in k)(typeof exports=="object"?exports:ee)[n]=k[n]}}(typeof self!="undefined"?self:this,function(){return function(ee){var e={};function k(n){if(e[n])return e[n].exports;var w=e[n]={i:n,l:!1,exports:{}};return ee[n].call(w.exports,w,w.exports,k),w.l=!0,w.exports}return k.m=ee,k.c=e,k.d=function(n,w,I){k.o(n,w)||Object.defineProperty(n,w,{enumerable:!0,get:I})},k.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},k.t=function(n,w){if(1&w&&(n=k(n)),8&w||4&w&&typeof n=="object"&&n&&n.__esModule)return n;var I=Object.create(null);if(k.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:n}),2&w&&typeof n!="string")for(var _ in n)k.d(I,_,function(D){return n[D]}.bind(null,_));return I},k.n=function(n){var w=n&&n.__esModule?function(){return n.default}:function(){return n};return k.d(w,"a",w),w},k.o=function(n,w){return Object.prototype.hasOwnProperty.call(n,w)},k.p="",k(k.s=0)}([function(ee,e,k){(function(n){var w;e=ee.exports=H,w=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],v=e.src=[],P=0,A=P++;v[A]="0|[1-9]\\d*";var T=P++;v[T]="[0-9]+";var E=P++;v[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=P++;v[b]="("+v[A]+")\\.("+v[A]+")\\.("+v[A]+")";var u=P++;v[u]="("+v[T]+")\\.("+v[T]+")\\.("+v[T]+")";var S=P++;v[S]="(?:"+v[A]+"|"+v[E]+")";var f=P++;v[f]="(?:"+v[T]+"|"+v[E]+")";var h=P++;v[h]="(?:-("+v[S]+"(?:\\."+v[S]+")*))";var g=P++;v[g]="(?:-?("+v[f]+"(?:\\."+v[f]+")*))";var d=P++;v[d]="[0-9A-Za-z-]+";var y=P++;v[y]="(?:\\+("+v[d]+"(?:\\."+v[d]+")*))";var c=P++,o="v?"+v[b]+v[h]+"?"+v[y]+"?";v[c]="^"+o+"$";var l="[v=\\s]*"+v[u]+v[g]+"?"+v[y]+"?",i=P++;v[i]="^"+l+"$";var t=P++;v[t]="((?:<|>)?=?)";var r=P++;v[r]=v[T]+"|x|X|\\*";var s=P++;v[s]=v[A]+"|x|X|\\*";var a=P++;v[a]="[v=\\s]*("+v[s]+")(?:\\.("+v[s]+")(?:\\.("+v[s]+")(?:"+v[h]+")?"+v[y]+"?)?)?";var m=P++;v[m]="[v=\\s]*("+v[r]+")(?:\\.("+v[r]+")(?:\\.("+v[r]+")(?:"+v[g]+")?"+v[y]+"?)?)?";var p=P++;v[p]="^"+v[t]+"\\s*"+v[a]+"$";var R=P++;v[R]="^"+v[t]+"\\s*"+v[m]+"$";var F=P++;v[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=P++;v[U]="(?:~>?)";var G=P++;v[G]="(\\s*)"+v[U]+"\\s+",D[G]=new RegExp(v[G],"g");var C=P++;v[C]="^"+v[U]+v[a]+"$";var z=P++;v[z]="^"+v[U]+v[m]+"$";var M=P++;v[M]="(?:\\^)";var q=P++;v[q]="(\\s*)"+v[M]+"\\s+",D[q]=new RegExp(v[q],"g");var Z=P++;v[Z]="^"+v[M]+v[a]+"$";var j=P++;v[j]="^"+v[M]+v[m]+"$";var $=P++;v[$]="^"+v[t]+"\\s*("+l+")$|^$";var W=P++;v[W]="^"+v[t]+"\\s*("+o+")$|^$";var Y=P++;v[Y]="(\\s*)"+v[t]+"\\s*("+l+"|"+v[a]+")",D[Y]=new RegExp(v[Y],"g");var ie=P++;v[ie]="^\\s*("+v[a]+")\\s+-\\s+("+v[a]+")\\s*$";var re=P++;v[re]="^\\s*("+v[m]+")\\s+-\\s+("+v[m]+")\\s*$";var oe=P++;v[oe]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)w(ue,v[ue]),D[ue]||(D[ue]=new RegExp(v[ue]));function de(se,we){if(se instanceof H)return se;if(typeof se!="string"||se.length>I||!(we?D[i]:D[c]).test(se))return null;try{return new H(se,we)}catch{return null}}function H(se,we){if(se instanceof H){if(se.loose===we)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof H))return new H(se,we);w("SemVer",se,we),this.loose=we;var Ee=se.trim().match(we?D[i]:D[c]);if(!Ee)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(Ae){if(/^[0-9]+$/.test(Ae)){var Fe=+Ae;if(Fe>=0&&Fe<_)return Fe}return Ae}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=de,e.valid=function(se,we){var Ee=de(se,we);return Ee?Ee.version:null},e.clean=function(se,we){var Ee=de(se.trim().replace(/^[=v]+/,""),we);return Ee?Ee.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(se){return w("SemVer.compare",this.version,this.loose,se),se instanceof H||(se=new H(se,this.loose)),this.compareMain(se)||this.comparePre(se)},H.prototype.compareMain=function(se){return se instanceof H||(se=new H(se,this.loose)),V(this.major,se.major)||V(this.minor,se.minor)||V(this.patch,se.patch)},H.prototype.comparePre=function(se){if(se instanceof H||(se=new H(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var we=0;do{var Ee=this.prerelease[we],Ae=se.prerelease[we];if(w("prerelease compare",we,Ee,Ae),Ee===void 0&&Ae===void 0)return 0;if(Ae===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==Ae)return V(Ee,Ae)}while(++we)},H.prototype.inc=function(se,we){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,we,Ee,Ae){typeof Ee=="string"&&(Ae=Ee,Ee=void 0);try{return new H(se,Ee).inc(we,Ae).version}catch{return null}},e.diff=function(se,we){if(he(se,we))return null;var Ee=de(se),Ae=de(we);if(Ee.prerelease.length||Ae.prerelease.length){for(var Fe in Ee)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&Ee[Fe]!==Ae[Fe])return"pre"+Fe;return"prerelease"}for(var Fe in Ee)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&Ee[Fe]!==Ae[Fe])return Fe},e.compareIdentifiers=V;var O=/^[0-9]+$/;function V(se,we){var Ee=O.test(se),Ae=O.test(we);return Ee&&Ae&&(se=+se,we=+we),Ee&&!Ae?-1:Ae&&!Ee?1:se<we?-1:se>we?1:0}function J(se,we,Ee){return new H(se,Ee).compare(new H(we,Ee))}function ae(se,we,Ee){return J(se,we,Ee)>0}function ge(se,we,Ee){return J(se,we,Ee)<0}function he(se,we,Ee){return J(se,we,Ee)===0}function le(se,we,Ee){return J(se,we,Ee)!==0}function pe(se,we,Ee){return J(se,we,Ee)>=0}function Q(se,we,Ee){return J(se,we,Ee)<=0}function B(se,we,Ee,Ae){var Fe;switch(we){case"===":typeof se=="object"&&(se=se.version),typeof Ee=="object"&&(Ee=Ee.version),Fe=se===Ee;break;case"!==":typeof se=="object"&&(se=se.version),typeof Ee=="object"&&(Ee=Ee.version),Fe=se!==Ee;break;case"":case"=":case"==":Fe=he(se,Ee,Ae);break;case"!=":Fe=le(se,Ee,Ae);break;case">":Fe=ae(se,Ee,Ae);break;case">=":Fe=pe(se,Ee,Ae);break;case"<":Fe=ge(se,Ee,Ae);break;case"<=":Fe=Q(se,Ee,Ae);break;default:throw new TypeError("Invalid operator: "+we)}return Fe}function x(se,we){if(se instanceof x){if(se.loose===we)return se;se=se.value}if(!(this instanceof x))return new x(se,we);w("comparator",se,we),this.loose=we,this.parse(se),this.semver===X?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(se,we){return V(we,se)},e.major=function(se,we){return new H(se,we).major},e.minor=function(se,we){return new H(se,we).minor},e.patch=function(se,we){return new H(se,we).patch},e.compare=J,e.compareLoose=function(se,we){return J(se,we,!0)},e.rcompare=function(se,we,Ee){return J(we,se,Ee)},e.sort=function(se,we){return se.sort(function(Ee,Ae){return e.compare(Ee,Ae,we)})},e.rsort=function(se,we){return se.sort(function(Ee,Ae){return e.rcompare(Ee,Ae,we)})},e.gt=ae,e.lt=ge,e.eq=he,e.neq=le,e.gte=pe,e.lte=Q,e.cmp=B,e.Comparator=x;var X={};function fe(se,we){if(se instanceof fe)return se.loose===we?se:new fe(se.raw,we);if(se instanceof x)return new fe(se.value,we);if(!(this instanceof fe))return new fe(se,we);if(this.loose=we,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function ye(se){return!se||se.toLowerCase()==="x"||se==="*"}function ke(se,we,Ee,Ae,Fe,je,We,He,Ke,ne,be,Pe,Le){return((we=ye(Ee)?"":ye(Ae)?">="+Ee+".0.0":ye(Fe)?">="+Ee+"."+Ae+".0":">="+we)+" "+(He=ye(Ke)?"":ye(ne)?"<"+(+Ke+1)+".0.0":ye(be)?"<"+Ke+"."+(+ne+1)+".0":Pe?"<="+Ke+"."+ne+"."+be+"-"+Pe:"<="+He)).trim()}function Re(se,we){for(var Ee=0;Ee<se.length;Ee++)if(!se[Ee].test(we))return!1;if(we.prerelease.length){for(Ee=0;Ee<se.length;Ee++)if(w(se[Ee].semver),se[Ee].semver!==X&&se[Ee].semver.prerelease.length>0){var Ae=se[Ee].semver;if(Ae.major===we.major&&Ae.minor===we.minor&&Ae.patch===we.patch)return!0}return!1}return!0}function Ne(se,we,Ee){try{we=new fe(we,Ee)}catch{return!1}return we.test(se)}function Ue(se,we,Ee,Ae){var Fe,je,We,He,Ke;switch(se=new H(se,Ae),we=new fe(we,Ae),Ee){case">":Fe=ae,je=Q,We=ge,He=">",Ke=">=";break;case"<":Fe=ge,je=pe,We=ae,He="<",Ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(se,we,Ae))return!1;for(var ne=0;ne<we.set.length;++ne){var be=we.set[ne],Pe=null,Le=null;if(be.forEach(function(Me){Me.semver===X&&(Me=new x(">=0.0.0")),Pe=Pe||Me,Le=Le||Me,Fe(Me.semver,Pe.semver,Ae)?Pe=Me:We(Me.semver,Le.semver,Ae)&&(Le=Me)}),Pe.operator===He||Pe.operator===Ke||(!Le.operator||Le.operator===He)&&je(se,Le.semver)||Le.operator===Ke&&We(se,Le.semver))return!1}return!0}x.prototype.parse=function(se){var we=this.loose?D[$]:D[W],Ee=se.match(we);if(!Ee)throw new TypeError("Invalid comparator: "+se);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new H(Ee[2],this.loose):this.semver=X},x.prototype.toString=function(){return this.value},x.prototype.test=function(se){return w("Comparator.test",se,this.loose),this.semver===X||(typeof se=="string"&&(se=new H(se,this.loose)),B(se,this.operator,this.semver,this.loose))},x.prototype.intersects=function(se,we){if(!(se instanceof x))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new fe(se.value,we),Ne(this.value,Ee,we);if(se.operator==="")return Ee=new fe(this.value,we),Ne(se.semver,Ee,we);var Ae=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),Fe=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),je=this.semver.version===se.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),He=B(this.semver,"<",se.semver,we)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),Ke=B(this.semver,">",se.semver,we)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return Ae||Fe||je&&We||He||Ke},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(se){var we=this.loose;se=se.trim(),w("range",se,we);var Ee=we?D[re]:D[ie];se=se.replace(Ee,ke),w("hyphen replace",se),se=se.replace(D[Y],"$1$2$3"),w("comparator trim",se,D[Y]),se=(se=(se=se.replace(D[G],"$1~")).replace(D[q],"$1^")).split(/\s+/).join(" ");var Ae=we?D[$]:D[W],Fe=se.split(" ").map(function(je){return function(We,He){return w("comp",We),We=function(Ke,ne){return Ke.trim().split(/\s+/).map(function(be){return function(Pe,Le){w("caret",Pe,Le);var Me=Le?D[j]:D[Z];return Pe.replace(Me,function(Ve,ze,qe,Xe,Ge){var Ze;return w("caret",Pe,Ve,ze,qe,Xe,Ge),ye(ze)?Ze="":ye(qe)?Ze=">="+ze+".0.0 <"+(+ze+1)+".0.0":ye(Xe)?Ze=ze==="0"?">="+ze+"."+qe+".0 <"+ze+"."+(+qe+1)+".0":">="+ze+"."+qe+".0 <"+(+ze+1)+".0.0":Ge?(w("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=ze==="0"?qe==="0"?">="+ze+"."+qe+"."+Xe+Ge+" <"+ze+"."+qe+"."+(+Xe+1):">="+ze+"."+qe+"."+Xe+Ge+" <"+ze+"."+(+qe+1)+".0":">="+ze+"."+qe+"."+Xe+Ge+" <"+(+ze+1)+".0.0"):(w("no pr"),Ze=ze==="0"?qe==="0"?">="+ze+"."+qe+"."+Xe+" <"+ze+"."+qe+"."+(+Xe+1):">="+ze+"."+qe+"."+Xe+" <"+ze+"."+(+qe+1)+".0":">="+ze+"."+qe+"."+Xe+" <"+(+ze+1)+".0.0"),w("caret return",Ze),Ze})}(be,ne)}).join(" ")}(We,He),w("caret",We),We=function(Ke,ne){return Ke.trim().split(/\s+/).map(function(be){return function(Pe,Le){var Me=Le?D[z]:D[C];return Pe.replace(Me,function(Ve,ze,qe,Xe,Ge){var Ze;return w("tilde",Pe,Ve,ze,qe,Xe,Ge),ye(ze)?Ze="":ye(qe)?Ze=">="+ze+".0.0 <"+(+ze+1)+".0.0":ye(Xe)?Ze=">="+ze+"."+qe+".0 <"+ze+"."+(+qe+1)+".0":Ge?(w("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=">="+ze+"."+qe+"."+Xe+Ge+" <"+ze+"."+(+qe+1)+".0"):Ze=">="+ze+"."+qe+"."+Xe+" <"+ze+"."+(+qe+1)+".0",w("tilde return",Ze),Ze})}(be,ne)}).join(" ")}(We,He),w("tildes",We),We=function(Ke,ne){return w("replaceXRanges",Ke,ne),Ke.split(/\s+/).map(function(be){return function(Pe,Le){Pe=Pe.trim();var Me=Le?D[R]:D[p];return Pe.replace(Me,function(Ve,ze,qe,Xe,Ge,Ze){w("xRange",Pe,Ve,ze,qe,Xe,Ge,Ze);var tt=ye(qe),st=tt||ye(Xe),ot=st||ye(Ge);return ze==="="&&ot&&(ze=""),tt?Ve=ze===">"||ze==="<"?"<0.0.0":"*":ze&&ot?(st&&(Xe=0),ot&&(Ge=0),ze===">"?(ze=">=",st?(qe=+qe+1,Xe=0,Ge=0):ot&&(Xe=+Xe+1,Ge=0)):ze==="<="&&(ze="<",st?qe=+qe+1:Xe=+Xe+1),Ve=ze+qe+"."+Xe+"."+Ge):st?Ve=">="+qe+".0.0 <"+(+qe+1)+".0.0":ot&&(Ve=">="+qe+"."+Xe+".0 <"+qe+"."+(+Xe+1)+".0"),w("xRange return",Ve),Ve})}(be,ne)}).join(" ")}(We,He),w("xrange",We),We=function(Ke,ne){return w("replaceStars",Ke,ne),Ke.trim().replace(D[oe],"")}(We,He),w("stars",We),We}(je,we)}).join(" ").split(/\s+/);return this.loose&&(Fe=Fe.filter(function(je){return!!je.match(Ae)})),Fe=Fe.map(function(je){return new x(je,we)})},fe.prototype.intersects=function(se,we){if(!(se instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(Ae){return se.set.some(function(Fe){return Fe.every(function(je){return Ae.intersects(je,we)})})})})},e.toComparators=function(se,we){return new fe(se,we).set.map(function(Ee){return Ee.map(function(Ae){return Ae.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new H(se,this.loose));for(var we=0;we<this.set.length;we++)if(Re(this.set[we],se))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(se,we,Ee){var Ae=null,Fe=null;try{var je=new fe(we,Ee)}catch{return null}return se.forEach(function(We){je.test(We)&&(Ae&&Fe.compare(We)!==-1||(Fe=new H(Ae=We,Ee)))}),Ae},e.minSatisfying=function(se,we,Ee){var Ae=null,Fe=null;try{var je=new fe(we,Ee)}catch{return null}return se.forEach(function(We){je.test(We)&&(Ae&&Fe.compare(We)!==1||(Fe=new H(Ae=We,Ee)))}),Ae},e.validRange=function(se,we){try{return new fe(se,we).range||"*"}catch{return null}},e.ltr=function(se,we,Ee){return Ue(se,we,"<",Ee)},e.gtr=function(se,we,Ee){return Ue(se,we,">",Ee)},e.outside=Ue,e.prerelease=function(se,we){var Ee=de(se,we);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(se,we,Ee){return se=new fe(se,Ee),we=new fe(we,Ee),se.intersects(we)},e.coerce=function(se){if(se instanceof H)return se;if(typeof se!="string")return null;var we=se.match(D[F]);return we==null?null:de((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,k(1))},function(ee,e){var k,n,w=ee.exports={};function I(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function D(f){if(k===setTimeout)return setTimeout(f,0);if((k===I||!k)&&setTimeout)return k=setTimeout,setTimeout(f,0);try{return k(f,0)}catch{try{return k.call(null,f,0)}catch{return k.call(this,f,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:I}catch{k=I}try{n=typeof clearTimeout=="function"?clearTimeout:_}catch{n=_}})();var v,P=[],A=!1,T=-1;function E(){A&&v&&(A=!1,v.length?P=v.concat(P):T=-1,P.length&&b())}function b(){if(!A){var f=D(E);A=!0;for(var h=P.length;h;){for(v=P,P=[];++T<h;)v&&v[T].run();T=-1,h=P.length}v=null,A=!1,function(g){if(n===clearTimeout)return clearTimeout(g);if((n===_||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(g);try{n(g)}catch{try{return n.call(null,g)}catch{return n.call(this,g)}}}(f)}}function u(f,h){this.fun=f,this.array=h}function S(){}w.nextTick=function(f){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];P.push(new u(f,h)),P.length!==1||A||D(b)},u.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=S,w.addListener=S,w.once=S,w.off=S,w.removeListener=S,w.removeAllListeners=S,w.emit=S,w.prependListener=S,w.prependOnceListener=S,w.listeners=function(f){return[]},w.binding=function(f){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(f){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(me[122],ve([0,1]),function(ee,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(D,v,P){this.level=D,this.key=v,this.value=P,this.forward=[]}}const w=void 0;class I{constructor(D,v=2**16){this.comparator=D,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(v)|0),this._header=new n(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,w,w)}has(D){return Boolean(I._search(this,D,this.comparator))}get(D){return I._search(this,D,this.comparator)?.value}set(D,v){return I._insert(this,D,v,this.comparator)&&(this._size+=1),this}delete(D){const v=I._delete(this,D,this.comparator);return v&&(this._size-=1),v}forEach(D,v){let P=this._header.forward[0];for(;P;)D.call(v,P.value,P.key,this),P=P.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",v=this._header.forward[0];for(;v;)D+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return D}static _search(D,v,P){let A=D._header;for(let T=D._level-1;T>=0;T--)for(;A.forward[T]&&P(A.forward[T].key,v)<0;)A=A.forward[T];if(A=A.forward[0],A&&P(A.key,v)===0)return A}static _insert(D,v,P,A){let T=[],E=D._header;for(let b=D._level-1;b>=0;b--){for(;E.forward[b]&&A(E.forward[b].key,v)<0;)E=E.forward[b];T[b]=E}if(E=E.forward[0],E&&A(E.key,v)===0)return E.value=P,!1;{let b=I._randomLevel(D);if(b>D._level){for(let u=D._level;u<b;u++)T[u]=D._header;D._level=b}E=new n(b,v,P);for(let u=0;u<b;u++)E.forward[u]=T[u].forward[u],T[u].forward[u]=E;return!0}}static _randomLevel(D,v=.5){let P=1;for(;Math.random()<v&&P<D._maxLevel;)P+=1;return P}static _delete(D,v,P){let A=[],T=D._header;for(let E=D._level-1;E>=0;E--){for(;T.forward[E]&&P(T.forward[E].key,v)<0;)T=T.forward[E];A[E]=T}if(T=T.forward[0],!T||P(T.key,v)!==0)return!1;for(let E=0;E<D._level&&A[E].forward[E]===T;E++)A[E].forward[E]=T.forward[E];for(;D._level>0&&D._header.forward[D._level-1]===w;)D._level-=1;return!0}}e.SkipList=I}),define(me[123],ve([0,1,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=k.globals.performance&&typeof k.globals.performance.now=="function";class w{constructor(_){this._highResolution=n&&_,this._startTime=this._now(),this._stopTime=-1}static create(_=!0){return new w(_)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=w}),define(me[7],ve([0,1,9,74,2,120,123]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let D=!1,v=!1;var P;(function(i){i.None=()=>w.Disposable.None;function t(re){if(v){const{onListenerDidAdd:oe}=re,ue=u.create();let de=0;re.onListenerDidAdd=()=>{++de==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),oe?.()}}}function r(re){return(oe,ue=null,de)=>{let H=!1,O;return O=re(V=>{if(!H)return O?O.dispose():H=!0,oe.call(ue,V)},null,de),H&&O.dispose(),O}}i.once=r;function s(re,oe,ue){return U((de,H=null,O)=>re(V=>de.call(H,oe(V)),null,O),ue)}i.map=s;function a(re,oe,ue){return U((de,H=null,O)=>re(V=>{oe(V),de.call(H,V)},null,O),ue)}i.forEach=a;function m(re,oe,ue){return U((de,H=null,O)=>re(V=>oe(V)&&de.call(H,V),null,O),ue)}i.filter=m;function p(re){return re}i.signal=p;function R(...re){return(oe,ue=null,de)=>(0,w.combinedDisposable)(...re.map(H=>H(O=>oe.call(ue,O),null,de)))}i.any=R;function F(re,oe,ue,de){let H=ue;return s(re,O=>(H=oe(H,O),H),de)}i.reduce=F;function U(re,oe){let ue;const de={onFirstListenerAdd(){ue=re(H.fire,H)},onLastListenerRemove(){ue.dispose()}};oe||t(de);const H=new f(de);return oe&&oe.add(H),H.event}function G(re,oe,ue=100,de=!1,H,O){let V,J,ae,ge=0;const he={leakWarningThreshold:H,onFirstListenerAdd(){V=re(pe=>{ge++,J=oe(J,pe),de&&!ae&&(le.fire(J),J=void 0),clearTimeout(ae),ae=setTimeout(()=>{const Q=J;J=void 0,ae=void 0,(!de||ge>1)&&le.fire(Q),ge=0},ue)})},onLastListenerRemove(){V.dispose()}};O||t(he);const le=new f(he);return O&&O.add(le),le.event}i.debounce=G;function C(re,oe=(de,H)=>de===H,ue){let de=!0,H;return m(re,O=>{const V=de||!oe(O,H);return de=!1,H=O,V},ue)}i.latch=C;function z(re,oe,ue){return[i.filter(re,oe,ue),i.filter(re,de=>!oe(de),ue)]}i.split=z;function M(re,oe=!1,ue=[]){let de=ue.slice(),H=re(J=>{de?de.push(J):V.fire(J)});const O=()=>{de&&de.forEach(J=>V.fire(J)),de=null},V=new f({onFirstListenerAdd(){H||(H=re(J=>V.fire(J)))},onFirstListenerDidAdd(){de&&(oe?setTimeout(O):O())},onLastListenerRemove(){H&&H.dispose(),H=null}});return V.event}i.buffer=M;class q{constructor(oe){this.event=oe}map(oe){return new q(s(this.event,oe))}forEach(oe){return new q(a(this.event,oe))}filter(oe){return new q(m(this.event,oe))}reduce(oe,ue){return new q(F(this.event,oe,ue))}latch(){return new q(C(this.event))}debounce(oe,ue=100,de=!1,H){return new q(G(this.event,oe,ue,de,H))}on(oe,ue,de){return this.event(oe,ue,de)}once(oe,ue,de){return r(this.event)(oe,ue,de)}}function Z(re){return new q(re)}i.chain=Z;function j(re,oe,ue=de=>de){const de=(...J)=>V.fire(ue(...J)),H=()=>re.on(oe,de),O=()=>re.removeListener(oe,de),V=new f({onFirstListenerAdd:H,onLastListenerRemove:O});return V.event}i.fromNodeEventEmitter=j;function $(re,oe,ue=de=>de){const de=(...J)=>V.fire(ue(...J)),H=()=>re.addEventListener(oe,de),O=()=>re.removeEventListener(oe,de),V=new f({onFirstListenerAdd:H,onLastListenerRemove:O});return V.event}i.fromDOMEventEmitter=$;function W(re){return new Promise(oe=>r(re)(oe))}i.toPromise=W;function Y(re,oe){return oe(void 0),re(ue=>oe(ue))}i.runAndSubscribe=Y;function ie(re,oe){let ue=null;function de(O){ue?.dispose(),ue=new w.DisposableStore,oe(O,ue)}de(void 0);const H=re(O=>de(O));return(0,w.toDisposable)(()=>{H.dispose(),ue?.dispose()})}i.runAndSubscribeWithStore=ie})(P=e.Event||(e.Event={}));class A{constructor(t){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${t}_${A._idPool++}`}start(t){this._stopWatch=new _.StopWatch(!0),this._listenerCount=t}stop(){if(this._stopWatch){const t=this._stopWatch.elapsed();this._elapsedOverall+=t,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${t.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}A._idPool=0;let T=-1;function E(i){const t=T;return T=i,{dispose(){T=t}}}e.setGlobalLeakWarningThreshold=E;class b{constructor(t,r=Math.random().toString(18).slice(2,5)){this.customThreshold=t,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(t,r){let s=T;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||r<s)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(t.value)||0;if(this._stacks.set(t.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let m,p=0;for(const[R,F]of this._stacks)(!m||p<F)&&(m=R,p=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${p}):`),console.warn(m)}return()=>{const m=this._stacks.get(t.value)||0;this._stacks.set(t.value,m-1)}}}class u{constructor(t){this.value=t}static create(){return new u(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(t,r,s){this.callback=t,this.callbackThis=r,this.stack=s,this.subscription=new w.SafeDisposable}invoke(t){this.callback.call(this.callbackThis,t)}}class f{constructor(t){this._disposed=!1,this._options=t,this._leakageMon=T>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const t=Array.from(this._listeners);queueMicrotask(()=>{for(const r of t)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(t,r,s)=>{this._listeners||(this._listeners=new I.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let m,p;this._leakageMon&&this._listeners.size>=30&&(p=u.create(),m=this._leakageMon.check(p,this._listeners.size+1)),D&&(p=p??u.create());const R=new S(t,r,p),F=this._listeners.push(R);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,t,r);const U=R.subscription.set(()=>{m&&m(),this._disposed||(F(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof w.DisposableStore?s.add(U):Array.isArray(s)&&s.push(U),U}),this._event}fire(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,t]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,s]=this._deliveryQueue.shift();try{r.invoke(s)}catch(a){(0,k.onUnexpectedError)(a)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=f;class h extends f{async fireAsync(t,r,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,t]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[a,m]=this._asyncDeliveryQueue.shift(),p=[],R={...m,token:r,waitUntil:F=>{if(Object.isFrozen(p))throw new Error("waitUntil can NOT be called asynchronous");s&&(F=s(F,a.callback)),p.push(F)}};try{a.invoke(R)}catch(F){(0,k.onUnexpectedError)(F);continue}Object.freeze(p),await Promise.allSettled(p).then(F=>{for(const U of F)U.status==="rejected"&&(0,k.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=h;class g extends f{constructor(t){super(t);this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=t?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const t=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(t))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(t){this._listeners&&(this._isPaused!==0?this._eventQueue.push(t):super.fire(t))}}e.PauseableEmitter=g;class d extends g{constructor(t){super(t);this._delay=t.delay??100}fire(t){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(t)}}e.DebounceEmitter=d;class y extends f{constructor(t){super(t);this._queuedEvents=[],this._mergeFn=t?.merge}fire(t){this._queuedEvents.push(t),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(t){const r={event:t,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const s=()=>{this.hasListeners&&this.unhook(r);const a=this.events.indexOf(r);this.events.splice(a,1)};return(0,w.toDisposable)((0,n.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(t=>this.hook(t))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(t=>this.unhook(t))}hook(t){t.listener=t.event(r=>this.emitter.fire(r))}unhook(t){t.listener&&t.listener.dispose(),t.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class o{constructor(){this.buffers=[]}wrapEvent(t){return(r,s,a)=>t(m=>{const p=this.buffers[this.buffers.length-1];p?p.push(()=>r.call(s,m)):r.call(s,m)},void 0,a)}bufferEvents(t){const r=[];this.buffers.push(r);const s=t();return this.buffers.pop(),r.forEach(a=>a()),s}}e.EventBufferer=o;class l{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=w.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(me[21],ve([0,1,7]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(D,v){const P=setTimeout(D.bind(v),0);return{dispose(){clearTimeout(P)}}});var w;(function(D){function v(P){return P===D.None||P===D.Cancelled||P instanceof I?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}D.isCancellationToken=v,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(w=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=w.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=w.None}}e.CancellationTokenSource=_}),define(me[124],ve([0,1,21]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(_){this.task=_,this.result=null}get(){if(this.result)return this.result;const _=new k.CancellationTokenSource,D=this.task(_.token);return this.result={promise:D,dispose:()=>{this.result=null,_.cancel(),_.dispose()}},this.result}}e.Cache=n;class w{constructor(_){this.computeFn=_,this.lastCache=void 0,this.lastArgKey=void 0}get(_){const D=JSON.stringify(_);return this.lastArgKey!==D&&(this.lastArgKey=D,this.lastCache=this.computeFn(_)),this.lastCache}}e.LRUCachedComputed=w}),define(me[43],ve([0,1,9,2]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(y){const c=y;return c?typeof c.read=="function":!1}e.isReadable=w;function I(y){const c=y;return c?[c.on,c.pause,c.resume,c.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=I;function _(y){const c=y;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=_;function D(y,c){return new v(y,c)}e.newWriteableStream=D;class v{constructor(c,o){this.reducer=c,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(o=>o(c))}emitError(c){this.listeners.error.length===0?(0,k.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(o=>o(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,o){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(c,o){if(this.state.destroyed)return;let l;switch(c){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const i=l.indexOf(o);i>=0&&l.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(y,c){const o=[];let l;for(;(l=y.read())!==null;)o.push(l);return c(o)}e.consumeReadable=P;function A(y,c,o){const l=[];let i;for(;(i=y.read())!==null&&l.length<o;)l.push(i);return i===null&&l.length>0?c(l):{read:()=>{if(l.length>0)return l.shift();if(typeof i!="undefined"){const t=i;return i=void 0,t}return y.read()}}}e.peekReadable=A;function T(y,c){return new Promise((o,l)=>{const i=[];E(y,{onData:t=>{c&&i.push(t)},onError:t=>{c?l(t):o(void 0)},onEnd:()=>{o(c?c(i):void 0)}})})}e.consumeStream=T;function E(y,c){let o=!1;return y.on("error",l=>{o||c.onError(l)}),y.on("end",()=>{o||c.onEnd()}),y.on("data",l=>{o||c.onData(l)}),(0,n.toDisposable)(()=>o=!0)}e.listenStream=E;function b(y,c){return new Promise((o,l)=>{const i=new n.DisposableStore,t=[],r=m=>{if(t.push(m),t.length>c)return i.dispose(),y.pause(),o({stream:y,buffer:t,ended:!1})},s=m=>l(m),a=()=>o({stream:y,buffer:t,ended:!0});i.add((0,n.toDisposable)(()=>y.removeListener("error",s))),y.on("error",s),i.add((0,n.toDisposable)(()=>y.removeListener("end",a))),y.on("end",a),i.add((0,n.toDisposable)(()=>y.removeListener("data",r))),y.on("data",r)})}e.peekStream=b;function u(y,c){const o=D(c);return o.end(y),o}e.toStream=u;function S(){const y=D(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=S;function f(y){let c=!1;return{read:()=>c?null:(c=!0,y)}}e.toReadable=f;function h(y,c,o){const l=D(o);return E(y,{onData:i=>l.write(c.data(i)),onError:i=>l.error(c.error?c.error(i):i),onEnd:()=>l.end()}),l}e.transform=h;function g(y,c,o){let l=!1;return{read:()=>{const i=c.read();return l?i:(l=!0,i!==null?o([y,i]):y)}}}e.prefixedReadable=g;function d(y,c,o){let l=!1;const i=D(o);return E(c,{onData:t=>l?i.write(t):(l=!0,i.write(o([y,t]))),onError:t=>i.error(t),onEnd:()=>{l||(l=!0,i.write(y)),i.end()}}),i}e.prefixedStream=d}),define(me[17],ve([0,1,43]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let w,I;class _{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return n?new _(Buffer.allocUnsafe(m)):new _(new Uint8Array(m))}static wrap(m){return n&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new _(m)}static fromString(m,p){return!(p?.dontUseNodeBuffer||!1)&&n?new _(Buffer.from(m)):(w||(w=new TextEncoder),new _(w.encode(m)))}static fromByteArray(m){const p=_.alloc(m.length);for(let R=0,F=m.length;R<F;R++)p.buffer[R]=m[R];return p}static concat(m,p){if(typeof p=="undefined"){p=0;for(let U=0,G=m.length;U<G;U++)p+=m[U].byteLength}const R=_.alloc(p);let F=0;for(let U=0,G=m.length;U<G;U++){const C=m[U];R.set(C,F),F+=C.byteLength}return R}clone(){const m=_.alloc(this.byteLength);return m.set(this),m}toString(){return n?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(m,p){return new _(this.buffer.subarray(m,p))}set(m,p){if(m instanceof _)this.buffer.set(m.buffer,p);else if(m instanceof Uint8Array)this.buffer.set(m,p);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),p);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return P(this.buffer,m)}writeUInt32BE(m,p){A(this.buffer,m,p)}readUInt32LE(m){return T(this.buffer,m)}writeUInt32LE(m,p){E(this.buffer,m,p)}readUInt8(m){return b(this.buffer,m)}writeUInt8(m,p){u(this.buffer,m,p)}}e.VSBuffer=_;function D(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0}e.readUInt16LE=D;function v(a,m,p){a[p+0]=m&255,m=m>>>8,a[p+1]=m&255}e.writeUInt16LE=v;function P(a,m){return a[m]*2**24+a[m+1]*2**16+a[m+2]*2**8+a[m+3]}e.readUInt32BE=P;function A(a,m,p){a[p+3]=m,m=m>>>8,a[p+2]=m,m=m>>>8,a[p+1]=m,m=m>>>8,a[p]=m}e.writeUInt32BE=A;function T(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0|a[m+2]<<16>>>0|a[m+3]<<24>>>0}e.readUInt32LE=T;function E(a,m,p){a[p+0]=m&255,m=m>>>8,a[p+1]=m&255,m=m>>>8,a[p+2]=m&255,m=m>>>8,a[p+3]=m&255}e.writeUInt32LE=E;function b(a,m){return a[m]}e.readUInt8=b;function u(a,m,p){a[p]=m}e.writeUInt8=u;function S(a){return k.consumeReadable(a,m=>_.concat(m))}e.readableToBuffer=S;function f(a){return k.toReadable(a)}e.bufferToReadable=f;function h(a){return k.consumeStream(a,m=>_.concat(m))}e.streamToBuffer=h;async function g(a){return a.ended?_.concat(a.buffer):_.concat([...a.buffer,await h(a.stream)])}e.bufferedStreamToBuffer=g;function d(a){return k.toStream(a,m=>_.concat(m))}e.bufferToStream=d;function y(a){return k.transform(a,{data:m=>typeof m=="string"?_.fromString(m):_.wrap(m)},m=>_.concat(m))}e.streamToBufferReadableStream=y;function c(a){return k.newWriteableStream(m=>_.concat(m),a)}e.newWriteableBufferStream=c;function o(a,m){return k.prefixedReadable(a,m,p=>_.concat(p))}e.prefixedBufferReadable=o;function l(a,m){return k.prefixedStream(a,m,p=>_.concat(p))}e.prefixedBufferStream=l;function i(a){let m=0,p=0,R=0;const F=new Uint8Array(Math.floor(a.length/4*3)),U=C=>{switch(p){case 3:F[R++]=m|C,p=0;break;case 2:F[R++]=m|C>>>2,m=C<<6,p=3;break;case 1:F[R++]=m|C>>>4,m=C<<4,p=2;break;default:m=C<<2,p=1}};for(let C=0;C<a.length;C++){const z=a.charCodeAt(C);if(z>=65&&z<=90)U(z-65);else if(z>=97&&z<=122)U(z-97+26);else if(z>=48&&z<=57)U(z-48+52);else if(z===43||z===45)U(62);else if(z===47||z===95)U(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${a[C]}`)}}const G=R;for(;p>0;)U(0);return _.wrap(F).slice(0,G)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},m=!0,p=!1){const R=p?r:t;let F="";const U=a.byteLength%3;let G=0;for(;G<a.byteLength-U;G+=3){const C=a[G+0],z=a[G+1],M=a[G+2];F+=R[C>>>2],F+=R[(C<<4|z>>>4)&63],F+=R[(z<<2|M>>>6)&63],F+=R[M&63]}if(U===1){const C=a[G+0];F+=R[C>>>2],F+=R[C<<4&63],m&&(F+="==")}else if(U===2){const C=a[G+0],z=a[G+1];F+=R[C>>>2],F+=R[(C<<4|z>>>4)&63],F+=R[z<<2&63],m&&(F+="=")}return F}e.encodeBase64=s}),define(me[15],ve([0,1,124,119]),function(ee,e,k,n){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function I(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=I;const _=/{(\d+)}/g;function D(ne,...be){return be.length===0?ne:ne.replace(_,function(Pe,Le){const Me=parseInt(Le,10);return isNaN(Me)||Me<0||Me>=be.length?Pe:be[Me]})}e.format=D;const v=/{([^}]+)}/g;function P(ne,be){return ne.replace(v,(Pe,Le)=>be[Le]??Pe)}e.format2=P;function A(ne){return ne.replace(/[<>&]/g,function(be){switch(be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return be}})}e.escape=A;function T(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function E(ne,be){let Pe=0;const Le=be.charCodeAt(0);for(let Me=ne.length-1;Me>=0;Me--)ne.charCodeAt(Me)===Le&&Pe++;return Pe}e.count=E;function b(ne,be,Pe="\u2026"){return ne.length<=be?ne:`${ne.substr(0,be)}${Pe}`}e.truncate=b;function u(ne,be=" "){const Pe=S(ne,be);return f(Pe,be)}e.trim=u;function S(ne,be){if(!ne||!be)return ne;const Pe=be.length;if(Pe===0||ne.length===0)return ne;let Le=0;for(;ne.indexOf(be,Le)===Le;)Le=Le+Pe;return ne.substring(Le)}e.ltrim=S;function f(ne,be){if(!ne||!be)return ne;const Pe=be.length,Le=ne.length;if(Pe===0||Le===0)return ne;let Me=Le,Ve=-1;for(;Ve=ne.lastIndexOf(be,Me-1),!(Ve===-1||Ve+Pe!==Me);){if(Ve===0)return"";Me=Ve}return ne.substring(0,Me)}e.rtrim=f;function h(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g(ne){return ne.replace(/\*/g,"")}e.stripWildcards=g;function d(ne,be,Pe={}){if(!ne)throw new Error("Cannot create regex from empty string");be||(ne=T(ne)),Pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Le="";return Pe.global&&(Le+="g"),Pe.matchCase||(Le+="i"),Pe.multiline&&(Le+="m"),Pe.unicode&&(Le+="u"),new RegExp(ne,Le)}e.createRegExp=d;function y(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function c(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function o(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=o;function l(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=l;function i(ne){for(let be=0,Pe=ne.length;be<Pe;be++){const Le=ne.charCodeAt(be);if(Le!==32&&Le!==9)return be}return-1}e.firstNonWhitespaceIndex=i;function t(ne,be=0,Pe=ne.length){for(let Le=be;Le<Pe;Le++){const Me=ne.charCodeAt(Le);if(Me!==32&&Me!==9)return ne.substring(be,Le)}return ne.substring(be,Pe)}e.getLeadingWhitespace=t;function r(ne,be=ne.length-1){for(let Pe=be;Pe>=0;Pe--){const Le=ne.charCodeAt(Pe);if(Le!==32&&Le!==9)return Pe}return-1}e.lastNonWhitespaceIndex=r;function s(ne,be){return ne<be?-1:ne>be?1:0}e.compare=s;function a(ne,be,Pe=0,Le=ne.length,Me=0,Ve=be.length){for(;Pe<Le&&Me<Ve;Pe++,Me++){let Xe=ne.charCodeAt(Pe),Ge=be.charCodeAt(Me);if(Xe<Ge)return-1;if(Xe>Ge)return 1}const ze=Le-Pe,qe=Ve-Me;return ze<qe?-1:ze>qe?1:0}e.compareSubstring=a;function m(ne,be){return p(ne,be,0,ne.length,0,be.length)}e.compareIgnoreCase=m;function p(ne,be,Pe=0,Le=ne.length,Me=0,Ve=be.length){for(;Pe<Le&&Me<Ve;Pe++,Me++){let Xe=ne.charCodeAt(Pe),Ge=be.charCodeAt(Me);if(Xe===Ge)continue;if(Xe>=128||Ge>=128)return a(ne.toLowerCase(),be.toLowerCase(),Pe,Le,Me,Ve);R(Xe)&&(Xe-=32),R(Ge)&&(Ge-=32);const Ze=Xe-Ge;if(Ze!==0)return Ze}const ze=Le-Pe,qe=Ve-Me;return ze<qe?-1:ze>qe?1:0}e.compareSubstringIgnoreCase=p;function R(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=R;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function U(ne,be){return ne.length===be.length&&p(ne,be)===0}e.equalsIgnoreCase=U;function G(ne,be){const Pe=be.length;return be.length>ne.length?!1:p(ne,be,0,Pe)===0}e.startsWithIgnoreCase=G;function C(ne,be){let Pe,Le=Math.min(ne.length,be.length);for(Pe=0;Pe<Le;Pe++)if(ne.charCodeAt(Pe)!==be.charCodeAt(Pe))return Pe;return Le}e.commonPrefixLength=C;function z(ne,be){let Pe,Le=Math.min(ne.length,be.length);const Me=ne.length-1,Ve=be.length-1;for(Pe=0;Pe<Le;Pe++)if(ne.charCodeAt(Me-Pe)!==be.charCodeAt(Ve-Pe))return Pe;return Le}e.commonSuffixLength=z;function M(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=M;function q(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=q;function Z(ne,be){return(ne-55296<<10)+(be-56320)+65536}e.computeCodePoint=Z;function j(ne,be,Pe){const Le=ne.charCodeAt(Pe);if(M(Le)&&Pe+1<be){const Me=ne.charCodeAt(Pe+1);if(q(Me))return Z(Le,Me)}return Le}e.getNextCodePoint=j;function $(ne,be){const Pe=ne.charCodeAt(be-1);if(q(Pe)&&be>1){const Le=ne.charCodeAt(be-2);if(M(Le))return Z(Le,Pe)}return Pe}class W{constructor(be,Pe=0){this._str=be,this._len=be.length,this._offset=Pe}get offset(){return this._offset}setOffset(be){this._offset=be}prevCodePoint(){const be=$(this._str,this._offset);return this._offset-=be>=65536?2:1,be}nextCodePoint(){const be=j(this._str,this._len,this._offset);return this._offset+=be>=65536?2:1,be}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class Y{constructor(be,Pe=0){this._iterator=new W(be,Pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const be=we.getInstance(),Pe=this._iterator,Le=Pe.offset;let Me=be.getGraphemeBreakType(Pe.nextCodePoint());for(;!Pe.eol();){const Ve=Pe.offset,ze=be.getGraphemeBreakType(Pe.nextCodePoint());if(Ue(Me,ze)){Pe.setOffset(Ve);break}Me=ze}return Pe.offset-Le}prevGraphemeLength(){const be=we.getInstance(),Pe=this._iterator,Le=Pe.offset;let Me=be.getGraphemeBreakType(Pe.prevCodePoint());for(;Pe.offset>0;){const Ve=Pe.offset,ze=be.getGraphemeBreakType(Pe.prevCodePoint());if(Ue(ze,Me)){Pe.setOffset(Ve);break}Me=ze}return Le-Pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function ie(ne,be){return new Y(ne,be).nextGraphemeLength()}e.nextCharLength=ie;function re(ne,be){return new Y(ne,be).prevGraphemeLength()}e.prevCharLength=re;function oe(ne,be){be>0&&q(ne.charCodeAt(be))&&be--;const Pe=be+ie(ne,be);return[Pe-re(ne,Pe),Pe]}e.getCharContainingOffset=oe;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function de(ne){return ue.test(ne)}e.containsRTL=de;const H=/^[\t\n\r\x20-\x7E]*$/;function O(ne){return H.test(ne)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=V;function J(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=J;function ae(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=ae;function ge(ne,be){if(ne.length<be)return ne;const Pe=/\b/g;let Le=0;for(;Pe.test(ne)&&!(ne.length-Pe.lastIndex<be);)Le=Pe.lastIndex,Pe.lastIndex+=1;return ne.substring(Le).replace(/^\s/,"")}e.lcut=ge;const he=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function Q(ne){return ne&&(ne=ne.replace(he,""),ne=ne.replace(le,""),ne=ne.replace(pe,"")),ne}e.removeAnsiEscapeCodes=Q,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function B(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=B;function x(ne){return B(ne)?ne.substr(1):ne}e.stripUTF8BOM=x;function X(ne,be){if(!ne||!be||ne.length<be.length)return!1;const Pe=be.length,Le=ne.toLowerCase();let Me=0,Ve=-1;for(;Me<Pe;){const ze=Le.indexOf(be[Me],Ve+1);if(ze<0)return!1;Ve=ze,Me++}return!0}e.fuzzyContains=X;function fe(ne,be=!1){return ne?(be&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=fe;function ye(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ye;function ke(ne,be=1){if(be===0)return"";let Pe=-1;do Pe=ne.indexOf(`
`,Pe+1),be--;while(be>0&&Pe>=0);return Pe===-1?ne:(ne[Pe-1]==="\r"&&Pe--,ne.substr(0,Pe))}e.getNLines=ke;function Re(ne){const be=90-65+1;return ne=ne%(2*be),ne<be?String.fromCharCode(97+ne):String.fromCharCode(65+ne-be)}e.singleLetterHash=Re;function Ne(ne){return we.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=Ne;function Ue(ne,be){return ne===0?be!==5&&be!==7:ne===2&&be===3?!1:ne===4||ne===2||ne===3||be===4||be===2||be===3?!0:!(ne===8&&(be===8||be===9||be===11||be===12)||(ne===11||ne===9)&&(be===9||be===10)||(ne===12||ne===10)&&be===10||be===5||be===13||be===7||ne===1||ne===13&&be===14||ne===6&&be===6)}var se;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(se=e.GraphemeBreakType||(e.GraphemeBreakType={}));class we{constructor(){this._data=Ee()}static getInstance(){return we._INSTANCE||(we._INSTANCE=new we),we._INSTANCE}getGraphemeBreakType(be){if(be<32)return be===10?3:be===13?2:4;if(be<127)return 0;const Pe=this._data,Le=Pe.length/3;let Me=1;for(;Me<=Le;)if(be<Pe[3*Me])Me=2*Me;else if(be>Pe[3*Me+1])Me=2*Me+1;else return Pe[3*Me+2];return 0}}we._INSTANCE=null;function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ae(ne,be){if(ne===0)return 0;const Pe=Fe(ne,be);if(Pe!==void 0)return Pe;const Le=new W(be,ne);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=Ae;function Fe(ne,be){const Pe=new W(be,ne);let Le=Pe.prevCodePoint();for(;je(Le)||Le===65039||Le===8419;){if(Pe.offset===0)return;Le=Pe.prevCodePoint()}if(!ae(Le))return;let Me=Pe.offset;return Me>0&&Pe.prevCodePoint()===8205&&(Me=Pe.offset),Me}function je(ne){return 127995<=ne&&ne<=127999}var We;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.noBreakWhitespace="\xA0";class He{constructor(be){this.confusableDictionary=be}static getInstance(be){return He.cache.get(Array.from(be))}static getLocales(){return He._locales.getValue()}isAmbiguous(be){return this.confusableDictionary.has(be)}getPrimaryConfusable(be){return this.confusableDictionary.get(be)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He,w=He,He.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),He.cache=new k.LRUCachedComputed(ne=>{function be(Ge){const Ze=new Map;for(let tt=0;tt<Ge.length;tt+=2)Ze.set(Ge[tt],Ge[tt+1]);return Ze}function Pe(Ge,Ze){const tt=new Map(Ge);for(const[st,ot]of Ze)tt.set(st,ot);return tt}function Le(Ge,Ze){if(!Ge)return Ze;const tt=new Map;for(const[st,ot]of Ge)Ze.has(st)&&tt.set(st,ot);return tt}const Me=w.ambiguousCharacterData.getValue();let Ve=ne.filter(Ge=>!Ge.startsWith("_")&&Ge in Me);Ve.length===0&&(Ve=["_default"]);let ze;for(const Ge of Ve){const Ze=be(Me[Ge]);ze=Le(ze,Ze)}const qe=be(Me._common),Xe=Pe(qe,ze);return new He(Xe)}),He._locales=new n.Lazy(()=>Object.keys(He.ambiguousCharacterData.getValue()).filter(ne=>!ne.startsWith("_")));class Ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ke.getRawData())),this._data}static isInvisibleCharacter(be){return Ke.getData().has(be)}static get codePoints(){return Ke.getData()}}e.InvisibleCharacters=Ke,Ke._data=void 0}),define(me[125],ve([0,1,15]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(h){return w(h,0)}e.hash=n;function w(h,g){switch(typeof h){case"object":return h===null?I(349,g):Array.isArray(h)?v(h,g):P(h,g);case"string":return D(h,g);case"boolean":return _(h,g);case"number":return I(h,g);case"undefined":return I(937,g);default:return I(617,g)}}e.doHash=w;function I(h,g){return(g<<5)-g+h|0}e.numberHash=I;function _(h,g){return I(h?433:863,g)}function D(h,g){g=I(149417,g);for(let d=0,y=h.length;d<y;d++)g=I(h.charCodeAt(d),g);return g}e.stringHash=D;function v(h,g){return g=I(104579,g),h.reduce((d,y)=>w(y,d),g)}function P(h,g){return g=I(181387,g),Object.keys(h).sort().reduce((d,y)=>(d=D(y,d),w(h[y],d)),g)}class A{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=w(g,this._value),this._value}}e.Hasher=A;var T;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function E(h,g,d=32){const y=d-g,c=~((1<<y)-1);return(h<<g|(c&h)>>>y)>>>0}function b(h,g=0,d=h.byteLength,y=0){for(let c=0;c<d;c++)h[g+c]=y}function u(h,g,d="0"){for(;h.length<g;)h=d+h;return h}function S(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(d=>d.toString(16).padStart(2,"0")).join(""):u((h>>>0).toString(16),g/4)}e.toHexString=S;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const d=g.length;if(d===0)return;const y=this._buff;let c=this._buffLen,o=this._leftoverHighSurrogate,l,i;for(o!==0?(l=o,i=-1,o=0):(l=g.charCodeAt(0),i=0);;){let t=l;if(k.isHighSurrogate(l))if(i+1<d){const r=g.charCodeAt(i+1);k.isLowSurrogate(r)?(i++,t=k.computeCodePoint(l,r)):t=65533}else{o=l;break}else k.isLowSurrogate(l)&&(t=65533);if(c=this._push(y,c,t),i++,i<d)l=g.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=o}_push(g,d,y){return y<128?g[d++]=y:y<2048?(g[d++]=192|(y&1984)>>>6,g[d++]=128|(y&63)>>>0):y<65536?(g[d++]=224|(y&61440)>>>12,g[d++]=128|(y&4032)>>>6,g[d++]=128|(y&63)>>>0):(g[d++]=240|(y&1835008)>>>18,g[d++]=128|(y&258048)>>>12,g[d++]=128|(y&4032)>>>6,g[d++]=128|(y&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=f._bigBlock32,d=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,d.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,E(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let y=this._h0,c=this._h1,o=this._h2,l=this._h3,i=this._h4,t,r,s;for(let a=0;a<80;a++)a<20?(t=c&o|~c&l,r=1518500249):a<40?(t=c^o^l,r=1859775393):a<60?(t=c&o|c&l|o&l,r=2400959708):(t=c^o^l,r=3395469782),s=E(y,5)+t+i+r+g.getUint32(a*4,!1)&4294967295,i=l,l=o,o=E(c,30),c=y,y=s;this._h0=this._h0+y&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))});var St=this&&this.__classPrivateFieldSet||function(ee,e,k,n,w){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!w:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?w.call(ee,k):w?w.value=k:e.set(ee,k),k},et=this&&this.__classPrivateFieldGet||function(ee,e,k,n){if(k==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?n:k==="a"?n.call(ee):n?n.value:e.get(ee)};define(me[31],ve([0,1,16,15]),function(ee,e,k,n){"use strict";var w,I,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(i,t,r){let s=i.get(t);return s===void 0&&(s=r,i.set(t,s)),s}e.getOrSet=D;function v(i){const t=[];return i.forEach((r,s)=>{t.push(`${s} => ${r}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=v;function P(i){const t=[];return i.forEach(r=>{t.push(r)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=P;class A{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const r=t.charCodeAt(0),s=this._value.charCodeAt(this._pos);return r-s}value(){return this._value[this._pos]}}e.StringIterator=A;class T{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class E{constructor(t=!0,r=!0){this._splitOnBackslash=t,this._caseSensitive=r}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let r=t.length-1;r>=0;r--,this._valueLen--){const s=this._value.charCodeAt(r);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var b;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(b||(b={}));class u{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(f||(f={}));class h{constructor(t){this._iter=t}static forUris(t=()=>!1){return new h(new u(t))}static forPaths(t=!1){return new h(new E(void 0,!t))}static forStrings(){return new h(new A)}static forConfigKeys(){return new h(new T)}clear(){this._root=void 0}fill(t,r){if(r){const s=r.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a,t)}else{const s=t.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a[0],a[1])}}set(t,r){const s=this._iter.reset(t);let a;this._root||(this._root=new S,this._root.segment=s.value());const m=[];for(a=this._root;;){const R=s.cmp(a.segment);if(R>0)a.left||(a.left=new S,a.left.segment=s.value()),m.push([-1,a]),a=a.left;else if(R<0)a.right||(a.right=new S,a.right.segment=s.value()),m.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new S,a.mid.segment=s.value()),m.push([0,a]),a=a.mid;else break}const p=a.value;a.value=r,a.key=t;for(let R=m.length-1;R>=0;R--){const F=m[R][1];F.updateHeight();const U=F.balanceFactor();if(U<-1||U>1){const G=m[R][0],C=m[R+1][0];if(G===1&&C===1)m[R][1]=F.rotateLeft();else if(G===-1&&C===-1)m[R][1]=F.rotateRight();else if(G===1&&C===-1)F.right=m[R+1][1]=m[R+1][1].rotateRight(),m[R][1]=F.rotateLeft();else if(G===-1&&C===1)F.left=m[R+1][1]=m[R+1][1].rotateLeft(),m[R][1]=F.rotateRight();else throw new Error;if(R>0)switch(m[R-1][0]){case-1:m[R-1][1].left=m[R][1];break;case 1:m[R-1][1].right=m[R][1];break;case 0:m[R-1][1].mid=m[R][1];break}else this._root=m[0][1]}}return p}get(t){return this._getNode(t)?.value}_getNode(t){const r=this._iter.reset(t);let s=this._root;for(;s;){const a=r.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(t){const r=this._getNode(t);return!(r?.value===void 0&&r?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,r){const s=this._iter.reset(t),a=[];let m=this._root;for(;m;){const p=s.cmp(m.segment);if(p>0)a.push([-1,m]),m=m.left;else if(p<0)a.push([1,m]),m=m.right;else if(s.hasNext())s.next(),a.push([0,m]),m=m.mid;else break}if(!!m){if(r?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const p=this._min(m.right),{key:R,value:F,segment:U}=p;this._delete(p.key,!1),m.key=R,m.value=F,m.segment=U}else{const p=m.left??m.right;if(a.length>0){const[R,F]=a[a.length-1];switch(R){case-1:F.left=p;break;case 0:F.mid=p;break;case 1:F.right=p;break}}else this._root=p}for(let p=a.length-1;p>=0;p--){const R=a[p][1];R.updateHeight();const F=R.balanceFactor();if(F>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),a[p][1]=R.rotateLeft()):F<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),a[p][1]=R.rotateRight()),p>0)switch(a[p-1][0]){case-1:a[p-1][1].left=a[p][1];break;case 1:a[p-1][1].right=a[p][1];break;case 0:a[p-1][1].mid=a[p][1];break}else this._root=a[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const r=this._iter.reset(t);let s=this._root,a;for(;s;){const m=r.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(r.hasNext())r.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(t){const r=this._iter.reset(t);let s=this._root;for(;s;){const a=r.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(t){for(const[r,s]of this)t(s,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=r=>{if(!r)return!0;const s=r.balanceFactor();return s<-1||s>1?!1:t(r.left)&&t(r.right)};return t(this._root)}}e.TernarySearchTree=h;class g{constructor(t,r){this.uri=t,this.value=r}}class d{constructor(t,r){this[w]="ResourceMap",t instanceof d?(this.map=new Map(t.map),this.toKey=r??d.defaultToKey):(this.map=new Map,this.toKey=t??d.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),new g(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r!="undefined"&&(t=t.bind(r));for(let[s,a]of this.map)t(a.value,a.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=d,d.defaultToKey=i=>i.toString();var y;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class c{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const s=this._map.get(t);if(!!s)return r!==0&&this.touch(s,r),s.value}set(t,r,s=0){let a=this._map.get(t);if(a)a.value=r,s!==0&&this.touch(a,s);else{switch(a={key:t,value:r,next:void 0,previous:void 0},s){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(!!r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const s=this._state;let a=this._head;for(;a;){if(r?t.bind(r)(a.value,a.key,this):t(a.value,a.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,r=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const m={value:s.key,done:!1};return s=s.next,m}else return{value:void 0,done:!0}}};return a}values(){const t=this,r=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const m={value:s.value,done:!1};return s=s.next,m}else return{value:void 0,done:!0}}};return a}entries(){const t=this,r=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const m={value:[s.key,s.value],done:!1};return s=s.next,m}else return{value:void 0,done:!0}}};return a}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,s=this.size;for(;r&&s>t;)this._map.delete(r.key),r=r.next,s--;this._head=r,this._size=s,r&&(r.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,s=t.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const s=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(s.previous=a,a.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const s=t.next,a=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=a,a.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,s)=>{t.push([s,r])}),t}fromJSON(t){this.clear();for(const[r,s]of t)this.set(r,s)}}e.LinkedMap=c;class o extends c{constructor(t,r=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(t){_.set(this,void 0),St(this,_,t,"f")}get size(){return et(this,_,"f").size}forEach(t,r){et(this,_,"f").forEach(t,r)}get(t){return et(this,_,"f").get(t)}has(t){return et(this,_,"f").has(t)}entries(){return et(this,_,"f").entries()}keys(){return et(this,_,"f").keys()}values(){return et(this,_,"f").values()}[(_=new WeakMap,Symbol.iterator)](){return et(this,_,"f").entries()}}e.ReadonlyMapView=l}),define(me[126],ve([0,1,31,15]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...B){return function(x,X){for(let fe=0,ye=B.length;fe<ye;fe++){const ke=B[fe](x,X);if(ke)return ke}return null}}e.or=w,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(B,x,X){if(!X||X.length<x.length)return null;let fe;return B?fe=n.startsWithIgnoreCase(X,x):fe=X.indexOf(x)===0,fe?x.length>0?[{start:0,end:x.length}]:[]:null}function _(B,x){const X=x.toLowerCase().indexOf(B.toLowerCase());return X===-1?null:[{start:X,end:X+B.length}]}e.matchesContiguousSubString=_;function D(B,x){return v(B.toLowerCase(),x.toLowerCase(),0,0)}e.matchesSubString=D;function v(B,x,X,fe){if(X===B.length)return[];if(fe===x.length)return null;if(B[X]===x[fe]){let ye=null;return(ye=v(B,x,X+1,fe+1))?h({start:fe,end:fe+1},ye):null}return v(B,x,X,fe+1)}function P(B){return 97<=B&&B<=122}function A(B){return 65<=B&&B<=90}e.isUpper=A;function T(B){return 48<=B&&B<=57}function E(B){return B===32||B===9||B===10||B===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(B=>b.add(B.charCodeAt(0)));function u(B){return E(B)||b.has(B)}function S(B,x){return B===x||u(B)&&u(x)}function f(B){return P(B)||A(B)||T(B)}function h(B,x){return x.length===0?x=[B]:B.end===x[0].start?x[0].start=B.start:x.unshift(B),x}function g(B,x){for(let X=x;X<B.length;X++){const fe=B.charCodeAt(X);if(A(fe)||T(fe)||X>0&&!f(B.charCodeAt(X-1)))return X}return B.length}function d(B,x,X,fe){if(X===B.length)return[];if(fe===x.length)return null;if(B[X]!==x[fe].toLowerCase())return null;{let ye=null,ke=fe+1;for(ye=d(B,x,X+1,fe+1);!ye&&(ke=g(x,ke))<x.length;)ye=d(B,x,X+1,ke),ke++;return ye===null?null:h({start:fe,end:fe+1},ye)}}function y(B){let x=0,X=0,fe=0,ye=0,ke=0;for(let we=0;we<B.length;we++)ke=B.charCodeAt(we),A(ke)&&x++,P(ke)&&X++,f(ke)&&fe++,T(ke)&&ye++;const Re=x/B.length,Ne=X/B.length,Ue=fe/B.length,se=ye/B.length;return{upperPercent:Re,lowerPercent:Ne,alphaPercent:Ue,numericPercent:se}}function c(B){const{upperPercent:x,lowerPercent:X}=B;return X===0&&x>.6}function o(B){const{upperPercent:x,lowerPercent:X,alphaPercent:fe,numericPercent:ye}=B;return X>.2&&x<.8&&fe>.6&&ye<.2}function l(B){let x=0,X=0,fe=0,ye=0;for(let ke=0;ke<B.length;ke++)fe=B.charCodeAt(ke),A(fe)&&x++,P(fe)&&X++,E(fe)&&ye++;return(x===0||X===0)&&ye===0?B.length<=30:x<=5}function i(B,x){if(!x||(x=x.trim(),x.length===0)||!l(B)||x.length>60)return null;const X=y(x);if(!o(X)){if(!c(X))return null;x=x.toLowerCase()}let fe=null,ye=0;for(B=B.toLowerCase();ye<x.length&&(fe=d(B,x,0,ye))===null;)ye=g(x,ye+1);return fe}e.matchesCamelCase=i;function t(B,x,X=!1){if(!x||x.length===0)return null;let fe=null,ye=0;for(B=B.toLowerCase(),x=x.toLowerCase();ye<x.length&&(fe=r(B,x,0,ye,X))===null;)ye=s(x,ye+1);return fe}e.matchesWords=t;function r(B,x,X,fe,ye){if(X===B.length)return[];if(fe===x.length)return null;if(S(B.charCodeAt(X),x.charCodeAt(fe))){let ke=null,Re=fe+1;if(ke=r(B,x,X+1,fe+1,ye),!ye)for(;!ke&&(Re=s(x,Re))<x.length;)ke=r(B,x,X+1,Re,ye),Re++;return ke===null?null:h({start:fe,end:fe+1},ke)}else return null}function s(B,x){for(let X=x;X<B.length;X++)if(u(B.charCodeAt(X))||X>0&&u(B.charCodeAt(X-1)))return X;return B.length}const a=w(e.matchesPrefix,i,_),m=w(e.matchesPrefix,i,D),p=new k.LRUCache(1e4);function R(B,x,X=!1){if(typeof B!="string"||typeof x!="string")return null;let fe=p.get(B);fe||(fe=new RegExp(n.convertSimple2RegExpPattern(B),"i"),p.set(B,fe));const ye=fe.exec(x);return ye?[{start:ye.index,end:ye.index+ye[0].length}]:X?m(B,x):a(B,x)}e.matchesFuzzy=R;function F(B,x){const X=J(B,B.toLowerCase(),0,x,x.toLowerCase(),0,!0);return X?G(X):null}e.matchesFuzzy2=F;function U(B,x,X,fe,ye,ke){const Re=Math.min(13,B.length);for(;X<Re;X++){const Ne=J(B,x,X,fe,ye,ke,!1);if(Ne)return Ne}return[0,ke]}e.anyScore=U;function G(B){if(typeof B=="undefined")return[];const x=[],X=B[1];for(let fe=B.length-1;fe>1;fe--){const ye=B[fe]+X,ke=x[x.length-1];ke&&ke.end===ye?ke.end=ye+1:x.push({start:ye,end:ye+1})}return x}e.createMatches=G;const C=128;function z(){const B=[],x=[];for(let X=0;X<=C;X++)x[X]=0;for(let X=0;X<=C;X++)B.push(x.slice(0));return B}function M(B){const x=[];for(let X=0;X<=B;X++)x[X]=0;return x}const q=M(2*C),Z=M(2*C),j=z(),$=z(),W=z(),Y=!1;function ie(B,x,X,fe,ye){function ke(Ne,Ue,se=" "){for(;Ne.length<Ue;)Ne=se+Ne;return Ne}let Re=` |   |${fe.split("").map(Ne=>ke(Ne,3)).join("|")}
`;for(let Ne=0;Ne<=X;Ne++)Ne===0?Re+=" |":Re+=`${x[Ne-1]}|`,Re+=B[Ne].slice(0,ye+1).map(Ue=>ke(Ue.toString(),3)).join("|")+`
`;return Re}function re(B,x,X,fe){B=B.substr(x),X=X.substr(fe),console.log(ie($,B,B.length,X,X.length)),console.log(ie(W,B,B.length,X,X.length)),console.log(ie(j,B,B.length,X,X.length))}function oe(B,x){if(x<0||x>=B.length)return!1;const X=B.codePointAt(x);switch(X){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!n.isEmojiImprecise(X)}}function ue(B,x){if(x<0||x>=B.length)return!1;switch(B.charCodeAt(x)){case 32:case 9:return!0;default:return!1}}function de(B,x,X){return x[B]!==X[B]}function H(B,x,X,fe,ye,ke,Re=!1){for(;x<X&&ye<ke;)B[x]===fe[ye]&&(Re&&(q[x]=ye),x+=1),ye+=1;return x===X}e.isPatternInWord=H;var O;(function(B){B[B.Diag=1]="Diag",B[B.Left=2]="Left",B[B.LeftLeft=3]="LeftLeft"})(O||(O={}));var V;(function(B){B.Default=[-100,0];function x(X){return!X||X.length===2&&X[0]===-100&&X[1]===0}B.isDefault=x})(V=e.FuzzyScore||(e.FuzzyScore={}));function J(B,x,X,fe,ye,ke,Re){const Ne=B.length>C?C:B.length,Ue=fe.length>C?C:fe.length;if(X>=Ne||ke>=Ue||Ne-X>Ue-ke||!H(x,X,Ne,ye,ke,Ue,!0))return;ae(Ne,Ue,X,ke,x,ye);let se=1,we=1,Ee=X,Ae=ke;const Fe=[!1];for(se=1,Ee=X;Ee<Ne;se++,Ee++){const ne=q[Ee],be=Z[Ee],Pe=Ee+1<Ne?Z[Ee+1]:Ue;for(we=ne-ke+1,Ae=ne;Ae<Pe;we++,Ae++){let Le=Number.MIN_SAFE_INTEGER,Me=!1;Ae<=be&&(Le=ge(B,x,Ee,X,fe,ye,Ae,Ue,ke,j[se-1][we-1]===0,Fe));let Ve=0;Le!==Number.MAX_SAFE_INTEGER&&(Me=!0,Ve=Le+$[se-1][we-1]);const ze=Ae>ne,qe=ze?$[se][we-1]+(j[se][we-1]>0?-5:0):0,Xe=Ae>ne+1&&j[se][we-1]>0,Ge=Xe?$[se][we-2]+(j[se][we-2]>0?-5:0):0;if(Xe&&(!ze||Ge>=qe)&&(!Me||Ge>=Ve))$[se][we]=Ge,W[se][we]=3,j[se][we]=0;else if(ze&&(!Me||qe>=Ve))$[se][we]=qe,W[se][we]=2,j[se][we]=0;else if(Me)$[se][we]=Ve,W[se][we]=1,j[se][we]=j[se-1][we-1]+1;else throw new Error("not possible")}}if(Y&&re(B,X,fe,ke),!Fe[0]&&!Re)return;se--,we--;const je=[$[se][we],ke];let We=0,He=0;for(;se>=1;){let ne=we;do{const be=W[se][ne];if(be===3)ne=ne-2;else if(be===2)ne=ne-1;else break}while(ne>=1);We>1&&x[X+se-1]===ye[ke+we-1]&&!de(ne+ke-1,fe,ye)&&We+1>j[se][ne]&&(ne=we),ne===we?We++:We=1,He||(He=ne),se--,we=ne-1,je.push(we)}Ue===Ne&&(je[0]+=2);const Ke=He-Ne;return je[0]-=Ke,je}e.fuzzyScore=J;function ae(B,x,X,fe,ye,ke){let Re=B-1,Ne=x-1;for(;Re>=X&&Ne>=fe;)ye[Re]===ke[Ne]&&(Z[Re]=Ne,Re--),Ne--}function ge(B,x,X,fe,ye,ke,Re,Ne,Ue,se,we){if(x[X]!==ke[Re])return Number.MIN_SAFE_INTEGER;let Ee=1,Ae=!1;return Re===X-fe?Ee=B[X]===ye[Re]?7:5:de(Re,ye,ke)&&(Re===0||!de(Re-1,ye,ke))?(Ee=B[X]===ye[Re]?7:5,Ae=!0):oe(ke,Re)&&(Re===0||!oe(ke,Re-1))?Ee=5:(oe(ke,Re-1)||ue(ke,Re-1))&&(Ee=5,Ae=!0),Ee>1&&X===fe&&(we[0]=!0),Ae||(Ae=de(Re,ye,ke)||oe(ke,Re-1)||ue(ke,Re-1)),X===fe?Re>Ue&&(Ee-=Ae?3:5):se?Ee+=Ae?2:0:Ee+=Ae?0:1,Re+1===Ne&&(Ee-=Ae?3:5),Ee}function he(B,x,X,fe,ye,ke,Re){return pe(B,x,X,fe,ye,ke,!0,Re)}e.fuzzyScoreGracefulAggressive=he;function le(B,x,X,fe,ye,ke,Re){return pe(B,x,X,fe,ye,ke,!1,Re)}e.fuzzyScoreGraceful=le;function pe(B,x,X,fe,ye,ke,Re,Ne){let Ue=J(B,x,X,fe,ye,ke,Ne);if(Ue&&!Re)return Ue;if(B.length>=3){const se=Math.min(7,B.length-1);for(let we=X+1;we<se;we++){const Ee=Q(B,we);if(Ee){const Ae=J(Ee,Ee.toLowerCase(),X,fe,ye,ke,Ne);Ae&&(Ae[0]-=3,(!Ue||Ae[0]>Ue[0])&&(Ue=Ae))}}}return Ue}function Q(B,x){if(x+1>=B.length)return;const X=B[x],fe=B[x+1];if(X!==fe)return B.slice(0,x)+fe+X+B.slice(x+2)}}),define(me[127],ve([0,1,38,126,15]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(k.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${I.source}`,"g");function v(f){return f.replace(D,(h,g)=>g?h:`\\${h}`)}e.escapeIcons=v;const P=new RegExp(`\\\\${I.source}`,"g");function A(f){return f.replace(P,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=A;const T=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function E(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(T,(h,g,d,y)=>d?h:g||y||"")}e.stripIcons=E;function b(f){const h=f.indexOf(e.iconStartMarker);return h===-1?{text:f}:u(f,h)}e.parseLabelWithIcons=b;function u(f,h){const g=[];let d="";function y(a){if(a){d+=a;for(const m of a)g.push(l)}}let c=-1,o="",l=0,i,t,r=h;const s=f.length;for(y(f.substr(0,h));r<s;)i=f[r],t=f[r+1],i===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(c=r,y(o),o=e.iconStartMarker,r++):i===")"&&c!==-1?(l+=r-c+1,c=-1,o=""):c!==-1?_.test(i)?o+=i:(y(o),c=-1,o=""):y(i),r++;return y(o),{text:d,iconOffsets:g}}function S(f,h,g=!1){const{text:d,iconOffsets:y}=h;if(!y||y.length===0)return(0,n.matchesFuzzy)(f,d,g);const c=(0,w.ltrim)(d," "),o=d.length-c.length,l=(0,n.matchesFuzzy)(f,c,g);if(l)for(const i of l){const t=y[i.start+o]+o;i.start+=t,i.end+=t}return l}e.matchesFuzzyIconAware=S}),define(me[76],ve([0,1,31]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new k.LRUCache(1e4);function w(P){return v(P,"NFC",n)}e.normalizeNFC=w;const I=new k.LRUCache(1e4);function _(P){return v(P,"NFD",I)}e.normalizeNFD=_;const D=/[^\u0000-\u0080]/;function v(P,A,T){if(!P)return P;const E=T.get(P);if(E)return E;let b;return D.test(P)?b=P.normalize(A):b=P,T.set(P,b),b}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(A){return _(A).replace(P,"")}}()}),define(me[128],ve([0,1,15]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(n||(n={})),function(w){const I="error",_="warning",D="warn",v="info",P="ignore";function A(E){return E?k.equalsIgnoreCase(I,E)?w.Error:k.equalsIgnoreCase(_,E)||k.equalsIgnoreCase(D,E)?w.Warning:k.equalsIgnoreCase(v,E)?w.Info:w.Ignore:w.Ignore}w.fromValue=A;function T(E){switch(E){case w.Error:return I;case w.Warning:return _;case w.Info:return v;default:return P}}w.toString=T}(n||(n={})),e.default=n}),define(me[12],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(a){return Array.isArray(a)}e.isArray=k;function n(a){return typeof a=="string"}e.isString=n;function w(a){return Array.isArray(a)&&a.every(m=>n(m))}e.isStringArray=w;function I(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=I;function _(a){return typeof a=="object"&&(a instanceof Uint8Array||a instanceof Uint16Array||a instanceof Uint32Array||a instanceof Float32Array||a instanceof Float64Array||a instanceof Int8Array||a instanceof Int16Array||a instanceof Int32Array||a instanceof BigInt64Array||a instanceof BigUint64Array||a instanceof Uint8ClampedArray)}e.isTypedArray=_;function D(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=D;function v(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=v;function P(a){return a===!0||a===!1}e.isBoolean=P;function A(a){return typeof a=="undefined"}e.isUndefined=A;function T(a){return!E(a)}e.isDefined=T;function E(a){return A(a)||a===null}e.isUndefinedOrNull=E;function b(a,m){if(!a)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=b;function u(a){if(E(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=u;function S(...a){const m=[];for(let p=0;p<a.length;p++){const R=a[p];if(E(R))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);m.push(R)}return m}e.assertAllDefined=S;const f=Object.prototype.hasOwnProperty;function h(a){if(!I(a))return!1;for(let m in a)if(f.call(a,m))return!1;return!0}e.isEmptyObject=h;function g(a){return typeof a=="function"}e.isFunction=g;function d(...a){return a.length>0&&a.every(g)}e.areFunctions=d;function y(a,m){const p=Math.min(a.length,m.length);for(let R=0;R<p;R++)c(a[R],m[R])}e.validateConstraints=y;function c(a,m){if(n(m)){if(typeof a!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(g(m)){try{if(a instanceof m)return}catch{}if(!E(a)&&a.constructor===m||m.length===1&&m.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function o(a){let m=[],p=Object.getPrototypeOf(a);for(;Object.prototype!==p;)m=m.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return m}e.getAllPropertyNames=o;function l(a){const m=[];for(const p of o(a))typeof a[p]=="function"&&m.push(p);return m}e.getAllMethodNames=l;function i(a,m){const p=F=>function(){const U=Array.prototype.slice.call(arguments,0);return m(F,U)};let R={};for(const F of a)R[F]=p(F);return R}e.createProxyObject=i;function t(a){return a===null?void 0:a}e.withNullAsUndefined=t;function r(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=r;function s(a,m="Unreachable"){throw new Error(m)}e.assertNever=s}),define(me[33],ve([0,1,5,3,15,12]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function D(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=D;function v(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=v;function P(r,s=k.posix.sep){if(!r)return"";const a=r.length,m=r.charCodeAt(0);if(_(m)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let R=3;const F=R;for(;R<a&&!_(r.charCodeAt(R));R++);if(F!==R&&!_(r.charCodeAt(R+1))){for(R+=1;R<a;R++)if(_(r.charCodeAt(R)))return r.slice(0,R+1).replace(/[\\/]/g,s)}}return s}else if(h(m)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<a;p++)if(_(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=P;function A(r){if(!n.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let a=2;const m=a;for(;a<r.length&&(s=r.charCodeAt(a),s!==92);a++);return!(m===a||(s=r.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=A;const T=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(r,s=n.isWindows){const a=s?T:E;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||s&&b.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=u;function S(r,s,a){const m=r===s;return!a||m?m:!r||!s?!1:(0,w.equalsIgnoreCase)(r,s)}e.isEqual=S;function f(r,s,a,m=k.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(a){if(!(0,w.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let R=s.length;return s.charAt(s.length-1)===m&&R--,r.charAt(R)===m}return s.charAt(s.length-1)!==m&&(s+=m),r.indexOf(s)===0}e.isEqualOrParent=f;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=h;function g(r,s){return n.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(s,r)),r=(0,k.normalize)(r),n.isWindows?(r=(0,w.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,w.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=g;function d(r){const s=(0,k.normalize)(r);return n.isWindows?r.length>3?!1:y(s)&&(r.length===2||s.charCodeAt(2)===92):s===k.posix.sep}e.isRootOrDriveLetter=d;function y(r,s){return(s!==void 0?s:n.isWindows)?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function c(r){return y(r)?r[0]:void 0}e.getDriveLetter=c;function o(r,s,a){return s.length>r.length?-1:r===s?0:(a&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=o;function l(r){const s=r.split(":");let a,m,p;for(const R of s){const F=Number(R);(0,I.isNumber)(F)?m===void 0?m=F:p===void 0&&(p=F):a=a?[a,R].join(":"):R}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:m!==void 0?m:void 0,column:p!==void 0?p:m!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(r,s,a=8){let m="";for(let R=0;R<a;R++)m+=i.charAt(Math.floor(Math.random()*i.length));let p;return s?p=`${s}-${m}`:p=m,r?(0,k.join)(r,p):p}e.randomPath=t}),define(me[22],ve([0,1,12]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const f=Array.isArray(S)?[]:{};return Object.keys(S).forEach(h=>{S[h]&&typeof S[h]=="object"?f[h]=n(S[h]):f[h]=S[h]}),f}e.deepClone=n;function w(S){if(!S||typeof S!="object")return S;const f=[S];for(;f.length>0;){const h=f.shift();Object.freeze(h);for(const g in h)if(I.call(h,g)){const d=h[g];typeof d=="object"&&!Object.isFrozen(d)&&!(0,k.isTypedArray)(d)&&f.push(d)}}return S}e.deepFreeze=w;const I=Object.prototype.hasOwnProperty;function _(S,f){return D(S,f,new Set)}e.cloneAndChange=_;function D(S,f,h){if((0,k.isUndefinedOrNull)(S))return S;const g=f(S);if(typeof g!="undefined")return g;if((0,k.isArray)(S)){const d=[];for(const y of S)d.push(D(y,f,h));return d}if((0,k.isObject)(S)){if(h.has(S))throw new Error("Cannot clone recursive data-structure");h.add(S);const d={};for(let y in S)I.call(S,y)&&(d[y]=D(S[y],f,h));return h.delete(S),d}return S}function v(S,f,h=!0){return(0,k.isObject)(S)?((0,k.isObject)(f)&&Object.keys(f).forEach(g=>{g in S?h&&((0,k.isObject)(S[g])&&(0,k.isObject)(f[g])?v(S[g],f[g],h):S[g]=f[g]):S[g]=f[g]}),S):f}e.mixin=v;function P(S,f){if(S===f)return!0;if(S==null||f===null||f===void 0||typeof S!=typeof f||typeof S!="object"||Array.isArray(S)!==Array.isArray(f))return!1;let h,g;if(Array.isArray(S)){if(S.length!==f.length)return!1;for(h=0;h<S.length;h++)if(!P(S[h],f[h]))return!1}else{const d=[];for(g in S)d.push(g);d.sort();const y=[];for(g in f)y.push(g);if(y.sort(),!P(d,y))return!1;for(h=0;h<d.length;h++)if(!P(S[d[h]],f[d[h]]))return!1}return!0}e.equals=P;function A(S){const f=new Set;return JSON.stringify(S,(h,g)=>{if((0,k.isObject)(g)||Array.isArray(g)){if(f.has(g))return"[Circular]";f.add(g)}return g})}e.safeStringify=A;function T(S,f,h){const g=f(S);return typeof g=="undefined"?h:g}e.getOrDefault=T;function E(S,f){const h=Object.create(null);return!S||!f||Object.keys(f).forEach(d=>{const y=S[d],c=f[d];P(y,c)||(h[d]=c)}),h}e.distinct=E;function b(S,f){const h=f.toLowerCase(),g=Object.keys(S).find(d=>d.toLowerCase()===h);return g?S[g]:S[f]}e.getCaseInsensitive=b;function u(S,f){const h=Object.create(null);for(const[g,d]of Object.entries(S))f(g,d)&&(h[g]=d);return h}e.filter=u}),define(me[4],ve([0,1,5,3]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const w=/^\w[\w\d+.-]*$/,I=/^\//,_=/^\/\//;function D(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!w.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!I.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(i,t){return!i&&!t?"file":i}function P(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==T&&(t=T+t):t=T;break}return t}const A="",T="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(t,r,s,a,m,p=!1){typeof t=="object"?(this.scheme=t.scheme||A,this.authority=t.authority||A,this.path=t.path||A,this.query=t.query||A,this.fragment=t.fragment||A):(this.scheme=v(t,p),this.authority=r||A,this.path=P(this.scheme,s||A),this.query=a||A,this.fragment=m||A,D(this,p))}static isUri(t){return t instanceof b?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return d(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:s,path:a,query:m,fragment:p}=t;return r===void 0?r=this.scheme:r===null&&(r=A),s===void 0?s=this.authority:s===null&&(s=A),a===void 0?a=this.path:a===null&&(a=A),m===void 0?m=this.query:m===null&&(m=A),p===void 0?p=this.fragment:p===null&&(p=A),r===this.scheme&&s===this.authority&&a===this.path&&m===this.query&&p===this.fragment?this:new S(r,s,a,m,p)}static parse(t,r=!1){const s=E.exec(t);return s?new S(s[2]||A,l(s[4]||A),l(s[5]||A),l(s[7]||A),l(s[9]||A),r):new S(A,A,A,A,A)}static file(t){let r=A;if(n.isWindows&&(t=t.replace(/\\/g,T)),t[0]===T&&t[1]===T){const s=t.indexOf(T,2);s===-1?(r=t.substring(2),t=T):(r=t.substring(2,s),t=t.substring(s)||T)}return new S("file",r,t,A,A)}static from(t){const r=new S(t.scheme,t.authority,t.path,t.query,t.fragment);return D(r,!0),r}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return n.isWindows&&t.scheme==="file"?s=b.file(k.win32.join(d(t,!0),...r)).path:s=k.posix.join(t.path,...r),t.with({path:s})}toString(t=!1){return y(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof b)return t;{const r=new S(t);return r._formatted=t.external,r._fsPath=t._sep===u?t.fsPath:null,r}}else return t}}e.URI=b;const u=n.isWindows?1:void 0;class S extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(t=!1){return t?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=u),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,t){let r,s=-1;for(let a=0;a<i.length;a++){const m=i.charCodeAt(a);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||t&&m===47)s!==-1&&(r+=encodeURIComponent(i.substring(s,a)),s=-1),r!==void 0&&(r+=i.charAt(a));else{r===void 0&&(r=i.substr(0,a));const p=f[m];p!==void 0?(s!==-1&&(r+=encodeURIComponent(i.substring(s,a)),s=-1),r+=p):s===-1&&(s=a)}}return s!==-1&&(r+=encodeURIComponent(i.substring(s))),r!==void 0?r:i}function g(i){let t;for(let r=0;r<i.length;r++){const s=i.charCodeAt(r);s===35||s===63?(t===void 0&&(t=i.substr(0,r)),t+=f[s]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function d(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=d;function y(i,t){const r=t?g:h;let s="",{scheme:a,authority:m,path:p,query:R,fragment:F}=i;if(a&&(s+=a,s+=":"),(m||a==="file")&&(s+=T,s+=T),m){let U=m.indexOf("@");if(U!==-1){const G=m.substr(0,U);m=m.substr(U+1),U=G.indexOf(":"),U===-1?s+=r(G,!1):(s+=r(G.substr(0,U),!1),s+=":",s+=r(G.substr(U+1),!1)),s+="@"}m=m.toLowerCase(),U=m.indexOf(":"),U===-1?s+=r(m,!1):(s+=r(m.substr(0,U),!1),s+=m.substr(U))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const U=p.charCodeAt(1);U>=65&&U<=90&&(p=`/${String.fromCharCode(U+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const U=p.charCodeAt(0);U>=65&&U<=90&&(p=`${String.fromCharCode(U+32)}:${p.substr(2)}`)}s+=r(p,!0)}return R&&(s+="?",s+=r(R,!1)),F&&(s+="#",s+=t?F:h(F,!1)),s}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(i){return i.match(o)?i.replace(o,t=>c(t)):i}}),define(me[77],ve([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(P){const A=P;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.isRemoteConsoleLog=n;function w(P){const A=[];let T;try{const E=JSON.parse(P.arguments),b=E[E.length-1];b&&b.__$stack&&(E.pop(),T=b.__$stack),A.push(...E)}catch{A.push("Unable to log remote console arguments",P.arguments)}return{args:A,stack:T}}e.parse=w;function I(P){if(typeof P!="string")return I(w(P).stack);const A=P;if(A){const T=_(A),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(T||"");if(E&&E.length===4)return{uri:k.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=I;function _(P){if(!P)return P;const A=P.indexOf(`
`);return A===-1?P:P.substring(0,A)}function D(P,A){const{args:T,stack:E}=w(P),b=typeof T[0]=="string"&&T.length===1;let u=_(E);u&&(u=`(${u.trim()})`);let S=[];if(typeof T[0]=="string"?u&&b?S=[`%c[${A}] %c${T[0]} %c${u}`,v("blue"),v(""),v("grey")]:S=[`%c[${A}] %c${T[0]}`,v("blue"),v(""),...T.slice(1)]:S=[`%c[${A}]%`,v("blue"),...T],u&&!b&&S.push(u),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,S)}e.log=D;function v(P){return`color: ${P}`}}),define(me[50],ve([0,1,17,15,4]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(P){return JSON.stringify(P,D)}e.stringify=I;function _(P){let A=JSON.parse(P);return A=v(A),A}e.parse=_;function D(P,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,n.regExpFlags)(A)}:A}function v(P,A=0){if(!P||A>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return w.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof k.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let T=0;T<P.length;++T)P[T]=v(P[T],A+1);else for(const T in P)Object.hasOwnProperty.call(P,T)&&(P[T]=v(P[T],A+1))}return P}e.revive=v}),define(me[8],ve([0,1,3,4]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}set(v,P,A){this._hosts[v]=P,this._ports[v]=A}setConnectionToken(v,P){this._connectionTokens[v]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)return this._delegate(v);const P=v.authority;let A=this._hosts[P];A&&A.indexOf(":")!==-1&&(A=`[${A}]`);const T=this._ports[P],E=this._connectionTokens[P];let b=`path=${encodeURIComponent(v.path)}`;return typeof E=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),n.URI.from({scheme:k.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:k.isWeb?window.location.host:`${A}:${T}`,path:k.isWeb?n.URI.joinPath(n.URI.parse(window.location.href),"/vscode-remote-resource").path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new I;class _{asBrowserUri(v,P){const A=this.toUri(v,P);return A.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(A):A.scheme===w.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${w.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?A.with({scheme:w.vscodeFileResource,authority:A.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(v,P){const A=this.toUri(v,P);return A.scheme===w.vscodeFileResource?A.with({scheme:w.file,authority:A.authority!==_.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(v,P){return n.URI.isUri(v)?v:n.URI.parse(P.toUrl(v))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _}),define(me[20],ve([0,1,33,8,5,3,15,4]),function(ee,e,k,n,w,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(b){return(0,D.uriToFsPath)(b,!0)}e.originalFSPath=v;class P{constructor(u){this._ignorePathCasing=u}compare(u,S,f=!1){return u===S?0:(0,_.compare)(this.getComparisonKey(u,f),this.getComparisonKey(S,f))}isEqual(u,S,f=!1){return u===S?!0:!u||!S?!1:this.getComparisonKey(u,f)===this.getComparisonKey(S,f)}getComparisonKey(u,S=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,S,f=!1){if(u.scheme===S.scheme){if(u.scheme===n.Schemas.file)return k.isEqualOrParent(v(u),v(S),this._ignorePathCasing(u))&&u.query===S.query&&(f||u.fragment===S.fragment);if((0,e.isEqualAuthority)(u.authority,S.authority))return k.isEqualOrParent(u.path,S.path,this._ignorePathCasing(u),"/")&&u.query===S.query&&(f||u.fragment===S.fragment)}return!1}joinPath(u,...S){return D.URI.joinPath(u,...S)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return w.posix.basename(u.path)}extname(u){return w.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let S;return u.scheme===n.Schemas.file?S=D.URI.file(w.dirname(v(u))).path:(S=w.posix.dirname(u.path),u.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),S="/")),u.with({path:S})}normalizePath(u){if(!u.path.length)return u;let S;return u.scheme===n.Schemas.file?S=D.URI.file(w.normalize(v(u))).path:S=w.posix.normalize(u.path),u.with({path:S})}relativePath(u,S){if(u.scheme!==S.scheme||!(0,e.isEqualAuthority)(u.authority,S.authority))return;if(u.scheme===n.Schemas.file){const g=w.relative(v(u),v(S));return I.isWindows?k.toSlashes(g):g}let f=u.path||"/",h=S.path||"/";if(this._ignorePathCasing(u)){let g=0;for(const d=Math.min(f.length,h.length);g<d&&!(f.charCodeAt(g)!==h.charCodeAt(g)&&f.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);f=h.substr(0,g)+f.substr(g)}return w.posix.relative(f,h)}resolvePath(u,S){if(u.scheme===n.Schemas.file){const f=D.URI.file(w.resolve(v(u),S));return u.with({authority:f.authority,path:f.path})}return S=k.toPosixPath(S),u.with({path:w.posix.resolve(u.path,S)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,S){return u===S||u!==void 0&&S!==void 0&&(0,_.equalsIgnoreCase)(u,S)}hasTrailingPathSeparator(u,S=w.sep){if(u.scheme===n.Schemas.file){const f=v(u);return f.length>k.getRoot(f).length&&f[f.length-1]===S}else{const f=u.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,S=w.sep){return(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,S=w.sep){let f=!1;if(u.scheme===n.Schemas.file){const h=v(u);f=h!==void 0&&h.length===k.getRoot(h).length&&h[h.length-1]===S}else{S="/";const h=u.path;f=h.length===1&&h.charCodeAt(h.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path+"/"}):u}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(b=>b.scheme===n.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new P(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(b,u){const S=[];for(let f=0;f<b.length;f++){const h=u(b[f]);b.some((g,d)=>d===f?!1:(0,e.isEqualOrParent)(h,u(g)))||S.push(b[f])}return S}e.distinctParents=A;var T;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function u(S){const f=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(d=>{const[y,c]=d.split(":");y&&c&&f.set(y,c)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&f.set(b.META_DATA_MIME,g),f}b.parseMetaData=u})(T=e.DataUri||(e.DataUri={}));function E(b,u,S){if(u){let f=b.path;return f&&f[0]!==w.posix.sep&&(f=w.posix.sep+f),b.with({scheme:S,authority:u,path:f})}return b.with({scheme:S})}e.toLocalResource=E}),define(me[14],ve([0,1,21,9,7,2,20,3]),function(ee,e,k,n,w,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(de){return!!de&&typeof de.then=="function"}e.isThenable=v;function P(de){const H=new k.CancellationTokenSource,O=de(H.token),V=new Promise((J,ae)=>{const ge=H.token.onCancellationRequested(()=>{ge.dispose(),H.dispose(),ae(new n.CancellationError)});Promise.resolve(O).then(he=>{ge.dispose(),H.dispose(),J(he)},he=>{ge.dispose(),H.dispose(),ae(he)})});return new class{cancel(){H.cancel()}then(J,ae){return V.then(J,ae)}catch(J){return this.then(void 0,J)}finally(J){return V.finally(J)}}}e.createCancelablePromise=P;function A(de,H,O){return new Promise((V,J)=>{const ae=H.onCancellationRequested(()=>{ae.dispose(),V(O)});de.then(V,J).finally(()=>ae.dispose())})}e.raceCancellation=A;function T(de,H){return new Promise((O,V)=>{const J=H.onCancellationRequested(()=>{J.dispose(),V(new n.CancellationError)});de.then(O,V).finally(()=>J.dispose())})}e.raceCancellationError=T;async function E(de){let H=-1;const O=de.map((J,ae)=>J.then(ge=>(H=ae,ge))),V=await Promise.race(O);return de.forEach((J,ae)=>{ae!==H&&J.cancel()}),V}e.raceCancellablePromises=E;function b(de,H,O){let V;const J=setTimeout(()=>{V?.(void 0),O?.()},H);return Promise.race([de.finally(()=>clearTimeout(J)),new Promise(ae=>V=ae)])}e.raceTimeout=b;function u(de){return new Promise((H,O)=>{const V=de();v(V)?V.then(H,O):H(V)})}e.asPromise=u;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(H){if(this.activePromise){if(this.queuedPromiseFactory=H,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(O,O).then(V)})}return new Promise((O,V)=>{this.queuedPromise.then(O,V)})}return this.activePromise=H(),new Promise((O,V)=>{this.activePromise.then(J=>{this.activePromise=null,O(J)},J=>{this.activePromise=null,V(J)})})}}e.Throttler=S;class f{constructor(){this.current=Promise.resolve(null)}queue(H){return this.current=this.current.then(()=>H(),()=>H())}}e.Sequencer=f;class h{constructor(){this.promiseMap=new Map}queue(H,O){const J=(this.promiseMap.get(H)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(H)===J&&this.promiseMap.delete(H)});return this.promiseMap.set(H,J),J}}e.SequencerByKey=h;const g=(de,H)=>{let O=!0;const V=setTimeout(()=>{O=!1,H()},de);return{isTriggered:()=>O,dispose:()=>{clearTimeout(V),O=!1}}},d=de=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,de())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class y{constructor(H){this.defaultDelay=H,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(H,O=this.defaultDelay){this.task=H,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((J,ae)=>{this.doResolve=J,this.doReject=ae}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const J=this.task;return this.task=null,J()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?d(V):g(O,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=y;class c{constructor(H){this.delayer=new y(H),this.throttler=new S}trigger(H,O){return this.delayer.trigger(()=>this.throttler.queue(H),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class o{constructor(){this._isOpen=!1,this._promise=new Promise((H,O)=>{this._completePromise=H})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class l extends o{constructor(H){super();this._timeout=setTimeout(()=>this.open(),H)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function i(de,H){return H?new Promise((O,V)=>{const J=setTimeout(()=>{ae.dispose(),O()},de),ae=H.onCancellationRequested(()=>{clearTimeout(J),ae.dispose(),V(new n.CancellationError)})}):P(O=>i(de,O))}e.timeout=i;function t(de,H=0){const O=setTimeout(de,H);return(0,I.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function r(de){const H=[];let O=0;const V=de.length;function J(){return O<V?de[O++]():null}function ae(ge){ge!=null&&H.push(ge);const he=J();return he?he.then(ae):Promise.resolve(H)}return Promise.resolve(null).then(ae)}e.sequence=r;function s(de,H=V=>!!V,O=null){let V=0;const J=de.length,ae=()=>{if(V>=J)return Promise.resolve(O);const ge=de[V++];return Promise.resolve(ge()).then(le=>H(le)?Promise.resolve(le):ae())};return ae()}e.first=s;function a(de,H=V=>!!V,O=null){if(de.length===0)return Promise.resolve(O);let V=de.length;const J=()=>{V=-1;for(const ae of de)ae.cancel?.()};return new Promise((ae,ge)=>{for(const he of de)he.then(le=>{--V>=0&&H(le)?(J(),ae(le)):V===0&&ae(O)}).catch(le=>{--V>=0&&(J(),ge(le))})})}e.firstParallel=a;class m{constructor(H){this._size=0,this.maxDegreeOfParalellism=H,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(H){return this._size++,new Promise((O,V)=>{this.outstandingPromises.push({factory:H,c:O,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const H=this.outstandingPromises.shift();this.runningPromises++;const O=H.factory();O.then(H.c,H.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class p extends m{constructor(){super(1)}}e.Queue=p;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const H=new W;return this.drainers.add(H),H.p}isDrained(){for(const[,H]of this.queues)if(H.size>0)return!1;return!0}queueFor(H,O=_.extUri){const V=O.getComparisonKey(H);let J=this.queues.get(V);return J||(J=new p,w.Event.once(J.onDrained)(()=>{J?.dispose(),this.queues.delete(V),this.onDidQueueDrain()}),this.queues.set(V,J)),J}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const H of this.drainers)H.complete();this.drainers.clear()}dispose(){for(const[,H]of this.queues)H.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class F{constructor(H,O){this._token=-1,typeof H=="function"&&typeof O=="number"&&this.setIfNotSet(H,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(H,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,H()},O)}setIfNotSet(H,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,H()},O))}}e.TimeoutTimer=F;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(H,O){this.cancel(),this._token=setInterval(()=>{H()},O)}}e.IntervalTimer=U;class G{constructor(H,O){this.timeoutToken=-1,this.runner=H,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(H=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,H)}get delay(){return this.timeout}set delay(H){this.timeout=H}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=G;class C{constructor(H,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=H,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(H=this.timeout){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(H/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=C;class z extends G{constructor(H,O){super(H,O);this.units=[]}work(H){this.units.push(H),this.isScheduled()||this.schedule()}doRun(){const H=this.units;this.units=[],this.runner&&this.runner(H)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class M extends I.Disposable{constructor(H,O){super();this.options=H,this.handler=O,this.pendingWork=[],this.throttler=this._register(new I.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(H){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+H.length>this.options.maxBufferedWork)return!1}else if(this.pending+H.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...H),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new G(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,D.setTimeout0)(()=>{if(H)return;const O=Date.now()+15;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(de,H)=>{const O=requestIdleCallback(de,typeof H=="number"?{timeout:H}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(O))}}}}();class q{constructor(H){this._didRun=!1,this._executor=()=>{try{this._value=H()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function Z(de,H,O){let V;for(let J=0;J<O;J++)try{return await de()}catch(ae){V=ae,await i(H)}throw V}e.retry=Z;class j{hasPending(H){return this._pending?typeof H=="number"?this._pending.taskId===H:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(H,O,V){return this._pending={taskId:H,cancel:()=>V?.(),promise:O},O.then(()=>this.donePending(H),()=>this.donePending(H)),O}donePending(H){this._pending&&H===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const H=this._next;this._next=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this._next)this._next.run=H;else{let O,V;const J=new Promise((ae,ge)=>{O=ae,V=ge});this._next={run:H,promise:J,promiseResolve:O,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=j;class ${constructor(H,O=()=>Date.now()){this.interval=H,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const H=this.nowFn();return H-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=H,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((H,O)=>{this.completeCallback=H,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(H){return new Promise(O=>{this.completeCallback(H),this.resolved=!0,O()})}error(H){return new Promise(O=>{this.errorCallback(H),this.rejected=!0,O()})}cancel(){new Promise(H=>{this.errorCallback(new n.CancellationError),this.rejected=!0,H()})}}e.DeferredPromise=W;var Y;(function(de){async function H(V){let J;const ae=await Promise.all(V.map(ge=>ge.then(he=>he,he=>{J||(J=he)})));if(typeof J!="undefined")throw J;return ae}de.settled=H;function O(V){return new Promise(async(J,ae)=>{try{await V(J,ae)}catch(ge){ae(ge)}})}de.withAsyncBody=O})(Y=e.Promises||(e.Promises={}));var ie;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(ie||(ie={}));class re{constructor(H){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const O={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(H(O)),this.resolve()}catch(V){this.reject(V)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(H){return new re(O=>{O.emitMany(H)})}static fromPromise(H){return new re(async O=>{O.emitMany(await H)})}static fromPromises(H){return new re(async O=>{await Promise.all(H.map(async V=>O.emitOne(await V)))})}static merge(H){return new re(async O=>{await Promise.all(H.map(async V=>{for await(const J of V)O.emitOne(J)}))})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(H<this._results.length)return{done:!1,value:this._results[H++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(H,O){return new re(async V=>{for await(const J of H)V.emitOne(O(J))})}map(H){return re.map(this,H)}static filter(H,O){return new re(async V=>{for await(const J of H)O(J)&&V.emitOne(J)})}filter(H){return re.filter(this,H)}static coalesce(H){return re.filter(H,O=>!!O)}coalesce(){return re.coalesce(this)}static async toPromise(H){const O=[];for await(const V of H)O.push(V);return O}toPromise(){return re.toPromise(this)}emitOne(H){this._state===0&&(this._results.push(H),this._onStateChanged.fire())}emitMany(H){this._state===0&&(this._results=this._results.concat(H),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(H){this._state===0&&(this._state=2,this._error=H,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class oe extends re{constructor(H,O){super(O);this._source=H}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function ue(de){const H=new k.CancellationTokenSource,O=de(H.token);return new oe(H,async V=>{const J=H.token.onCancellationRequested(()=>{J.dispose(),H.dispose(),V.reject(new n.CancellationError)});try{for await(const ae of O){if(H.token.isCancellationRequested)return;V.emitOne(ae)}J.dispose(),H.dispose()}catch(ae){J.dispose(),H.dispose(),V.reject(ae)}})}e.createCancelableAsyncIterable=ue}),define(me[78],ve([0,1,14,33,31,5,3,15]),function(ee,e,k,n,w,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",A="[^/\\\\]",T=/\//g;function E(j,$){switch(j){case 0:return"";case 1:return`${A}*?`;default:return`(?:${P}|${A}+${P}${$?`|${P}${A}+`:""})*?`}}function b(j,$){if(!j)return[];const W=[];let Y=!1,ie=!1,re="";for(const oe of j){switch(oe){case $:if(!Y&&!ie){W.push(re),re="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}re+=oe}return re&&W.push(re),W}e.splitGlobAware=b;function u(j){if(!j)return"";let $="";const W=b(j,e.GLOB_SPLIT);if(W.every(Y=>Y===e.GLOBSTAR))$=".*";else{let Y=!1;W.forEach((ie,re)=>{if(ie===e.GLOBSTAR){if(Y)return;$+=E(2,re===W.length-1)}else{let oe=!1,ue="",de=!1,H="";for(const O of ie){if(O!=="}"&&oe){ue+=O;continue}if(de&&(O!=="]"||!H)){let V;O==="-"?V=O:(O==="^"||O==="!")&&!H?V="^":O===e.GLOB_SPLIT?V="":V=(0,D.escapeRegExpCharacters)(O),H+=V;continue}switch(O){case"{":oe=!0;continue;case"[":de=!0;continue;case"}":{$+=`(?:${b(ue,",").map(ae=>u(ae)).join("|")})`,oe=!1,ue="";break}case"]":{$+="["+H+"]",de=!1,H="";break}case"?":$+=A;continue;case"*":$+=E(1);continue;default:$+=(0,D.escapeRegExpCharacters)(O)}}re<W.length-1&&(W[re+1]!==e.GLOBSTAR||re+2<W.length)&&($+=P)}Y=ie===e.GLOBSTAR})}return $}const S=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new w.LRUCache(1e4),o=function(){return!1},l=function(){return null};function i(j,$){if(!j)return l;let W;typeof j!="string"?W=j.pattern:W=j,W=W.trim();const Y=`${W}_${!!$.trimForExclusions}`;let ie=c.get(Y);if(ie)return t(ie,j);let re;return S.test(W)?ie=s(W.substr(4),W):(re=f.exec(r(W,$)))?ie=a(re[1],W):($.trimForExclusions?g:h).test(W)?ie=m(W,$):(re=d.exec(r(W,$)))?ie=p(re[1].substr(1),W,!0):(re=y.exec(r(W,$)))?ie=p(re[1],W,!1):ie=R(W),c.set(Y,ie),t(ie,j)}function t(j,$){return typeof $=="string"?j:function(W,Y){return(0,n.isEqualOrParent)(W,$.base,!_.isLinux)?j(W.substr($.base.length+1),Y):null}}function r(j,$){return $.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function s(j,$){return function(W,Y){return typeof W=="string"&&W.endsWith(j)?$:null}}function a(j,$){const W=`/${j}`,Y=`\\${j}`,ie=function(oe,ue){return typeof oe!="string"?null:ue?ue===j?$:null:oe===j||oe.endsWith(W)||oe.endsWith(Y)?$:null},re=[j];return ie.basenames=re,ie.patterns=[$],ie.allBasenames=re,ie}function m(j,$){const W=Z(j.slice(1,-1).split(",").map(ue=>i(ue,$)).filter(ue=>ue!==l),j),Y=W.length;if(!Y)return l;if(Y===1)return W[0];const ie=function(ue,de){for(let H=0,O=W.length;H<O;H++)if(W[H](ue,de))return j;return null},re=W.find(ue=>!!ue.allBasenames);re&&(ie.allBasenames=re.allBasenames);const oe=W.reduce((ue,de)=>de.allPaths?ue.concat(de.allPaths):ue,[]);return oe.length&&(ie.allPaths=oe),ie}function p(j,$,W){const Y=I.sep===I.posix.sep,ie=Y?j:j.replace(T,I.sep),re=I.sep+ie,oe=I.posix.sep+j;let ue;return W?ue=function(de,H){return typeof de=="string"&&(de===ie||de.endsWith(re)||!Y&&(de===j||de.endsWith(oe)))?$:null}:ue=function(de,H){return typeof de=="string"&&(de===ie||!Y&&de===j)?$:null},ue.allPaths=[(W?"*/":"./")+j],ue}function R(j){try{const $=new RegExp(`^${u(j)}$`);return function(W){return $.lastIndex=0,typeof W=="string"&&$.test(W)?j:null}}catch{return l}}function F(j,$,W){return!j||typeof $!="string"?!1:U(j)($,void 0,W)}e.match=F;function U(j,$={}){if(!j)return o;if(typeof j=="string"||G(j)){const W=i(j,$);if(W===l)return o;const Y=function(ie,re){return!!W(ie,re)};return W.allBasenames&&(Y.allBasenames=W.allBasenames),W.allPaths&&(Y.allPaths=W.allPaths),Y}return M(j,$)}e.parse=U;function G(j){const $=j;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}e.isRelativePattern=G;function C(j){return j.allBasenames||[]}e.getBasenameTerms=C;function z(j){return j.allPaths||[]}e.getPathTerms=z;function M(j,$){const W=Z(Object.getOwnPropertyNames(j).map(ue=>q(ue,j[ue],$)).filter(ue=>ue!==l)),Y=W.length;if(!Y)return l;if(!W.some(ue=>!!ue.requiresSiblings)){if(Y===1)return W[0];const ue=function(O,V){for(let J=0,ae=W.length;J<ae;J++){const ge=W[J](O,V);if(ge)return ge}return null},de=W.find(O=>!!O.allBasenames);de&&(ue.allBasenames=de.allBasenames);const H=W.reduce((O,V)=>V.allPaths?O.concat(V.allPaths):O,[]);return H.length&&(ue.allPaths=H),ue}const ie=function(ue,de,H){let O;for(let V=0,J=W.length;V<J;V++){const ae=W[V];ae.requiresSiblings&&H&&(de||(de=(0,I.basename)(ue)),O||(O=de.substr(0,de.length-(0,I.extname)(ue).length)));const ge=ae(ue,de,O,H);if(ge)return ge}return null},re=W.find(ue=>!!ue.allBasenames);re&&(ie.allBasenames=re.allBasenames);const oe=W.reduce((ue,de)=>de.allPaths?ue.concat(de.allPaths):ue,[]);return oe.length&&(ie.allPaths=oe),ie}function q(j,$,W){if($===!1)return l;const Y=i(j,W);if(Y===l)return l;if(typeof $=="boolean")return Y;if($){const ie=$.when;if(typeof ie=="string"){const re=(oe,ue,de,H)=>{if(!H||!Y(oe,ue))return null;const O=ie.replace("$(basename)",de),V=H(O);return(0,k.isThenable)(V)?V.then(J=>J?j:null):V?j:null};return re.requiresSiblings=!0,re}}return Y}function Z(j,$){const W=j.filter(ue=>!!ue.basenames);if(W.length<2)return j;const Y=W.reduce((ue,de)=>{const H=de.basenames;return H?ue.concat(H):ue},[]);let ie;if($){ie=[];for(let ue=0,de=Y.length;ue<de;ue++)ie.push($)}else ie=W.reduce((ue,de)=>{const H=de.patterns;return H?ue.concat(H):ue},[]);const re=function(ue,de){if(typeof ue!="string")return null;if(!de){let O;for(O=ue.length;O>0;O--){const V=ue.charCodeAt(O-1);if(V===47||V===92)break}de=ue.substr(O)}const H=Y.indexOf(de);return H!==-1?ie[H]:null};re.basenames=Y,re.patterns=ie,re.allBasenames=Y;const oe=j.filter(ue=>!ue.basenames);return oe.push(re),oe}}),define(me[79],ve([0,1,9,127,20,15,4]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(S){S[S.Paragraph=0]="Paragraph",S[S.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class v{constructor(f="",h=!1){if(this.value=f,typeof this.value!="string")throw(0,k.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(f,h=0){return this.value+=E(this.supportThemeIcons?(0,n.escapeIcons)(f):f).replace(/([ \t]+)/g,(g,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,h){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(f,h,g){return this.value+="[",this.value+=this._escape(h,"]"),this.value+="](",this.value+=this._escape(String(f),")"),g&&(this.value+=` "${this._escape(this._escape(g,'"'),")")}"`),this.value+=")",this}_escape(f,h){const g=new RegExp((0,I.escapeRegExpCharacters)(h),"g");return f.replace(g,(d,y)=>f.charAt(y-1)!=="\\"?`\\${d}`:d)}}e.MarkdownString=v;function P(S){return A(S)?!S.value:Array.isArray(S)?S.every(P):!0}e.isEmptyMarkdownString=P;function A(S){return S instanceof v?!0:S&&typeof S=="object"?typeof S.value=="string"&&(typeof S.isTrusted=="boolean"||S.isTrusted===void 0)&&(typeof S.supportThemeIcons=="boolean"||S.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function T(S,f){return S===f?!0:!S||!f?!1:S.value===f.value&&S.isTrusted===f.isTrusted&&S.supportThemeIcons===f.supportThemeIcons&&S.supportHtml===f.supportHtml&&(S.baseUri===f.baseUri||!!S.baseUri&&!!f.baseUri&&(0,w.isEqual)(_.URI.from(S.baseUri),_.URI.from(f.baseUri)))}e.markdownStringEqual=T;function E(S){return S.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function b(S){return S&&S.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function u(S){const f=[],h=S.split("|").map(d=>d.trim());S=h[0];const g=h[1];if(g){const d=/height=(\d+)/.exec(g),y=/width=(\d+)/.exec(g),c=d?d[1]:"",o=y?y[1]:"",l=isFinite(parseInt(o)),i=isFinite(parseInt(c));l&&f.push(`width="${o}"`),i&&f.push(`height="${c}"`)}return{href:S,dimensions:f}}e.parseHrefAndDimensions=u}),define(me[80],ve([0,1,33,8,5,3,20,15,4]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(t,r,s){if(typeof t=="string"&&(t=v.URI.file(t)),s){const m=s.getWorkspaceFolder(t);if(m){const p=s.getWorkspace().folders.length>1;let R;if((0,_.isEqual)(m.uri,t)?R="":R=(0,_.relativePath)(m.uri,t),p){const F=m.name?m.name:(0,_.basename)(m.uri);R=R?F+" \u2022 "+R:F}return R}}if(t.scheme!==n.Schemas.file&&t.scheme!==n.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,k.hasDriveLetter)(t.fsPath))return(0,w.normalize)(T(t.fsPath));let a=(0,w.normalize)(t.fsPath);return!I.isWindows&&r?.userHome&&(a=b(a,r.userHome.fsPath)),a}e.getPathLabel=P;function A(t){if(!t)return;typeof t=="string"&&(t=v.URI.file(t));const r=(0,_.basename)(t)||(t.scheme===n.Schemas.file?t.fsPath:t.path);return I.isWindows&&(0,k.isRootOrDriveLetter)(r)?T(r):r}e.getBaseLabel=A;function T(t,r){return(0,k.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=T;let E=Object.create(null);function b(t,r){if(I.isWindows||!t||!r)return t;let s=E.original===r?E.normalized:void 0;return s||(s=`${(0,D.rtrim)(r,w.posix.sep)}${w.posix.sep}`,E={original:r,normalized:s}),(I.isLinux?t.startsWith(s):(0,D.startsWithIgnoreCase)(t,s))&&(t=`~/${t.substr(s.length)}`),t}e.tildify=b;function u(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=u;const S="\u2026",f="\\\\",h="~";function g(t,r=w.sep){const s=new Array(t.length);let a=!1;for(let m=0;m<t.length;m++){let p=t[m];if(p===""){s[m]=`.${r}`;continue}if(!p){s[m]=p;continue}a=!0;let R="";p.indexOf(f)===0?(R=p.substr(0,p.indexOf(f)+f.length),p=p.substr(p.indexOf(f)+f.length)):p.indexOf(r)===0?(R=p.substr(0,p.indexOf(r)+r.length),p=p.substr(p.indexOf(r)+r.length)):p.indexOf(h)===0&&(R=p.substr(0,p.indexOf(h)+h.length),p=p.substr(p.indexOf(h)+h.length));const F=p.split(r);for(let U=1;a&&U<=F.length;U++)for(let G=F.length-U;a&&G>=0;G--){a=!1;let C=F.slice(G,G+U).join(r);for(let z=0;!a&&z<t.length;z++)if(z!==m&&t[z]&&t[z].indexOf(C)>-1){const M=G+U===F.length,q=G>0&&t[z].indexOf(r)>-1?r+C:C,Z=t[z].endsWith(q);a=!M||Z}if(!a){let z="";(F[0].endsWith(":")||R!=="")&&(G===1&&(G=0,U++,C=F[0]+r+C),G>0&&(z=F[0]+r),z=R+z),G>0&&(z=z+S+r),z=z+C,G+U<F.length&&(z=z+r+S),s[m]=z}}a&&(s[m]=p)}return s}e.shorten=g;var d;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function y(t,r=Object.create(null)){const s=[];let a=!1,m="";for(const p of t)if(p==="$"||a&&p==="{")m&&s.push({value:m,type:d.TEXT}),m="",a=!0;else if(p==="}"&&a){const R=r[m];if(typeof R=="string")R.length&&s.push({value:R,type:d.VARIABLE});else if(R){const F=s[s.length-1];(!F||F.type!==d.SEPARATOR)&&s.push({value:R.label,type:d.SEPARATOR})}m="",a=!1}else m+=p;return m&&!a&&s.push({value:m,type:d.TEXT}),s.filter((p,R)=>{if(p.type===d.SEPARATOR){const F=s[R-1],U=s[R+1];return[F,U].every(G=>G&&(G.type===d.VARIABLE||G.type===d.TEXT)&&G.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=y;function c(t,r){return I.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):t.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function o(t,r){return I.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):I.isWindows?t.replace(/&&|&/g,s=>s==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function l(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=l;function i(t){const r=t.indexOf("/")!==-1?w.posix:w.win32,s=r.basename(t),a=r.dirname(t);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=i}),define(me[61],ve([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(A){return A.toJSON()}class w{constructor(T){this._uriTransformer=T}transformIncoming(T){const E=this._uriTransformer.transformIncoming(T);return E===T?T:n(k.URI.from(E))}transformOutgoing(T){const E=this._uriTransformer.transformOutgoing(T);return E===T?T:n(k.URI.from(E))}transformOutgoingURI(T){const E=this._uriTransformer.transformOutgoing(T);return E===T?T:k.URI.from(E)}transformOutgoingScheme(T){return this._uriTransformer.transformOutgoingScheme(T)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function I(A,T,E){if(!A||E>200)return null;if(typeof A=="object"){if(A instanceof k.URI)return T.transformOutgoing(A);for(let b in A)if(Object.hasOwnProperty.call(A,b)){const u=I(A[b],T,E+1);u!==null&&(A[b]=u)}}return null}function _(A,T){const E=I(A,T,0);return E===null?A:E}e.transformOutgoingURIs=_;function D(A,T,E,b){if(!A||b>200)return null;if(typeof A=="object"){if(A.$mid===1)return E?k.URI.revive(T.transformIncoming(A)):T.transformIncoming(A);for(let u in A)if(Object.hasOwnProperty.call(A,u)){const S=D(A[u],T,E,b+1);S!==null&&(A[u]=S)}}return null}function v(A,T){const E=D(A,T,!1,0);return E===null?A:E}e.transformIncomingURIs=v;function P(A,T){const E=D(A,T,!0,0);return E===null?A:E}e.transformAndReviveIncomingURIs=P}),define(me[23],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(v){return k.test(v)}e.isUUID=n;const w=new Uint8Array(16),I=[];for(let v=0;v<256;v++)I.push(v.toString(16).padStart(2,"0"));let _;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?_=crypto.getRandomValues.bind(crypto):_=function(v){for(let P=0;P<v.length;P++)v[P]=Math.floor(Math.random()*256);return v};function D(){_(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let v=0,P="";return P+=I[w[v++]],P+=I[w[v++]],P+=I[w[v++]],P+=I[w[v++]],P+="-",P+=I[w[v++]],P+=I[w[v++]],P+="-",P+=I[w[v++]],P+=I[w[v++]],P+="-",P+=I[w[v++]],P+=I[w[v++]],P+="-",P+=I[w[v++]],P+=I[w[v++]],P+=I[w[v++]],P+=I[w[v++]],P+=I[w[v++]],P+=I[w[v++]],P}e.generateUuid=D}),define(me[129],ve([0,1,258]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(I="utf8"){this.stringDecoder=new k.StringDecoder(I),this.remaining=null}write(I){const _=[],D=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(D.length<1)return _;let v=0,P,A=v;for(;A<D.length;)if(P=D.charCodeAt(A),P===13||P===10){if(_.push(D.substring(v,A)),A++,A<D.length){const T=P;P=D.charCodeAt(A),(T===13&&P===10||T===10&&P===13)&&A++}v=A}else A++;return this.remaining=v<D.length?D.substr(v):null,_}end(){return this.remaining}}e.LineDecoder=n}),function(){"use strict";function ee(e,k,n,w){function I(u){return new Promise(S=>n.exists(u,S))}function _(u){return new Promise((S,f)=>{const h=new Date;n.utimes(u,h,h,g=>g?f(g):S())})}function D(u){return new Promise((S,f)=>n.mkdir(u,{recursive:!0},h=>h&&h.code!=="EEXIST"?f(h):S(u)))}function v(u){return new Promise((S,f)=>n.rm(u,{recursive:!0,force:!0,maxRetries:3},h=>h?f(h):S()))}function P(u){return new Promise((S,f)=>n.readFile(u,"utf8",(h,g)=>h?f(h):S(g)))}function A(u,S){return new Promise((f,h)=>n.writeFile(u,S,"utf8",g=>g?h(g):f()))}function T(u){const S=k.join(u,"languagepacks.json");try{return e(S)}catch{}}function E(u,S){try{for(;S;){if(u[S])return S;{const f=S.lastIndexOf("-");if(f>0)S=S.substring(0,f);else return}}}catch(f){console.error("Resolving language pack configuration failed.",f)}}function b(u,S,f,h){if(h==="pseudo")return Promise.resolve({locale:h,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:h,availableLanguages:{}});if(h&&(h==="en"||h==="en-us"))return Promise.resolve({locale:h,availableLanguages:{}});const g=h;w.mark("code/willGenerateNls");const d=function(y){return w.mark("code/didGenerateNls"),Promise.resolve({locale:y,availableLanguages:{}})};try{if(!u)return d(g);const y=T(S);if(!y||(h=E(y,h),!h))return d(g);const c=y[h];let o;return!c||typeof c.hash!="string"||!c.translations||typeof(o=c.translations.vscode)!="string"?d(g):I(o).then(l=>{if(!l)return d(g);const i=c.hash+"."+h,t=k.join(S,"clp",i),r=k.join(t,u),s=k.join(t,"tcf.json"),a=k.join(t,"corrupted.info"),m={locale:g,availableLanguages:{"*":h},_languagePackId:i,_translationsConfigFile:s,_cacheRoot:t,_resolvedLanguagePackCoreLocation:r,_corruptedFile:a};return I(a).then(p=>{let R;return p?R=v(t):R=Promise.resolve(void 0),R.then(()=>I(r).then(F=>F?(_(r).catch(()=>{}),w.mark("code/didGenerateNls"),m):D(r).then(()=>Promise.all([P(f),P(o)])).then(U=>{const G=JSON.parse(U[0]),C=JSON.parse(U[1]).contents,z=Object.keys(G.bundles),M=[];for(const q of z){const Z=G.bundles[q],j=Object.create(null);for(const $ of Z){const W=G.keys[$],Y=G.messages[$],ie=C[$];let re;if(ie){re=[];for(let oe=0;oe<W.length;oe++){const ue=W[oe],de=typeof ue=="string"?ue:ue.key;let H=ie[de];H===void 0&&(H=Y[oe]),re.push(H)}}else re=Y;j[$]=re}M.push(A(k.join(r,q.replace(/\//g,"!")+".nls.json"),JSON.stringify(j)))}return M.push(A(s,JSON.stringify(c.translations))),Promise.all(M)}).then(()=>(w.mark("code/didGenerateNls"),m)).catch(U=>(console.error("Generating translation files failed.",U),d(h)))))})})}catch(y){return console.error("Generating translation files failed.",y),d(h)}}return{getNLSConfiguration:b}}if(typeof define=="function")define(me[130],ve([0,81,28,44]),function(e,k,n,w){return ee(e.__$__nodeRequire,k,n,w)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("fs"),n=require("../common/performance");module.exports=ee(require,e,k,n)}else throw new Error("Unknown context")}(),define(me[131],ve([0,1,24]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function w(_){const D=_.replace(/\-/g,":").toLowerCase();return!n.has(D)}function I(){const _=(0,k.networkInterfaces)();for(let D in _){const v=_[D];if(v){for(const{mac:P}of v)if(w(P))return P}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=I}),define(me[82],ve([0,1,24,9,31,23,131]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(A){return this._virtualMachineOUIs||(this._virtualMachineOUIs=w.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(A)}value(){if(this._value===void 0){let A=0,T=0;const E=(0,k.networkInterfaces)();for(let b in E){const u=E[b];if(u)for(const{mac:S,internal:f}of u)f||(T+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(A+=1))}this._value=T>0?A/T:0}return this._value}};let D;async function v(){return D||(D=(async()=>await P()||I.generateUuid())()),D}e.getMachineId=v;async function P(){try{const A=await new Promise((E,b)=>{ee(["crypto"],E,b)}),T=(0,_.getMac)();return A.createHash("sha256").update(T,"utf8").digest("hex")}catch(A){n.onUnexpectedError(A);return}}}),define(me[19],ve([0,1,28,24,132,14,33,76,5,3,20,4]),function(ee,e,k,n,w,I,_,D,v,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function b(M,q=E.UNLINK){if((0,_.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return q===E.UNLINK?S(M):u(M)}async function u(M){try{const q=(0,_.randomPath)((0,n.tmpdir)());try{await k.promises.rename(M,q)}catch{return S(M)}S(q).catch(Z=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function S(M){return(0,w.promisify)(k.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function f(M){if((0,_.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function h(M,q){return y(await(q?g(M):(0,w.promisify)(k.readdir)(M)))}async function g(M){try{return await(0,w.promisify)(k.readdir)(M,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const q=[],Z=await h(M);for(const j of Z){let $=!1,W=!1,Y=!1;try{const ie=await e.Promises.lstat((0,v.join)(M,j));$=ie.isFile(),W=ie.isDirectory(),Y=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}q.push({name:j,isFile:()=>$,isDirectory:()=>W,isSymbolicLink:()=>Y})}return q}function d(M){return y(k.readdirSync(M))}e.readdirSync=d;function y(M){return M.map(q=>typeof q=="string"?P.isMacintosh?(0,D.normalizeNFC)(q):q:(q.name=P.isMacintosh?(0,D.normalizeNFC)(q.name):q.name,q))}async function c(M){const q=await h(M),Z=[];for(const j of q)await l.existsDirectory((0,v.join)(M,j))&&Z.push(j);return Z}function o(M,q=1e3){return new Promise(Z=>{let j=!1;const $=setInterval(()=>{j||(j=!0,k.access(M,W=>{j=!1,W&&(clearInterval($),Z(void 0))}))},q)})}e.whenDeleted=o;var l;(function(M){async function q($){let W;try{if(W=await e.Promises.lstat($),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(P.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ie}throw Y}}M.stat=q;async function Z($){try{const{stat:W,symbolicLink:Y}=await M.stat($);return W.isFile()&&Y?.dangling!==!0}catch{}return!1}M.existsFile=Z;async function j($){try{const{stat:W,symbolicLink:Y}=await M.stat($);return W.isDirectory()&&Y?.dangling!==!0}catch{}return!1}M.existsDirectory=j})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new I.ResourceQueue;function t(M,q,Z){return i.queueFor(T.URI.file(M),A.extUriBiasedIgnorePathCase).queue(()=>{const j=m(Z);return new Promise(($,W)=>s(M,q,j,Y=>Y?W(Y):$()))})}let r=!0;function s(M,q,Z,j){if(!r)return k.writeFile(M,q,{mode:Z.mode,flag:Z.flag},j);k.open(M,Z.flag,Z.mode,($,W)=>{if($)return j($);k.writeFile(W,q,Y=>{if(Y)return k.close(W,()=>j(Y));k.fdatasync(W,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),r=!1),k.close(W,re=>j(re))))})})}function a(M,q,Z){const j=m(Z);if(!r)return k.writeFileSync(M,q,{mode:j.mode,flag:j.flag});const $=k.openSync(M,j.flag,j.mode);try{k.writeFileSync($,q);try{k.fdatasyncSync($)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r=!1}}finally{k.closeSync($)}}e.writeFileSync=a;function m(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function p(M,q){if(M!==q)try{await e.Promises.rename(M,q)}catch(Z){if(M.toLowerCase()!==q.toLowerCase()&&Z.code==="EXDEV"||M.endsWith("."))await R(M,q,{preserveSymlinks:!1}),await b(M,E.MOVE);else throw Z}}async function R(M,q,Z){return U(M,q,{root:{source:M,target:q},options:Z,handledSourcePaths:new Set})}const F=511;async function U(M,q,Z){if(Z.handledSourcePaths.has(M))return;Z.handledSourcePaths.add(M);const{stat:j,symbolicLink:$}=await l.stat(M);if($){if(Z.options.preserveSymlinks)try{return await z(M,q,Z)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if($.dangling)return}return j.isDirectory()?G(M,q,j.mode&F,Z):C(M,q,j.mode&F)}async function G(M,q,Z,j){await e.Promises.mkdir(q,{recursive:!0,mode:Z});const $=await h(M);for(const W of $)await U((0,v.join)(M,W),(0,v.join)(q,W),j)}async function C(M,q,Z){await e.Promises.copyFile(M,q),await e.Promises.chmod(q,Z)}async function z(M,q,Z){let j=await e.Promises.readlink(M);(0,_.isEqualOrParent)(j,Z.root.source,!P.isLinux)&&(j=(0,v.join)(Z.root.target,j.substr(Z.root.source.length+1))),await e.Promises.symlink(j,q)}e.Promises=new class{get access(){return(0,w.promisify)(k.access)}get stat(){return(0,w.promisify)(k.stat)}get lstat(){return(0,w.promisify)(k.lstat)}get utimes(){return(0,w.promisify)(k.utimes)}get read(){return(M,q,Z,j,$)=>new Promise((W,Y)=>{k.read(M,q,Z,j,$,(ie,re,oe)=>ie?Y(ie):W({bytesRead:re,buffer:oe}))})}get readFile(){return(0,w.promisify)(k.readFile)}get write(){return(M,q,Z,j,$)=>new Promise((W,Y)=>{k.write(M,q,Z,j,$,(ie,re,oe)=>ie?Y(ie):W({bytesWritten:re,buffer:oe}))})}get appendFile(){return(0,w.promisify)(k.appendFile)}get fdatasync(){return(0,w.promisify)(k.fdatasync)}get truncate(){return(0,w.promisify)(k.truncate)}get rename(){return(0,w.promisify)(k.rename)}get copyFile(){return(0,w.promisify)(k.copyFile)}get open(){return(0,w.promisify)(k.open)}get close(){return(0,w.promisify)(k.close)}get symlink(){return(0,w.promisify)(k.symlink)}get readlink(){return(0,w.promisify)(k.readlink)}get chmod(){return(0,w.promisify)(k.chmod)}get mkdir(){return(0,w.promisify)(k.mkdir)}get unlink(){return(0,w.promisify)(k.unlink)}get rmdir(){return(0,w.promisify)(k.rmdir)}get realpath(){return(0,w.promisify)(k.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return b}get move(){return p}get copy(){return R}}}),define(me[133],ve([0,1,28,5,3,15,19]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(E){if(w.isLinux)return E;const b=(0,n.dirname)(E);if(E===b)return E;const u=((0,n.basename)(E)||E).toLowerCase();try{const f=(0,_.readdirSync)(b).filter(h=>h.toLowerCase()===u);if(f.length===1){const h=D(b);if(h)return(0,n.join)(h,f[0])}else if(f.length>1){const h=f.indexOf(u);if(h>=0){const g=D(b);if(g)return(0,n.join)(g,f[h])}}}catch{}return null}e.realcaseSync=D;async function v(E){if(w.isLinux)return E;const b=(0,n.dirname)(E);if(E===b)return E;const u=((0,n.basename)(E)||E).toLowerCase();try{const f=(await _.Promises.readdir(b)).filter(h=>h.toLowerCase()===u);if(f.length===1){const h=await v(b);if(h)return(0,n.join)(h,f[0])}else if(f.length>1){const h=f.indexOf(u);if(h>=0){const g=await v(b);if(g)return(0,n.join)(g,f[h])}}}catch{}return null}e.realcase=v;async function P(E){try{return await _.Promises.realpath(E)}catch{const u=T(E);return await _.Promises.access(u,k.constants.R_OK),u}}e.realpath=P;function A(E){try{return k.realpathSync(E)}catch{const u=T(E);return k.accessSync(u,k.constants.R_OK),u}}e.realpathSync=A;function T(E){return(0,I.rtrim)((0,n.normalize)(E),n.sep)}}),define(me[134],ve([0,1,83]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(D,v,P,A=1){let T=!1;return new Promise(E=>{const b=setTimeout(()=>{if(!T)return T=!0,E(0)},P);w(D,v,A,u=>{if(!T)return T=!0,clearTimeout(b),E(u)})})}e.findFreePort=n;function w(D,v,P,A){if(v===0)return A(0);const T=new k.Socket;T.once("connect",()=>(_(T),w(D+P,v-1,P,A))),T.once("data",()=>{}),T.once("error",E=>(_(T),E.code!=="ECONNREFUSED"?w(D+P,v-1,P,A):A(D))),T.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(D,v,P){let A=!1,T,E=1;const b=k.createServer({pauseOnConnect:!0});function u(S,f){A||(A=!0,b.removeAllListeners(),b.close(),T&&clearTimeout(T),f(S))}return new Promise(S=>{T=setTimeout(()=>{u(0,S)},P),b.on("listening",()=>{u(D,S)}),b.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&E<v?(D++,E++,b.listen(D,"127.0.0.1")):u(0,S)}),b.on("close",()=>{u(0,S)}),b.listen(D,"127.0.0.1")})}e.findFreePortFaster=I;function _(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(v){console.error(v)}}}),define(me[84],ve([0,1,24,5,19]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,_=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var v;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(v||(v={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let A;process.env.PROCESSOR_ARCHITEW6432?A=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?A=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?A=1:A=0;class T{constructor(c,o,l){this.exePath=c,this.displayName=o,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:y=!1}={}){return y?P===0?process.env["ProgramFiles(x86)"]||null:A===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:y=!1,findPreview:c=!1}={}){const o=E({useAlternateBitness:y});if(!o)return null;const l=n.join(o,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(l))return null;let i=-1,t=null;for(const a of await w.Promises.readdir(l)){let m=-1;if(c){const R=a.indexOf("-");if(R<0)continue;const F=a.substring(0,R);if(!I.test(F)||a.substring(R+1)!=="preview")continue;m=parseInt(F,10)}else{if(!I.test(a))continue;m=parseInt(a,10)}if(m<=i)continue;const p=n.join(l,a,"pwsh.exe");!await w.SymlinkSupport.existsFile(p)||(t=p,i=m)}if(!t)return null;const r=o.includes("x86")?" (x86)":"",s=c?" Preview":"";return new T(t,`PowerShell${s}${r}`,!0)}async function u({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:o,pwshMsixName:l}=y?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:_,pwshMsixName:"PowerShell (Store)"};for(const i of await w.Promises.readdir(c))if(o.test(i)){const t=n.join(c,i,"pwsh.exe");return new T(t,l)}return null}function S(){const y=n.join(k.homedir(),".dotnet","tools","pwsh.exe");return new T(y,".NET Core PowerShell Global Tool")}function f(){const y=n.join(process.env.windir,P===1&&A!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new T(y,"Windows PowerShell",!0)}async function*h(){let y=await b();y&&(yield y),y=await b({useAlternateBitness:!0}),y&&(yield y),y=await u(),y&&(yield y),y=S(),y&&(yield y),y=await b({findPreview:!0}),y&&(yield y),y=await u({findPreview:!0}),y&&(yield y),y=await b({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=f(),y&&(yield y)}async function*g(){for await(const y of h())await y.exists()&&(yield y)}e.enumeratePowerShellInstallations=g;async function d(){for await(const y of g())return y;return null}e.getFirstAvailablePowerShellInstallation=d}),define(me[85],ve([0,1,39,8]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function w(_){return new Promise((D,v)=>{let P;const A=new Map;function T(b,u,S,f,h){const g=A.get(u);if(b===_||g){const d={name:E(S),cmd:S,pid:b,ppid:u,load:f,mem:h};A.set(b,d),b===_&&(P=d),g&&(g.children||(g.children=[]),g.children.push(d),g.children.length>1&&(g.children=g.children.sort((y,c)=>y.pid-c.pid)))}}function E(b){const u=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,g=/--crashes-directory/,d=/\\pipe\\winpty-control/,y=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(g.exec(b))return"electron-crash-reporter";if(d.exec(b))return"winpty-process";if(y.exec(b))return"console-window-host (Windows internal process)";let o=c.exec(b);if(o&&o.length===2)return o[1]==="renderer"?u.exec(b)?"shared-process":S.exec(b)?"issue-reporter":f.exec(b)?"process-explorer":"window":o[1]==="utility"&&h.exec(b)?"utility-network-service":o[1];const l=/[a-zA-Z-]+\.js/g;let i="";do o=l.exec(b),o&&(i+=o+" ");while(o);return i&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${i}`:b}if(process.platform==="win32"){const b=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,S)=>{ee(["windows-process-tree"],u,S)}).then(u=>{u.getProcessList(_,S=>{u.getProcessCpuUsage(S,f=>{const h=new Map;f.forEach(g=>{const d=b(g.commandLine||"");h.set(g.pid,{name:E(d),cmd:d,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),P=h.get(_),P?(h.forEach(g=>{const d=h.get(g.ppid);d&&(d.children||(d.children=[]),d.children.push(g))}),h.forEach(g=>{g.children&&(g.children=g.children.sort((d,y)=>d.pid-y.pid))}),D(P)):v(new Error(`Root process ${_} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let b=function(){let u=[P];const S=[];for(;u.length;){const h=u.shift();h&&(S.push(h.pid),h.children&&(u=u.concat(h.children)))}let f=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",ee).fsPath);f+=" "+S.join(" "),(0,k.exec)(f,{},(h,g,d)=>{if(h||d)v(h||new Error(d.toString()));else{const y=g.toString().split(`
`);for(let c=0;c<S.length;c++){const o=A.get(S[c]);o.load=parseFloat(y[c])}if(!P){v(new Error(`Root process ${_} not found`));return}D(P)}})};(0,k.exec)("which ps",{},(u,S,f)=>{if(u||f)if(process.platform!=="linux")v(u||new Error(f.toString()));else{const h=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",ee).fsPath);(0,k.exec)(h,{},(g,d,y)=>{g||y?v(g||new Error(y.toString())):(I(d,T),b())})}else{const h=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${h} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,y,c)=>{d||c&&!c.includes("screen size is bogus")?v(d||new Error(c.toString())):(I(y,T),process.platform==="linux"?b():P?D(P):v(new Error(`Root process ${_} not found`)))})}})}})}e.listProcesses=w;function I(_,D){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,P=_.toString().split(`
`);for(const A of P){const T=v.exec(A.trim());T&&T.length===6&&D(parseInt(T[1]),parseInt(T[2]),T[5],parseFloat(T[3]),parseFloat(T[4]))}}});var Te=this&&this.__decorate||function(ee,e,k,n){var w=arguments.length,I=w<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,k):n,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(ee,e,k,n);else for(var D=ee.length-1;D>=0;D--)(_=ee[D])&&(I=(w<3?_(I):w>3?_(e,k,I):_(e,k))||I);return w>3&&I&&Object.defineProperty(e,k,I),I};define(me[40],ve([0,1,16,14,17,21,73,9,7,2,50,15,12]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function u(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function f(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(h||(h={}));class g{constructor(Y){this.buffer=Y,this.pos=0}read(Y){const ie=this.buffer.slice(this.pos,this.pos+Y);return this.pos+=ie.byteLength,ie}}class d{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(Y){this.buffers.push(Y)}}var y;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(y||(y={}));function c(W){const Y=w.VSBuffer.alloc(4);return Y.writeUInt32BE(W,0),Y}function o(W){return W.read(4).readUInt32BE(0)}function l(W){const Y=w.VSBuffer.alloc(1);return Y.writeUInt8(W,0),Y}const i={Undefined:l(y.Undefined),String:l(y.String),Buffer:l(y.Buffer),VSBuffer:l(y.VSBuffer),Array:l(y.Array),Object:l(y.Object)},t=typeof Buffer!="undefined";function r(W,Y){if(typeof Y=="undefined")W.write(i.Undefined);else if(typeof Y=="string"){const ie=w.VSBuffer.fromString(Y);W.write(i.String),W.write(c(ie.byteLength)),W.write(ie)}else if(t&&Buffer.isBuffer(Y)){const ie=w.VSBuffer.wrap(Y);W.write(i.Buffer),W.write(c(ie.byteLength)),W.write(ie)}else if(Y instanceof w.VSBuffer)W.write(i.VSBuffer),W.write(c(Y.byteLength)),W.write(Y);else if(Array.isArray(Y)){W.write(i.Array),W.write(c(Y.length));for(const ie of Y)r(W,ie)}else{const ie=w.VSBuffer.fromString(JSON.stringify(Y));W.write(i.Object),W.write(c(ie.byteLength)),W.write(ie)}}function s(W){switch(W.read(1).readUInt8(0)){case y.Undefined:return;case y.String:return W.read(o(W)).toString();case y.Buffer:return W.read(o(W)).buffer;case y.VSBuffer:return W.read(o(W));case y.Array:{const ie=o(W),re=[];for(let oe=0;oe<ie;oe++)re.push(s(W));return re}case y.Object:return JSON.parse(W.read(o(W)).toString())}}class a{constructor(Y,ie,re=null,oe=1e3){this.protocol=Y,this.ctx=ie,this.logger=re,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ue=>this.onRawMessage(ue)),this.sendResponse({type:200})}registerChannel(Y,ie){this.channels.set(Y,ie),setTimeout(()=>this.flushPendingRequests(Y),0)}sendResponse(Y){switch(Y.type){case 200:{const ie=this.send([Y.type]);this.logger?.logOutgoing(ie,0,1,f(Y.type));return}case 201:case 202:case 204:case 203:{const ie=this.send([Y.type,Y.id],Y.data);this.logger?.logOutgoing(ie,Y.id,1,f(Y.type),Y.data);return}}}send(Y,ie=void 0){const re=new d;return r(re,Y),r(re,ie),this.sendBuffer(re.buffer)}sendBuffer(Y){try{return this.protocol.send(Y),Y.byteLength}catch{return 0}}onRawMessage(Y){const ie=new g(Y),re=s(ie),oe=s(ie),ue=re[0];switch(ue){case 100:return this.logger?.logIncoming(Y.byteLength,re[1],1,`${u(ue)}: ${re[2]}.${re[3]}`,oe),this.onPromise({type:ue,id:re[1],channelName:re[2],name:re[3],arg:oe});case 102:return this.logger?.logIncoming(Y.byteLength,re[1],1,`${u(ue)}: ${re[2]}.${re[3]}`,oe),this.onEventListen({type:ue,id:re[1],channelName:re[2],name:re[3],arg:oe});case 101:return this.logger?.logIncoming(Y.byteLength,re[1],1,`${u(ue)}`),this.disposeActiveRequest({type:ue,id:re[1]});case 103:return this.logger?.logIncoming(Y.byteLength,re[1],1,`${u(ue)}`),this.disposeActiveRequest({type:ue,id:re[1]})}}onPromise(Y){const ie=this.channels.get(Y.channelName);if(!ie){this.collectPendingRequest(Y);return}const re=new I.CancellationTokenSource;let oe;try{oe=ie.call(this.ctx,Y.name,Y.arg,re.token)}catch(H){oe=Promise.reject(H)}const ue=Y.id;oe.then(H=>{this.sendResponse({id:ue,data:H,type:201}),this.activeRequests.delete(Y.id)},H=>{H instanceof Error?this.sendResponse({id:ue,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.sendResponse({id:ue,data:H,type:203}),this.activeRequests.delete(Y.id)});const de=(0,P.toDisposable)(()=>re.cancel());this.activeRequests.set(Y.id,de)}onEventListen(Y){const ie=this.channels.get(Y.channelName);if(!ie){this.collectPendingRequest(Y);return}const re=Y.id,ue=ie.listen(this.ctx,Y.name,Y.arg)(de=>this.sendResponse({id:re,data:de,type:204}));this.activeRequests.set(Y.id,ue)}disposeActiveRequest(Y){const ie=this.activeRequests.get(Y.id);ie&&(ie.dispose(),this.activeRequests.delete(Y.id))}collectPendingRequest(Y){let ie=this.pendingRequests.get(Y.channelName);ie||(ie=[],this.pendingRequests.set(Y.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.sendResponse({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ie.push({request:Y,timeoutTimer:re})}flushPendingRequests(Y){const ie=this.pendingRequests.get(Y);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.onPromise(re.request);break;case 102:this.onEventListen(re.request);break}this.pendingRequests.delete(Y)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var m;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(Y,ie=null){this.protocol=Y,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(re=>this.onBuffer(re)),this.logger=ie}getChannel(Y){const ie=this;return{call(re,oe,ue){return ie.isDisposed?Promise.reject(D.canceled()):ie.requestPromise(Y,re,oe,ue)},listen(re,oe){return ie.isDisposed?v.Event.None:ie.requestEvent(Y,re,oe)}}}requestPromise(Y,ie,re,oe=I.CancellationToken.None){const ue=this.lastRequestId++,H={id:ue,type:100,channelName:Y,name:ie,arg:re};if(oe.isCancellationRequested)return Promise.reject(D.canceled());let O;return new Promise((J,ae)=>{if(oe.isCancellationRequested)return ae(D.canceled());const ge=()=>{const Q=B=>{switch(B.type){case 201:this.handlers.delete(ue),J(B.data);break;case 202:{this.handlers.delete(ue);const x=new Error(B.data.message);x.stack=B.data.stack,x.name=B.data.name,ae(x);break}case 203:this.handlers.delete(ue),ae(B.data);break}};this.handlers.set(ue,Q),this.sendRequest(H)};let he=null;this.state===h.Idle?ge():(he=(0,n.createCancelablePromise)(Q=>this.whenInitialized()),he.then(()=>{he=null,ge()}));const le=()=>{he?(he.cancel(),he=null):this.sendRequest({id:ue,type:101}),ae(D.canceled())},pe=oe.onCancellationRequested(le);O=(0,P.combinedDisposable)((0,P.toDisposable)(le),pe),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(Y,ie,re){const oe=this.lastRequestId++,de={id:oe,type:102,channelName:Y,name:ie,arg:re};let H=null;const O=new v.Emitter({onFirstListenerAdd:()=>{H=(0,n.createCancelablePromise)(J=>this.whenInitialized()),H.then(()=>{H=null,this.activeRequests.add(O),this.sendRequest(de)})},onLastListenerRemove:()=>{H?(H.cancel(),H=null):(this.activeRequests.delete(O),this.sendRequest({id:oe,type:103}))}}),V=J=>O.fire(J.data);return this.handlers.set(oe,V),O.event}sendRequest(Y){switch(Y.type){case 100:case 102:{const ie=this.send([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.logger&&this.logger.logOutgoing(ie,Y.id,0,`${u(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const ie=this.send([Y.type,Y.id]);this.logger&&this.logger.logOutgoing(ie,Y.id,0,u(Y.type));return}}}send(Y,ie=void 0){const re=new d;return r(re,Y),r(re,ie),this.sendBuffer(re.buffer)}sendBuffer(Y){try{return this.protocol.send(Y),Y.byteLength}catch{return 0}}onBuffer(Y){const ie=new g(Y),re=s(ie),oe=s(ie),ue=re[0];switch(ue){case 200:return this.logger&&this.logger.logIncoming(Y.byteLength,0,0,f(ue)),this.onResponse({type:re[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(Y.byteLength,re[1],0,f(ue),oe),this.onResponse({type:re[0],id:re[1],data:oe})}}onResponse(Y){if(Y.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}const ie=this.handlers.get(Y.id);ie&&ie(Y)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Te([_.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class R{constructor(Y){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,Y(({protocol:ie,onDidClientDisconnect:re})=>{v.Event.once(ie.onMessage)(ue=>{const de=new g(ue),H=s(de),O=new a(ie,H),V=new p(ie);this.channels.forEach((ae,ge)=>O.registerChannel(ge,ae));const J={channelServer:O,channelClient:V,ctx:H};this._connections.add(J),this._onDidAddConnection.fire(J),re(()=>{O.dispose(),V.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const Y=[];return this._connections.forEach(ie=>Y.push(ie)),Y}getChannel(Y,ie){const re=this;return{call(oe,ue,de){let H;if((0,E.isFunction)(ie)){let V=(0,k.getRandomElement)(re.connections.filter(ie));H=V?Promise.resolve(V):v.Event.toPromise(v.Event.filter(re.onDidAddConnection,ie))}else H=ie.routeCall(re,oe,ue);const O=H.then(V=>V.channelClient.getChannel(Y));return U(O).call(oe,ue,de)},listen(oe,ue){if((0,E.isFunction)(ie))return re.getMulticastEvent(Y,ie,oe,ue);const de=ie.routeEvent(re,oe,ue).then(H=>H.channelClient.getChannel(Y));return U(de).listen(oe,ue)}}}getMulticastEvent(Y,ie,re,oe){const ue=this;let de=new P.DisposableStore;const H=new v.Emitter({onFirstListenerAdd:()=>{de=new P.DisposableStore;const O=new v.EventMultiplexer,V=new Map,J=ge=>{const le=ge.channelClient.getChannel(Y).listen(re,oe),pe=O.add(le);V.set(ge,pe)},ae=ge=>{const he=V.get(ge);!he||(he.dispose(),V.delete(ge))};ue.connections.filter(ie).forEach(J),v.Event.filter(ue.onDidAddConnection,ie)(J,void 0,de),ue.onDidRemoveConnection(ae,void 0,de),O.event(H.fire,H,de),de.add(O)},onLastListenerRemove:()=>{de.dispose()}});return H.event}registerChannel(Y,ie){this.channels.set(Y,ie),this._connections.forEach(re=>{re.channelServer.registerChannel(Y,ie)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class F{constructor(Y,ie,re=null){const oe=new d;r(oe,ie),Y.send(oe.buffer),this.channelClient=new p(Y,re),this.channelServer=new a(Y,ie,re)}getChannel(Y){return this.channelClient.getChannel(Y)}registerChannel(Y,ie){this.channelServer.registerChannel(Y,ie)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function U(W){return{call(Y,ie,re){return W.then(oe=>oe.call(Y,ie,re))},listen(Y,ie){const re=new v.Relay;return W.then(oe=>re.input=oe.listen(Y,ie)),re.event}}}e.getDelayedChannel=U;function G(W){let Y=!1;return{call(ie,re,oe){return Y?W.call(ie,re,oe):(0,n.timeout)(0).then(()=>Y=!0).then(()=>W.call(ie,re,oe))},listen(ie,re){if(Y)return W.listen(ie,re);const oe=new v.Relay;return(0,n.timeout)(0).then(()=>Y=!0).then(()=>oe.input=W.listen(ie,re)),oe.event}}}e.getNextTickChannel=G;class C{constructor(Y){this.fn=Y}routeCall(Y){return this.route(Y)}routeEvent(Y){return this.route(Y)}async route(Y){for(const ie of Y.connections)if(await Promise.resolve(this.fn(ie.ctx)))return Promise.resolve(ie);return await v.Event.toPromise(Y.onDidAddConnection),await this.route(Y)}}e.StaticRouter=C;var z;(function(W){function Y(ue,de){const H=ue,O=de&&de.disableMarshalling,V=new Map;for(const J in H)re(J)&&V.set(J,v.Event.buffer(H[J],!0));return new class{listen(J,ae,ge){const he=V.get(ae);if(he)return he;if(oe(ae)){const le=H[ae];if(typeof le=="function")return le.call(H,ge)}throw new Error(`Event not found: ${ae}`)}call(J,ae,ge){const he=H[ae];if(typeof he=="function"){if(!O&&Array.isArray(ge))for(let le=0;le<ge.length;le++)ge[le]=(0,A.revive)(ge[le]);return he.apply(H,ge)}throw new Error(`Method not found: ${ae}`)}}}W.fromService=Y;function ie(ue,de){const H=de&&de.disableMarshalling;return new Proxy({},{get(O,V){if(typeof V=="string")return de?.properties?.has(V)?de.properties.get(V):oe(V)?function(J){return ue.listen(V,J)}:re(V)?ue.listen(V):async function(...J){let ae;de&&!(0,E.isUndefinedOrNull)(de.context)?ae=[de.context,...J]:ae=J;const ge=await ue.call(V,ae);return H?ge:(0,A.revive)(ge)};throw new Error(`Property not found: ${String(V)}`)}})}W.toService=ie;function re(ue){return ue[0]==="o"&&ue[1]==="n"&&T.isUpperAsciiLetter(ue.charCodeAt(2))}function oe(ue){return/^onDynamic/.test(ue)&&T.isUpperAsciiLetter(ue.charCodeAt(9))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let Y=W.toString();if(Y!=="[object Object]")return Y}return W}function Z(W){return Array.isArray(W)?W.map(q):q(W)}function j(W,Y,ie,re,oe,ue,de){de=Z(de);const H=M[oe],O=H[re%H.length];let V=[`%c[${W}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(ue)?(V=V.concat(de),V.push(")")):V.push(de),console.log.apply(console,V)}e.logWithColors=j;class ${constructor(Y,ie){this._outgoingPrefix=Y,this._incomingPrefix=ie,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(Y,ie,re,oe,ue){this._totalOutgoing+=Y,j(this._outgoingPrefix,this._totalOutgoing,Y,ie,re,oe,ue)}logIncoming(Y,ie,re,oe,ue){this._totalIncoming+=Y,j(this._incomingPrefix,this._totalIncoming,Y,ie,re,oe,ue)}}e.IPCLogger=$}),define(me[86],ve([0,1,17,7,2,40]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(_=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(t){t.enableDiagnostics=!1,t.records=[];const r=new WeakMap;let s=0;function a(p,R){if(!r.has(p)){const F=String(++s);r.set(p,F)}return r.get(p)}function m(p,R,F,U){if(!t.enableDiagnostics)return;const G=a(p,R);if(U instanceof k.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const C=k.VSBuffer.alloc(U.byteLength);C.set(U),t.records.push({timestamp:Date.now(),id:G,label:R,type:F,buff:C})}else t.records.push({timestamp:Date.now(),id:G,label:R,type:F,data:U})}t.traceSocketEvent=m})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function A(){return P||(P=k.VSBuffer.alloc(0)),P}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,s){if(r===0)return A();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return s&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let a=k.VSBuffer.alloc(r),m=0,p=0;for(;r>0;){const R=this._chunks[p];if(R.byteLength>r){const F=R.slice(0,r);a.set(F,m),m+=r,s&&(this._chunks[p]=R.slice(r),this._totalLength-=r),r-=r}else a.set(R,m),m+=R.byteLength,s?(this._chunks.shift(),this._totalLength-=R.byteLength):p++,r-=R.byteLength}return a}}e.ChunkStream=T;var E;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(E||(E={}));function b(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(r,s,a,m){this.type=r,this.id=s,this.ack=a,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends w.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,m=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new S(a,m,p,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=k.VSBuffer.alloc(13);s.writeUInt8(r.type,0),s.writeUInt32BE(r.id,1),s.writeUInt32BE(r.ack,5),s.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(s,r.data)}_bufferAdd(r,s){const a=this._totalLength===0;return this._data.push(r,s),this._totalLength+=r.byteLength+s.byteLength,a}_bufferTake(){const r=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,s){this._bufferAdd(r,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class g extends w.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new S(1,0,0,r))}}e.Protocol=g;class d extends I.IPCClient{constructor(r,s,a=null){super(r,s,a);this.protocol=r}static fromSocket(r,s){return new d(new g(r),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=d;class y{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=y;class c{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],s=0,a=this._first;for(;a;)r[s++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const s=new c(r);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class l{constructor(){this.lastRuns=[];const r=Date.now();for(let s=0;s<l._HISTORY_LENGTH;s++)this.lastRuns[s]=r-1e3*s;setInterval(()=>{for(let s=l._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const r=Date.now(),s=(1+l._HISTORY_LENGTH)*1e3;let a=0;for(let m=0;m<l._HISTORY_LENGTH;m++)r-this.lastRuns[m]<=s&&a++;return 1-a/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class i{constructor(r,s=null,a=l.getInstance()){this._onControlMessage=new y,this.onControlMessage=this._onControlMessage.event,this._onMessage=new y,this.onMessage=this._onMessage.event,this._onDidDispose=new y,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new y,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new y,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,w.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new S(5,0,0,A());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new S(7,0,0,A());this._socketWriter.write(r)}sendResume(){const r=new S(8,0,0,A());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,s){this._isReconnecting=!0,this._socketDisposables=(0,w.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new S(3,0,this._incomingAckId,A());this._socketWriter.write(r);const s=this._outgoingUnackMsg.toArray();for(let a=0,m=s.length;a<m;a++)this._socketWriter.write(s[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new S(6,0,0,A())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let a=0,m=s.length;a<m;a++)this._socketWriter.write(s[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new S(1,s,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const s=new S(2,0,0,r);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),s=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&a>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const p=Math.max(2e4-s,2e4-a,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new S(3,0,this._incomingAckId,A());this._socketWriter.write(r)}}e.PersistentProtocol=i}),define(me[135],ve([0,1,14,7,2,12]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var _;(function(T){T[T.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(_=e.StorageHint||(e.StorageHint={}));function D(T){const E=T;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=D;var v;(function(T){T[T.None=0]="None",T[T.Initialized=1]="Initialized",T[T.Closed=2]="Closed"})(v=e.StorageState||(e.StorageState={}));class P extends w.Disposable{constructor(E,b=Object.create(null)){super();this.database=E,this.options=b,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=v.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((b,u)=>this.accept(u,b)),E.deleted?.forEach(b=>this.accept(b,void 0))}accept(E,b){if(this.state===v.Closed)return;let u=!1;(0,I.isUndefinedOrNull)(b)?u=this.cache.delete(E):this.cache.get(E)!==b&&(this.cache.set(E,b),u=!0),u&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===v.None&&(this.state=v.Initialized,this.options.hint!==_.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,b){const u=this.cache.get(E);return(0,I.isUndefinedOrNull)(u)?b:u}getBoolean(E,b){const u=this.get(E);return(0,I.isUndefinedOrNull)(u)?b:u==="true"}getNumber(E,b){const u=this.get(E);return(0,I.isUndefinedOrNull)(u)?b:parseInt(u,10)}async set(E,b){if(this.state===v.Closed)return;if((0,I.isUndefinedOrNull)(b))return this.delete(E);const u=String(b);if(this.cache.get(E)!==u)return this.cache.set(E,u),this.pendingInserts.set(E,u),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async delete(E){if(!(this.state===v.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=v.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(E){if(!!this.hasPending)return this.doFlush(E)}async doFlush(E){return this.flushDelayer.trigger(()=>this.flushPending(),E)}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=P,P.DEFAULT_FLUSH_DELAY=100;class A{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((b,u)=>this.items.set(u,b)),E.delete&&E.delete.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=A}),define(me[87],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class k{constructor(w,I){this.lineNumber=w,this.column=I}with(w=this.lineNumber,I=this.column){return w===this.lineNumber&&I===this.column?this:new k(w,I)}delta(w=0,I=0){return this.with(this.lineNumber+w,this.column+I)}equals(w){return k.equals(this,w)}static equals(w,I){return!w&&!I?!0:!!w&&!!I&&w.lineNumber===I.lineNumber&&w.column===I.column}isBefore(w){return k.isBefore(this,w)}static isBefore(w,I){return w.lineNumber<I.lineNumber?!0:I.lineNumber<w.lineNumber?!1:w.column<I.column}isBeforeOrEqual(w){return k.isBeforeOrEqual(this,w)}static isBeforeOrEqual(w,I){return w.lineNumber<I.lineNumber?!0:I.lineNumber<w.lineNumber?!1:w.column<=I.column}static compare(w,I){const _=w.lineNumber|0,D=I.lineNumber|0;if(_===D){const v=w.column|0,P=I.column|0;return v-P}return _-D}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(w){return new k(w.lineNumber,w.column)}static isIPosition(w){return w&&typeof w.lineNumber=="number"&&typeof w.column=="number"}}e.Position=k}),define(me[51],ve([0,1,87]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class n{constructor(I,_,D,v){I>D||I===D&&_>v?(this.startLineNumber=D,this.startColumn=v,this.endLineNumber=I,this.endColumn=_):(this.startLineNumber=I,this.startColumn=_,this.endLineNumber=D,this.endColumn=v)}isEmpty(){return n.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return n.containsPosition(this,I)}static containsPosition(I,_){return!(_.lineNumber<I.startLineNumber||_.lineNumber>I.endLineNumber||_.lineNumber===I.startLineNumber&&_.column<I.startColumn||_.lineNumber===I.endLineNumber&&_.column>I.endColumn)}static strictContainsPosition(I,_){return!(_.lineNumber<I.startLineNumber||_.lineNumber>I.endLineNumber||_.lineNumber===I.startLineNumber&&_.column<=I.startColumn||_.lineNumber===I.endLineNumber&&_.column>=I.endColumn)}containsRange(I){return n.containsRange(this,I)}static containsRange(I,_){return!(_.startLineNumber<I.startLineNumber||_.endLineNumber<I.startLineNumber||_.startLineNumber>I.endLineNumber||_.endLineNumber>I.endLineNumber||_.startLineNumber===I.startLineNumber&&_.startColumn<I.startColumn||_.endLineNumber===I.endLineNumber&&_.endColumn>I.endColumn)}strictContainsRange(I){return n.strictContainsRange(this,I)}static strictContainsRange(I,_){return!(_.startLineNumber<I.startLineNumber||_.endLineNumber<I.startLineNumber||_.startLineNumber>I.endLineNumber||_.endLineNumber>I.endLineNumber||_.startLineNumber===I.startLineNumber&&_.startColumn<=I.startColumn||_.endLineNumber===I.endLineNumber&&_.endColumn>=I.endColumn)}plusRange(I){return n.plusRange(this,I)}static plusRange(I,_){let D,v,P,A;return _.startLineNumber<I.startLineNumber?(D=_.startLineNumber,v=_.startColumn):_.startLineNumber===I.startLineNumber?(D=_.startLineNumber,v=Math.min(_.startColumn,I.startColumn)):(D=I.startLineNumber,v=I.startColumn),_.endLineNumber>I.endLineNumber?(P=_.endLineNumber,A=_.endColumn):_.endLineNumber===I.endLineNumber?(P=_.endLineNumber,A=Math.max(_.endColumn,I.endColumn)):(P=I.endLineNumber,A=I.endColumn),new n(D,v,P,A)}intersectRanges(I){return n.intersectRanges(this,I)}static intersectRanges(I,_){let D=I.startLineNumber,v=I.startColumn,P=I.endLineNumber,A=I.endColumn,T=_.startLineNumber,E=_.startColumn,b=_.endLineNumber,u=_.endColumn;return D<T?(D=T,v=E):D===T&&(v=Math.max(v,E)),P>b?(P=b,A=u):P===b&&(A=Math.min(A,u)),D>P||D===P&&v>A?null:new n(D,v,P,A)}equalsRange(I){return n.equalsRange(this,I)}static equalsRange(I,_){return!!I&&!!_&&I.startLineNumber===_.startLineNumber&&I.startColumn===_.startColumn&&I.endLineNumber===_.endLineNumber&&I.endColumn===_.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(I){return new k.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(I){return new k.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,_){return new n(this.startLineNumber,this.startColumn,I,_)}setStartPosition(I,_){return new n(I,_,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(I){return new n(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,_=I){return new n(I.lineNumber,I.column,_.lineNumber,_.column)}static lift(I){return I?new n(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,_){return!(I.endLineNumber<_.startLineNumber||I.endLineNumber===_.startLineNumber&&I.endColumn<_.startColumn||_.endLineNumber<I.startLineNumber||_.endLineNumber===I.startLineNumber&&_.endColumn<I.startColumn)}static areIntersecting(I,_){return!(I.endLineNumber<_.startLineNumber||I.endLineNumber===_.startLineNumber&&I.endColumn<=_.startColumn||_.endLineNumber<I.startLineNumber||_.endLineNumber===I.startLineNumber&&_.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,_){if(I&&_){const P=I.startLineNumber|0,A=_.startLineNumber|0;if(P===A){const T=I.startColumn|0,E=_.startColumn|0;if(T===E){const b=I.endLineNumber|0,u=_.endLineNumber|0;if(b===u){const S=I.endColumn|0,f=_.endColumn|0;return S-f}return b-u}return T-E}return P-A}return(I?1:0)-(_?1:0)}static compareRangesUsingEnds(I,_){return I.endLineNumber===_.endLineNumber?I.endColumn===_.endColumn?I.startLineNumber===_.startLineNumber?I.startColumn-_.startColumn:I.startLineNumber-_.startLineNumber:I.endColumn-_.endColumn:I.endLineNumber-_.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.Range=n}),define(me[136],ve([0,1,7,2]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class w{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,v){return this._map.set(D,v),this.fire([D]),(0,n.toDisposable)(()=>{this._map.get(D)===v&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,v){this._factories.get(D)?.dispose();const P=new I(this,D,v);return this._factories.set(D,P),(0,n.toDisposable)(()=>{const A=this._factories.get(D);!A||A!==P||(this._factories.delete(D),A.dispose())})}async getOrCreate(D){const v=this.get(D);if(v)return v;const P=this._factories.get(D);return!P||P.isResolved?null:(await P.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const P=this._factories.get(D);return!!(!P||P.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=w;class I extends n.Disposable{constructor(D,v,P){super();this._registry=D,this._languageId=v,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(me[137],ve([0,1,4,51,136,38]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var _;(function(C){C[C.Null=0]="Null",C[C.PlainText=1]="PlainText"})(_=e.LanguageId||(e.LanguageId={}));var D;(function(C){C[C.NotSet=-1]="NotSet",C[C.None=0]="None",C[C.Italic=1]="Italic",C[C.Bold=2]="Bold",C[C.Underline=4]="Underline",C[C.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var v;(function(C){C[C.None=0]="None",C[C.DefaultForeground=1]="DefaultForeground",C[C.DefaultBackground=2]="DefaultBackground"})(v=e.ColorId||(e.ColorId={}));var P;(function(C){C[C.Other=0]="Other",C[C.Comment=1]="Comment",C[C.String=2]="String",C[C.RegEx=3]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var A;(function(C){C[C.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",C[C.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",C[C.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",C[C.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",C[C.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",C[C.ITALIC_MASK=1024]="ITALIC_MASK",C[C.BOLD_MASK=2048]="BOLD_MASK",C[C.UNDERLINE_MASK=4096]="UNDERLINE_MASK",C[C.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",C[C.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",C[C.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",C[C.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",C[C.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",C[C.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",C[C.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",C[C.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",C[C.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",C[C.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",C[C.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",C[C.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(A=e.MetadataConsts||(e.MetadataConsts={}));class T{static getLanguageId(z){return(z&255)>>>0}static getTokenType(z){return(z&768)>>>8}static getFontStyle(z){return(z&15360)>>>10}static getForeground(z){return(z&8372224)>>>14}static getBackground(z){return(z&4286578688)>>>23}static getClassNameFromMetadata(z){const M=this.getForeground(z);let q="mtk"+M;const Z=this.getFontStyle(z);return Z&1&&(q+=" mtki"),Z&2&&(q+=" mtkb"),Z&4&&(q+=" mtku"),Z&8&&(q+=" mtks"),q}static getInlineStyleFromMetadata(z,M){const q=this.getForeground(z),Z=this.getFontStyle(z);let j=`color: ${M[q]};`;Z&1&&(j+="font-style: italic;"),Z&2&&(j+="font-weight: bold;");let $="";return Z&4&&($+=" underline"),Z&8&&($+=" line-through"),$&&(j+=`text-decoration:${$};`),j}static getPresentationFromMetadata(z){const M=this.getForeground(z),q=this.getFontStyle(z);return{foreground:M,italic:Boolean(q&1),bold:Boolean(q&2),underline:Boolean(q&4),strikethrough:Boolean(q&8)}}}e.TokenMetadata=T;class E{constructor(z,M,q){this._tokenBrand=void 0,this.offset=z,this.type=M,this.language=q}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=E;class b{constructor(z,M){this._tokenizationResultBrand=void 0,this.tokens=z,this.endState=M}}e.TokenizationResult=b;class u{constructor(z,M){this._encodedTokenizationResultBrand=void 0,this.tokens=z,this.endState=M}}e.EncodedTokenizationResult=u;var S;(function(C){C[C.Method=0]="Method",C[C.Function=1]="Function",C[C.Constructor=2]="Constructor",C[C.Field=3]="Field",C[C.Variable=4]="Variable",C[C.Class=5]="Class",C[C.Struct=6]="Struct",C[C.Interface=7]="Interface",C[C.Module=8]="Module",C[C.Property=9]="Property",C[C.Event=10]="Event",C[C.Operator=11]="Operator",C[C.Unit=12]="Unit",C[C.Value=13]="Value",C[C.Constant=14]="Constant",C[C.Enum=15]="Enum",C[C.EnumMember=16]="EnumMember",C[C.Keyword=17]="Keyword",C[C.Text=18]="Text",C[C.Color=19]="Color",C[C.File=20]="File",C[C.Reference=21]="Reference",C[C.Customcolor=22]="Customcolor",C[C.Folder=23]="Folder",C[C.TypeParameter=24]="TypeParameter",C[C.User=25]="User",C[C.Issue=26]="Issue",C[C.Snippet=27]="Snippet"})(S=e.CompletionItemKind||(e.CompletionItemKind={}));var f;(function(C){const z=new Map;z.set(0,I.Codicon.symbolMethod),z.set(1,I.Codicon.symbolFunction),z.set(2,I.Codicon.symbolConstructor),z.set(3,I.Codicon.symbolField),z.set(4,I.Codicon.symbolVariable),z.set(5,I.Codicon.symbolClass),z.set(6,I.Codicon.symbolStruct),z.set(7,I.Codicon.symbolInterface),z.set(8,I.Codicon.symbolModule),z.set(9,I.Codicon.symbolProperty),z.set(10,I.Codicon.symbolEvent),z.set(11,I.Codicon.symbolOperator),z.set(12,I.Codicon.symbolUnit),z.set(13,I.Codicon.symbolValue),z.set(15,I.Codicon.symbolEnum),z.set(14,I.Codicon.symbolConstant),z.set(15,I.Codicon.symbolEnum),z.set(16,I.Codicon.symbolEnumMember),z.set(17,I.Codicon.symbolKeyword),z.set(27,I.Codicon.symbolSnippet),z.set(18,I.Codicon.symbolText),z.set(19,I.Codicon.symbolColor),z.set(20,I.Codicon.symbolFile),z.set(21,I.Codicon.symbolReference),z.set(22,I.Codicon.symbolCustomColor),z.set(23,I.Codicon.symbolFolder),z.set(24,I.Codicon.symbolTypeParameter),z.set(25,I.Codicon.account),z.set(26,I.Codicon.issues);function M(j){let $=z.get(j);return $||(console.info("No codicon found for CompletionItemKind "+j),$=I.Codicon.symbolProperty),$}C.toIcon=M;const q=new Map;q.set("method",0),q.set("function",1),q.set("constructor",2),q.set("field",3),q.set("variable",4),q.set("class",5),q.set("struct",6),q.set("interface",7),q.set("module",8),q.set("property",9),q.set("event",10),q.set("operator",11),q.set("unit",12),q.set("value",13),q.set("constant",14),q.set("enum",15),q.set("enum-member",16),q.set("enumMember",16),q.set("keyword",17),q.set("snippet",27),q.set("text",18),q.set("color",19),q.set("file",20),q.set("reference",21),q.set("customcolor",22),q.set("folder",23),q.set("type-parameter",24),q.set("typeParameter",24),q.set("account",25),q.set("issue",26);function Z(j,$){let W=q.get(j);return typeof W=="undefined"&&!$&&(W=9),W}C.fromString=Z})(f=e.CompletionItemKinds||(e.CompletionItemKinds={}));var h;(function(C){C[C.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var g;(function(C){C[C.KeepWhitespace=1]="KeepWhitespace",C[C.InsertAsSnippet=4]="InsertAsSnippet"})(g=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var d;(function(C){C[C.Invoke=0]="Invoke",C[C.TriggerCharacter=1]="TriggerCharacter",C[C.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(C){C[C.Automatic=0]="Automatic",C[C.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(C){C[C.Invoke=1]="Invoke",C[C.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(C){C[C.Invoke=1]="Invoke",C[C.TriggerCharacter=2]="TriggerCharacter",C[C.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(C){C[C.Text=0]="Text",C[C.Read=1]="Read",C[C.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(C){return C&&k.URI.isUri(C.uri)&&n.Range.isIRange(C.range)&&(n.Range.isIRange(C.originSelectionRange)||n.Range.isIRange(C.targetSelectionRange))}e.isLocationLink=i;var t;(function(C){C[C.File=0]="File",C[C.Module=1]="Module",C[C.Namespace=2]="Namespace",C[C.Package=3]="Package",C[C.Class=4]="Class",C[C.Method=5]="Method",C[C.Property=6]="Property",C[C.Field=7]="Field",C[C.Constructor=8]="Constructor",C[C.Enum=9]="Enum",C[C.Interface=10]="Interface",C[C.Function=11]="Function",C[C.Variable=12]="Variable",C[C.Constant=13]="Constant",C[C.String=14]="String",C[C.Number=15]="Number",C[C.Boolean=16]="Boolean",C[C.Array=17]="Array",C[C.Object=18]="Object",C[C.Key=19]="Key",C[C.Null=20]="Null",C[C.EnumMember=21]="EnumMember",C[C.Struct=22]="Struct",C[C.Event=23]="Event",C[C.Operator=24]="Operator",C[C.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(C){C[C.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(C){const z=new Map;z.set(0,I.Codicon.symbolFile),z.set(1,I.Codicon.symbolModule),z.set(2,I.Codicon.symbolNamespace),z.set(3,I.Codicon.symbolPackage),z.set(4,I.Codicon.symbolClass),z.set(5,I.Codicon.symbolMethod),z.set(6,I.Codicon.symbolProperty),z.set(7,I.Codicon.symbolField),z.set(8,I.Codicon.symbolConstructor),z.set(9,I.Codicon.symbolEnum),z.set(10,I.Codicon.symbolInterface),z.set(11,I.Codicon.symbolFunction),z.set(12,I.Codicon.symbolVariable),z.set(13,I.Codicon.symbolConstant),z.set(14,I.Codicon.symbolString),z.set(15,I.Codicon.symbolNumber),z.set(16,I.Codicon.symbolBoolean),z.set(17,I.Codicon.symbolArray),z.set(18,I.Codicon.symbolObject),z.set(19,I.Codicon.symbolKey),z.set(20,I.Codicon.symbolNull),z.set(21,I.Codicon.symbolEnumMember),z.set(22,I.Codicon.symbolStruct),z.set(23,I.Codicon.symbolEvent),z.set(24,I.Codicon.symbolOperator),z.set(25,I.Codicon.symbolTypeParameter);function M(q){let Z=z.get(q);return Z||(console.info("No codicon found for SymbolKind "+q),Z=I.Codicon.symbolProperty),Z}C.toIcon=M})(s=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(z){this.value=z}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var m;(function(C){function z(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}C.is=z})(m=e.Command||(e.Command={}));var p;(function(C){C[C.Collapsed=0]="Collapsed",C[C.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var R;(function(C){C[C.Unresolved=0]="Unresolved",C[C.Resolved=1]="Resolved"})(R=e.CommentThreadState||(e.CommentThreadState={}));var F;(function(C){C[C.Editing=0]="Editing",C[C.Preview=1]="Preview"})(F=e.CommentMode||(e.CommentMode={}));var U;(function(C){C[C.Type=1]="Type",C[C.Parameter=2]="Parameter"})(U=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new w.TokenizationRegistry;var G;(function(C){C[C.None=0]="None",C[C.Option=1]="Option",C[C.Default=2]="Default",C[C.Preferred=3]="Preferred"})(G=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[138],ve([10,11]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(me[139],ve([0,1,138]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,w=n*60,I=w*24,_=I*7,D=I*30,v=I*365;function P(T,E,b){typeof T!="number"&&(T=T.getTime());const u=Math.round((new Date().getTime()-T)/1e3);if(u<-30)return(0,k.localize)(0,null,P(new Date().getTime()+u*1e3,!1));if(u<30)return(0,k.localize)(1,null);let S;return u<n?(S=u,E?S===1?b?(0,k.localize)(2,null,S):(0,k.localize)(3,null,S):b?(0,k.localize)(4,null,S):(0,k.localize)(5,null,S):S===1?b?(0,k.localize)(6,null,S):(0,k.localize)(7,null,S):b?(0,k.localize)(8,null,S):(0,k.localize)(9,null,S)):u<w?(S=Math.floor(u/n),E?S===1?b?(0,k.localize)(10,null,S):(0,k.localize)(11,null,S):b?(0,k.localize)(12,null,S):(0,k.localize)(13,null,S):S===1?b?(0,k.localize)(14,null,S):(0,k.localize)(15,null,S):b?(0,k.localize)(16,null,S):(0,k.localize)(17,null,S)):u<I?(S=Math.floor(u/w),E?S===1?b?(0,k.localize)(18,null,S):(0,k.localize)(19,null,S):b?(0,k.localize)(20,null,S):(0,k.localize)(21,null,S):S===1?b?(0,k.localize)(22,null,S):(0,k.localize)(23,null,S):b?(0,k.localize)(24,null,S):(0,k.localize)(25,null,S)):u<_?(S=Math.floor(u/I),E?S===1?(0,k.localize)(26,null,S):(0,k.localize)(27,null,S):S===1?(0,k.localize)(28,null,S):(0,k.localize)(29,null,S)):u<D?(S=Math.floor(u/_),E?S===1?b?(0,k.localize)(30,null,S):(0,k.localize)(31,null,S):b?(0,k.localize)(32,null,S):(0,k.localize)(33,null,S):S===1?b?(0,k.localize)(34,null,S):(0,k.localize)(35,null,S):b?(0,k.localize)(36,null,S):(0,k.localize)(37,null,S)):u<v?(S=Math.floor(u/D),E?S===1?b?(0,k.localize)(38,null,S):(0,k.localize)(39,null,S):b?(0,k.localize)(40,null,S):(0,k.localize)(41,null,S):S===1?b?(0,k.localize)(42,null,S):(0,k.localize)(43,null,S):b?(0,k.localize)(44,null,S):(0,k.localize)(45,null,S)):(S=Math.floor(u/v),E?S===1?b?(0,k.localize)(46,null,S):(0,k.localize)(47,null,S):b?(0,k.localize)(48,null,S):(0,k.localize)(49,null,S):S===1?b?(0,k.localize)(50,null,S):(0,k.localize)(51,null,S):b?(0,k.localize)(52,null,S):(0,k.localize)(53,null,S))}e.fromNow=P;function A(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(me[140],ve([10,11]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(me[36],ve([0,1,16,12,140]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function I(T,E){return E&&(T.stack||T.stacktrace)?w.localize(0,null,D(T),_(T.stack)||_(T.stacktrace)):D(T)}function _(T){return Array.isArray(T)?T.join(`
`):T}function D(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?w.localize(1,null,T.message):T.message||w.localize(2,null)}function v(T=null,E=!1){if(!T)return w.localize(3,null);if(Array.isArray(T)){const b=k.coalesce(T),u=v(b[0],E);return b.length>1?w.localize(4,null,u,b.length):u}if(n.isString(T))return T;if(T.detail){const b=T.detail;if(b.error)return I(b.error,E);if(b.exception)return I(b.exception,E)}return T.stack?I(T,E):T.message?T.message:w.localize(5,null)}e.toErrorMessage=v;function P(T){const E=T;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=P;function A(T,E=Object.create(null)){const b=new Error(T);return E.actions&&(b.actions=E.actions),b}e.createErrorWithActions=A}),define(me[141],ve([10,11]),function(ee,e){return ee.create("vs/base/common/jsonErrorMessages",e)}),define(me[142],ve([0,1,141]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(w){switch(w){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(me[143],ve([10,11]),function(ee,e){return ee.create("vs/base/node/processes",e)}),define(me[62],ve([0,1,39,33,8,22,5,3,25,75,12,129,19,143]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function u(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(o,l){if(D.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};l&&(i.cwd=l);const t=k.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],i);return new Promise(r=>{t.once("error",s=>{r({success:!1,error:s})}),t.once("exit",(s,a)=>{r(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(D.isLinux||D.isMacintosh)try{const i=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",ee).fsPath;return new Promise(t=>{k.execFile(i,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,s,a)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function f(o){!o||(delete o.DEBUG,D.isMacintosh&&delete o.DYLD_LIBRARY_PATH,D.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=f;function h(o=v.env){return o.comspec||"cmd.exe"}e.getWindowsShell=h;class g{constructor(l,i,t,r){if(i!==void 0&&t!==void 0&&r!==void 0)this.cmd=l,this.args=i,this.shell=t,this.options=r;else{const s=l;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(v.env).forEach(a=>{s[a]=v.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const i=l.lastIndexOf(_.sep);return i!==-1&&(l=l.substring(i+1)),g.WellKnowCommands[l]?l:"other"}start(l){return D.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(v.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(i=>{let t,r;const s=new Promise((a,m)=>{t=a,r=m});if(i){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(m,p,R)=>{this.childProcess=null;const F=m;F&&F.killed?r({killed:this.terminateRequested,stdout:p.toString(),stderr:R.toString()}):this.handleExec(t,l,m,p,R)})}else{let a=null;const m=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,t,l,r);const R={terminated:this.terminateRequested};A.isNumber(p)&&(R.cmdCode=p),t(R)};if(this.shell&&D.isWindows){const p=I.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let R=!1,F=!1;const U=[];let G=this.ensureQuotes(this.cmd);U.push(G.value),R=G.quoted,this.args&&this.args.forEach(z=>{G=this.ensureQuotes(z),U.push(G.value),F=F&&G.quoted});const C=["/s","/c"];R?F?C.push('"'+U.join(" ")+'"'):U.length>1?C.push('"'+U[0]+'" '+U.slice(1).join(" ")):C.push('"'+U[0]+'"'):C.push(U.join(" ")),a=k.spawn(h(),C,p)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(A.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",p=>{this.childProcess=null,r({terminated:this.terminateRequested,error:p})}),a.pid&&(this.childProcess.on("close",m),this.handleSpawn(a,t,l,r,!0)))}return s})}handleClose(l,i,t,r){}ensureQuotes(l){return g.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,S(l,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!D.isWindows)return l(!1);const i=k.spawn(h(),["/s","/c"]);i.on("error",t=>l(!0)),i.on("exit",t=>l(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class d extends g{constructor(l,i,t,r){super(l,i,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,i,t,r,s){[r,s].forEach((a,m)=>{const p=new T.LineDecoder;p.write(a).forEach(U=>{i({line:U,source:m===0?0:1})});const F=p.end();F&&i({line:F,source:m===0?0:1})}),l({terminated:this.terminateRequested,error:t})}handleSpawn(l,i,t,r,s){const a=new T.LineDecoder,m=new T.LineDecoder;l.stdout.on("data",p=>{a.write(p).forEach(F=>t({line:F,source:0}))}),l.stderr.on("data",p=>{m.write(p).forEach(F=>t({line:F,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=m}handleClose(l,i,t,r){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&t({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&t({line:a,source:1})}}e.LineProcess=d;function y(o){let l=[],i=!1;const t=function(r){if(i){l.push(r);return}(!o.send(r,a=>{if(a&&console.error(a),i=!1,l.length>0){const m=l.slice(0);l=[],m.forEach(p=>t(p))}})||D.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=y;var c;(function(o){async function l(i,t,r){if(_.isAbsolute(i))return i;if(t===void 0&&(t=v.cwd()),_.dirname(i)!=="."||(r===void 0&&A.isString(v.env.PATH)&&(r=v.env.PATH.split(_.delimiter)),r===void 0||r.length===0))return _.join(t,i);async function a(m){if(await E.Promises.exists(m)){let p;try{p=await E.Promises.stat(m)}catch(R){R.message.startsWith("EACCES")&&(p=await E.Promises.lstat(m))}return p?!p.isDirectory():!1}return!1}for(let m of r){let p;if(_.isAbsolute(m)?p=_.join(m,i):p=_.join(t,m,i),await a(p))return p;let R=p+".com";if(await a(R)||(R=p+".exe",await a(R)))return R}return _.join(t,i)}o.findExecutable=l})(c=e.win32||(e.win32={}))}),define(me[144],ve([0,1,24,3,84,62]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function _(b,u){return b===1?n.isWindows?T():I.getWindowsShell(u):P(b,u)}e.getSystemShell=_;function D(b,u){return b===1?n.isWindows?E(u):I.getWindowsShell(u):P(b,u)}e.getSystemShellSync=D;let v=null;function P(b,u){if(n.isLinux&&b===2||n.isMacintosh&&b===3)return"/bin/bash";if(!v){let S;if(n.isWindows)S="/bin/bash";else{if(S=u.SHELL,!S)try{S=(0,k.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}v=S}return v}let A=null;async function T(){return A||(A=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),A}function E(b){if(A)return A;const u=n.isWindows&&parseFloat((0,k.release)())>=10,S=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${b.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?f:I.getWindowsShell(b)}}),define(me[88],ve([0,1,39,14,17,21,77,9,7,2,22,62,40]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class b extends E.ChannelServer{constructor(f){super({send:h=>{try{process.send&&process.send(h.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",h=>w.VSBuffer.wrap(Buffer.from(h,"base64")))},f);process.once("disconnect",()=>this.dispose())}}e.Server=b;class u{constructor(f,h){this.modulePath=f,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new n.Delayer(g),this.child=null,this._client=null}getChannel(f){const h=this;return{call(g,d,y){return h.requestPromise(f,g,d,y)},listen(g,d){return h.requestEvent(f,g,d)}}}requestPromise(f,h,g,d=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const y=this.getCachedChannel(f),c=(0,n.createCancelablePromise)(i=>y.call(h,g,i)),o=d.onCancellationRequested(()=>c.cancel()),l=(0,P.toDisposable)(()=>c.cancel());return this.activeRequests.add(l),c.finally(()=>{o.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(f,h,g){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let d;const y=new v.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(f).listen(h,g)(y.fire,y),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return y.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,A.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,T.removeDangerousEnvVariables)(h.env),this.child=(0,k.fork)(this.modulePath,f,h);const g=new v.Emitter;v.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,_.isRemoteConsoleLog)(t)){(0,_.log)(t,`IPC Library: ${this.options.serverName}`);return}g.fire(w.VSBuffer.wrap(Buffer.from(t,"base64")))});const y=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,c=t=>this.child&&this.child.connected&&y.send(t.buffer.toString("base64")),o=g.event,l={send:c,onMessage:o};this._client=new E.ChannelClient(l);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",i),this.activeRequests.forEach(s=>(0,P.dispose)(s)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(f){let h=this.channels.get(f);return h||(h=this.client.getChannel(f),this.channels.set(f,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=u}),define(me[145],ve([10,11]),function(ee,e){return ee.create("vs/base/node/zip",e)}),define(me[146],ve([10,11]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[147],ve([10,11]),function(ee,e){return ee.create("vs/platform/environment/node/argv",e)}),define(me[148],ve([10,11]),function(ee,e){return ee.create("vs/platform/environment/node/argvHelper",e)}),define(me[149],ve([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(me[150],ve([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[151],ve([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(me[152],ve([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(me[153],ve([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(me[154],ve([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(me[155],ve([10,11]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[156],ve([10,11]),function(ee,e){return ee.create("vs/platform/files/common/fileService",e)}),define(me[157],ve([10,11]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(me[158],ve([10,11]),function(ee,e){return ee.create("vs/platform/files/common/io",e)}),define(me[159],ve([10,11]),function(ee,e){return ee.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(me[160],ve([10,11]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(me[161],ve([10,11]),function(ee,e){return ee.create("vs/platform/request/common/request",e)}),define(me[162],ve([10,11]),function(ee,e){return ee.create("vs/platform/shell/node/shellEnv",e)}),define(me[163],ve([10,11]),function(ee,e){return ee.create("vs/platform/telemetry/common/telemetryService",e)}),define(me[164],ve([10,11]),function(ee,e){return ee.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(me[165],ve([10,11]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(me[166],ve([10,11]),function(ee,e){return ee.create("vs/server/node/remoteAgentEnvironmentImpl",e)}),define(me[167],ve([10,11]),function(ee,e){return ee.create("vs/server/node/serverEnvironmentService",e)}),define(me[168],ve([10,11]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(me[169],ve([10,11]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[170],ve([10,11]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionPoints",e)}),define(me[171],ve([0,1,7,2]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class w{constructor(){this._onCloseEmitter=new k.Emitter,this._onReloadEmitter=new k.Emitter,this._onTerminateEmitter=new k.Emitter,this._onAttachEmitter=new k.Emitter}call(D,v,P){switch(v){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:P[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:P[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:P[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:P[0],port:P[1],subId:P[2]}))}throw new Error("Method not implemented.")}listen(D,v,P){switch(v){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=w,w.ChannelName="extensionhostdebugservice";class I extends n.Disposable{constructor(D){super();this.channel=D}reload(D){this.channel.call("reload",[D])}get onReload(){return this.channel.listen("reload")}close(D){this.channel.call("close",[D])}get onClose(){return this.channel.listen("close")}attachSession(D,v,P){this.channel.call("attach",[D,v,P])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(D,v){this.channel.call("terminate",[D,v])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(D,v){return this.channel.call("openExtensionDevelopmentHostWindow",[D,v])}}e.ExtensionHostDebugChannelClient=I}),define(me[172],ve([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class n{constructor(_){this.service=_}listen(_,D,v){throw new Error("Invalid listen")}call(_,D,v){switch(D){case"download":return this.service.download(k.URI.revive(v[0]),k.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=n;class w{constructor(_,D){this.channel=_,this.getUriTransformer=D}async download(_,D){const v=this.getUriTransformer();v&&(_=v.transformOutgoingURI(_),D=v.transformOutgoingURI(D)),await this.channel.call("download",[_,D])}}e.DownloadServiceChannelClient=w}),define(me[173],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var k;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(k=e.EditorActivation||(e.EditorActivation={}));var n;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(n=e.EditorResolution||(e.EditorResolution={}));var w;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(w=e.EditorOpenSource||(e.EditorOpenSource={}));var I;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var _;(function(D){D.PROGRAMMATIC="api",D.NAVIGATION="code.navigation",D.JUMP="code.jump"})(_=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(me[174],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class k{constructor(w){this.machineId=w}encryption(){return new Promise((w,I)=>ee(["vscode-encrypt"],w,I))}async encrypt(w){try{return(await this.encryption()).encrypt(this.machineId,w)}catch{return w}}async decrypt(w){try{return(await this.encryption()).decrypt(this.machineId,w)}catch{return w}}}e.EncryptionMainService=k}),define(me[89],ve([0,1,139,73,8,5,25,20,4]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class P{constructor(S,f,h){this._args=S,this.paths=f,this.productService=h}get appRoot(){return(0,I.dirname)(w.FileAccess.asFileUri("",ee).fsPath)}get userHome(){return v.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return v.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.paths.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return v.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(v.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=_.env.VSCODE_PORTABLE;return S?v.URI.file((0,I.join)(S,"argv.json")):(0,D.joinPath)(this.appSettingsHome,"argv.json")}get snippetsHome(){return(0,D.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,I.resolve)(S):(0,I.normalize)((0,I.join)(w.FileAccess.asFileUri("",ee).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,I.resolve)(S):(0,I.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,I.resolve)(S);const f=_.env.VSCODE_EXTENSIONS;if(f)return f;const h=_.env.VSCODE_PORTABLE;return h?(0,I.join)(h,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(f=>/^[^:/?#]+?:\/\//.test(f)?v.URI.parse(f):v.URI.file((0,I.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?v.URI.parse(S):v.URI.file((0,I.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return A(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!_.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,D.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return v.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Te([n.memoize],P.prototype,"appRoot",null),Te([n.memoize],P.prototype,"userHome",null),Te([n.memoize],P.prototype,"userDataPath",null),Te([n.memoize],P.prototype,"appSettingsHome",null),Te([n.memoize],P.prototype,"tmpDir",null),Te([n.memoize],P.prototype,"cacheHome",null),Te([n.memoize],P.prototype,"userRoamingDataHome",null),Te([n.memoize],P.prototype,"settingsResource",null),Te([n.memoize],P.prototype,"userDataSyncHome",null),Te([n.memoize],P.prototype,"userDataSyncLogResource",null),Te([n.memoize],P.prototype,"sync",null),Te([n.memoize],P.prototype,"machineSettingsResource",null),Te([n.memoize],P.prototype,"globalStorageHome",null),Te([n.memoize],P.prototype,"workspaceStorageHome",null),Te([n.memoize],P.prototype,"localHistoryHome",null),Te([n.memoize],P.prototype,"keybindingsResource",null),Te([n.memoize],P.prototype,"keyboardLayoutResource",null),Te([n.memoize],P.prototype,"argvResource",null),Te([n.memoize],P.prototype,"snippetsHome",null),Te([n.memoize],P.prototype,"isExtensionDevelopment",null),Te([n.memoize],P.prototype,"untitledWorkspacesHome",null),Te([n.memoize],P.prototype,"installSourcePath",null),Te([n.memoize],P.prototype,"builtinExtensionsPath",null),Te([n.memoize],P.prototype,"extensionsPath",null),Te([n.memoize],P.prototype,"extensionDevelopmentLocationURI",null),Te([n.memoize],P.prototype,"extensionDevelopmentKind",null),Te([n.memoize],P.prototype,"extensionTestsLocationURI",null),Te([n.memoize],P.prototype,"debugExtensionHost",null),Te([n.memoize],P.prototype,"serviceMachineIdResource",null),Te([n.memoize],P.prototype,"telemetryLogResource",null),Te([n.memoize],P.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=P;function A(u,S){return b(u["inspect-extensions"],u["inspect-brk-extensions"],5870,S,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=A;function T(u,S){return b(u["inspect-search"],u["inspect-brk-search"],5876,S,u.extensionEnvironment)}e.parseSearchPort=T;function E(u,S){return b(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,S,u.extensionEnvironment)}e.parsePtyHostPort=E;function b(u,S,f,h,g,d){const c=Number(S||u)||(h?null:f),o=c?Boolean(!!S):!1;let l;if(d)try{l=JSON.parse(d)}catch{}return{port:c,break:o,debugId:g,env:l}}}),define(me[52],ve([0,1,259,3,147]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const I={o:(0,w.localize)(0,null),e:(0,w.localize)(1,null),t:(0,w.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,w.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,w.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,w.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,w.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,w.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,w.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,w.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,w.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,w.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,w.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,w.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,w.localize)(14,null)},category:{type:"string",cat:"e",description:(0,w.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,w.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,w.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,w.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,w.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,w.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,w.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,w.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,w.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,w.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,w.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,w.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,w.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,w.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,w.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,w.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const _={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function D(u,S,f=_){const h={},g=["_"],d=[];for(let l in S){const i=S[l];i.alias&&(h[l]=i.alias),i.type==="string"||i.type==="string[]"?(g.push(l),i.deprecates&&g.push(...i.deprecates)):i.type==="boolean"&&(d.push(l),i.deprecates&&d.push(...i.deprecates))}const y=k(u,{string:g,boolean:d,alias:h}),c={},o=y;c._=y._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(let l in S){const i=S[l];i.alias&&delete o[i.alias];let t=o[l];if(i.deprecates)for(const r of i.deprecates)o.hasOwnProperty(r)&&(t||(t=o[r],t&&f.onDeprecatedOption(r,i.deprecationMessage||(0,w.localize)(33,null))),delete o[r]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),f.onMultipleValues(l,t)),c[l]=t,i.deprecationMessage&&f.onDeprecatedOption(l,i.deprecationMessage)),delete o[l]}for(let l in o)f.onUnknownOption(l);return c}e.parseArgs=D;function v(u,S){let f="";return S.args&&(Array.isArray(S.args)?f=` <${S.args.join("> <")}>`:f=` <${S.args}>`),S.alias?`-${S.alias} --${u}${f}`:`--${u}${f}`}function P(u,S){let f=0,h=[];for(const c in u){const o=u[c],l=v(c,o);f=Math.max(f,l.length),h.push([l,o.description])}let g=f+2+1;if(S-g<25)return h.reduce((c,o)=>c.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let d=S-g-1,y=[];for(const c of h){let o=c[0],l=T(c[1],d),i=A(g-o.length-2);y.push("  "+o+i+l[0]);for(let t=1;t<l.length;t++)y.push(A(g)+l[t])}return y}e.formatOptions=P;function A(u){return" ".repeat(u)}function T(u,S){let f=[];for(;u.length;){let h=u.length<S?u.length:u.lastIndexOf(" ",S),g=u.slice(0,h).trim();u=u.slice(h),f.push(g)}return f}function E(u,S,f,h,g){const d=process.stdout.isTTY&&process.stdout.columns||80,y=g?.noInputFiles!==!0?`[${(0,w.localize)(34,null)}...]`:"",c=[`${u} ${f}`];c.push(""),c.push(`${(0,w.localize)(35,null)}: ${S} [${(0,w.localize)(36,null)}]${y}`),c.push(""),g?.noPipe!==!0&&(n.isWindows?c.push((0,w.localize)(37,null,S)):c.push((0,w.localize)(38,null,S)),c.push(""));const o={};for(const l in h){const i=h[l];if(i.description&&i.cat){let t=o[i.cat];t||(o[i.cat]=t={}),t[l]=i}}for(let l in o){const i=l;let t=o[i];t&&(c.push(I[i]),c.push(...P(t,d)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=E;function b(u,S){return`${u||(0,w.localize)(39,null)}
${S||(0,w.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=b}),define(me[175],ve([0,1,260,148,52]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const I=2048;function _(E,b){const u={onUnknownOption:f=>{console.warn((0,n.localize)(0,null,f))},onMultipleValues:(f,h)=>{console.warn((0,n.localize)(1,null,f,h))},onDeprecatedOption:(f,h)=>{console.warn((0,n.localize)(2,null,f,h))}},S=(0,w.parseArgs)(E,w.OPTIONS,b?u:void 0);return S.goto&&S._.forEach(f=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,n.localize)(3,null))),S["max-memory"]&&k(parseInt(S["max-memory"])>=I,`The max-memory argument cannot be specified lower than ${I} MB.`),S}function D(E){const b=E.findIndex(u=>!/^-/.test(u));if(b>-1)return[...E.slice(0,b),...E.slice(b+1)]}function v(E){let[,...b]=E;process.env.VSCODE_DEV&&(b=D(b)||[]);const u=!T(process.env);return _(b,u)}e.parseMainProcessArgv=v;function P(E){const[,,...b]=E;return _(b,!0)}e.parseCLIProcessArgv=P;function A(E,...b){const u=E.indexOf("--");return u===-1?E.push(...b):E.splice(u,0,...b),E}e.addArg=A;function T(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=T}),function(){"use strict";function ee(e,k,n,w){function I(D){const v=_(D),P=[v];return e.isAbsolute(v)||P.unshift(w),e.resolve(...P)}function _(D){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,n);const A=D["user-data-dir"];if(A)return A;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const T=process.env.USERPROFILE;if(typeof T!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(T,"AppData","Roaming")}break;case"darwin":P=e.join(k.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,n)}return{getUserDataPath:I}}if(typeof define=="function")define(me[176],ve([0,81,24,8,20,25]),function(e,k,n,w,I,_){const D=I.dirname(w.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(I.joinPath(D,"package.json").fsPath);return ee(k,n,v.name,_.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),n=require("os");module.exports=ee(k,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(me[177],ve([0,1,24,89,176]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class I extends n.AbstractNativeEnvironmentService{constructor(D,v){super(D,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,w.getUserDataPath)(D)},v)}}e.NativeEnvironmentService=I}),define(me[178],ve([0,1,22]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function w(I,_){const D=v=>{if(typeof v!="string")return;const P=n.exec(v);if(!P)return;const A=_[P[1]]??v;return typeof A=="string"?A:typeof A.message=="string"?A.message:v};return(0,k.cloneAndChange)(I,D)}e.localizeManifest=w}),define(me[63],ve([0,1,155]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function I(E){return E=E.trim(),E==="*"||n.test(E)}e.isValidVersionStr=I;function _(E){if(!I(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=E.match(n);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=_;function D(E){if(!E)return null;let b=E.majorBase,u=E.majorMustEqual,S=E.minorBase,f=E.minorMustEqual,h=E.patchBase,g=E.patchMustEqual;E.hasCaret&&(b===0||(f=!1),g=!1);let d=0;if(E.preRelease){const y=w.exec(E.preRelease);if(y){const[,c,o,l]=y;d=Date.UTC(Number(c),Number(o)-1,Number(l))}}return{majorBase:b,majorMustEqual:u,minorBase:S,minorMustEqual:f,patchBase:h,patchMustEqual:g,isMinimum:E.hasGreaterEquals,notBefore:d}}e.normalizeVersion=D;function v(E,b,u){let S;typeof E=="string"?S=D(_(E)):S=E;let f;b instanceof Date?f=b.getTime():typeof b=="string"&&(f=new Date(b).getTime());let h;if(typeof u=="string"?h=D(_(u)):h=u,!S||!h)return!1;let g=S.majorBase,d=S.minorBase,y=S.patchBase,c=h.majorBase,o=h.minorBase,l=h.patchBase,i=h.notBefore,t=h.majorMustEqual,r=h.minorMustEqual,s=h.patchMustEqual;return h.isMinimum?g>c?!0:g<c?!1:d>o?!0:d<o||f&&f<i?!1:y>=l:(g===1&&c===0&&(!t||!r||!s)&&(c=1,o=0,l=0,t=!0,r=!1,s=!1),g<c?!1:g>c?!t:d<o?!1:d>o?!r:y<l?!1:y>l?!s:!(f&&f<i))}e.isValidVersion=v;function P(E,b,u,S,f){return S||typeof u.main=="undefined"&&typeof u.browser=="undefined"?!0:T(E,b,u.engines.vscode,f)}e.isValidExtensionVersion=P;function A(E,b,u){return E==="*"||T(b,u,E)}e.isEngineValid=A;function T(E,b,u,S=[]){let f=D(_(u));if(!f)return S.push(k.localize(0,null,u)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return S.push(k.localize(1,null,u)),!1}else if(!f.majorMustEqual)return S.push(k.localize(2,null,u)),!1;return v(E,b,f)?!0:(S.push(k.localize(3,null,E,u)),!1)}}),define(me[179],ve([0,1,17,23]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function w(I,_,D){let v=D&&D.get("storage.serviceMachineId",0)||null;if(v)return v;try{const A=(await _.readFile(I.serviceMachineIdResource)).value.toString();v=(0,n.isUUID)(A)?A:null}catch{v=null}if(!v){v=(0,n.generateUuid)();try{await _.writeFile(I.serviceMachineIdResource,k.VSBuffer.fromString(v))}catch{}}return D&&D.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=w}),define(me[53],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(w,I=[],_=!1){this.ctor=w,this.staticArguments=I,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=k}),define(me[180],ve([0,1,53]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function w(_,D,v){D instanceof k.SyncDescriptor||(D=new k.SyncDescriptor(D,[],v)),n.push([_,D])}e.registerSingleton=w;function I(){return n}e.getSingletonServiceDescriptors=I}),define(me[181],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=k;class n{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let _ of this._nodes.values())_.outgoing.size===0&&I.push(_);return I}insertEdge(I,_){const D=this.lookupOrInsertNode(I),v=this.lookupOrInsertNode(_);D.outgoing.set(this._hashFn(_),v),v.incoming.set(this._hashFn(I),D)}removeNode(I){const _=this._hashFn(I);this._nodes.delete(_);for(let D of this._nodes.values())D.outgoing.delete(_),D.incoming.delete(_)}lookupOrInsertNode(I){const _=this._hashFn(I);let D=this._nodes.get(_);return D||(D=new k(I),this._nodes.set(_,D)),D}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[_,D]of this._nodes)I.push(`${_}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,_]of this._nodes){const D=new Set([I]),v=this._findCycle(_,D);if(v)return v}}_findCycle(I,_){for(let[D,v]of I.outgoing){if(_.has(D))return[..._,D].join(" -> ");_.add(D);const P=this._findCycle(v,_);if(P)return P;_.delete(D)}}}e.Graph=n}),define(me[6],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function D(v){return v[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=D})(k=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function n(_,D,v){D[k.DI_TARGET]===D?D[k.DI_DEPENDENCIES].push({id:_,index:v}):(D[k.DI_DEPENDENCIES]=[{id:_,index:v}],D[k.DI_TARGET]=D)}function w(_){if(k.serviceIds.has(_))return k.serviceIds.get(_);const D=function(v,P,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(D,v,A)};return D.toString=()=>_,k.serviceIds.set(_,D),D}e.createDecorator=w;function I(_){return _}e.refineServiceDecorator=I}),define(me[26],ve([0,1,12,4,6]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof n.URI)}e.isConfigurationOverrides=I;function _(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||k.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=_;var D;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function v(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=v;function P(h,g){const d=Object.create(null);for(let y in h)A(d,y,h[y],g);return d}e.toValuesTree=P;function A(h,g,d,y){const c=g.split("."),o=c.pop();let l=h;for(let i=0;i<c.length;i++){let t=c[i],r=l[t];switch(typeof r){case"undefined":r=l[t]=Object.create(null);break;case"object":break;default:y(`Ignoring ${g} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}l=r}if(typeof l=="object"&&l!==null)try{l[o]=d}catch{y(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(l)}`)}else y(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=A;function T(h,g){const d=g.split(".");E(h,d)}e.removeFromValueTree=T;function E(h,g){const d=g.shift();if(g.length===0){delete h[d];return}if(Object.keys(h).indexOf(d)!==-1){const y=h[d];typeof y=="object"&&!Array.isArray(y)&&(E(y,g),Object.keys(y).length===0&&delete h[d])}}function b(h,g,d){function y(l,i){let t=l;for(const r of i){if(typeof t!="object"||t===null)return;t=t[r]}return t}const c=g.split("."),o=y(h,c);return typeof o=="undefined"?d:o}e.getConfigurationValue=b;function u(h,g,d){Object.keys(g).forEach(y=>{y!=="__proto__"&&(y in h?k.isObject(h[y])&&k.isObject(g[y])?u(h[y],g[y],d):d&&(h[y]=g[y]):h[y]=g[y])})}e.merge=u;function S(h,g,d){const y=h.inspect(g),c=h.inspect(d);return typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:y.defaultValue}e.getMigratedSettingValue=S;function f(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(me[90],ve([0,1,3,15,6]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",k.isMacintosh),I.set("isLinux",k.isLinux),I.set("isWindows",k.isWindows),I.set("isWeb",k.isWeb),I.set("isMacNative",k.isMacintosh&&!k.isWeb),I.set("isEdge",k.isEdge),I.set("isFirefox",k.isFirefox),I.set("isChrome",k.isChrome),I.set("isSafari",k.isSafari);const _=Object.prototype.hasOwnProperty;var D;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return T.INSTANCE}static true(){return E.INSTANCE}static has(C){return b.create(C)}static equals(C,z){return u.create(C,z)}static notEquals(C,z){return h.create(C,z)}static regex(C,z){return i.create(C,z)}static in(C,z){return S.create(C,z)}static not(C){return g.create(C)}static and(...C){return s.create(C,null)}static or(...C){return a.create(C,null,!0)}static greater(C,z){return y.create(C,z)}static greaterEquals(C,z){return c.create(C,z)}static smaller(C,z){return o.create(C,z)}static smallerEquals(C,z){return l.create(C,z)}static deserialize(C,z=!1){if(!!C)return this._deserializeOrExpression(C,z)}static _deserializeOrExpression(C,z){let M=C.split("||");return a.create(M.map(q=>this._deserializeAndExpression(q,z)),null,!0)}static _deserializeAndExpression(C,z){let M=C.split("&&");return s.create(M.map(q=>this._deserializeOne(q,z)),null)}static _deserializeOne(C,z){if(C=C.trim(),C.indexOf("!=")>=0){let M=C.split("!=");return h.create(M[0].trim(),this._deserializeValue(M[1],z))}if(C.indexOf("==")>=0){let M=C.split("==");return u.create(M[0].trim(),this._deserializeValue(M[1],z))}if(C.indexOf("=~")>=0){let M=C.split("=~");return i.create(M[0].trim(),this._deserializeRegexValue(M[1],z))}if(C.indexOf(" in ")>=0){let M=C.split(" in ");return S.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(C)){const M=C.split(">=");return c.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(C)){const M=C.split(">");return y.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(C)){const M=C.split("<=");return l.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(C)){const M=C.split("<");return o.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(C)?g.create(C.substr(1).trim()):b.create(C)}static _deserializeValue(C,z){if(C=C.trim(),C==="true")return!0;if(C==="false")return!1;let M=/^'([^']*)'$/.exec(C);return M?M[1].trim():C}static _deserializeRegexValue(C,z){if((0,n.isFalsyOrWhitespace)(C)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=C.indexOf("/"),q=C.lastIndexOf("/");if(M===q||M<0){if(z)throw new Error(`bad regexp-value '${C}', missing /-enclosure`);return console.warn(`bad regexp-value '${C}', missing /-enclosure`),null}let Z=C.slice(M+1,q),j=C[q+1]==="i"?"i":"";try{return new RegExp(Z,j)}catch($){if(z)throw new Error(`bad regexp-value '${C}', parse error: ${$}`);return console.warn(`bad regexp-value '${C}', parse error: ${$}`),null}}}e.ContextKeyExpr=v;function P(G,C){const z=G?G.substituteConstants():void 0,M=C?C.substituteConstants():void 0;return!z&&!M?!0:!z||!M?!1:z.equals(M)}e.expressionsAreEqualWithConstantSubstitution=P;function A(G,C){return G.cmp(C)}class T{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=T,T.INSTANCE=new T;class E{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return T.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class b{constructor(C,z){this.key=C,this.negated=z,this.type=2}static create(C,z=null){const M=I.get(C);return typeof M=="boolean"?M?E.INSTANCE:T.INSTANCE:new b(C,z)}cmp(C){return C.type!==this.type?this.type-C.type:p(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=I.get(this.key);return typeof C=="boolean"?C?E.INSTANCE:T.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class u{constructor(C,z,M){this.key=C,this.value=z,this.negated=M,this.type=4}static create(C,z,M=null){if(typeof z=="boolean")return z?b.create(C,M):g.create(C,M);const q=I.get(C);return typeof q=="boolean"?z===(q?"true":"false")?E.INSTANCE:T.INSTANCE:new u(C,z,M)}cmp(C){return C.type!==this.type?this.type-C.type:R(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=I.get(this.key);if(typeof C=="boolean"){const z=C?"true":"false";return this.value===z?E.INSTANCE:T.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class S{constructor(C,z){this.key=C,this.valueKey=z,this.type=10,this.negated=null}static create(C,z){return new S(C,z)}cmp(C){return C.type!==this.type?this.type-C.type:R(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const z=C.getValue(this.valueKey),M=C.getValue(this.key);return Array.isArray(z)?z.indexOf(M)>=0:typeof M=="string"&&typeof z=="object"&&z!==null?_.call(z,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=S;class f{constructor(C){this._actual=C,this.type=11}static create(C){return new f(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new f(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class h{constructor(C,z,M){this.key=C,this.value=z,this.negated=M,this.type=5}static create(C,z,M=null){if(typeof z=="boolean")return z?g.create(C,M):b.create(C,M);const q=I.get(C);return typeof q=="boolean"?z===(q?"true":"false")?T.INSTANCE:E.INSTANCE:new h(C,z,M)}cmp(C){return C.type!==this.type?this.type-C.type:R(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=I.get(this.key);if(typeof C=="boolean"){const z=C?"true":"false";return this.value===z?T.INSTANCE:E.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=h;class g{constructor(C,z){this.key=C,this.negated=z,this.type=3}static create(C,z=null){const M=I.get(C);return typeof M=="boolean"?M?T.INSTANCE:E.INSTANCE:new g(C,z)}cmp(C){return C.type!==this.type?this.type-C.type:p(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=I.get(this.key);return typeof C=="boolean"?C?T.INSTANCE:E.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function d(G,C){if(typeof G=="string"){const z=parseFloat(G);isNaN(z)||(G=z)}return typeof G=="string"||typeof G=="number"?C(G):T.INSTANCE}class y{constructor(C,z,M){this.key=C,this.value=z,this.negated=M,this.type=12}static create(C,z,M=null){return d(z,q=>new y(C,q,M))}cmp(C){return C.type!==this.type?this.type-C.type:R(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=y;class c{constructor(C,z,M){this.key=C,this.value=z,this.negated=M,this.type=13}static create(C,z,M=null){return d(z,q=>new c(C,q,M))}cmp(C){return C.type!==this.type?this.type-C.type:R(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class o{constructor(C,z,M){this.key=C,this.value=z,this.negated=M,this.type=14}static create(C,z,M=null){return d(z,q=>new o(C,q,M))}cmp(C){return C.type!==this.type?this.type-C.type:R(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class l{constructor(C,z,M){this.key=C,this.value=z,this.negated=M,this.type=15}static create(C,z,M=null){return d(z,q=>new l(C,q,M))}cmp(C){return C.type!==this.type?this.type-C.type:R(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=l;class i{constructor(C,z){this.key=C,this.regexp=z,this.type=7,this.negated=null}static create(C,z){return new i(C,z)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const z=this.regexp?this.regexp.source:"",M=C.regexp?C.regexp.source:"";return z<M?-1:z>M?1:0}equals(C){if(C.type===this.type){const z=this.regexp?this.regexp.source:"",M=C.regexp?C.regexp.source:"";return this.key===C.key&&z===M}return!1}substituteConstants(){return this}evaluate(C){let z=C.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class t{constructor(C){this._actual=C,this.type=8}static create(C){return new t(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new t(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function r(G){let C=null;for(let z=0,M=G.length;z<M;z++){const q=G[z].substituteConstants();if(G[z]!==q&&C===null){C=[];for(let Z=0;Z<z;Z++)C[Z]=G[Z]}C!==null&&(C[z]=q)}return C===null?G:C}class s{constructor(C,z){this.expr=C,this.negated=z,this.type=6}static create(C,z){return s._normalizeArr(C,z)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let z=0,M=this.expr.length;z<M;z++){const q=A(this.expr[z],C.expr[z]);if(q!==0)return q}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let z=0,M=this.expr.length;z<M;z++)if(!this.expr[z].equals(C.expr[z]))return!1;return!0}return!1}substituteConstants(){const C=r(this.expr);return C===this.expr?this:s.create(C,this.negated)}evaluate(C){for(let z=0,M=this.expr.length;z<M;z++)if(!this.expr[z].evaluate(C))return!1;return!0}static _normalizeArr(C,z){const M=[];let q=!1;for(const Z of C)if(!!Z){if(Z.type===1){q=!0;continue}if(Z.type===0)return T.INSTANCE;if(Z.type===6){M.push(...Z.expr);continue}M.push(Z)}if(M.length===0&&q)return E.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(A);for(let Z=1;Z<M.length;Z++)M[Z-1].equals(M[Z])&&(M.splice(Z,1),Z--);if(M.length===1)return M[0];for(;M.length>1;){const Z=M[M.length-1];if(Z.type!==9)break;M.pop();const j=M.pop(),$=M.length===0,W=a.create(Z.expr.map(Y=>s.create([Y,j],null)),null,$);W&&(M.push(W),M.sort(A))}return M.length===1?M[0]:new s(M,z)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(let z of this.expr)C.push(...z.keys());return C}map(C){return new s(this.expr.map(z=>z.map(C)),null)}negate(){if(!this.negated){const C=[];for(let z of this.expr)C.push(z.negate());this.negated=a.create(C,this,!0)}return this.negated}}class a{constructor(C,z){this.expr=C,this.negated=z,this.type=9}static create(C,z,M){return a._normalizeArr(C,z,M)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let z=0,M=this.expr.length;z<M;z++){const q=A(this.expr[z],C.expr[z]);if(q!==0)return q}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let z=0,M=this.expr.length;z<M;z++)if(!this.expr[z].equals(C.expr[z]))return!1;return!0}return!1}substituteConstants(){const C=r(this.expr);return C===this.expr?this:a.create(C,this.negated,!1)}evaluate(C){for(let z=0,M=this.expr.length;z<M;z++)if(this.expr[z].evaluate(C))return!0;return!1}static _normalizeArr(C,z,M){let q=[],Z=!1;if(C){for(let j=0,$=C.length;j<$;j++){const W=C[j];if(!!W){if(W.type===0){Z=!0;continue}if(W.type===1)return E.INSTANCE;if(W.type===9){q=q.concat(W.expr);continue}q.push(W)}}if(q.length===0&&Z)return T.INSTANCE;q.sort(A)}if(q.length!==0){if(q.length===1)return q[0];for(let j=1;j<q.length;j++)q[j-1].equals(q[j])&&(q.splice(j,1),j--);if(q.length===1)return q[0];if(M){for(let j=0;j<q.length;j++)for(let $=j+1;$<q.length;$++)F(q[j],q[$])&&(q.splice($,1),$--);if(q.length===1)return q[0]}return new a(q,z)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(let z of this.expr)C.push(...z.keys());return C}map(C){return new a(this.expr.map(z=>z.map(C)),null)}negate(){if(!this.negated){let C=[];for(let z of this.expr)C.push(z.negate());for(;C.length>1;){const z=C.shift(),M=C.shift(),q=[];for(const j of U(z))for(const $ of U(M))q.push(s.create([j,$],null));const Z=C.length===0;C.unshift(a.create(q,null,Z))}this.negated=C[0]}return this.negated}}class m extends b{constructor(C,z,M){super(C,null);this._defaultValue=z,typeof M=="object"?m._info.push({...M,key:C}):M!==!0&&m._info.push({key:C,description:M,type:z!=null?typeof z:void 0})}static all(){return m._info.values()}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return u.create(this.key,C)}notEqualsTo(C){return h.create(this.key,C)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(G,C){return G<C?-1:G>C?1:0}function R(G,C,z,M){return G<z?-1:G>z?1:C<M?-1:C>M?1:0}function F(G,C){if(C.type===6&&G.type!==9&&G.type!==6){for(const q of C.expr)if(G.equals(q))return!0}const z=G.negate(),M=U(z).concat(U(C));M.sort(A);for(let q=0;q<M.length;q++){const j=M[q].negate();for(let $=q+1;$<M.length;$++){const W=M[$];if(j.equals(W))return!0}}return!1}e.implies=F;function U(G){return G.type===9?G.expr:[G]}}),define(me[64],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,k.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,k.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(I,_){return this.secretVault[I]?.[_]??null}async setPassword(I,_,D){this.secretVault[I]=this.secretVault[I]??{},this.secretVault[I][_]=D}async deletePassword(I,_){return this.secretVault[I]?.[_]?(delete this.secretVault[I][_],Object.keys(this.secretVault[I]).length===0&&delete this.secretVault[I],!0):!1}async findPassword(I){return JSON.stringify(this.secretVault[I])??null}async findCredentials(I){const _=[];for(const D of Object.keys(this.secretVault[I]||{}))_.push({account:D,password:this.secretVault[I][D]});return _}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(me[182],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function n(I){return!!I.hostName&&!!I.errorMessage}e.isRemoteDiagnosticError=n;class w{async getPerformanceInfo(_,D){return{}}async getSystemInfo(_,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,D){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}e.NullDiagnosticsService=w}),define(me[65],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(me[183],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,k.createDecorator)("encryptionMainService")}),define(me[29],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(me[30],ve([0,1,150,6]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function w(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=w;function I(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function _(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function D(h,g){return g==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function v(h,g,d){return D(g,d)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===d?!0:P(d).includes(h)}e.isTargetPlatformCompatible=v;function P(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function A(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=A;var T;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var E;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var b;(function(h){h.Install="install",h.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var u;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var S;(function(h){h.Unsupported="Unsupported",h.UnsupportedPreRelease="UnsupportedPreRelease",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(g,d){super(g);this.code=d,this.name=d}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService")}),define(me[184],ve([0,1,7,2,22,4,61,30]),function(ee,e,k,n,w,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(S,f){return I.URI.revive(f?f.transformIncoming(S):S)}function P(S,f){return f?f.transformOutgoingURI(S):S}function A(S,f){f=f||_.DefaultURITransformer;const h=S.manifest;return{...(0,_.transformAndReviveIncomingURIs)({...S,manifest:void 0},f),manifest:h}}function T(S,f){return f?(0,w.cloneAndChange)(S,h=>h instanceof I.URI?f.transformOutgoingURI(h):void 0):S}class E{constructor(f,h){this.service=f,this.getUriTransformer=h,this.onInstallExtension=k.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,h){const g=this.getUriTransformer(f);switch(h){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,d=>d.map(y=>({...y,local:y.local?T(y.local,g):y.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,h,g){const d=this.getUriTransformer(f);switch(h){case"zip":return this.service.zip(A(g[0],d)).then(y=>P(y,d));case"unzip":return this.service.unzip(v(g[0],d));case"install":return this.service.install(v(g[0],d),g[1]);case"getManifest":return this.service.getManifest(v(g[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],g[1]);case"uninstall":return this.service.uninstall(A(g[0],d),g[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(A(g[0],d));case"getInstalled":return this.service.getInstalled(g[0]).then(y=>y.map(c=>T(c,d)));case"updateMetadata":return this.service.updateMetadata(A(g[0],d),g[1]).then(y=>T(y,d));case"updateExtensionScope":return this.service.updateExtensionScope(A(g[0],d),g[1]).then(y=>T(y,d));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=E;class b extends n.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(h=>this._onInstallExtension.fire({identifier:h.identifier,source:this.isUriComponents(h.source)?I.URI.revive(h.source):h.source}))),this._register(this.channel.listen("onDidInstallExtensions")(h=>this._onDidInstallExtensions.fire(h.map(g=>({...g,local:g.local?A(g.local,null):g.local,source:this.isUriComponents(g.source)?I.URI.revive(g.source):g.source}))))),this._register(this.channel.listen("onUninstallExtension")(h=>this._onUninstallExtension.fire(h))),this._register(this.channel.listen("onDidUninstallExtension")(h=>this._onDidUninstallExtension.fire(h)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const h=await this.getTargetPlatform();return f.allTargetPlatforms.some(g=>(0,D.isTargetPlatformCompatible)(g,f.allTargetPlatforms,h))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(h=>I.URI.revive(h)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,h){return Promise.resolve(this.channel.call("install",[f,h])).then(g=>A(g,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,h){return Promise.resolve(this.channel.call("installFromGallery",[f,h])).then(g=>A(g,null))}uninstall(f,h){return Promise.resolve(this.channel.call("uninstall",[f,h]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(h=>h.map(g=>A(g,null)))}updateMetadata(f,h){return Promise.resolve(this.channel.call("updateMetadata",[f,h])).then(g=>A(g,null))}updateExtensionScope(f,h){return Promise.resolve(this.channel.call("updateExtensionScope",[f,h])).then(g=>A(g,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=b;class u{constructor(f){this.service=f}listen(f,h){throw new Error("Invalid listen")}call(f,h,g){switch(h){case"getConfigBasedTips":return this.service.getConfigBasedTips(I.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(me[18],ve([0,1,9,31,5,15,12,4,157,6]),function(ee,e,k,n,w,I,_,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function A($){return $.create===!0}e.isFileOpenForWriteOptions=A;var T;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var E;(function($){$[$.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var b;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u($){return!!($.capabilities&2)}e.hasReadWriteCapability=u;function S($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=S;function f($){return!!($.capabilities&32768)}e.hasFileCloneCapability=f;function h($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function g($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=g;function d($){return u($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=d;var y;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(W,Y){super(W);this.code=Y}}e.FileSystemProviderError=c;function o($,W){const Y=new c($.toString(),W);return i(Y,W),Y}e.createFileSystemProviderError=o;function l($){return $||o((0,v.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=l;function i($,W){return $.name=W?`${W} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=i;function t($){if(!$)return y.Unknown;if($ instanceof c)return $.code;const W=/^(.+) \(FileSystemError\)$/.exec($.name);if(!W)return y.Unknown;switch(W[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=t;function r($){if($ instanceof F)return $.fileOperationResult;switch(t($)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(W,Y,ie){this.resource=W,this.operation=Y,this.target=ie}isOperation(W){return this.operation===W}}e.FileOperationEvent=a;var m;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class p{constructor(W,Y){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=W;const ie=new Map;for(const re of W){const oe=ie.get(re.type);switch(oe?oe.push([re.resource,re]):ie.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,oe]of ie)switch(re){case 1:this.added=n.TernarySearchTree.forUris(()=>Y),this.added.fill(oe);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>Y),this.updated.fill(oe);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>Y),this.deleted.fill(oe);break}}contains(W,...Y){return this.doContains(W,{includeChildren:!1},...Y)}affects(W,...Y){return this.doContains(W,{includeChildren:!0},...Y)}doContains(W,Y,...ie){if(!W)return!1;const re=ie.length>0;return!!((!re||ie.includes(1))&&(this.added?.get(W)||Y.includeChildren&&this.added?.findSuperstr(W))||(!re||ie.includes(0))&&(this.updated?.get(W)||Y.includeChildren&&this.updated?.findSuperstr(W))||(!re||ie.includes(2))&&(this.deleted?.findSubstr(W)||Y.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=p;function R($,W,Y){return!$||!W||$===W||W.length>$.length?!1:(W.charAt(W.length-1)!==w.sep&&(W+=w.sep),Y?(0,I.startsWithIgnoreCase)($,W):$.indexOf(W)===0)}e.isParent=R;class F extends k.ErrorNoTelemetry{constructor(W,Y,ie){super(W);this.fileOperationResult=Y,this.options=ie}}e.FileOperationError=F;class U extends F{constructor(W,Y,ie){super(W,2,ie);this.stat=Y}}e.NotModifiedSinceFileOperationError=U;var G;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(G=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function z($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=z;async function M($,W){if(!W.hasProvider(D.URI.from({scheme:$.scheme})))return new Promise(Y=>{const ie=W.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===$.scheme&&re.added&&(ie.dispose(),Y())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class q{static formatSize(W){return(0,_.isNumber)(W)||(W=0),W<q.KB?(0,v.localize)(1,null,W.toFixed(0)):W<q.MB?(0,v.localize)(2,null,(W/q.KB).toFixed(2)):W<q.GB?(0,v.localize)(3,null,(W/q.MB).toFixed(2)):W<q.TB?(0,v.localize)(4,null,(W/q.GB).toFixed(2)):(0,v.localize)(5,null,(W/q.TB).toFixed(2))}}e.ByteSize=q,q.KB=1024,q.MB=q.KB*q.KB,q.GB=q.MB*q.KB,q.TB=q.GB*q.KB;var Z;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(Z=e.Arch||(e.Arch={}));function j($){return{maxFileSize:$===0?300*q.MB:16*q.GB,maxHeapSize:$===0?700*q.MB:2*700*q.MB}}e.getPlatformLimits=j}),define(me[185],ve([0,1,17,36,9,7,2,43,4,23,18]),function(ee,e,k,n,w,I,_,D,v,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class T extends _.Disposable{constructor(b,u){super();this.channel=b,this.extraCapabilities=u,this.onDidChangeCapabilities=I.Event.None,this._onDidChange=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,P.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(b){return this.channel.call("stat",[b])}readdir(b){return this.channel.call("readdir",[b])}async readFile(b,u){const{buffer:S}=await this.channel.call("readFile",[b,u]);return S}readFileStream(b,u,S){const f=(0,D.newWriteableStream)(g=>k.VSBuffer.concat(g.map(d=>k.VSBuffer.wrap(d))).buffer),h=this.channel.listen("readFileStream",[b,u])(g=>{if(g instanceof k.VSBuffer)f.write(g.buffer);else{if(g==="end")f.end();else{let d=g;d instanceof Error||(d=(0,A.createFileSystemProviderError)((0,n.toErrorMessage)(d),A.FileSystemProviderErrorCode.Unknown)),f.error(d),f.end()}h.dispose()}});return S.onCancellationRequested(()=>{f.error((0,w.canceled)()),f.end(),h.dispose()}),f}writeFile(b,u,S){return this.channel.call("writeFile",[b,k.VSBuffer.wrap(u),S])}open(b,u){return this.channel.call("open",[b,u])}close(b){return this.channel.call("close",[b])}async read(b,u,S,f,h){const[g,d]=await this.channel.call("read",[b,u,h]);return S.set(g.buffer.slice(0,d),f),d}write(b,u,S,f,h){return this.channel.call("write",[b,u,k.VSBuffer.wrap(S),f,h])}mkdir(b){return this.channel.call("mkdir",[b])}delete(b,u){return this.channel.call("delete",[b,u])}rename(b,u,S){return this.channel.call("rename",[b,u,S])}copy(b,u,S){return this.channel.call("copy",[b,u,S])}cloneFile(b,u){return this.channel.call("cloneFile",[b,u])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(b=>{if(Array.isArray(b)){const u=b;this._onDidChange.fire(u.map(S=>({resource:v.URI.revive(S.resource),type:S.type})))}else{const u=b;this._onDidWatchError.fire(u)}}))}watch(b,u){const S=(0,P.generateUuid)();return this.channel.call("watch",[this.sessionId,S,b,u]),(0,_.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=T}),define(me[91],ve([0,1,17,9,158,18]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function _(A,T,E,b,u,S){let f;try{await D(A,T,E,b,u,S)}catch(h){f=h}finally{f&&u.errorTransformer&&(f=u.errorTransformer(f)),typeof f!="undefined"&&E.error(f),E.end()}}e.readFileIntoStream=_;async function D(A,T,E,b,u,S){v(S);const f=await A.open(T,{create:!1});try{v(S);let h=0,g=0,d=u&&typeof u.length=="number"?u.length:void 0,y=k.VSBuffer.alloc(Math.min(u.bufferSize,typeof d=="number"?d:u.bufferSize)),c=u&&typeof u.position=="number"?u.position:0,o=0;do g=await A.read(f,c,y.buffer,o,y.byteLength-o),c+=g,o+=g,h+=g,typeof d=="number"&&(d-=g),o===y.byteLength&&(await E.write(b(y)),y=k.VSBuffer.alloc(Math.min(u.bufferSize,typeof d=="number"?d:u.bufferSize)),o=0);while(g>0&&(typeof d!="number"||d>0)&&v(S)&&P(h,u));if(o>0){let l=o;typeof d=="number"&&(l=Math.min(o,d)),E.write(b(y.slice(0,l)))}}catch(h){throw(0,I.ensureFileSystemProviderError)(h)}finally{await A.close(f)}}function v(A){if(A.isCancellationRequested)throw(0,n.canceled)();return!0}function P(A,T){if(T?.limits){if(typeof T.limits.memory=="number"&&A>T.limits.memory)throw(0,I.createFileSystemProviderError)((0,w.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof T.limits.size=="number"&&A>T.limits.size)throw(0,I.createFileSystemProviderError)((0,w.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(me[54],ve([0,1,2,3,4,18]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function _(b){return b.recursive===!0}e.isRecursiveWatchRequest=_;class D extends k.Disposable{constructor(u,S,f,h){super();this.onFileChanges=u,this.onLogMessage=S,this.verboseLogging=f,this.options=h,this.watcherDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new k.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(S=>this.onFileChanges(S))),u.add(this.watcher.onDidLogMessage(S=>this.onLogMessage(S))),u.add(this.watcher.onDidError(S=>this.onError(S)))}onError(u){this.options.restartOnError?this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=D,D.MAX_RESTARTS=5;class v extends D{constructor(u,S,f){super(u,S,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=v;class P extends D{constructor(u,S,f){super(u,S,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function A(b){return b.map(u=>({type:u.type,resource:w.URI.file(u.path)}))}e.toFileChanges=A;function T(b){const u=new E;for(const S of b)u.processEvent(S);return u.coalesce()}e.coalesceEvents=T;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return n.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const S=this.mapPathToChange.get(this.toKey(u));let f=!1;if(S){const h=S.type,g=u.type;S.path!==u.path&&(u.type===2||u.type===1)?f=!0:h===1&&g===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(S)):h===2&&g===1?S.type=0:h===1&&g===0||(S.type=g)}else f=!0;f&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],S=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(u.push(f),!1):!0).sort((f,h)=>f.path.length-h.path.length).filter(f=>S.some(h=>(0,I.isParent)(f.path,h,!n.isLinux))?!1:(S.push(f.path),!0)).concat(u)}}}),define(me[186],ve([0,1,28,14,21,33,78,2,76,5,3,133,19,54]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends D.Disposable{constructor(h,g,d,y){super();this.request=h,this.onDidFilesChange=g,this.onLogMessage=d,this.verboseLogging=y,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(u.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,_.parse)(c)),this.cts=new w.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const h=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await E.Promises.stat(h);this._register(await this.doWatch(h,g.isDirectory()))}catch(h){h.code!=="ENOENT"?this.error(h):this.trace(h)}}async normalizePath(h){let g=h.path;try{g=await E.Promises.realpath(h.path),h.path===g&&(g=await(0,T.realcase)(h.path)??h.path),h.path!==g&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${g})`)}catch{}return g}async doWatch(h,g){if(A.isMacintosh&&(0,I.isEqualOrParent)(h,"/Volumes/",!0))return this.error(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const d=new w.CancellationTokenSource(this.cts.token);let y=new D.DisposableStore;try{const c=(0,P.basename)(h),o=(0,k.watch)(h);y.add((0,D.toDisposable)(()=>{o.removeAllListeners(),o.close()})),this.trace(`Started watching: '${h}'`);const l=new Set;if(g)try{for(const t of await E.Promises.readdir(h))l.add(t)}catch(t){this.error(t)}const i=new Map;y.add((0,D.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),o.on("error",(t,r)=>{this.error(`Failed to watch ${h} for changes using fs.watch() (${t}, ${r})`),this.dispose()}),o.on("change",(t,r)=>{if(d.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${r}`);let s="";if(r&&(s=r.toString(),A.isMacintosh&&(s=(0,v.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(g)if(t==="rename"){i.get(s)?.dispose();const a=setTimeout(async()=>{if(i.delete(s),s===c&&!await E.Promises.exists(h)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.existsChildStrictCase((0,P.join)(h,s));if(d.token.isCancellationRequested)return;let p;m?l.has(s)?p=0:(p=1,l.add(s)):(l.delete(s),p=2),this.onFileChange({path:(0,P.join)(this.request.path,s),type:p})},u.FILE_DELETE_HANDLER_DELAY);i.set(s,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;l.has(s)?a=0:(a=1,l.add(s)),this.onFileChange({path:(0,P.join)(this.request.path,s),type:a})}else if(t==="rename"||s!==c){const a=setTimeout(async()=>{const m=await E.Promises.exists(h);d.token.isCancellationRequested||(m?(this.onFileChange({path:this.request.path,type:0},!0),y.add(await this.doWatch(h,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);y.clear(),y.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await E.Promises.exists(h)&&!d.token.isCancellationRequested&&this.error(`Failed to watch ${h} for changes using fs.watch() (${c.toString()})`)}return(0,D.toDisposable)(()=>{d.dispose(!0),y.dispose()})}async onFileChange(h,g=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!g&&this.excludes.some(d=>d(h.path))?this.verboseLogging&&this.trace(` >> ignored ${h.path}`):this.fileChangesBuffer.push(h);try{await this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,b.coalesceEvents)(d);if(y.length>0){if(this.verboseLogging)for(const o of y)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(y)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${y[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${y.length}, most recent change: ${y[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(h){if(A.isLinux)return E.Promises.exists(h);try{const g=(0,P.basename)(h);return(await E.Promises.readdir((0,P.dirname)(h))).some(y=>y===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(h){this.verboseLogging=h}error(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}warn(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}trace(h){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.FILE_DELETE_HANDLER_DELAY=100,u.FILE_CHANGES_HANDLER_DELAY=50;async function S(f,h,g,d,y=512){const c=await E.Promises.open(f,"r"),o=Buffer.allocUnsafe(y),l=new w.CancellationTokenSource(d);let i,t=!1;const r={path:f,excludes:[],recursive:!1},s=new u(r,a=>{(async()=>{for(const{type:m}of a)if(m===0){if(t)return;t=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:p}=await E.Promises.read(c,o,0,y,null);if(!p||l.token.isCancellationRequested)break;h(o.slice(0,p))}}catch(p){i=new Error(p),l.dispose(!0)}finally{t=!1}}})()});return await s.ready,g(),new Promise((a,m)=>{l.token.onCancellationRequested(async()=>{s.dispose();try{await E.Promises.close(c)}catch(p){i=new Error(p)}i?m(i):a()})})}e.watchFileContents=S}),define(me[187],ve([0,1,16,7,2,3,186]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends w.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(P){const A=this.normalizeRequests(P),T=A.filter(b=>{const u=this.watchers.get(b.path);return u?!(0,k.equals)(u.request.excludes,b.excludes):!0}),E=Array.from(this.watchers.values()).filter(({request:b})=>!A.find(u=>u.path===b.path&&(0,k.equals)(u.excludes,b.excludes))).map(({request:b})=>b.path);T.length&&this.trace(`Request to start watching: ${T.map(b=>`${b.path} (excludes: ${b.excludes.length>0?b.excludes:"<none>"})`).join(",")}`),E.length&&this.trace(`Request to stop watching: ${E.join(",")}`);for(const b of E)this.stopWatching(b);for(const b of T)this.startWatching(b)}startWatching(P){const A=new _.NodeJSFileWatcherLibrary(P,E=>this._onDidChangeFile.fire(E),E=>this._onDidLogMessage.fire(E),this.verboseLogging),T={request:P,instance:A};this.watchers.set(P.path,T)}async stop(){for(const[P]of this.watchers)this.stopWatching(P);this.watchers.clear()}stopWatching(P){const A=this.watchers.get(P);A&&(this.watchers.delete(P),A.instance.dispose())}normalizeRequests(P){const A=new Map;for(const T of P){const E=I.isLinux?T.path:T.path.toLowerCase();A.set(E,T)}return Array.from(A.values())}async setVerboseLogging(P){this.verboseLogging=P;for(const[,A]of this.watchers)A.instance.setVerboseLogging(P)}trace(P){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P)})}toMessage(P,A){return A?`[File Watcher (node.js)] ${P} (path: ${A.request.path})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=D}),define(me[188],ve([0,1,54,187]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class w extends k.AbstractNonRecursiveWatcherClient{constructor(_,D,v){super(_,D,v);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=w}),define(me[189],ve([0,1,8,40,88,54]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class _ extends I.AbstractUniversalWatcherClient{constructor(v,P,A){super(v,P,A);this.init()}createWatcher(v){const P=v.add(new w.Client(k.FileAccess.asFileUri("bootstrap-fork",ee).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(P.onDidProcessExit(({code:A,signal:T})=>this.onError(`terminated by itself with code ${A}, signal: ${T}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(P.getChannel("watcher")))}}e.UniversalWatcherClient=_}),define(me[66],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...w){this._entries=new Map;for(let[I,_]of w)this.set(I,_)}set(w,I){const _=this._entries.get(w);return this._entries.set(w,I),_}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=k}),define(me[92],ve([0,1,14,9,53,181,6,66]),function(ee,e,k,n,w,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class P extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class A{constructor(u=new D.ServiceCollection,S=!1,f){this._activeInstantiations=new Set,this._services=u,this._strict=S,this._parent=f,this._services.set(_.IInstantiationService,this)}createChild(u){return new A(u,this._strict,this)}invokeFunction(u,...S){let f=E.traceInvocation(u),h=!1;try{return u({get:d=>{if(h)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const y=this._getOrCreateServiceInstance(d,f);if(!y)throw new Error(`[invokeFunction] unknown service '${d}'`);return y}},...S)}finally{h=!0,f.stop()}}createInstance(u,...S){let f,h;return u instanceof w.SyncDescriptor?(f=E.traceCreation(u.ctor),h=this._createInstance(u.ctor,u.staticArguments.concat(S),f)):(f=E.traceCreation(u),h=this._createInstance(u,S,f)),f.stop(),h}_createInstance(u,S=[],f){let h=_._util.getServiceDependencies(u).sort((y,c)=>y.index-c.index),g=[];for(const y of h){let c=this._getOrCreateServiceInstance(y.id,f);c||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${y.id}.`,!1),g.push(c)}let d=h.length>0?h[0].index:S.length;if(S.length!==d){console.trace(`[createInstance] First service dependency of ${u.name} at position ${d+1} conflicts with ${S.length} static arguments`);let y=d-S.length;y>0?S=S.concat(new Array(y)):S=S.slice(0,d)}return new u(...[...S,...g])}_setServiceInstance(u,S){if(this._services.get(u)instanceof w.SyncDescriptor)this._services.set(u,S);else if(this._parent)this._parent._setServiceInstance(u,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let S=this._services.get(u);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):S}_getOrCreateServiceInstance(u,S){let f=this._getServiceInstanceOrDescriptor(u);return f instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,f,S.branch(u,!0)):(S.branch(u,!1),f)}_safeCreateAndCacheServiceInstance(u,S,f){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,S,f)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,S,f){const h=new I.Graph(y=>y.id.toString());let g=0;const d=[{id:u,desc:S,_trace:f}];for(;d.length;){const y=d.pop();if(h.lookupOrInsertNode(y),g++>1e3)throw new P(h);for(let c of _._util.getServiceDependencies(y.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(c.id);if(o||this._throwIfStrict(`[createInstance] ${u} depends on ${c.id} which is NOT registered.`,!0),o instanceof w.SyncDescriptor){const l={id:c.id,desc:o,_trace:y._trace.branch(c.id,!0)};h.insertEdge(y,l),d.push(l)}}}for(;;){const y=h.roots();if(y.length===0){if(!h.isEmpty())throw new P(h);break}for(const{data:c}of y){if(this._getServiceInstanceOrDescriptor(c.id)instanceof w.SyncDescriptor){const l=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,l)}h.removeNode(c)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,S,f=[],h,g){if(this._services.get(u)instanceof w.SyncDescriptor)return this._createServiceInstance(S,f,h,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,S,f,h,g);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(u,S=[],f,h){if(f){const g=new k.IdleValue(()=>this._createInstance(u,S,h));return new Proxy(Object.create(null),{get(d,y){if(y in d)return d[y];let c=g.value,o=c[y];return typeof o!="function"||(o=o.bind(c),d[y]=o),o},set(d,y,c){return g.value[y]=c,!0}})}else return this._createInstance(u,S,h)}_throwIfStrict(u,S){if(S&&console.warn(S),this._strict)throw new Error(u)}}e.InstantiationService=A;var T;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(T||(T={}));class E{constructor(u,S){this.type=u,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return v?new E(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(u){return v?new E(0,u.name):E._None}branch(u,S){let f=new E(2,u.toString());return this._dep.push([u,S,f]),f}stop(){let u=Date.now()-this._start;E._totals+=u;let S=!1;function f(g,d){let y=[],c=new Array(g+1).join("	");for(const[o,l,i]of d._dep)if(l&&i){S=!0,y.push(`${c}CREATES -> ${o}`);let t=f(g+1,i);t&&y.push(t)}else y.push(`${c}uses -> ${o}`);return y.join(`
`)}let h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(u>2||S)&&console.log(h.join(`
`))}}e.Trace=E,E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(me[190],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,k.createDecorator)("labelService")}),define(me[67],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function n(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const I of w.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}e.isValidLocalization=n}),define(me[13],ve([0,1,36,7,2,3,6]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function D(){return new Date().toISOString()}var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function P(l,i,t){switch(i){case v.Trace:l.trace(t);break;case v.Debug:l.debug(t);break;case v.Info:l.info(t);break;case v.Warning:l.warn(t);break;case v.Error:l.error(t);break;case v.Critical:l.critical(t);break;default:throw new Error("Invalid log level")}}e.log=P;function A(l){let i="";for(let t=0;t<l.length;t++){let r=l[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}i+=(t>0?" ":"")+r}return i}e.format=A;class T extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class E extends T{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(v.Trace)&&this.log(v.Trace,A([i,...t]))}debug(i,...t){this.checkLogLevel(v.Debug)&&this.log(v.Debug,A([i,...t]))}info(i,...t){this.checkLogLevel(v.Info)&&this.log(v.Info,A([i,...t]))}warn(i,...t){this.checkLogLevel(v.Warning)&&this.log(v.Warning,A([i,...t]))}error(i,...t){if(this.checkLogLevel(v.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(v.Error,A(r))}else this.log(v.Error,A([i,...t]))}critical(i,...t){this.checkLogLevel(v.Critical)&&this.log(v.Critical,A([i,...t]))}flush(){}}e.AbstractMessageLogger=E;class b extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!I.isWindows}trace(i,...t){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,i,...t):console.log(`[main ${D()}]`,i,...t))}debug(i,...t){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,i,...t):console.log(`[main ${D()}]`,i,...t))}info(i,...t){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,i,...t):console.log(`[main ${D()}]`,i,...t))}warn(i,...t){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,i,...t):console.warn(`[main ${D()}]`,i,...t))}error(i,...t){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,i,...t):console.error(`[main ${D()}]`,i,...t))}critical(i,...t){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,i,...t):console.error(`[main ${D()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class u extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=u;class S extends T{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class f extends T{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const r of this.logServices)r.trace(i,...t)}debug(i,...t){for(const r of this.logServices)r.debug(i,...t)}info(i,...t){for(const r of this.logServices)r.info(i,...t)}warn(i,...t){for(const r of this.logServices)r.warn(i,...t)}error(i,...t){for(const r of this.logServices)r.error(i,...t)}critical(i,...t){for(const r of this.logServices)r.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=f;class h extends w.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=h;class g extends w.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,t?.always?v.Trace:this.logLevel,t),this.loggers.set(i.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class d{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return v.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=d;function y(l){if(l.verbose)return v.Trace;if(typeof l.logLevel=="string"){const i=c(l.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function c(l){switch(l){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=c;function o(l){switch(l){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=o});var Oe=this&&this.__param||function(ee,e){return function(k,n){e(k,n,ee)}};define(me[191],ve([0,1,64,7,2,13,3]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let D=class Ot extends w.Disposable{constructor(P){super();this.logService=P,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(P,A){const T=await this.withKeytar(),E=await T.getPassword(P,A);if(E)try{let{content:b,hasNextChunk:u}=JSON.parse(E);if(!b||!u)return E;let S=1;for(;u;){const f=await T.getPassword(P,`${A}-${S}`),h=JSON.parse(f);b+=h.content,u=h.hasNextChunk,S++}return b}catch{return E}return E}async setPassword(P,A,T){const E=await this.withKeytar(),b=3,u=async(S,f,h)=>{let g=0,d;for(;g<b;)try{await E.setPassword(S,f,h);return}catch(y){d=y,this.logService.warn("Error attempting to set a password: ",y),g++,await new Promise(c=>setTimeout(c,200))}throw d};if(_.isWindows&&T.length>Ot.MAX_PASSWORD_LENGTH){let S=0,f=0,h=!0;for(;h;){const g=T.substring(S,S+Ot.PASSWORD_CHUNK_SIZE);S+=Ot.PASSWORD_CHUNK_SIZE,h=T.length-S>0;const d={content:g,hasNextChunk:h};await u(P,f?`${A}-${f}`:A,JSON.stringify(d)),f++}}else await u(P,A,T);this._onDidChangePassword.fire({service:P,account:A})}async deletePassword(P,A){const E=await(await this.withKeytar()).deletePassword(P,A);return E&&this._onDidChangePassword.fire({service:P,account:A}),E}async findPassword(P){return(await this.withKeytar()).findPassword(P)}async findCredentials(P){return(await this.withKeytar()).findCredentials(P)}clear(){return this._keytarCache instanceof k.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,D=Te([Oe(0,I.ILogService)],D),e.BaseCredentialsMainService=D}),define(me[192],ve([0,1,39,14,36,7,2,8,5,19,29,13]),function(ee,e,k,n,w,I,_,D,v,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let E=class extends _.Disposable{constructor(u,S){super();this.environmentService=u,this.logService=S,this.processesLimiter=new n.Limiter(5)}async postUninstall(u){const S=this.parseScript(u,"uninstall");return S&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${f}`)))),P.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(u,S){const f=`vscode:${S}`;if(u.location.scheme===D.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[f]=="string"){const h=u.manifest.scripts[f].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${f} should be a node script`),null):{script:(0,v.join)(u.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(u,S,f,h,g){return new Promise((d,y)=>{const c=this.start(u,S,f,g);let o;const l=i=>{o&&(clearTimeout(o),o=null),i?y(i):d(void 0)};c.on("error",i=>{l((0,w.toErrorMessage)(i)||"Unknown")}),c.on("exit",(i,t)=>{l(i?`post-${S} process exited with code ${i}`:void 0)}),h&&(o=setTimeout(()=>{o=null,c.kill(),y("timed out")},5e3))})}start(u,S,f,h){const g={silent:!0,execArgv:void 0},d=(0,k.fork)(u,[`--type=extension-post-${S}`,...f],g);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const y=I.Event.fromNodeEventEmitter(d.stdout,"data"),c=I.Event.fromNodeEventEmitter(d.stderr,"data");y(i=>this.logService.info(h.identifier.id,h.manifest.version,`post-${S}`,i)),c(i=>this.logService.error(h.identifier.id,h.manifest.version,`post-${S}`,i));const o=I.Event.any(I.Event.map(y,i=>({data:`%c${i}`,format:[""]})),I.Event.map(c,i=>({data:`%c${i}`,format:["color: red"]})));return I.Event.debounce(o,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),d}getExtensionStoragePath(u){return(0,v.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};E=Te([Oe(0,A.IEnvironmentService),Oe(1,T.ILogService)],E),e.ExtensionsLifecycle=E}),define(me[193],ve([0,1,16,14,9,7,2,5,54,13]),function(ee,e,k,n,w,I,_,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class A extends _.Disposable{constructor(E,b){super();this.logService=E,this.options=b,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(E,b){return b.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,b):this.watchNonRecursive(E,b)}watchUniversal(E,b){const u={path:this.toFilePath(E),excludes:b.excludes,recursive:b.recursive},S=(0,k.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,w.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(b=>this._onDidChangeFile.fire((0,v.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const b of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(b)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const b of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(b)&&E.includes(b.path)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,b){const u={path:this.toFilePath(E),excludes:b.excludes,recursive:!1},S=(0,k.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,w.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,v.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,D.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=A}),define(me[93],ve([0,1,16,14,17,21,7,125,49,2,31,8,44,20,43,156,18,91,13]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends P.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${c}`);const l=new P.DisposableStore;return this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o}),l.add(o.onDidChangeFile(i=>this._onDidFilesChange.fire(new f.FileChangesEvent(i,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&l.add(o.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),l.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,P.dispose)(l)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(l){o.push(l)}}),!this.provider.has(c)&&await n.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,o){const l=this.provider.get(c.scheme);return!!(l&&l.capabilities&o)}listCapabilities(){return v.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,b.isAbsolutePath)(c))throw new f.FileOperationError((0,S.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const l=new Error;throw l.name="ENOPRO",l.message=(0,S.localize)(1,null,c.toString()),l}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasReadWriteCapability)(o)||(0,f.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(l){throw(0,f.toFileSystemProviderErrorCode)(l)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,S.localize)(2,null,this.resourceForError(c)),1):(0,f.ensureFileSystemProviderError)(l)}}async doResolveFile(c,o){const l=await this.withProvider(c),i=this.isPathCaseSensitive(l),t=o?.resolveTo,r=o?.resolveSingleChildDescendants,s=o?.resolveMetadata,a=await l.stat(c);let m;return this.toFileStat(l,c,a,void 0,!!s,(p,R)=>(m||(m=A.TernarySearchTree.forUris(()=>!i),m.set(c,!0),t&&m.fill(!0,t)),m.get(p.resource)||m.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&r?R===1:!1))}async toFileStat(c,o,l,i,t,r){const{providerExtUri:s}=this.getExtUri(c),a={resource:o,name:s.basename(o),isFile:(l.type&f.FileType.File)!=0,isDirectory:(l.type&f.FileType.Directory)!=0,isSymbolicLink:(l.type&f.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&f.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,f.etag)({mtime:l.mtime,size:l.size}),children:void 0};if(a.isDirectory&&r(a,i)){try{const m=await c.readdir(o),p=await n.Promises.settled(m.map(async([R,F])=>{try{const U=s.joinPath(o,R),G=t?await c.stat(U):{type:F};return await this.toFileStat(c,U,G,m.length,t,r)}catch(U){return this.logService.trace(U),null}}));a.children=(0,k.coalesce)(p)}catch(m){this.logService.trace(m),a.children=[]}return a}return a}async resolveAll(c){return n.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async stat(c){const o=await this.withProvider(c),l=await o.stat(c);return this.toFileStat(o,c,l,void 0,!0,()=>!1)}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(l){return l}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new f.FileOperationError((0,S.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=w.VSBuffer.fromString(""),l){await this.doValidateCreateFile(c,l);const i=await this.writeFile(c,o);return this._onDidRunOperation.fire(new f.FileOperationEvent(c,0,i)),i}async writeFile(c,o,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,c,l)||await this.mkdirp(i,t.dirname(c));let s;if((0,f.hasReadWriteCapability)(i)&&!(o instanceof w.VSBuffer))if((0,u.isReadableStream)(o)){const a=await(0,u.peekStream)(o,3);a.ended?s=w.VSBuffer.concat(a.buffer):s=a}else s=(0,u.peekReadable)(o,a=>w.VSBuffer.concat(a),3);else s=o;!(0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)&&s instanceof w.VSBuffer?await this.doWriteUnbuffered(i,c,l,s):await this.doWriteBuffered(i,c,l,s instanceof w.VSBuffer?(0,w.bufferToReadable)(s):s),this._onDidRunOperation.fire(new f.FileOperationEvent(c,4))}catch(r){throw new f.FileOperationError((0,S.localize)(4,null,this.resourceForError(c),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),l)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,l){if(!!l?.unlock&&!(c.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(o)));let t;try{t=await c.stat(o)}catch{return}if((t.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,S.localize)(6,null,this.resourceForError(o)),0,l);if(this.throwIfFileIsReadonly(o,t),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==f.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&l.mtime<t.mtime&&l.etag!==(0,f.etag)({mtime:l.mtime,size:t.size}))throw new f.FileOperationError((0,S.localize)(7,null),3,l);return t}async readFile(c,o,l){const i=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(i,c,o,l):this.doReadFile(i,c,o,l)}async doReadFileAtomic(c,o,l,i){return new Promise((t,r)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(c,o,l,i);t(s)}catch(s){r(s)}})})}async doReadFile(c,o,l,i){const t=await this.doReadFileStream(c,o,{...l,preferUnbuffered:!0},i);return{...t,value:await(0,w.streamToBuffer)(t.value)}}async readFileStream(c,o,l){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,o,l)}async doReadFileStream(c,o,l,i){const t=new I.CancellationTokenSource(i),r=this.validateReadFile(o,l).then(a=>a,a=>{throw t.cancel(),a});let s;try{return typeof l?.etag=="string"&&l.etag!==f.ETAG_DISABLED&&await r,l?.atomic&&(0,f.hasFileAtomicReadCapability)(c)||!((0,f.hasOpenReadWriteCloseCapability)(c)||(0,f.hasFileReadStreamCapability)(c))||(0,f.hasReadWriteCapability)(c)&&l?.preferUnbuffered?s=this.readFileUnbuffered(c,o,l):(0,f.hasFileReadStreamCapability)(c)?s=this.readFileStreamed(c,o,t.token,l):s=this.readFileBuffered(c,o,t.token,l),{...await r,value:s}}catch(a){s&&await(0,u.consumeStream)(s);const m=(0,S.localize)(8,null,this.resourceForError(o),(0,f.ensureFileSystemProviderError)(a).toString());throw a instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(m,a.stat,l):new f.FileOperationError(m,(0,f.toFileOperationResult)(a),l)}}readFileStreamed(c,o,l,i=Object.create(null)){const t=c.readFileStream(o,i,l);return(0,u.transform)(t,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new f.FileOperationError((0,S.localize)(9,null,this.resourceForError(o),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(c,o,l,i=Object.create(null)){const t=(0,w.newWriteableBufferStream)();return(0,h.readFileIntoStream)(c,o,t,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new f.FileOperationError((0,S.localize)(10,null,this.resourceForError(o),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),i)},l),t}readFileUnbuffered(c,o,l){const i=(0,u.newWriteableStream)(t=>w.VSBuffer.concat(t));return(async()=>{try{let t;l?.atomic&&(0,f.hasFileAtomicReadCapability)(c)?t=await c.readFile(o,{atomic:!0}):t=await c.readFile(o),typeof l?.position=="number"&&(t=t.slice(l.position)),typeof l?.length=="number"&&(t=t.slice(0,l.length)),this.validateReadFileLimits(o,t.byteLength,l),i.end(w.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(c,o){const l=await this.resolve(c,{resolveMetadata:!0});if(l.isDirectory)throw new f.FileOperationError((0,S.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==f.ETAG_DISABLED&&o.etag===l.etag)throw new f.NotModifiedSinceFileOperationError((0,S.localize)(12,null),l,o);return this.validateReadFileLimits(c,l.size,o),l}validateReadFileLimits(c,o,l){if(l?.limits){let i;if(typeof l.limits.memory=="number"&&o>l.limits.memory&&(i=9),typeof l.limits.size=="number"&&o>l.limits.size&&(i=7),typeof i=="number")throw new f.FileOperationError((0,S.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,o,l){return this.doCanMoveCopy(c,o,"move",l)}async canCopy(c,o,l){return this.doCanMoveCopy(c,o,"copy",l)}async doCanMoveCopy(c,o,l,i){if(c.toString()!==o.toString())try{const t=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(t,c,r,o,l,i)}catch(t){return t}return!0}async move(c,o,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(i,c,t,o,"move",!!l),s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,r==="move"?2:3,s)),s}async copy(c,o,l){const i=await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(i,c,t,o,"copy",!!l),s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,r==="copy"?3:2,s)),s}async doMoveCopy(c,o,l,i,t,r){if(o.toString()===i.toString())return t;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,o,l,i,t,r);if(s&&!a&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(i)),t==="copy"){if(c===l&&(0,f.hasFileFolderCopyCapability)(c))await c.copy(o,i,{overwrite:r});else{const m=await this.resolve(o);m.isDirectory?await this.doCopyFolder(c,m,l,i):await this.doCopyFile(c,o,l,i)}return t}else return c===l?(await c.rename(o,i,{overwrite:r}),t):(await this.doMoveCopy(c,o,l,i,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,l,i){if((0,f.hasOpenReadWriteCloseCapability)(c)&&(0,f.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(c,o,l,i);if((0,f.hasOpenReadWriteCloseCapability)(c)&&(0,f.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(c,o,l,i);if((0,f.hasReadWriteCapability)(c)&&(0,f.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(c,o,l,i);if((0,f.hasReadWriteCapability)(c)&&(0,f.hasReadWriteCapability)(l))return this.doPipeUnbuffered(c,o,l,i)}async doCopyFolder(c,o,l,i){await l.mkdir(i),Array.isArray(o.children)&&await n.Promises.settled(o.children.map(async t=>{const r=this.getExtUri(l).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(c,await this.resolve(t.resource),l,r):this.doCopyFile(c,t.resource,l,r)}))}async doValidateMoveCopy(c,o,l,i,t,r){let s=!1;if(c===l){const{providerExtUri:m,isPathCaseSensitive:p}=this.getExtUri(c);if(p||(s=m.isEqual(o,i)),s&&t==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(o),this.resourceForError(i)));if(!s&&m.isEqualOrParent(i,o))throw new Error((0,S.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!s){if(!r)throw new f.FileOperationError((0,S.localize)(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(c===l){const{providerExtUri:m}=this.getExtUri(c);if(m.isEqualOrParent(o,i))throw new Error((0,S.localize)(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,0,l)),l}async mkdirp(c,o){const l=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(o,i.dirname(o));)try{if(((await c.stat(o)).type&f.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(o)));break}catch(t){if((0,f.toFileSystemProviderErrorCode)(t)!==f.FileSystemProviderErrorCode.FileNotFound)throw t;l.push(i.basename(o)),o=i.dirname(o)}for(let t=l.length-1;t>=0;t--){o=i.joinPath(o,l[t]);try{await c.mkdir(o)}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(l){return l}return!0}async doValidateDelete(c,o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(l.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(c)));let t;try{t=await l.stat(c)}catch{}if(t)this.throwIfFileIsReadonly(c,t);else throw new f.FileOperationError((0,S.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(c)))}return l}async del(c,o){const l=await this.doValidateDelete(c,o),i=!!o?.useTrash,t=!!o?.recursive;await l.delete(c,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new f.FileOperationEvent(c,1))}async cloneFile(c,o){const l=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(l===i&&this.getExtUri(l).providerExtUri.isEqual(c,o))return;if(l===i&&(0,f.hasFileCloneCapability)(l))return l.cloneFile(c,o);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(o));const t=this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri);return l===i&&(0,f.hasFileFolderCopyCapability)(l)?t.queue(()=>l.copy(c,o,{overwrite:!0})):t.queue(()=>this.doCopyFile(l,c,i,o))}watch(c,o={recursive:!1,excludes:[]}){const l=new P.DisposableStore;let i=!1,t=()=>{i=!0};return l.add((0,P.toDisposable)(()=>t())),(async()=>{try{const r=await this.doWatch(c,o);i?(0,P.dispose)(r):t=()=>(0,P.dispose)(r)}catch(r){this.logService.error(r)}})(),l}async doWatch(c,o){const l=await this.withProvider(c),i=(0,D.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(c),o]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:l.watch(c,o)},this.activeWatchers.set(i,t)),t.count+=1,(0,P.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,P.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,P.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,l,i){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const t=await c.open(o,{create:!0,unlock:l?.unlock??!1});try{(0,u.isReadableStream)(i)||(0,u.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,t,i):await this.doWriteReadableBufferedQueued(c,t,i)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await c.close(t)}})}async doWriteStreamBufferedQueued(c,o,l){let i=0,t;if((0,u.isReadableBufferedStream)(l)){if(l.buffer.length>0){const r=w.VSBuffer.concat(l.buffer);await this.doWriteBuffer(c,o,r,r.byteLength,i,0),i+=r.byteLength}if(l.ended)return;t=l.stream}else t=l;return new Promise((r,s)=>{(0,u.listenStream)(t,{onData:async a=>{t.pause();try{await this.doWriteBuffer(c,o,a,a.byteLength,i,0)}catch(m){return s(m)}i+=a.byteLength,setTimeout(()=>t.resume())},onError:a=>s(a),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,o,l){let i=0,t;for(;(t=l.read())!==null;)await this.doWriteBuffer(c,o,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(c,o,l,i,t,r){let s=0;for(;s<i;)s+=await c.write(o,t+s,l.buffer,r+s,i-s)}async doWriteUnbuffered(c,o,l,i){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,l,i))}async doWriteUnbufferedQueued(c,o,l,i){let t;i instanceof w.VSBuffer?t=i:(0,u.isReadableStream)(i)?t=await(0,w.streamToBuffer)(i):(0,u.isReadableBufferedStream)(i)?t=await(0,w.bufferedStreamToBuffer)(i):t=(0,w.readableToBuffer)(i),await c.writeFile(o,t.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(c,o,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,l,i))}async doPipeBufferedQueued(c,o,l,i){let t,r;try{t=await c.open(o,{create:!1}),r=await l.open(i,{create:!0,unlock:!1});const s=w.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,m=0,p=0;do p=await c.read(t,a,s.buffer,m,s.byteLength-m),await this.doWriteBuffer(l,r,s,p,a,m),a+=p,m+=p,m===s.byteLength&&(m=0);while(p>0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof t=="number"?c.close(t):Promise.resolve(),typeof r=="number"?l.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,o,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,l,i))}async doPipeUnbufferedQueued(c,o,l,i){return l.writeFile(i,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,l,i))}async doPipeUnbufferedToBufferedQueued(c,o,l,i){const t=await l.open(i,{create:!0,unlock:!1});try{const r=await c.readFile(o);await this.doWriteBuffer(l,t,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await l.close(t)}}async doPipeBufferedToUnbuffered(c,o,l,i){const t=await(0,w.streamToBuffer)(this.readFileBuffered(c,o,I.CancellationToken.None));await this.doWriteUnbuffered(l,i,void 0,t)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new f.FileOperationError((0,S.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,S.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===T.Schemas.file?c.fsPath:c.toString(!0)}};d=Te([Oe(0,g.ILogService)],d),e.FileService=d}),define(me[55],ve([0,1,28,261,14,31,17,7,33,2,5,3,20,43,19,159,18,91,193,36,189,188]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(k)}catch(l){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(l)}`)}})();class o extends g.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t);this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new I.ResourceMap(r=>E.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:r}=await u.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,r),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await u.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(t.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,E.joinPath)(i,s.name))).type:a=this.toType(s),r.push([s.name,a])}catch(a){this.logService.trace(a)}})),r}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let r;return t?.dangling?r=f.FileType.Unknown:i.isFile()?r=f.FileType.File:i.isDirectory()?r=f.FileType.Directory:r=f.FileType.Unknown,t&&(r|=f.FileType.SymbolicLink),r}async createResourceLock(i){const t=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let r;for(;r=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await r.wait();const s=new w.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,P.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),s.open()})}async readFile(i,t){let r;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const s=this.toFilePath(i);return await u.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{r?.dispose()}}readFileStream(i,t,r){const s=(0,b.newWriteableStream)(a=>_.VSBuffer.concat(a.map(m=>_.VSBuffer.wrap(m))).buffer);return(0,h.readFileIntoStream)(this,i,s,a=>a.buffer,{...t,bufferSize:256*1024},r),s}async writeFile(i,t,r){let s;try{const a=this.toFilePath(i);if(!r.create||!r.overwrite){if(await u.Promises.exists(a)){if(!r.overwrite)throw(0,f.createFileSystemProviderError)((0,S.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,f.createFileSystemProviderError)((0,S.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(s,0,t,0,t.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof s=="number"&&await this.close(s)}}async open(i,t){const r=this.toFilePath(i);let s;(0,f.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(i));let a;try{if((0,f.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:p}=await u.SymlinkSupport.stat(r);p.mode&128||await u.Promises.chmod(r,p.mode|128)}catch(p){this.logService.trace(p)}let m;if((0,f.isFileOpenForWriteOptions)(t)){if(T.isWindows)try{await u.Promises.truncate(r,0),m="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}m||(m="w")}else m="r";a=await u.Promises.open(r,m)}catch(m){throw s?.dispose(),(0,f.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,m):this.toFileSystemProviderError(m)}if(this.mapHandleToPos.set(a,0),(0,f.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(a,i),s){const m=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.mapHandleToLock.set(a,s),m&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),m.dispose())}return a}async close(i){const t=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await u.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await u.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{t&&(this.mapHandleToLock.get(i)===t&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,r,s,a){const m=this.normalizePos(i,t);let p=null;try{p=(await u.Promises.read(i,r,s,a,m)).bytesRead}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(i,m,p)}return p}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,r){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof t=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,s+r):this.mapHandleToPos.delete(i)))}async write(i,t,r,s,a){return(0,w.retry)(()=>this.doWrite(i,t,r,s,a),100,3)}async doWrite(i,t,r,s,a){const m=this.normalizePos(i,t);let p=null;try{p=(await u.Promises.write(i,r,s,a,m)).bytesWritten}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),R)}finally{this.updatePos(i,m,p)}return p}async mkdir(i){try{await u.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const r=this.toFilePath(i);t.recursive?await u.Promises.rm(r,u.RimRafMode.MOVE):await u.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,t,r){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"move",r.overwrite),await u.Promises.move(s,a)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,S.localize)(2,null,(0,A.basename)(s),(0,A.basename)((0,A.dirname)(a)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(i,t,r){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"copy",r.overwrite),await u.Promises.copy(s,a,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,S.localize)(3,null,(0,A.basename)(s),(0,A.basename)((0,A.dirname)(a)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(i,t,r,s){const a=this.toFilePath(i),m=this.toFilePath(t);let p=!1;if(!!(this.capabilities&1024)||(p=(0,v.isEqual)(a,m,!0)),p&&r==="copy")throw(0,f.createFileSystemProviderError)((0,S.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!p&&await u.Promises.exists(m)){if(!s)throw(0,f.createFileSystemProviderError)((0,S.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}async cloneFile(i,t){return this.doCloneFile(i,t,!1)}async doCloneFile(i,t,r){const s=this.toFilePath(i),a=this.toFilePath(t),m=!!(this.capabilities&1024);if((0,v.isEqual)(s,a,!m))return;const p=new P.DisposableStore;try{const[R,F]=await Promise.all([this.createResourceLock(i),this.createResourceLock(t)]);p.add(R),p.add(F),r&&await u.Promises.mkdir((0,A.dirname)(a),{recursive:!0}),await u.Promises.copyFile(s,a)}catch(R){if(R.code==="ENOENT"&&!r)return this.doCloneFile(i,t,!0);throw this.toFileSystemProviderError(R)}finally{p.dispose()}}createUniversalWatcher(i,t,r){return new y.UniversalWatcherClient(s=>i(s),s=>t(s),r)}createNonRecursiveWatcher(i,t,r){return new c.NodeJSWatcherClient(s=>i(s),s=>t(s),r)}toFileSystemProviderError(i){if(i instanceof f.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=f.FileSystemProviderErrorCode.NoPermissions;break;default:t=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let r=this.toFileSystemProviderError(t);if(i&&r.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await u.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(r=(0,f.createFileSystemProviderError)(t,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return r}}e.DiskFileSystemProvider=o}),define(me[194],ve([0,1,7,55,2,17,43,21]),function(ee,e,k,n,w,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends w.Disposable{constructor(T,E){super();this.provider=T,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(T,E,b){const u=this.getUriTransformer(T);switch(E){case"stat":return this.stat(u,b[0]);case"readdir":return this.readdir(u,b[0]);case"open":return this.open(u,b[0],b[1]);case"close":return this.close(b[0]);case"read":return this.read(b[0],b[1],b[2]);case"readFile":return this.readFile(u,b[0],b[1]);case"write":return this.write(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.writeFile(u,b[0],b[1],b[2]);case"rename":return this.rename(u,b[0],b[1],b[2]);case"copy":return this.copy(u,b[0],b[1],b[2]);case"cloneFile":return this.cloneFile(u,b[0],b[1]);case"mkdir":return this.mkdir(u,b[0]);case"delete":return this.delete(u,b[0],b[1]);case"watch":return this.watch(u,b[0],b[1],b[2],b[3]);case"unwatch":return this.unwatch(b[0],b[1])}throw new Error(`IPC Command ${E} not found`)}listen(T,E,b){const u=this.getUriTransformer(T);switch(E){case"fileChange":return this.onFileChange(u,b[0]);case"readFileStream":return this.onReadFileStream(u,b[0],b[1])}throw new Error(`Unknown event ${E}`)}stat(T,E){const b=this.transformIncoming(T,E,!0);return this.provider.stat(b)}readdir(T,E){const b=this.transformIncoming(T,E);return this.provider.readdir(b)}async readFile(T,E,b){const u=this.transformIncoming(T,E,!0),S=await this.provider.readFile(u,b);return I.VSBuffer.wrap(S)}onReadFileStream(T,E,b){const u=this.transformIncoming(T,E,!0),S=new D.CancellationTokenSource,f=new k.Emitter({onLastListenerRemove:()=>{S.cancel()}}),h=this.provider.readFileStream(u,b,S.token);return(0,_.listenStream)(h,{onData:g=>f.fire(I.VSBuffer.wrap(g)),onError:g=>f.fire(g),onEnd:()=>{f.fire("end"),f.dispose(),S.dispose()}}),f.event}writeFile(T,E,b,u){const S=this.transformIncoming(T,E);return this.provider.writeFile(S,b.buffer,u)}open(T,E,b){const u=this.transformIncoming(T,E,!0);return this.provider.open(u,b)}close(T){return this.provider.close(T)}async read(T,E,b){const u=I.VSBuffer.alloc(b),S=0,f=await this.provider.read(T,E,u.buffer,S,b);return[u,f]}write(T,E,b,u,S){return this.provider.write(T,E,b.buffer,u,S)}mkdir(T,E){const b=this.transformIncoming(T,E);return this.provider.mkdir(b)}delete(T,E,b){const u=this.transformIncoming(T,E);return this.provider.delete(u,b)}rename(T,E,b,u){const S=this.transformIncoming(T,E),f=this.transformIncoming(T,b);return this.provider.rename(S,f,u)}copy(T,E,b,u){const S=this.transformIncoming(T,E),f=this.transformIncoming(T,b);return this.provider.copy(S,f,u)}cloneFile(T,E,b){const u=this.transformIncoming(T,E),S=this.transformIncoming(T,b);return this.provider.cloneFile(u,S)}onFileChange(T,E){const b=new k.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(T,b))},onLastListenerRemove:()=>{(0,w.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return b.event}async watch(T,E,b,u,S){const f=this.sessionToWatcher.get(E);if(f){const h=this.transformIncoming(T,u),g=f.watch(b,h,S);this.watchRequests.set(E+b,g)}}async unwatch(T,E){const b=T+E,u=this.watchRequests.get(b);u&&((0,w.dispose)(u),this.watchRequests.delete(b))}dispose(){super.dispose();for(const[,T]of this.watchRequests)T.dispose();this.watchRequests.clear();for(const[,T]of this.sessionToWatcher)T.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class P extends w.Disposable{constructor(T,E,b,u){super();this.uriTransformer=T,this.logService=b,this.environmentService=u,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(E)}registerListeners(T){const E=this._register(new k.Emitter);this._register(E.event(b=>{T.fire(b.map(u=>({resource:this.uriTransformer.transformOutgoingURI(u.resource),type:u.type})))})),this._register(this.fileWatcher.onDidChangeFile(b=>E.fire(b))),this._register(this.fileWatcher.onDidWatchError(b=>T.fire(b)))}getRecursiveWatcherOptions(T){}getExtraExcludes(T){}watch(T,E,b){const u=this.getExtraExcludes(this.environmentService);return Array.isArray(u)&&(b.excludes=[...b.excludes,...u]),this.watcherRequests.set(T,this.fileWatcher.watch(E,b)),(0,w.toDisposable)(()=>{(0,w.dispose)(this.watcherRequests.get(T)),this.watcherRequests.delete(T)})}dispose(){super.dispose();for(const[,T]of this.watcherRequests)T.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=P}),define(me[94],ve([0,1,7,4,13]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class I{constructor(E){this.service=E,this.onDidChangeLogLevel=k.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(E,b,u){switch(b){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=I;class _{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){_.setLevel(this.channel,E)}static setLevel(E,b){return E.call("setLevel",b)}}e.LogLevelChannelClient=_;class D{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,b){throw new Error(`Event not found: ${b}`)}async call(E,b,u){switch(b){case"createLogger":this.createLogger(n.URI.revive(u[0]),u[1]);return;case"log":return this.log(n.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${b}`)}createLogger(E,b){this.loggers.set(E.toString(),this.loggerService.createLogger(E,b))}consoleLog(E,b){let u=console.log;switch(E){case w.LogLevel.Error:u=console.error;break;case w.LogLevel.Warning:u=console.warn;break;case w.LogLevel.Info:u=console.info;break}u.call(console,...b)}log(E,b){const u=this.loggers.get(E.toString());if(!u)throw new Error("Create the logger before logging");for(const[S,f]of b)(0,w.log)(u,S,f)}}e.LoggerChannel=D;class v extends w.AbstractLoggerService{constructor(E,b,u){super(E,b);this.channel=u}createConsoleMainLogger(){return new w.AdapterLogger({log:(E,b)=>{this.channel.call("consoleLog",[E,b])}})}doCreateLogger(E,b,u){return new P(this.channel,E,b,u)}}e.LoggerChannelClient=v;class P extends w.AbstractMessageLogger{constructor(E,b,u,S){super(S?.always);this.channel=E,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[b,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,b){const u=[[E,b]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(E){this.channel.call("log",[this.file,E])}}class A extends w.LogService{constructor(E,b){super(b);this.parent=E,this._register(E.onDidChangeLogLevel(u=>b.setLevel(u)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=A}),define(me[95],ve([0,1,18,13]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function w(D,v,P,A,T){try{const E=await new Promise((u,S)=>{ee(["spdlog"],u,S)});E.setFlushOn(n.LogLevel.Trace);const b=await E.createAsyncRotatingLogger(D,v,P,A);return T&&b.clearFormatters(),b}catch(E){console.error(E)}return null}function I(D,v,P){switch(v){case n.LogLevel.Trace:D.trace(P);break;case n.LogLevel.Debug:D.debug(P);break;case n.LogLevel.Info:D.info(P);break;case n.LogLevel.Warning:D.warn(P);break;case n.LogLevel.Error:D.error(P);break;case n.LogLevel.Critical:D.critical(P);break;default:throw new Error("Invalid log level")}}class _ extends n.AbstractMessageLogger{constructor(v,P,A,T,E){super();this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(v,P,A,T),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(v,P,A,T){const E=A?6:1,b=30/E*k.ByteSize.MB,u=await w(v,P,b,E,T);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:S,message:f}of this.buffer)I(this._logger,S,f);this.buffer=[]}}log(v,P){this._logger?I(this._logger,v,P):this.getLevel()<=v&&this.buffer.push({level:v,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(me[195],ve([0,1,128,160,6]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var _;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(v){function P(u,S){return S-u}v.compare=P;const A=Object.create(null);A[v.Error]=(0,n.localize)(0,null),A[v.Warning]=(0,n.localize)(1,null),A[v.Info]=(0,n.localize)(2,null);function T(u){return A[u]||""}v.toString=T;function E(u){switch(u){case k.default.Error:return v.Error;case k.default.Warning:return v.Warning;case k.default.Info:return v.Info;case k.default.Ignore:return v.Hint}}v.fromSeverity=E;function b(u){switch(u){case v.Error:return k.default.Error;case v.Warning:return k.default.Warning;case v.Info:return k.default.Info;case v.Hint:return k.default.Ignore}}v.toSeverity=b}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(v){const P="";function A(E){return T(E,!0)}v.makeKey=A;function T(E,b){let u=[P];return E.source?u.push(E.source.replace("\xA6","\\\xA6")):u.push(P),E.code?typeof E.code=="string"?u.push(E.code.replace("\xA6","\\\xA6")):u.push(E.code.value.replace("\xA6","\\\xA6")):u.push(P),E.severity!==void 0&&E.severity!==null?u.push(_.toString(E.severity)):u.push(P),E.message&&b?u.push(E.message.replace("\xA6","\\\xA6")):u.push(P),E.startLineNumber!==void 0&&E.startLineNumber!==null?u.push(E.startLineNumber.toString()):u.push(P),E.startColumn!==void 0&&E.startColumn!==null?u.push(E.startColumn.toString()):u.push(P),E.endLineNumber!==void 0&&E.endLineNumber!==null?u.push(E.endLineNumber.toString()):u.push(P),E.endColumn!==void 0&&E.endColumn!==null?u.push(E.endColumn.toString()):u.push(P),u.push(P),u.join("\xA6")}v.makeKeyOptionalMessage=T})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(me[45],ve([0,1,8,3,25,20]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const D=n.globals.vscode.context.configuration();if(D)_=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof ee?.__$__nodeRequire=="function"){const D=(0,I.dirname)(k.FileAccess.asFileUri("",ee));_=ee.__$__nodeRequire((0,I.joinPath)(D,"product.json").fsPath);const v=ee.__$__nodeRequire((0,I.joinPath)(D,"package.json").fsPath);w.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),Object.assign(_,{version:v.version,extensionsGallery:w.env.EXTENSIONS_GALLERY?JSON.parse(w.env.EXTENSIONS_GALLERY):_.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else _={nameShort:"Code - OSS",nameLong:"Code - OSS",applicationName:"code-oss",dataFolderName:".vscode-oss",win32MutexName:"vscodeoss",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",win32DirName:"Microsoft Code OSS",win32NameVersion:"Microsoft Code OSS",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"Microsoft.CodeOSS",win32ShellNameShort:"C&ode - OSS",darwinBundleIdentifier:"com.visualstudio.code.oss",linuxIconName:"com.visualstudio.code.oss",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-webview.net/insider/181b43c0e2949e36ecb623d8cc6de29d4fa2bae8/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.references-view",version:"0.0.89",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.17",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.66.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.0",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.66.2",date:"2022-05-06T15:02:09.829Z"},Object.keys(_).length===0&&Object.assign(_,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(me[27],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(me[34],ve([0,1,118,12]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(_,D){k.ok(n.isString(_)),k.ok(n.isObject(D)),k.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,D)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new w}),define(me[196],ve([0,1,7,34]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class I{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,P){this.schemasById[w(v)]=P,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new I;n.Registry.add(e.Extensions.JSONContribution,_)}),define(me[46],ve([0,1,16,7,12,146,26,196,34]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=v.Registry.as(D.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,l=!0){this.registerConfigurations([o],l)}registerConfigurations(o,l=!0){const i=this.doRegisterConfigurations(o,l);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(o){const l=this.doDeregisterConfigurations(o);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:o,remove:l}){const i=[];i.push(...this.doDeregisterConfigurations(l)),i.push(...this.doRegisterConfigurations(o,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(i)})}registerDefaultConfigurations(o){const l=[],i=[];for(const{overrides:t,source:r}of o)for(const s in t)if(l.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const a={...this.configurationDefaultsOverrides.get(s)?.value||{},...t[s]};this.configurationDefaultsOverrides.set(s,{source:r,value:a});const m=(0,_.getLanguageTagSettingPlainKey)(s),p={type:"object",default:a,description:I.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:w.isString(r)?void 0:r};i.push(...S(s)),this.configurationProperties[s]=p,this.defaultLanguageConfigurationOverridesNode.properties[s]=p}else{this.configurationDefaultsOverrides.set(s,{value:t[s],source:r});const a=this.configurationProperties[s];a&&(this.updatePropertyDefaultValue(s,a),this.updateSchema(s,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const l=[];for(const{overrides:i,source:t}of o)for(const r in i){const s=this.configurationDefaultsOverrides.get(r),a=w.isString(t)?t:t?.id,m=w.isString(s?.source)?s?.source:s?.source?.id;if(a===m)if(l.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const p=this.configurationProperties[r];p&&(this.updatePropertyDefaultValue(r,p),this.updateSchema(r,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const l of o)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,l){const i=[];return o.forEach(t=>{i.push(...this.validateAndRegisterProperties(t,l,t.extensionInfo,t.restrictedProperties)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),i}doDeregisterConfigurations(o){const l=[],i=t=>{if(t.properties)for(const r in t.properties)l.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,t.properties[r]);t.allOf&&t.allOf.forEach(r=>i(r))};for(const t of o){i(t);const r=this.configurationContributors.indexOf(t);r!==-1&&this.configurationContributors.splice(r,1)}return l}validateAndRegisterProperties(o,l=!0,i,t,r=3){r=w.isUndefinedOrNull(o.scope)?r:o.scope;let s=[],a=o.properties;if(a)for(let p in a){if(l&&d(p)){delete a[p];continue}const R=a[p];if(R.source=i,R.defaultDefaultValue=a[p].default,this.updatePropertyDefaultValue(p,R),e.OVERRIDE_PROPERTY_REGEX.test(p)?R.scope=void 0:(R.scope=w.isUndefinedOrNull(R.scope)?r:R.scope,R.restricted=w.isUndefinedOrNull(R.restricted)?!!t?.includes(p):R.restricted),a[p].hasOwnProperty("included")&&!a[p].included){this.excludedConfigurationProperties[p]=a[p],delete a[p];continue}else this.configurationProperties[p]=a[p];!a[p].deprecationMessage&&a[p].markdownDeprecationMessage&&(a[p].deprecationMessage=a[p].markdownDeprecationMessage),s.push(p)}let m=o.allOf;if(m)for(let p of m)s.push(...this.validateAndRegisterProperties(p,l,i,t,r));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const l=i=>{let t=i.properties;if(t)for(const s in t)this.updateSchema(s,t[s]);let r=i.allOf;r&&r.forEach(l)};l(o)}updateSchema(o,l){switch(e.allSettings.properties[o]=l,l.scope){case 1:e.applicationSettings.properties[o]=l;break;case 2:e.machineSettings.properties[o]=l;break;case 6:e.machineOverridableSettings.properties[o]=l;break;case 3:e.windowSettings.properties[o]=l;break;case 4:e.resourceSettings.properties[o]=l;break;case 5:e.resourceSettings.properties[o]=l,this.resourceLanguageSettingsSchema.properties[o]=l;break}}removeFromSchema(o,l){switch(delete e.allSettings.properties[o],l.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const l=`[${o}]`,i={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,i),e.allSettings.properties[l]=i,e.applicationSettings.properties[l]=i,e.machineSettings.properties[l]=i,e.machineOverridableSettings.properties[l]=i,e.windowSettings.properties[l]=i,e.resourceSettings.properties[l]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,l){const i=this.configurationDefaultsOverrides.get(o);let t=i?.value,r=i?.source;w.isUndefined(t)&&(t=l.defaultDefaultValue,r=void 0),w.isUndefined(t)&&(t=h(l.type)),l.default=t,l.defaultValueSource=r}}const b="\\[([^\\]]+)\\]",u=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(c){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let l=u.exec(c);for(;l?.length;){const i=l[1].trim();i&&o.push(i),l=u.exec(c)}}return(0,k.distinct)(o)}e.overrideIdentifiersFromKey=S;function f(c){return c.reduce((o,l)=>`${o}[${l}]`,"")}e.keyFromOverrideIdentifiers=f;function h(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const g=new E;v.Registry.add(e.Extensions.Configuration,g);function d(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?I.localize(7,null,c):g.getConfigurationProperties()[c]!==void 0?I.localize(8,null,c):null:I.localize(6,null)}e.validateProperty=d;function y(){const c=[],o=g.getConfigurationProperties();for(const l of Object.keys(o))c.push([l,o[l].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=y}),define(me[197],ve([0,1,16,7,59,2,31,22,12,4,26,46,34]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(i={},t=[],r=[]){this._contents=i,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,A.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const r=this.getContentsForOverrideIdentifer(t);return r?i?(0,A.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const r of this.overrides)r.identifiers.includes(i)&&t.push(...r.keys);return k.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return k.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=D.deepClone(this.contents),r=D.deepClone(this.overrides),s=[...this.keys];for(const a of i){this.mergeContents(t,a.contents);for(const m of a.overrides){const[p]=r.filter(R=>k.equals(R.identifiers,m.identifiers));p?(this.mergeContents(p.contents,m.contents),p.keys.push(...m.keys),p.keys=k.distinct(p.keys)):r.push(D.deepClone(m))}for(const m of a.keys)s.indexOf(m)===-1&&s.push(m)}return new b(t,s,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const s of k.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[s],m=t[s];m&&(typeof a=="object"&&typeof m=="object"?(a=D.deepClone(a),this.mergeContents(a,m)):a=m),r[s]=a}return new b(r,this.keys,this.overrides)}mergeContents(i,t){for(const r of Object.keys(t)){if(r in i&&v.isObject(i[r])&&v.isObject(t[r])){this.mergeContents(i[r],t[r]);continue}i[r]=D.deepClone(t[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?D.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,r=null;const s=a=>{a&&(r?this.mergeContents(r,a):r=D.deepClone(a))};for(const a of this.overrides)k.equals(a.identifiers,[i])?t=a.contents:a.identifiers.includes(i)&&s(a.contents);return s(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,A.addToValueTree)(this.contents,i,t,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,A.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let r=0;r<t;r++)i.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=b;class u extends b{constructor(i={}){const t=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),s=Object.create(null),a=[];for(const m in t){const p=i[m],R=p!==void 0?p:t[m].default;(0,A.addToValueTree)(s,m,R,F=>console.error(`Conflict in default settings: ${F}`))}for(const m of Object.keys(s))T.OVERRIDE_PROPERTY_REGEX.test(m)&&a.push({identifiers:(0,T.overrideIdentifiersFromKey)(m),keys:Object.keys(s[m]),contents:(0,A.toValuesTree)(s[m],p=>console.error(`Conflict in default settings file: ${p}`))});super(s,r,a)}}e.DefaultConfigurationModel=u;class S{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!v.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:r,keys:s,overrides:a,restricted:m}=this.doParseRaw(i,t);this._configurationModel=new b(r,s,a),this._restrictedConfigurations=m||[]}doParseContent(i){let t={},r=null,s=[],a=[],m=[];function p(F){Array.isArray(s)?s.push(F):r!==null&&(s[r]=F)}let R={onObjectBegin:()=>{let F={};p(F),a.push(s),s=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let F=[];p(F),a.push(s),s=F,r=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:p,onError:(F,U,G)=>{m.push({error:F,offset:U,length:G})}};if(i)try{w.visit(i,R),t=s[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return t}doParseRaw(i,t){const r=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,t);i=s.raw;const a=(0,A.toValuesTree)(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),m=Object.keys(i),p=this.toOverrides(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:a,keys:m,overrides:p,restricted:s.restricted}}filter(i,t,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const a={},m=[];for(let p in i)if(T.OVERRIDE_PROPERTY_REGEX.test(p)&&r){const R=this.filter(i[p],t,!1,s);a[p]=R.raw,m.push(...R.restricted)}else{const R=t[p],F=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&m.push(p),(F===void 0||s.scopes===void 0||s.scopes.includes(F))&&(s.skipRestricted&&R?.restricted||(a[p]=i[p]))}return{raw:a,restricted:m}}toOverrides(i,t){const r=[];for(const s of Object.keys(i))if(T.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const m in i[s])a[m]=i[s][m];r.push({identifiers:(0,T.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,A.toValuesTree)(a,t)})}return r}}e.ConfigurationModelParser=S;class f extends I.Disposable{constructor(i,t,r,s){super();this.userSettingsResource=i,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class h{constructor(i,t,r=new b,s=new b,a=new _.ResourceMap,m=new b,p=new _.ResourceMap,R=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=m,this._memoryConfigurationByResource=p,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(i,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(i)}updateValue(i,t,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new b,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(i):s.setValue(i,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,r){const s=this.getConsolidateConfigurationModel(t,r),a=this.getFolderConfigurationModelForResource(t.resource,r),m=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,p=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),R=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),F=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),U=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),G=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,C=a?t.overrideIdentifier?a.freeze().override(t.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,z=t.overrideIdentifier?m.override(t.overrideIdentifier).getValue(i):m.getValue(i),M=s.getValue(i),q=k.distinct(k.flatten(s.overrides.map(Z=>Z.identifiers))).filter(Z=>s.getOverrideValue(i,Z)!==void 0);return{defaultValue:p,userValue:R,userLocalValue:F,userRemoteValue:U,workspaceValue:G,workspaceFolderValue:C,memoryValue:z,value:M,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:G!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:C!==void 0?{value:a?.freeze().getValue(i),override:t.overrideIdentifier?a?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:m.getValue(i),override:t.overrideIdentifier?m.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const r=[];if(!t){const{added:s,updated:a,removed:m}=c(this._defaultConfiguration,i);t=[...s,...a,...m]}for(const s of t)for(const a of(0,T.overrideIdentifiersFromKey)(s)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(a),p=i.getKeysForOverrideIdentifier(a),R=[...p.filter(F=>m.indexOf(F)===-1),...m.filter(F=>p.indexOf(F)===-1),...m.filter(F=>!D.equals(this._defaultConfiguration.override(a).getValue(F),i.override(a).getValue(F)))];r.push([a,R])}return this.updateDefaultConfiguration(i),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:r,removed:s,overrides:a}=c(this.localUserConfiguration,i),m=[...t,...r,...s];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:r,removed:s,overrides:a}=c(this.remoteUserConfiguration,i);let m=[...t,...r,...s];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:r,removed:s,overrides:a}=c(this.workspaceConfiguration,i);let m=[...t,...r,...s];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(i,t){const r=this.folderConfigurations.get(i),{added:s,updated:a,removed:m,overrides:p}=c(r,t);let R=[...s,...a,...m];return(R.length||!r)&&this.updateFolderConfiguration(i,t),{keys:R,overrides:p}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:a,overrides:m}=c(t,void 0);return{keys:[...r,...s,...a],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let r=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const s=t.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const a=this._memoryConfigurationByResource.get(i);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(t=r.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=r}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const r=t.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:r,overrides:s,keys:a}=this._folderConfigurations.get(t);return i.push([t,{contents:r,overrides:s,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((m,p)=>(m.set(P.URI.revive(p[0]),this.parseConfigurationModel(p[1])),m),new _.ResourceMap);return new h(t,r,new b,s,a,new b,new _.ResourceMap,!1)}static parseConfigurationModel(i){return new b(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=h;function g(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,t=new Map;for(const s of l)s.keys.forEach(a=>i.add(a)),s.overrides.forEach(([a,m])=>{const p=(0,_.getOrSet)(t,a,new Set);m.forEach(R=>p.add(R))});const r=[];return t.forEach((s,a)=>r.push([a,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=g;class d{constructor(i,t,r,s){this.change=i,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(p=>a.add(p)),i.overrides.forEach(([,p])=>p.forEach(R=>a.add(R))),this.affectedKeys=[...a.values()];const m=new b;this.affectedKeys.forEach(p=>m.setValue(p,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!D.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let r=(0,A.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=d;class y extends d{constructor(i,t,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=y;function c(l,i){const{added:t,removed:r,updated:s}=o(i,l),a=[],m=l?.getAllOverrideIdentifiers()||[],p=i?.getAllOverrideIdentifiers()||[];if(i){const R=p.filter(F=>!m.includes(F));for(const F of R)a.push([F,i.getKeysForOverrideIdentifier(F)])}if(l){const R=m.filter(F=>!p.includes(F));for(const F of R)a.push([F,l.getKeysForOverrideIdentifier(F)])}if(i&&l){for(const R of m)if(p.includes(R)){const F=o({contents:l.getOverrideValue(void 0,R)||{},keys:l.getKeysForOverrideIdentifier(R)},{contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)});a.push([R,[...F.added,...F.removed,...F.updated]])}}return{added:t,removed:r,updated:s,overrides:a}}function o(l,i){const t=l?i?l.keys.filter(a=>i.keys.indexOf(a)===-1):[...l.keys]:[],r=i?l?i.keys.filter(a=>l.keys.indexOf(a)===-1):[...i.keys]:[],s=[];if(l&&i){for(const a of i.keys)if(l.keys.indexOf(a)!==-1){const m=(0,A.getConfigurationValue)(i.contents,a),p=(0,A.getConfigurationValue)(l.contents,a);D.equals(m,p)||s.push(a)}}return{added:t,removed:r,updated:s}}}),define(me[96],ve([0,1,14,7,2,20,26,197,46,34]),function(ee,e,k,n,w,I,_,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class A extends w.Disposable{constructor(E,b){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new D.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,b)),this.configuration=new D.Configuration(new D.DefaultConfigurationModel,new D.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(P.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:u})=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new D.Configuration(new D.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,b){const u=typeof E=="string"?E:void 0,S=(0,_.isConfigurationOverrides)(E)?E:(0,_.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(u,S,void 0)}updateValue(E,b,u,S){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(u,b,1)}onDidDefaultConfigurationChange(E){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new D.DefaultConfigurationModel,E);this.trigger(u,b,6)}trigger(E,b,u){const S=new D.ConfigurationChangeEvent(E,{data:b},this.configuration);S.source=u,S.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=A}),define(me[97],ve([0,1,9,6]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var w;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(w=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends k.ErrorNoTelemetry{constructor(D,v=w.Unknown,P){super(D);this._message=D,this._code=v,this._detail=P,this.isHandled=v===w.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(D){return D instanceof I&&D._code===w.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof I&&D._code===w.NoResolverFound}static isHandled(D){return D instanceof I&&D.isHandled}}e.RemoteAuthorityResolverError=I}),define(me[198],ve([0,1,8]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(I){return I.scheme===k.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=n;function w(I){if(!I)return;const _=I.indexOf("+");return _<0?I:I.substr(0,_)}e.getRemoteName=w}),define(me[41],ve([0,1,15,6,198]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=I;function _(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var v;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(v=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,S){if(typeof u=="undefined"||u===null)return typeof S=="undefined"||S===null;if(typeof S=="undefined"||S===null)return!1;if(typeof u=="string"||typeof S=="string"){let f=typeof u=="string"?u:u.value,h=typeof S=="string"?S:S.value;return k.equalsIgnoreCase(f,h)}return u._lower===S._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=P;function A(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function T(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function E(b,u){if(u){const S=`onResolveRemoteAuthority:${(0,w.getRemoteName)(u)}`;return b.activationEvents?.indexOf(S)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[35],ve([0,1,15,30,41,3,4,9,25]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,t){return i.uuid&&t.uuid?i.uuid===t.uuid:i.id===t.id?!0:(0,k.compareIgnoreCase)(i.id,t.id)===0}e.areSameExtensions=P;const A=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class T{constructor(t,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=t.id}static create(t){const r=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new T(t.identifier,r,s)}static parse(t){const r=A.exec(t);return r&&r[1]&&r[2]?new T({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof T?P(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=T;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(i){const t=E.exec(i);return t&&t[1]?[S(t[1]),t[2]]:[S(i),void 0]}e.getIdAndVersion=b;function u(i,t){return`${i}.${t}`}e.getExtensionId=u;function S(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function f(i,t){return S(u(i,t))}e.getGalleryExtensionId=f;function h(i,t){const r=[],s=a=>{for(const m of r)if(m.some(p=>P(t(p),t(a))))return m;return null};for(const a of i){const m=s(a);m?m.push(a):r.push([a])}return r}e.groupByExtension=h;function g(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function d(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function y(i){const t=new Set;if(i.malicious)for(const r of i.malicious)t.add(r.id);return t}e.getMaliciousExtensionsSet=y;function c(i,t){const r=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&r.every(m=>!P(m.identifier,{id:a}))){const m=i.filter(p=>P(p.identifier,{id:a}));m.length===1&&(r.push(m[0]),s.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=c;async function o(i,t){if(!I.isLinux)return!1;let r;try{r=(await i.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){t.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=o;async function l(i,t){const r=await o(i,t),s=(0,n.getTargetPlatform)(r?"alpine":I.platform,v.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=l}),define(me[98],ve([0,1,21,9,80,8,56,4,151,30,35,41]),function(ee,e,k,n,w,I,_,D,v,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const E=f=>(0,v.localize)(0,null,f),b=(0,v.localize)(1,null,"ms-dotnettools.csharp");function u(f,h){return h?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}let S=class{constructor(h,g){this.extensionManagementService=h,this.extensionGalleryService=g}get location(){}async listExtensions(h,g,d=console){let y=await this.extensionManagementService.getInstalled(1);const c=T.EXTENSION_CATEGORIES.map(l=>l.toLowerCase());if(g&&g!==""){if(c.indexOf(g.toLowerCase())<0){d.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}y=y.filter(l=>l.manifest.categories?l.manifest.categories.map(t=>t.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){d.log("Possible Categories: "),c.forEach(l=>{d.log(l)});return}this.location&&d.log((0,v.localize)(2,null,this.location)),y=y.sort((l,i)=>l.identifier.id.localeCompare(i.identifier.id));let o;for(let l of y)o!==l.identifier.id&&(o=l.identifier.id,d.log(u(l.manifest,h)))}async installExtensions(h,g,d,y,c=console){const o=[],l=[];h.length&&c.log(this.location?(0,v.localize)(3,null,this.location):(0,v.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),t=(m,p)=>{const R=i.find(F=>(0,A.areSameExtensions)(F.identifier,{id:m}));if(R){if(!y&&(!p||p==="prerelease"&&R.preRelease))return c.log((0,v.localize)(5,null,m,R.manifest.version,m)),!1;if(p&&R.manifest.version===p)return c.log((0,v.localize)(6,null,`${m}@${p}`)),!1}return!0},r=(m,p,R)=>{a.push({id:m,version:p!=="prerelease"?p:void 0,installOptions:{...d,isBuiltin:R,installPreReleaseVersion:p==="prerelease"||d.installPreReleaseVersion}})},s=[],a=[];for(const m of h)if(m instanceof D.URI)s.push(m);else{const[p,R]=(0,A.getIdAndVersion)(m);t(p,R)&&r(p,R,!1)}for(const m of g){const[p,R]=(0,A.getIdAndVersion)(m);t(p,R)&&r(p,R,!0)}if(s.length&&await Promise.all(s.map(async m=>{try{const p=await this.installVSIX(m,{...d,isBuiltin:!1},y,c);p&&l.push(p)}catch(p){c.error(p.message||p.stack||p),o.push(m.toString())}})),a.length){const m=await this.getGalleryExtensions(a);await Promise.all(a.map(async p=>{const R=m.get(p.id.toLowerCase());if(R)try{const F=await this.installFromGallery(p,R,i,y,c);F&&l.push(F)}catch(F){c.error(F.message||F.stack||F),o.push(p.id)}else c.error(`${E(p.version?`${p.id}@${p.version}`:p.id)}
${b}`),o.push(p.id)}))}if(o.length)throw new Error((0,v.localize)(7,null,o.join(", ")))}async installVSIX(h,g,d,y){const c=await this.extensionManagementService.getManifest(h);if(!c)throw new Error("Invalid vsix");if(await this.validateVSIX(c,d,y))try{return await this.extensionManagementService.install(h,g),y.log((0,v.localize)(8,null,(0,w.getBaseLabel)(h))),c}catch(l){if((0,n.isCancellationError)(l))return y.log((0,v.localize)(9,null,(0,w.getBaseLabel)(h))),null;throw l}return null}async getGalleryExtensions(h){const g=new Map,d=h.some(c=>c.installOptions.installPreReleaseVersion),y=await this.extensionGalleryService.getExtensions(h.map(c=>({...c,preRelease:d})),k.CancellationToken.None);for(const c of y)g.set(c.identifier.id.toLowerCase(),c);return g}async installFromGallery({id:h,version:g,installOptions:d},y,c,o,l){const i=await this.extensionGalleryService.getManifest(y,k.CancellationToken.None);if(i&&!this.validateExtensionKind(i,l))return null;const t=c.find(r=>(0,A.areSameExtensions)(r.identifier,y.identifier));if(t){if(y.version===t.manifest.version)return l.log((0,v.localize)(10,null,g?`${h}@${g}`:h)),null;l.log((0,v.localize)(11,null,h,y.version))}try{return d.isBuiltin?l.log(g?(0,v.localize)(12,null,h,g):(0,v.localize)(13,null,h)):l.log(g?(0,v.localize)(14,null,h,g):(0,v.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(y,{...d,installGivenVersion:!!g}),l.log((0,v.localize)(16,null,h,y.version)),i}catch(r){if((0,n.isCancellationError)(r))return l.log((0,v.localize)(17,null,h)),null;throw r}}validateExtensionKind(h,g){return!0}async validateVSIX(h,g,d){const y={id:(0,A.getGalleryExtensionId)(h.publisher,h.name)},o=(await this.extensionManagementService.getInstalled(1)).find(l=>(0,A.areSameExtensions)(y,l.identifier)&&(0,_.gt)(l.manifest.version,h.version));return o&&!g?(d.log((0,v.localize)(18,null,o.identifier.id,o.manifest.version,h.version)),!1):this.validateExtensionKind(h,d)}async uninstallExtensions(h,g,d=console){const y=async o=>{if(o instanceof D.URI){const l=await this.extensionManagementService.getManifest(o);return u(l)}return o},c=[];for(const o of h){const l=await y(o),t=(await this.extensionManagementService.getInstalled()).filter(r=>(0,A.areSameExtensions)(r.identifier,{id:l}));if(!t.length)throw new Error(`${this.notInstalled(l)}
${b}`);if(t.some(r=>r.type===0)){d.log((0,v.localize)(19,null,l));return}if(!g&&t.some(r=>r.isBuiltin)){d.log((0,v.localize)(20,null,l));return}d.log((0,v.localize)(21,null,l));for(const r of t)await this.extensionManagementService.uninstall(r),c.push(r);this.location?d.log((0,v.localize)(22,null,l,this.location)):d.log((0,v.localize)(23,null,l))}}async locateExtension(h,g=console){const d=await this.extensionManagementService.getInstalled();h.forEach(y=>{d.forEach(c=>{if(c.identifier.id===y&&c.location.scheme===I.Schemas.file){g.log(c.location.fsPath);return}})})}notInstalled(h){return this.location?(0,v.localize)(24,null,h,this.location):(0,v.localize)(25,null,h)}};S=Te([Oe(0,P.IExtensionManagementService),Oe(1,P.IExtensionGalleryService)],S),e.ExtensionManagementCLIService=S}),define(me[199],ve([0,1,14,9,2,3,20,56,4,23,19,29,30,35,18,13]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class extends w.Disposable{constructor(g,d,y,c){super();this.fileService=d,this.extensionGalleryService=y,this.logService=c,this.extensionsDownloadDir=v.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,d){await this.cleanUpPromise;const y=this.getName(g),c=(0,_.joinPath)(this.extensionsDownloadDir,y);if(!await this.fileService.exists(c)){const o=(0,_.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(g,o,d);try{await this.rename(o,c,Date.now()+2*60*1e3)}catch(l){try{await this.fileService.del(o)}catch{}if(l.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(l)}. Deleted the vsix from downloaded location`,o.path),l}}return c}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,d,y){try{await A.Promises.rename(g.fsPath,d.fsPath)}catch(c){if(I.isWindows&&c&&c.code==="EPERM"&&Date.now()<y)return this.logService.info(`Failed renaming ${g} to ${d} with 'EPERM' error. Trying again...`),this.rename(g,d,y);throw c}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const d=[],y=[];for(const l of g.children){const i=b.ExtensionKey.parse(l.name);i&&y.push([i,l])}const c=(0,b.groupByExtension)(y,([l])=>l),o=[];for(const l of c)l.sort((i,t)=>D.rcompare(i[0].version,t[0].version)),d.push(...l.slice(1).map(i=>i[1].resource)),o.push(l[0][1]);o.sort((l,i)=>l.mtime-i.mtime),d.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(l=>l.resource)),await k.Promises.settled(d.map(l=>(this.logService.trace("Deleting vsix from cache",l.path),this.fileService.del(l))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?b.ExtensionKey.create(g).toString().toLowerCase():(0,P.generateUuid)()}};f=Te([Oe(0,T.INativeEnvironmentService),Oe(1,u.IFileService),Oe(2,E.IExtensionGalleryService),Oe(3,S.ILogService)],f),e.ExtensionsDownloader=f}),define(me[200],ve([0,1,2,5,19,41]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class _ extends k.Disposable{constructor(v,P){super();this.environmentService=v,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(P.onDidInstallExtensions(A=>this.onDidInstallExtensions(A))),this._register(P.onDidUninstallExtension(A=>this.onDidUnInstallExtension(A)))}onDidInstallExtensions(v){v.some(P=>!!P.local)&&this.invalidate()}onDidUnInstallExtension(v){v.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=_}),define(me[99],ve([0,1,68,16,14,2,8,5,19,29,30,35,67,13]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends I.Disposable{constructor(h,g,d){super();this.extensionManagementService=h,this.logService=d,this.cache=this._register(new S(g,d)),this.extensionManagementService.registerParticipant({postInstall:async y=>this.postInstallExtension(y),postUninstall:async y=>this.postUninstallExtension(y)})}async getLanguageIds(){const h=await this.cache.getLanguagePacks(),g=["en",...Object.keys(h)];return(0,n.distinct)(g)}async postInstallExtension(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",h.identifier.id),await this.update())}async postUninstallExtension(h){const g=await this.cache.getLanguagePacks();Object.keys(g).some(d=>g[d]&&g[d].extensions.some(y=>(0,T.areSameExtensions)(y.extensionIdentifier,h.identifier)))&&(this.logService.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(g);return!(0,n.equals)(Object.keys(h),Object.keys(d))}};u=Te([Oe(0,A.IExtensionManagementService),Oe(1,P.INativeEnvironmentService),Oe(2,b.ILogService)],u),e.LocalizationsService=u;let S=class extends I.Disposable{constructor(h,g){super();this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(h.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(h){return this.withLanguagePacks(g=>{Object.keys(g).forEach(d=>delete g[d]),this.createLanguagePacksFromExtensions(g,...h)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(h,...g){for(const d of g)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(h,d);Object.keys(h).forEach(d=>this.updateHash(h[d]))}createLanguagePacksFromExtension(h,g){const d=g.identifier,y=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const c of y)if(g.location.scheme===_.Schemas.file&&(0,E.isValidLocalization)(c)){let o=h[c.languageId];o||(o={hash:"",extensions:[],translations:{}},h[c.languageId]=o);let l=o.extensions.filter(i=>(0,T.areSameExtensions)(i.extensionIdentifier,d))[0];l?l.version=g.manifest.version:o.extensions.push({extensionIdentifier:d,version:g.manifest.version});for(const i of c.translations)o.translations[i.id]=(0,D.join)(g.location.fsPath,i.path)}}updateHash(h){if(h){const g=(0,k.createHash)("md5");for(const d of h.extensions)g.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);h.hash=g.digest("hex")}}withLanguagePacks(h=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return v.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch{return{}}}).then(d=>(g=h(d),d)).then(d=>{for(const c of Object.keys(d))d[c]||delete d[c];this.languagePacks=d,this.initializedCache=!0;const y=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",y),v.Promises.writeFile(this.languagePacksFilePath,y)}).then(()=>g,d=>this.logService.error(d))})}};S=Te([Oe(0,P.INativeEnvironmentService),Oe(1,b.ILogService)],S)}),define(me[47],ve([0,1,17,161,46,6,34]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");function D(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=D;function v(u){return u.res.statusCode===204}async function P(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);return v(u)?null:(await(0,k.streamToBuffer)(u.stream)).toString()}e.asText=P;async function A(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);if(v(u))return null;const f=(await(0,k.streamToBuffer)(u.stream)).toString();try{return JSON.parse(f)}catch(h){throw h.message+=`:
`+f,h}}e.asJson=A;function T(u){b(u)}e.updateProxyConfigurationsScope=T;let E;function b(u){const S=_.Registry.as(w.Extensions.Configuration),f=E;E={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[E],remove:f?[f]:[]})}b(2)}),define(me[201],ve([0,1,21,8,18,47]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let _=class{constructor(v,P){this.requestService=v,this.fileService=P}async download(v,P,A=k.CancellationToken.None){if(v.scheme===n.Schemas.file||v.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(v,P);return}const T={type:"GET",url:v.toString()},E=await this.requestService.request(T,A);if(E.res.statusCode===200)await this.fileService.writeFile(P,E.stream);else{const b=await(0,I.asText)(E);throw new Error(`Expected 200, got back ${E.res.statusCode} instead.

${b}`)}}};_=Te([Oe(0,I.IRequestService),Oe(1,w.IFileService)],_),e.DownloadService=_}),define(me[202],ve([0,1,17,21]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class w{constructor(D){this.service=D}listen(D,v){throw new Error("Invalid listen")}call(D,v,P){switch(v){case"request":return this.service.request(P[0],n.CancellationToken.None).then(async({res:A,stream:T})=>{const E=await(0,k.streamToBuffer)(T);return[{statusCode:A.statusCode,headers:A.headers},E]})}throw new Error("Invalid call")}}e.RequestChannel=w;class I{constructor(D){this.channel=D}async request(D,v){return I.request(this.channel,D,v)}static async request(D,v,P){const[A,T]=await D.call("request",[v]);return{res:A,stream:(0,k.bufferToStream)(T)}}}e.RequestChannelClient=I}),define(me[203],ve([0,1,69,12]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function w(_,D){return _.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:_.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function I(_,D,v={}){const P=(0,k.parse)(_),A=v.proxyUrl||w(P,D);if(!A)return null;const T=(0,k.parse)(A);if(!/^https?:$/.test(T.protocol||""))return null;const E={host:T.hostname||"",port:T.port||(T.protocol==="https"?"443":"80"),auth:T.auth,rejectUnauthorized:(0,n.isBoolean)(v.strictSSL)?v.strictSSL:!0};return P.protocol==="http:"?new(await new Promise((b,u)=>{ee(["http-proxy-agent"],b,u)}))(E):new(await new Promise((b,u)=>{ee(["https-proxy-agent"],b,u)}))(E)}e.getProxyAgent=I}),define(me[70],ve([0,1,39,5,162,21,36,9,3,23,144,175,14]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const b=1e4;let u;async function S(h,g,d){return g["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(d)&&!g["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(d)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=E.Promises.withAsyncBody(async(y,c)=>{const o=new I.CancellationTokenSource,l=setTimeout(()=>{o.dispose(!0),c(new Error((0,w.localize)(0,null)))},b);try{y(await f(h,o.token))}catch(i){!(0,D.isCancellationError)(i)&&!o.token.isCancellationRequested?c(new Error((0,w.localize)(1,null,(0,_.toErrorMessage)(i)))):y({})}finally{clearTimeout(l),o.dispose()}})),u)}e.getResolvedShellEnv=S;async function f(h,g){const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",y);const c=(0,P.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(c+"(.*)"+c),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",l);const i=await(0,A.getSystemShell)(v.OS,l);return h.trace("getUnixShellEnvironment#shell",i),new Promise((t,r)=>{if(g.isCancellationRequested)return r((0,D.canceled)());const s=(0,n.basename)(i);let a,m;const p=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${p} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,m=["-Login","-Command"]):(a=`'${process.execPath}' ${p} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,s==="tcsh"?m=["-ic"]:m=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),a);const R=(0,k.spawn)(i,[...m,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});g.onCancellationRequested(()=>(R.kill(),r((0,D.canceled)()))),R.on("error",G=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,_.toErrorMessage)(G)),r(G)});const F=[];R.stdout.on("data",G=>F.push(G));const U=[];R.stderr.on("data",G=>U.push(G)),R.on("close",(G,C)=>{const z=Buffer.concat(F).toString("utf8");h.trace("getUnixShellEnvironment#raw",z);const M=Buffer.concat(U).toString("utf8");if(M.trim()&&h.trace("getUnixShellEnvironment#stderr",M),G||C)return r(new Error((0,w.localize)(2,null,G,C)));const q=o.exec(z),Z=q?q[1]:"{}";try{const j=JSON.parse(Z);d?j.ELECTRON_RUN_AS_NODE=d:delete j.ELECTRON_RUN_AS_NODE,y?j.ELECTRON_NO_ATTACH_CONSOLE=y:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",j),t(j)}catch(j){h.error("getUnixShellEnvironment#errorCaught",(0,_.toErrorMessage)(j)),r(j)}})})}}),define(me[204],ve([0,1,14,7,2,44,12,135,6]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const P="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var A;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(A=e.WillSaveStateReason||(e.WillSaveStateReason={}));var T;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(T=e.StorageScope||(e.StorageScope={}));var E;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));class b extends w.Disposable{constructor(h={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=h,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,I.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(h,g){g===P?(h===0?this._globalKeyTargets=void 0:h===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:h})):this._onDidChangeValue.fire({scope:h,key:g,target:this.getKeyTargets(h)[g]})}emitWillSaveState(h){this._onWillSaveState.fire({reason:h})}get(h,g,d){return this.getStorage(g)?.get(h,d)}getBoolean(h,g,d){return this.getStorage(g)?.getBoolean(h,d)}getNumber(h,g,d){return this.getStorage(g)?.getNumber(h,d)}store(h,g,d,y){if((0,_.isUndefinedOrNull)(g)){this.remove(h,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(h,d,y),this.getStorage(d)?.set(h,g)})}remove(h,g){this.withPausedEmitters(()=>{this.updateKeyTarget(h,g,void 0),this.getStorage(g)?.delete(h)})}withPausedEmitters(h){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{h()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(h,g){const d=[],y=this.getKeyTargets(h);for(const c of Object.keys(y))y[c]===g&&d.push(c);return d}updateKeyTarget(h,g,d){const y=this.getKeyTargets(g);typeof d=="number"?y[h]!==d&&(y[h]=d,this.getStorage(g)?.set(P,JSON.stringify(y))):typeof y[h]=="number"&&(delete y[h],this.getStorage(g)?.set(P,JSON.stringify(y)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(h){return h===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(h){const g=this.get(P,h);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}isNew(h){return this.getBoolean(e.IS_NEW_KEY,h)===!0}async flush(h=A.NONE){this._onWillSaveState.fire({reason:h});const g=this.getStorage(0),d=this.getStorage(1);switch(h){case A.NONE:await k.Promises.settled([g?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await k.Promises.settled([g?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve()]);break}}async logStorage(){const h=this.getStorage(0)?.items??new Map,g=this.getStorage(1)?.items??new Map;return S(h,g,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends b{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(h=>this.emitDidChangeValue(1,h))),this._register(this.globalStorage.onDidChangeStorage(h=>this.emitDidChangeValue(0,h)))}getStorage(h){return h===0?this.globalStorage:this.workspaceStorage}getLogDetails(h){return h===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(h){}}e.InMemoryStorageService=u;async function S(f,h,g,d){const y=s=>{try{return JSON.parse(s)}catch{return s}},c=new Map,o=new Map;f.forEach((s,a)=>{c.set(a,s),o.set(a,y(s))});const l=new Map,i=new Map;h.forEach((s,a)=>{l.set(a,s),i.set(a,y(s))}),console.group(`Storage: Global (path: ${g})`);let t=[];c.forEach((s,a)=>{t.push({key:a,value:s})}),console.table(t),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${d})`);let r=[];l.forEach((s,a)=>{r.push({key:a,value:s})}),console.table(r),console.groupEnd(),console.log(i)}e.logStorage=S}),define(me[205],ve([0,1,3,25,4,23]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(P){if(k.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function D(P,A,T,E,b,u,S,f,h,g){const d=Object.create(null);d["common.machineId"]=S,d.sessionID=(0,I.generateUuid)()+Date.now(),d.commitHash=b,d.version=u,d["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,k.PlatformToString)(k.platform),d["common.nodePlatform"]=n.platform,d["common.nodeArch"]=E,d["common.product"]=g||"desktop";const y=v(f||[]);y&&(d["common.msftInternal"]=y);let c=0;const o=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),k.isLinuxSnap&&(d["common.snap"]="true");const l=_(T);l&&(d["common.platformDetail"]=l);try{const i=await P.readFile(w.URI.file(h));d["common.source"]=i.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=D;function v(P){const A=n.env.USERDNSDOMAIN;if(!A)return!1;const T=A.toLowerCase();return P.some(E=>T===E)}e.verifyMicrosoftInternalDomain=v}),define(me[206],ve([0,1,16,9,2,22]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var _;(function(v){function P(A,T){return A.callstack<T.callstack?-1:A.callstack>T.callstack?1:0}v.compare=P})(_=e.ErrorEvent||(e.ErrorEvent={}));class D{constructor(P,A=D.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new w.DisposableStore,this._telemetryService=P,this._flushDelay=A;const T=n.errorHandler.addListener(E=>this._onErrorEvent(E));this._disposables.add((0,w.toDisposable)(T)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(P){if(!P||(P.detail&&P.detail.stack&&(P=P.detail),P instanceof n.ErrorNoTelemetry))return;let A=Array.isArray(P.stack)?P.stack.join(`
`):P.stack,T=P.message?P.message:(0,I.safeStringify)(P);!A||this._enqueue({msg:T,callstack:A})}_enqueue(P){const A=(0,k.binarySearch)(this._buffer,P,_.compare);A<0?(P.count=1,this._buffer.splice(~A,0,P)):(this._buffer[A].count||(this._buffer[A].count=0),this._buffer[A].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let P of this._buffer)this._telemetryService.publicLogError2("UnhandledError",P);this._buffer.length=0}}e.default=D,D.ERROR_FLUSH_TIMEOUT=5*1e3}),define(me[207],ve([0,1,2]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class n extends k.Disposable{constructor(I,_){super();this.telemetryService=I,this.telemetryAppender=_}async call(I,_,D){switch(_){case"updateTelemetryLevel":{const{telemetryLevel:v}=D;return this.telemetryService.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:P}=D;return this.telemetryAppender?this.telemetryAppender.log(v,P):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${_} not found`)}listen(I,_,D){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=n}),define(me[32],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var w;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(w=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(me[208],ve([0,1,24,49,14,59,8,5,3,4,82,19,85,182,18,27,32]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function g(l,i){const t=`${l}::${i.join(":")}`,r=h.get(t);if(r)return r;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,m=new Map,p=2e4;function R(U,G,C,z){const M=G.substring(U.length+1);return w.Promises.withAsyncBody(async q=>{let Z;try{Z=await T.Promises.readdir(G,{withFileTypes:!0})}catch{q();return}if(z.count>=p){z.count+=Z.length,z.maxReached=!0,q();return}let j=Z.length;if(j===0){q();return}let $=Z;z.count+Z.length>p&&(z.maxReached=!0,j=p-z.count,$=Z.slice(0,j)),z.count+=Z.length;for(const W of $)if(W.isDirectory()){if(C.includes(W.name)||await R(U,(0,D.join)(G,W.name),C,z),--j==0){q();return}}else{const Y=W.name.lastIndexOf(".");if(Y>=0){const ie=W.name.substring(Y+1);ie&&a.set(ie,(a.get(ie)??0)+1)}for(const ie of s)ie.relativePathPattern?.test(M)!==!1&&ie.filePattern.test(W.name)&&m.set(ie.tag,(m.get(ie.tag)??0)+1);if(--j==0){q();return}}})}const F=w.Promises.withAsyncBody(async U=>{const G={count:0,maxReached:!1};await R(l,l,i,G);const C=await c(l);U({configFiles:d(m),fileTypes:d(a),fileCount:G.count,maxFilesReached:G.maxReached,launchConfigFiles:C})});return h.set(t,F),F}e.collectWorkspaceStats=g;function d(l){return[...n.Iterable.map(l.entries(),([i,t])=>({name:i,count:t}))].sort((i,t)=>t.count-i.count)}function y(){const l={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},i=k.cpus();return i&&i.length>0&&(l.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),l}e.getMachineInfo=y;async function c(l){try{const i=new Map,t=(0,D.join)(l,".vscode","launch.json"),r=await T.Promises.readFile(t),s=[],a=(0,I.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,I.getNodeType)(a)==="object"&&a.configurations)for(const m of a.configurations){const p=m.type;p&&(i.has(p)?i.set(p,i.get(p)+1):i.set(p,1))}return d(i)}catch{return[]}}e.collectLaunchConfigs=c;let o=class{constructor(i,t){this.telemetryService=i,this.productService=t}formatMachineInfo(i){const t=[];return t.push(`OS Version:       ${i.os}`),t.push(`CPUs:             ${i.cpus}`),t.push(`Memory (System):  ${i.memory}`),t.push(`VM:               ${i.vmHint}`),t.join(`
`)}formatEnvironment(i){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const r=k.cpus();return r&&r.length>0&&t.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),v.isWindows||t.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${i.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(i,t){return Promise.all([(0,E.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[s,a]=r,m=this.formatProcessList(i,s);return t.forEach(p=>{if((0,b.isRemoteDiagnosticError)(p))m+=`
${p.errorMessage}`,a+=`
${p.errorMessage}`;else if(m+=`

Remote: ${p.hostName}`,p.processes&&(m+=`
${this.formatProcessList(i,p.processes)}`),p.workspaceMetadata){a+=`
|  Remote: ${p.hostName}`;for(const R of Object.keys(p.workspaceMetadata)){const F=p.workspaceMetadata[R];let U=`${F.fileCount} files`;F.maxFilesReached&&(U=`more than ${U}`),a+=`|    Folder (${R}): ${U}`,a+=this.formatWorkspaceStats(F)}}}),{processInfo:m,workspaceInfo:a}})}async getSystemInfo(i,t){const{memory:r,vmHint:s,os:a,cpus:m}=y(),p={os:a,memory:r,cpus:m,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:t};return v.isWindows||(p.load=`${k.loadavg().map(R=>Math.round(R)).join(", ")}`),v.isLinux&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(i,t){const r=[];return(0,E.listProcesses)(i.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,s)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),t.forEach(a=>{if((0,b.isRemoteDiagnosticError)(a))r.push(`
${a.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${a.hostName}`),r.push(this.formatMachineInfo(a.machineInfo)),a.processes&&r.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const m of Object.keys(a.workspaceMetadata)){const p=a.workspaceMetadata[m];let R=`${p.fileCount} files`;p.maxFilesReached&&(R=`more than ${R}`),r.push(`Folder (${m}): ${R}`),r.push(this.formatWorkspaceStats(p))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const t=[],r=60;let s=0;const a=(F,U)=>{const G=` ${F}(${U})`;s+G.length>r?(t.push(m),m="|                 ",s=m.length):s+=G.length,m+=G};let m="|      File types:";const p=10;let R=i.fileTypes.length>p?p:i.fileTypes.length;for(let F=0;F<R;F++){const U=i.fileTypes[F];a(U.name,U.count)}if(t.push(m),i.configFiles.length>=0&&(m="|      Conf files:",s=0,i.configFiles.forEach(F=>{a(F.name,F.count)}),t.push(m)),i.launchConfigFiles.length>0){let F="|      Launch Configs:";i.launchConfigFiles.forEach(U=>{F+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),t.push(F)}return t.join(`
`)}expandGPUFeatures(i){const t=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(t-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const t=[],r=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const m=P.URI.revive(a);if(m.scheme===_.Schemas.file){const p=m.fsPath;r.push(g(p,["node_modules",".git"]).then(R=>{let F=`${R.fileCount} files`;R.maxFilesReached&&(F=`more than ${F}`),t.push(`|    Folder (${(0,D.basename)(p)}): ${F}`),t.push(this.formatWorkspaceStats(R))}).catch(R=>{t.push(`|      Error: Unable to collect workspace stats for folder ${p} (${R.toString()})`)}))}else t.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,t){const r=new Map;i.windows.forEach(a=>r.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(i.mainPID,r,s,t,0),s.join(`
`)}formatProcessItem(i,t,r,s,a){const m=a===0;let p;m?p=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(p=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(p=`${p} (${t.get(s.pid)})`));const R=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(R/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(s.children)&&s.children.forEach(F=>this.formatProcessItem(i,t,r,F,a+1))}async getWorkspaceFileExtensions(i){const t=new Set;for(const{uri:r}of i.folders){const s=P.URI.revive(r);if(s.scheme!==_.Schemas.file)continue;const a=s.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(p=>t.add(p.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(i){for(const{uri:t}of i.folders){const r=P.URI.revive(t);if(r.scheme!==_.Schemas.file)continue;const s=r.fsPath;try{const a=await g(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),a.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),a.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};o=Te([Oe(0,f.ITelemetryService),Oe(1,S.IProductService)],o),e.DiagnosticsService=o}),define(me[209],ve([0,1,16,14,21,9,7,2,3,4,149,30,35,13,27,32]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends D.Disposable{constructor(o,l,i,t){super();this.galleryService=o,this.telemetryService=l,this.logService=i,this.productService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new _.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new _.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new _.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new _.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const l=await this.getTargetPlatform();return o.allTargetPlatforms.some(i=>(0,T.isTargetPlatformCompatible)(i,o.allTargetPlatforms,l))}async installFromGallery(o,l={}){try{if(!this.galleryService.isEnabled())throw new T.ExtensionManagementError(A.localize(0,null),T.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(o,!l.installGivenVersion,!!l.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,l)}catch(i){throw d(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(o),void 0,i),this.logService.error("Failed to install extension.",o.identifier.id),this.logService.error(i),g(i)}}async uninstall(o,l={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,l)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(A.localize(1,null));const l=await this.getTargetPlatform(),[i]=await this.galleryService.getExtensions([{...o.identifier,preRelease:o.preRelease}],{targetPlatform:l,compatible:!0},w.CancellationToken.None);if(!i)throw new Error(A.localize(2,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.extensionsControlManifest||o-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=o),this.extensionsControlManifest}registerParticipant(o){this.participants.push(o)}async installExtension(o,l,i){if(!P.URI.isUri(l)){let m=this.installingExtensions.get(E.ExtensionKey.create(l).toString());if(m)return this.logService.info("Extensions is already requested to install",l.identifier.id),m.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],r=[],s=this.createInstallExtensionTask(o,l,i);P.URI.isUri(l)||this.installingExtensions.set(E.ExtensionKey.create(l).toString(),s),this._onInstallExtension.fire({identifier:s.identifier,source:l}),this.logService.info("Installing extension:",s.identifier.id),t.push({task:s,manifest:o});let a=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",s.identifier.id);else try{const p=await this.getAllDepsAndPackExtensionsToInstall(s.identifier,o,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:R,manifest:F}of p){a=a||!!F.extensionDependencies?.some(G=>(0,E.areSameExtensions)({id:G},s.identifier));const U=E.ExtensionKey.create(R).toString();if(this.installingExtensions.has(U))this.logService.info("Extension is already requested to install",R.identifier.id);else{const G=this.createInstallExtensionTask(F,R,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(U,G),this._onInstallExtension.fire({identifier:G.identifier,source:R}),this.logService.info("Installing extension:",G.identifier.id),t.push({task:G,manifest:F})}}}catch(p){if(P.URI.isUri(s.source))(0,k.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",s.identifier.id,p.message),(0,k.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",s.identifier.id,p.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",s.identifier.id),p}const m=t.reduce((p,{task:R,manifest:F})=>(p.set(R.identifier.id.toLowerCase(),{task:R,manifest:F}),p),new Map);for(;m.size;){let p;const R=[...m.values()].filter(({manifest:F})=>!F.extensionDependencies?.some(U=>m.has(U.toLowerCase())));R.length?p=m.size===1?R:R.filter(({task:F})=>!(F===s&&!a)):(this.logService.info("Found extensions with circular dependencies",R.map(({task:F})=>F.identifier.id)),p=[...m.values()]),await this.joinAllSettled(p.map(async({task:F})=>{const U=new Date().getTime();try{const G=await F.run();if(await this.joinAllSettled(this.participants.map(C=>C.postInstall(G,F.source,i,w.CancellationToken.None))),!P.URI.isUri(F.source)&&(d(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(F.source),new Date().getTime()-U,void 0),v.isWeb&&F.operation!==3))try{await this.galleryService.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}r.push({local:G,identifier:F.identifier,operation:F.operation,source:F.source})}catch(G){throw P.URI.isUri(F.source)||d(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(F.source),new Date().getTime()-U,G),this.logService.error("Error while installing the extension:",F.identifier.id),G}finally{m.delete(F.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:p})=>this.logService.info("Extension installed successfully:",p.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:p})=>(0,E.areSameExtensions)(p,s.identifier))[0].local}catch(m){if(t.forEach(({task:p})=>p.cancel()),r.length)try{const p=await Promise.allSettled(r.map(({local:R})=>this.createUninstallExtensionTask(R,{versionOnly:!0}).run()));for(let R=0;R<p.length;R++){const F=p[R],{identifier:U}=r[R];F.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,I.getErrorMessage)(F.reason))}}catch(p){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(p),r.map(({identifier:R})=>R.id))}throw this._onDidInstallExtensions.fire(t.map(({task:p})=>({identifier:p.identifier,operation:2,source:p.source}))),m}finally{for(const{task:m}of t)if(!P.URI.isUri(m.source)){const p=E.ExtensionKey.create(m.source).toString();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(o){const l=[],i=[],t=await Promise.allSettled(o);for(const r of t)r.status==="fulfilled"?l.push(r.value):i.push(r.reason);if(i.length)throw h(i);return l}async getAllDepsAndPackExtensionsToInstall(o,l,i,t){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const s=[o,...r.map(p=>p.identifier)],a=[],m=async(p,R)=>{const F=R.extensionDependencies||[],U=[...F];if(R.extensionPack){const G=i?r.find(C=>(0,E.areSameExtensions)(C.identifier,p)):void 0;for(const C of R.extensionPack)G&&G.manifest.extensionPack&&G.manifest.extensionPack.some(z=>(0,E.areSameExtensions)({id:z},{id:C}))||U.every(z=>!(0,E.areSameExtensions)({id:z},{id:C}))&&U.push(C)}if(U.length){const G=[...s,...a.map(z=>z.gallery.identifier)],C=U.filter(z=>G.every(M=>!(0,E.areSameExtensions)(M,{id:z})));if(C.length){const z=await this.galleryService.getExtensions(C.map(M=>({id:M,preRelease:t})),w.CancellationToken.None);for(const M of z){if(G.find(j=>(0,E.areSameExtensions)(j,M.identifier)))continue;const q=F.some(j=>(0,E.areSameExtensions)({id:j},M.identifier));let Z;try{Z=await this.checkAndGetCompatibleVersion(M,!0,t)}catch(j){if(j instanceof T.ExtensionManagementError&&j.code===T.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!q){this.logService.info("Skipping the packed extension as it cannot be installed",M.identifier.id);continue}else throw j}a.push({gallery:Z.extension,manifest:Z.manifest}),await m(Z.extension.identifier,Z.manifest)}}}};return await m(o,l),r=await this.getInstalled(),a.filter(p=>!r.some(R=>(0,E.areSameExtensions)(R.identifier,p.gallery.identifier)))}async checkAndGetCompatibleVersion(o,l,i){const t=await this.getExtensionsControlManifest();if((0,E.getMaliciousExtensionsSet)(t).has(o.identifier.id))throw new T.ExtensionManagementError(A.localize(3,null,o.identifier.id),T.ExtensionManagementErrorCode.Malicious);if(!!t.unsupportedPreReleaseExtensions&&!!t.unsupportedPreReleaseExtensions[o.identifier.id])throw new T.ExtensionManagementError(A.localize(4,null,o.identifier.id,t.unsupportedPreReleaseExtensions[o.identifier.id].displayName),T.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(o)){const a=await this.getTargetPlatform();throw new T.ExtensionManagementError(A.localize(5,null,o.identifier.id,this.productService.nameLong,(0,T.TargetPlatformToString)(a)),T.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const r=await this.getCompatibleVersion(o,l,i);if(r){if(i&&l&&o.hasPreReleaseVersion&&!r.properties.isPreReleaseVersion)throw new T.ExtensionManagementError(A.localize(6,null,o.identifier.id,this.productService.nameLong,this.productService.version),T.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!i&&o.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([o.identifier],w.CancellationToken.None))[0]?new T.ExtensionManagementError(A.localize(7,null,o.identifier.id),T.ExtensionManagementErrorCode.ReleaseVersionNotFound):new T.ExtensionManagementError(A.localize(8,null,o.identifier.id,this.productService.nameLong,this.productService.version),T.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",r.identifier.id);const s=await this.galleryService.getManifest(r,w.CancellationToken.None);if(s===null)throw new T.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,T.ExtensionManagementErrorCode.Invalid);if(s.version!==r.version)throw new T.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,T.ExtensionManagementErrorCode.Invalid);return{extension:r,manifest:s}}async getCompatibleVersion(o,l,i){const t=await this.getTargetPlatform();let r=null;return l&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==i&&(r=(await this.galleryService.getExtensions([{...o.identifier,preRelease:i}],{targetPlatform:t,compatible:!0},w.CancellationToken.None))[0]||null),!r&&await this.galleryService.isExtensionCompatible(o,i,t)&&(r=o),!r&&l&&(r=await this.galleryService.getCompatibleExtension(o,i,t)),r}async unininstallExtension(o,l){const i=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),i.waitUntilTaskIsFinished();const t=(m,p)=>{const R=this.createUninstallExtensionTask(m,p);return this.uninstallingExtensions.set(R.extension.identifier.id.toLowerCase(),R),this.logService.info("Uninstalling extension:",m.identifier.id),this._onUninstallExtension.fire(m.identifier),R},r=(m,p)=>{p?this.logService.error("Failed to uninstall extension:",m.identifier.id,p.message):this.logService.info("Successfully uninstalled extension:",m.identifier.id),d(this.telemetryService,"extensionGallery:uninstall",(0,E.getLocalExtensionTelemetryData)(m),void 0,p),this._onDidUninstallExtension.fire({identifier:m.identifier,error:p?.code})},s=[],a=[];try{s.push(t(o,{}));const m=await this.getInstalled(1);if(l.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const p=this.getAllPackExtensionsToUninstall(o,m);for(const R of p)this.uninstallingExtensions.has(R.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",R.identifier.id):s.push(t(R,{}))}l.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(s.map(p=>p.extension),m,o),await this.joinAllSettled(s.map(async p=>{try{if(await p.run(),await this.joinAllSettled(this.participants.map(R=>R.postUninstall(p.extension,l,w.CancellationToken.None))),p.extension.identifier.uuid)try{await this.galleryService.reportStatistic(p.extension.manifest.publisher,p.extension.manifest.name,p.extension.manifest.version,"uninstall")}catch{}r(p.extension)}catch(R){const F=R instanceof T.ExtensionManagementError?R:new T.ExtensionManagementError((0,I.getErrorMessage)(R),T.ExtensionManagementErrorCode.Internal);throw r(p.extension,F),F}finally{a.push(p)}}))}catch(m){const p=m instanceof T.ExtensionManagementError?m:new T.ExtensionManagementError((0,I.getErrorMessage)(m),T.ExtensionManagementErrorCode.Internal);for(const R of s){try{R.cancel()}catch{}a.includes(R)||r(R.extension,p)}throw p}finally{for(const m of s)this.uninstallingExtensions.delete(m.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",m.extension.identifier.id)}}checkForDependents(o,l,i){for(const t of o){const r=this.getDependents(t,l);if(r.length){const s=r.filter(a=>!o.some(m=>(0,E.areSameExtensions)(m.identifier,a.identifier)));if(s.length)throw new Error(this.getDependentsErrorMessage(t,s,i))}}}getDependentsErrorMessage(o,l,i){return i===o?l.length===1?A.localize(9,null,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?A.localize(10,null,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):A.localize(11,null,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):l.length===1?A.localize(12,null,i.manifest.displayName||i.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?A.localize(13,null,i.manifest.displayName||i.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):A.localize(14,null,i.manifest.displayName||i.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name)}getAllPackExtensionsToUninstall(o,l,i=[]){if(i.indexOf(o)!==-1)return[];i.push(o);const t=o.manifest.extensionPack?o.manifest.extensionPack:[];if(t.length){const r=l.filter(a=>!a.isBuiltin&&t.some(m=>(0,E.areSameExtensions)({id:m},a.identifier))),s=[];for(const a of r)s.push(...this.getAllPackExtensionsToUninstall(a,l,i));return[...r,...s]}return[]}getDependents(o,l){return l.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(t=>(0,E.areSameExtensions)({id:t},o.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",o),o}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=Te([Oe(0,T.IExtensionGalleryService),Oe(1,S.ITelemetryService),Oe(2,b.ILogService),Oe(3,u.IProductService)],f),e.AbstractExtensionManagementService=f;function h(c){const o=Array.isArray(c)?c:[c];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((l,i)=>new Error(`${l.message}${l.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=h;function g(c){if(c instanceof T.ExtensionManagementError)return c;const o=new T.ExtensionManagementError(c.message,T.ExtensionManagementErrorCode.Internal);return o.stack=c.stack,o}function d(c,o,l,i,t){const r=t?t instanceof T.ExtensionManagementError?t.code:T.ExtensionManagementErrorCode.Internal:void 0;c.publicLogError(o,{...l,success:!t,duration:i,errorcode:r})}e.reportTelemetry=d;class y{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(o=>new Promise((l,i)=>{const t=o.onCancellationRequested(()=>{t.dispose(),i((0,I.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=y}),define(me[42],ve([0,1,22,12,26,32]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class _{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(g,d){return Promise.resolve(void 0)}publicLog2(g,d){return this.publicLog(g,d)}publicLogError(g,d){return Promise.resolve(void 0)}publicLogError2(g,d){return this.publicLogError(g,d)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=_,e.NullTelemetryService=new _;class D{async publicLog(g,d,y){}async publicLogError(g,d,y){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(h,g){return g.onDidChangeConfiguration(d=>{d.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(d.source),configurationKeys:u(d.sourceConfig)})})}e.configurationTelemetry=v;function P(h,g){return!(g.disableTelemetry||!h.enableTelemetry||g.extensionTestsLocationURI)}e.supportsTelemetry=P;function A(h){const g=h.getValue(I.TELEMETRY_SETTING_ID),d=h.getValue("telemetry.enableCrashReporter");if(h.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||d===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=A;function T(h){const g=Object.create(null),d=Object.create(null),y=Object.create(null);b(h,y);for(let c in y){c=c.length>150?c.substr(c.length-149):c;const o=y[c];typeof o=="number"?d[c]=o:typeof o=="boolean"?d[c]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${o.length}`),g[c]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(g[c]=o)}return{properties:g,measurements:d}}e.validateTelemetryData=T;function E(h){if(!h)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{h.indexOf(`${y}+`)===0&&(g=y)}),g}e.cleanRemoteAuthority=E;function b(h,g,d=0,y){if(!!h)for(let c of Object.getOwnPropertyNames(h)){const o=h[c],l=y?y+c:c;Array.isArray(o)?g[l]=(0,k.safeStringify)(o):o instanceof Date?g[l]=o.toISOString():(0,n.isObject)(o)?d<2?b(o,g,d+1,l+"."):g[l]=(0,k.safeStringify)(o):g[l]=o}}function u(h){if(!h)return[];const g=[];return S(g,"",h),g}function S(h,g,d){d&&typeof d=="object"&&!Array.isArray(d)?Object.keys(d).forEach(y=>S(h,g?`${g}.${y}`:y,d[y])):h.push(g)}function f(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(me[210],ve([0,1,179,42]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function w(I,_,D,v,P,A){const T={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${_.nameShort})`},E=await(0,k.getServiceMachineId)(D,P,A);return(0,n.supportsTelemetry)(_,D)&&(0,n.getTelemetryLevel)(v)===3&&(T["X-Market-User-Id"]=E),T}e.resolveMarketplaceHeaders=w}),define(me[100],ve([0,1,16,21,9,22,3,25,12,4,26,29,30,35,63,18,13,27,47,210,204,32]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const o=_.isWeb?"web":(0,E.getTargetPlatform)(_.platform,D.arch);var l;(function(H){H[H.None=0]="None",H[H.IncludeVersions=1]="IncludeVersions",H[H.IncludeFiles=2]="IncludeFiles",H[H.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",H[H.IncludeSharedAccounts=8]="IncludeSharedAccounts",H[H.IncludeVersionProperties=16]="IncludeVersionProperties",H[H.ExcludeNonValidated=32]="ExcludeNonValidated",H[H.IncludeInstallationTargets=64]="IncludeInstallationTargets",H[H.IncludeAssetUri=128]="IncludeAssetUri",H[H.IncludeStatistics=256]="IncludeStatistics",H[H.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",H[H.Unpublished=4096]="Unpublished",H[H.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(l||(l={}));function i(...H){return String(H.reduce((O,V)=>O|V,0))}var t;(function(H){H[H.Tag=1]="Tag",H[H.ExtensionId=4]="ExtensionId",H[H.Category=5]="Category",H[H.ExtensionName=7]="ExtensionName",H[H.Target=8]="Target",H[H.Featured=9]="Featured",H[H.SearchText=10]="SearchText",H[H.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class p{constructor(O=m){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,V=this.state.pageSize){return new p({...this.state,pageNumber:O,pageSize:V})}withFilter(O,...V){const J=[...this.state.criteria,...V.length?V.map(ae=>({filterType:O,value:ae})):[{filterType:O}]];return new p({...this.state,criteria:J})}withSortBy(O){return new p({...this.state,sortBy:O})}withSortOrder(O){return new p({...this.state,sortOrder:O})}withFlags(...O){return new p({...this.state,flags:O.reduce((V,J)=>V|J,0)})}withAssetTypes(...O){return new p({...this.state,assetTypes:O})}get raw(){const{criteria:O,pageNumber:V,pageSize:J,sortBy:ae,sortOrder:ge,flags:he,assetTypes:le}=this.state;return{filters:[{criteria:O,pageNumber:V,pageSize:J,sortBy:ae,sortOrder:ge}],assetTypes:le,flags:he}}get searchText(){const O=this.state.criteria.filter(V=>V.filterType===t.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber)}}}function R(H,O){const V=(H||[]).filter(J=>J.statisticName===O)[0];return V?V.value:0}function F(H){const O="Microsoft.VisualStudio.Code.Translation.";return H.files.filter(J=>J.assetType.indexOf(O)===0).reduce((J,ae)=>{const ge=C(H,ae.assetType);return ge&&J.push([ae.assetType.substring(O.length),ge]),J},[])}function U(H){if(H.properties){const O=H.properties.filter(ae=>ae.key===r.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=O.filter(ae=>V.test(ae.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return C(H,r.Repository)}function G(H){return{uri:`${H.fallbackAssetUri}/${r.VSIX}?redirect=true${H.targetPlatform?`&targetPlatform=${H.targetPlatform}`:""}`,fallbackUri:`${H.fallbackAssetUri}/${r.VSIX}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`}}function C(H,O){return H.files.filter(J=>J.assetType===O)[0]?{uri:`${H.assetUri}/${O}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`,fallbackUri:`${H.fallbackAssetUri}/${O}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`}:null}function z(H,O){const V=H.properties?H.properties.filter(ae=>ae.key===O):[],J=V.length>0&&V[0].value;return J?J.split(",").map(ae=>(0,b.adoptToGalleryExtensionId)(ae)):[]}function M(H){const O=H.properties?H.properties.filter(V=>V.key===s.Engine):[];return O.length>0&&O[0].value||""}function q(H){const O=H.properties?H.properties.filter(V=>V.key===s.PreRelease):[];return O.length>0&&O[0].value==="true"}function Z(H){const O=H.properties?H.properties.filter(J=>J.key===s.LocalizedLanguages):[],V=O.length>0&&O[0].value||"";return V?V.split(","):[]}function j(H){return H.indexOf("preview")!==-1}function $(H){return H.targetPlatform?(0,E.toTargetPlatform)(H.targetPlatform):"undefined"}function W(H){const O=(0,k.distinct)(H.versions.map($)),V=!!H.tags?.includes(E.WEB_EXTENSION_TAG),J=O.indexOf("web");return V?J===-1&&O.push("web"):J!==-1&&O.splice(J,1),O}function Y(H,O){const V=(0,E.getFallbackTargetPlarforms)(O);for(let J=0;J<H.length;J++){const ae=H[J];if(ae.version===H[J-1]?.version){let ge=J;const he=$(ae);if(he===O)for(;ge>0&&H[ge-1].version===ae.version;)ge--;else if(V.includes(he))for(;ge>0&&H[ge-1].version===ae.version&&$(H[ge-1])!==O;)ge--;ge!==J&&(H.splice(J,1),H.splice(ge,0,ae))}}return H}e.sortExtensionVersions=Y;function ie(H,O,V){H.telemetryData={index:O,querySource:V}}function re(H,O,V){const J=H.versions[0],ae={manifest:C(O,r.Manifest),readme:C(O,r.Details),changelog:C(O,r.Changelog),license:C(O,r.License),repository:U(O),download:G(O),icon:C(O,r.Icon),coreTranslations:F(O)};return{identifier:{id:(0,b.getGalleryExtensionId)(H.publisher.publisherName,H.extensionName),uuid:H.extensionId},name:H.extensionName,version:O.version,displayName:H.displayName,publisherId:H.publisher.publisherId,publisher:H.publisher.publisherName,publisherDisplayName:H.publisher.displayName,publisherDomain:H.publisher.domain?{link:H.publisher.domain,verified:!!H.publisher.isDomainVerified}:void 0,description:H.shortDescription||"",installCount:R(H.statistics,"install"),rating:R(H.statistics,"averagerating"),ratingCount:R(H.statistics,"ratingcount"),categories:H.categories||[],tags:H.tags||[],releaseDate:Date.parse(H.releaseDate),lastUpdated:Date.parse(H.lastUpdated),allTargetPlatforms:V,assets:ae,properties:{dependencies:z(O,s.Dependency),extensionPack:z(O,s.ExtensionPack),engine:M(O),localizedLanguages:Z(O),targetPlatform:$(O),isPreReleaseVersion:q(O)},hasPreReleaseVersion:q(J),hasReleaseVersion:!0,preview:j(H.flags)}}let oe=class{constructor(O,V,J,ae,ge,he,le,pe){this.requestService=V,this.logService=J,this.environmentService=ae,this.telemetryService=ge,this.fileService=he,this.productService=le,this.configurationService=pe;const Q=le.extensionsGallery;this.extensionsGalleryUrl=Q&&Q.serviceUrl,this.extensionsControlUrl=Q&&Q.controlUrl,this.commonHeadersPromise=(0,d.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,O)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,V,J){const ae=n.CancellationToken.isCancellationToken(V)?{}:V,ge=n.CancellationToken.isCancellationToken(V)?V:J,he=[],le=[],pe=[],Q=[];let B=!0;for(const fe of O){fe.uuid?le.push(fe.uuid):he.push(fe.id);const ye=!!(fe.version||fe.preRelease);pe.push({id:fe.id,uuid:fe.uuid,includePreRelease:ye}),fe.version&&Q.push({id:fe.id,uuid:fe.uuid,version:fe.version}),B=B&&!!fe.hasPreRelease&&!ye}if(!le.length&&!he.length)return[];let x=new p().withPage(1,O.length);le.length&&(x=x.withFilter(t.ExtensionId,...le)),he.length&&(x=x.withFilter(t.ExtensionName,...he)),(ae.queryAllVersions||B)&&(x=x.withFlags(x.flags,l.IncludeVersions));const{extensions:X}=await this.queryGalleryExtensions(x,{targetPlatform:ae.targetPlatform??o,includePreRelease:pe,versions:Q,compatible:!!ae.compatible},ge);return ae.source&&X.forEach((fe,ye)=>ie(fe,ye,ae.source)),X}async getCompatibleExtension(O,V,J){if((0,E.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(O,V,J))return O;const ae=new p().withFlags(l.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,O.identifier.uuid),{extensions:ge}=await this.queryGalleryExtensions(ae,{targetPlatform:J,compatible:!0,includePreRelease:V},n.CancellationToken.None);return ge[0]||null}async isExtensionCompatible(O,V,J){if(!(0,E.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,J)||!V&&O.properties.isPreReleaseVersion)return!1;let ae=O.properties.engine;if(!ae){const ge=await this.getManifest(O,n.CancellationToken.None);if(!ge)throw new Error("Manifest was not found");ae=ge.engines.vscode}return(0,u.isEngineValid)(ae,this.productService.version,this.productService.date)}async isValidVersion(O,V,J,ae,ge){if(!(0,E.isTargetPlatformCompatible)($(O),ae,ge)||V!=="any"&&q(O)!==(V==="prerelease"))return!1;if(J){const he=await this.getEngine(O);if(!(0,u.isEngineValid)(he,this.productService.version,this.productService.date))return!1}return!0}async query(O,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let J=O.text||"";const ae=(0,I.getOrDefault)(O,B=>B.pageSize,50);let ge=new p().withPage(1,ae);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(B,x,X)=>(ge=ge.withFilter(t.Category,X||x),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(B,x,X)=>(ge=ge.withFilter(t.Tag,X||x),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(ge=ge.withFilter(t.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),ge=ge.withFilter(t.SearchText,J)),ge=ge.withSortBy(0)):O.ids?ge=ge.withFilter(t.ExtensionId,...O.ids):O.names?ge=ge.withFilter(t.ExtensionName,...O.names):ge=ge.withSortBy(4),typeof O.sortBy=="number"&&(ge=ge.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(ge=ge.withSortOrder(O.sortOrder));const he=async(B,x)=>{const{extensions:X,total:fe}=await this.queryGalleryExtensions(B,{targetPlatform:o,compatible:!1,includePreRelease:!!O.includePreRelease},x);return X.forEach((ye,ke)=>ie(ye,(B.pageNumber-1)*B.pageSize+ke,O.source)),{extensions:X,total:fe}},{extensions:le,total:pe}=await he(ge,V),Q=async(B,x)=>{if(x.isCancellationRequested)throw new w.CancellationError;const{extensions:X}=await he(ge.withPage(B+1),x);return X};return{firstPage:le,total:pe,pageSize:ge.pageSize,getPage:Q}}async queryGalleryExtensions(O,V,J){const ae=O.flags;!!(O.flags&l.IncludeLatestVersionOnly)&&!!(O.flags&l.IncludeVersions)&&(O=O.withFlags(O.flags&~l.IncludeVersions,l.IncludeLatestVersionOnly)),!(O.flags&l.IncludeLatestVersionOnly)&&!(O.flags&l.IncludeVersions)&&(O=O.withFlags(O.flags,l.IncludeLatestVersionOnly)),V.versions?.length&&(O=O.withFlags(O.flags&~l.IncludeLatestVersionOnly,l.IncludeVersions)),O=O.withFlags(O.flags,l.IncludeAssetUri,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeStatistics,l.IncludeVersionProperties);const{galleryExtensions:ge,total:he}=await this.queryRawGalleryExtensions(O,J);if(!(O.flags&l.IncludeLatestVersionOnly)){const B=[];for(const x of ge){const X=await this.toGalleryExtensionWithCriteria(x,V);X&&B.push(X)}return{extensions:B,total:he}}const pe=[],Q=new Map;for(let B=0;B<ge.length;B++){const x=ge[B],X={id:(0,b.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},fe=(0,v.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(ke=>(0,b.areSameExtensions)(ke,X))?.includePreRelease;if(V.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(W(x),V.targetPlatform))continue;const ye=await this.toGalleryExtensionWithCriteria(x,V);!ye||ye.properties.isPreReleaseVersion&&(!fe||!ye.hasReleaseVersion)||!ye.properties.isPreReleaseVersion&&ye.properties.targetPlatform!==V.targetPlatform&&ye.hasPreReleaseVersion?Q.set(x.extensionId,B):pe.push([B,ye])}if(Q.size){const B=new Date().getTime(),x=new p().withFlags(ae&~l.IncludeLatestVersionOnly,l.IncludeVersions).withPage(1,Q.size).withFilter(t.ExtensionId,...Q.keys()),{extensions:X}=await this.queryGalleryExtensions(x,V,J);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-B,count:Q.size});for(const fe of X){const ye=Q.get(fe.identifier.uuid);pe.push([ye,fe])}}return{extensions:pe.sort((B,x)=>B[0]-x[0]).map(([,B])=>B),total:he}}async toGalleryExtensionWithCriteria(O,V){const J={id:(0,b.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},ae=V.versions?.find(pe=>(0,b.areSameExtensions)(pe,J))?.version,ge=(0,v.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(pe=>(0,b.areSameExtensions)(pe,J))?.includePreRelease,he=W(O),le=Y(O.versions,V.targetPlatform);if(V.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(he,V.targetPlatform))return null;for(let pe=0;pe<le.length;pe++){const Q=le[pe];if(!(ae&&Q.version!==ae)){if(await this.isValidVersion(Q,ge?"any":"release",V.compatible,he,V.targetPlatform))return re(O,Q,he);if(ae&&Q.version===ae)return null}}return ae||V.compatible?null:re(O,O.versions[0],he)}async queryRawGalleryExtensions(O,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,l.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(l.Unpublished));const J=await this.commonHeadersPromise,ae=JSON.stringify(O.raw),ge={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ae.length)},he=new Date().getTime();let le,pe,Q=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ae,headers:ge},V),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:Q};const B=await(0,g.asJson)(le);if(B){const x=B.results[0],X=x.extensions,fe=x.resultMetadata&&x.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return Q=fe&&fe.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:X,total:Q}}return{galleryExtensions:[],total:Q}}catch(B){throw pe=B,B}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(ae.length),duration:new Date().getTime()-he,success:!!le&&(0,g.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?(0,w.isCancellationError)(pe)?"canceled":(0,w.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(O,V,J,ae){if(!this.isEnabled())return;const ge=_.isWeb?this.api(`/itemName/${O}.${V}/version/${J}/statType/${ae==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${V}/${J}/stats?statType=${ae}`),he=_.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:he};try{await this.requestService.request({type:"POST",url:ge,headers:pe},n.CancellationToken.None)}catch{}}async download(O,V,J){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const ae=(0,b.getGalleryExtensionTelemetryData)(O),ge=new Date().getTime(),he=B=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ae,duration:B}),le=J===2?"install":J===3?"update":"",pe=le?{uri:`${O.assets.download.uri}${P.URI.parse(O.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${O.assets.download.fallbackUri}${P.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:O.assets.download,Q=await this.getAsset(pe);await this.fileService.writeFile(V,Q.stream),he(new Date().getTime()-ge)}async getReadme(O,V){if(O.assets.readme){const J=await this.getAsset(O.assets.readme,{},V);return await(0,g.asText)(J)||""}return""}async getManifest(O,V){if(O.assets.manifest){const J=await this.getAsset(O.assets.manifest,{},V),ae=await(0,g.asText)(J);return ae?JSON.parse(ae):null}return null}async getManifestFromRawExtensionVersion(O,V){const J=C(O,r.Manifest);if(!J)throw new Error("Manifest was not found");const ae={"Accept-Encoding":"gzip"},ge=await this.getAsset(J,{headers:ae});return await(0,g.asJson)(ge)}async getCoreTranslation(O,V){const J=O.assets.coreTranslations.filter(ae=>ae[0]===V.toUpperCase())[0];if(J){const ae=await this.getAsset(J[1]),ge=await(0,g.asText)(ae);return ge?JSON.parse(ge):null}return null}async getChangelog(O,V){if(O.assets.changelog){const J=await this.getAsset(O.assets.changelog,{},V);return await(0,g.asText)(J)||""}return""}async getAllCompatibleVersions(O,V,J){let ae=new p().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?ae=ae.withFilter(t.ExtensionId,O.identifier.uuid):ae=ae.withFilter(t.ExtensionName,O.identifier.id);const{galleryExtensions:ge}=await this.queryRawGalleryExtensions(ae,n.CancellationToken.None);if(!ge.length)return[];const he=W(ge[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(he,J))return[];const le=[];await Promise.all(ge[0].versions.map(async B=>{try{await this.isValidVersion(B,V?"any":"release",!0,he,J)&&le.push(B)}catch{}}));const pe=[],Q=new Set;for(const B of Y(le,J))Q.has(B.version)||(Q.add(B.version),pe.push({version:B.version,date:B.lastUpdated,isPreReleaseVersion:q(B)}));return pe}async getAsset(O,V={},J=n.CancellationToken.None){const ae=await this.commonHeadersPromise,ge={type:"GET"},he={...ae,...V.headers||{}};V={...V,...ge,headers:he};const le=O.uri,pe=O.fallbackUri,Q={...V,url:le};try{const B=await this.requestService.request(Q,J);if(B.res.statusCode===200)return B;const x=await(0,g.asText)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${x}`)}catch(B){if((0,w.isCancellationError)(B))throw B;const x=(0,w.getErrorMessage)(B);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:x});const X={...V,url:pe};return this.requestService.request(X,J)}}async getEngine(O){let V=M(O);if(!V){const J=await this.getManifestFromRawExtensionVersion(O,n.CancellationToken.None);if(!J)throw new Error("Manifest was not found");V=J.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,g.asJson)(O),J=[],ae={};if(V){for(const ge of V.malicious)J.push({id:ge});if(V.unsupported)for(const ge of Object.keys(V.unsupported)){const he=V.unsupported[ge];(0,v.isBoolean)(he)||(ae[ge.toLowerCase()]=he.preReleaseExtension)}if(V.migrateToPreRelease)for(const[ge,he]of Object.entries(V.migrateToPreRelease))(!he.engine||(0,u.isEngineValid)(he.engine,this.productService.version,this.productService.date))&&(ae[ge.toLowerCase()]=he)}return{malicious:J,unsupportedPreReleaseExtensions:ae}}};oe=Te([Oe(1,g.IRequestService),Oe(2,f.ILogService),Oe(3,T.IEnvironmentService),Oe(4,c.ITelemetryService),Oe(5,S.IFileService),Oe(6,h.IProductService),Oe(7,A.IConfigurationService)],oe);let ue=class extends oe{constructor(O,V,J,ae,ge,he,le,pe){super(O,V,J,ae,ge,he,le,pe)}};ue=Te([Oe(0,y.IStorageService),Oe(1,g.IRequestService),Oe(2,f.ILogService),Oe(3,T.IEnvironmentService),Oe(4,c.ITelemetryService),Oe(5,S.IFileService),Oe(6,h.IProductService),Oe(7,A.IConfigurationService)],ue),e.ExtensionGalleryService=ue;let de=class extends oe{constructor(O,V,J,ae,ge,he,le){super(void 0,O,V,J,ae,ge,he,le)}};de=Te([Oe(0,g.IRequestService),Oe(1,f.ILogService),Oe(2,T.IEnvironmentService),Oe(3,c.ITelemetryService),Oe(4,S.IFileService),Oe(5,h.IProductService),Oe(6,A.IConfigurationService)],de),e.ExtensionGalleryServiceWithNoStorageService=de}),define(me[211],ve([0,1,2,22,3,15,163,26,46,45,27,34,32,42]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let u=class{constructor(h,g,d){this._configurationService=g,this._productService=d,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(h,g){this._experimentProperties[h]=g}_updateTelemetryLevel(){this._telemetryLevel=(0,b.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const g=h.usage?3:h.error?2:0;this._telemetryLevel=Math.min(this._telemetryLevel,g)}}get telemetryLevel(){return this._telemetryLevel}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const h=await this._commonProperties;let g=h.sessionID,d=h["common.machineId"],y=h["common.firstSessionDate"],c=h["common.msftInternal"];return{sessionId:g,machineId:d,firstSessionDate:y,msftInternal:c}}dispose(){this._disposables.dispose()}_log(h,g,d,y){return this.telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(c=>{d=(0,n.mixin)(d,c),d=(0,n.mixin)(d,this._experimentProperties),d=(0,n.cloneAndChange)(d,o=>{if(typeof o=="string")return this._cleanupInfo(o,y)}),this._appenders.forEach(o=>o.log(h,d))},c=>{console.error(c)})}publicLog(h,g,d){return this._log(h,3,g,d)}publicLog2(h,g,d){return this.publicLog(h,g,d)}publicLogError(h,g){return this._sendErrorTelemetry?this._log(h,2,g,!0):Promise.resolve(void 0)}publicLogError2(h,g){return this.publicLogError(h,g)}_anonymizeFilePaths(h){let g=h;const d=[];for(let l of this._cleanupPatterns)for(;;){const i=l.exec(h);if(!i)break;d.push([i.index,l.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(g="";;){const l=c.exec(h);if(!l)break;!y.test(l[0])&&d.every(([i,t])=>l.index<i||l.index>=t)&&(g+=h.substring(o,l.index)+"<REDACTED: user-file-path>",o=c.lastIndex)}return o<h.length&&(g+=h.substr(o)),g}_removePropertiesWithPossibleUserInfo(h){if(!h)return h;const g=h.toLowerCase(),d=/@[a-zA-Z0-9-.]+/,y=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,c=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return y.test(g)?"<REDACTED: secret>":d.test(g)?"<REDACTED: email>":c.test(g)?"<REDACTED: token>":h}_cleanupInfo(h,g){let d=h;g&&(d=this._anonymizeFilePaths(d));for(let y of this._cleanupPatterns)d=d.replace(y,"");return d=this._removePropertiesWithPossibleUserInfo(d),d}};u.IDLE_START_EVENT_NAME="UserIdleStart",u.IDLE_STOP_EVENT_NAME="UserIdleStop",u=Te([Oe(1,D.IConfigurationService),Oe(2,A.IProductService)],u),e.TelemetryService=u;function S(){const f=(0,_.localize)(0,null,P.default.nameLong),h=P.default.privacyStatementUrl?(0,_.localize)(2,null,"https://aka.ms/vscode-telemetry",P.default.privacyStatementUrl):(0,_.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=w.isWeb?"":(0,_.localize)(3,null),d=(0,_.localize)(4,null),y=(0,_.localize)(5,null),c=(0,_.localize)(6,null),o=(0,_.localize)(7,null),l=`
|       | ${d} | ${y} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,_.localize)(8,null);return`
${f} ${h} ${g}

&nbsp;

${o}
${l}

&nbsp;

${i}
`}T.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,_.localize)(10,null),(0,_.localize)(11,null),(0,_.localize)(12,null),(0,_.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),T.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:P.default.privacyStatementUrl?(0,_.localize)(16,null,P.default.nameLong,P.default.privacyStatementUrl):(0,_.localize)(15,null,P.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,_.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(me[212],ve([0,1,26,6,27,32,211,42]),function(ee,e,k,n,w,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=class extends _.TelemetryService{constructor(A,T,E,b){super(A,E,b);this._telemetryCache=[],this._injectedTelemetryLevel=T}publicLog(A,T,E){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:A,data:T,anonymizeFilePaths:E,eventType:"usage"}),Promise.resolve()):this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(A,T,E)}publicLog2(A,T,E){return this.publicLog(A,T,E)}publicLogError(A,T){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:A,data:T,eventType:"error"}),Promise.resolve()):this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(A,T)}publicLogError2(A,T){return this.publicLogError(A,T)}async flushTelemetryCache(){if(this._telemetryCache?.length!==0){for(const A of this._telemetryCache)A.eventType==="usage"?await this.publicLog(A.eventName,A.data,A.anonymizeFilePaths):await this.publicLogError(A.eventName,A.data);this._telemetryCache=[]}}async updateInjectedTelemetryLevel(A){if(A===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");if(this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,A):A,this._injectedTelemetryLevel===0)this._telemetryCache=[],this.dispose();else return this.flushTelemetryCache()}};v=Te([Oe(2,k.IConfigurationService),Oe(3,w.IProductService)],v),e.ServerTelemetryService=v,e.ServerNullTelemetryService=new class extends D.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,n.refineServiceDecorator)(I.ITelemetryService)}),define(me[213],ve([0,1,9,22,42]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function I(D){const v=await new Promise((A,T)=>{ee(["applicationinsights"],A,T)});let P;return v.defaultClient?(P=new v.TelemetryClient(D),P.channel.setUseDiskRetryCaching(!0)):(v.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=v.defaultClient),D.indexOf("AIF-")===0&&(P.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),P}class _{constructor(v,P,A){this._eventPrefix=v,this._defaultData=P,this._defaultData||(this._defaultData=Object.create(null)),typeof A=="function"?this._aiClient=A():this._aiClient=A,this._asyncAIClient=null}_withAIClient(v){if(!!this._aiClient){if(typeof this._aiClient!="string"){v(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient)),this._asyncAIClient.then(P=>{v(P)},P=>{(0,k.onUnexpectedError)(P),console.error(P)})}}log(v,P){if(!!this._aiClient){P=(0,n.mixin)(P,this._defaultData),P=(0,w.validateTelemetryData)(P);try{this._withAIClient(A=>A.trackEvent({name:this._eventPrefix+"/"+v,properties:P.properties,measurements:P.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(v=>{this._withAIClient(P=>{try{P.flush({callback:()=>{this._aiClient=void 0,v(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=_}),define(me[214],ve([0,1,9,206]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class w extends n.default{installErrorListeners(){(0,k.setUnexpectedErrorHandler)(D=>console.error(D));const _=[];process.on("unhandledRejection",(D,v)=>{_.push(v),setTimeout(()=>{const P=_.indexOf(v);P>=0&&v.catch(A=>{_.splice(P,1),(0,k.isCancellationError)(A)||(console.warn(`rejected promise not handled within 1 second: ${A}`),A.stack&&console.warn(`stack trace: ${A.stack}`),D&&(0,k.onUnexpectedError)(D))})},1e3)}),process.on("rejectionHandled",D=>{const v=_.indexOf(D);v>=0&&_.splice(v,1)}),process.on("uncaughtException",D=>{(0,k.onUnexpectedError)(D)})}}e.default=w}),define(me[215],ve([0,1,14,21,7,2,13]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let D=class extends I.Disposable{constructor(P,A){super();this._logService=A,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new w.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=P===void 0?15e3:P}createRequest(P){return new Promise((A,T)=>{const E=++this._lastRequestId;this._pendingRequests.set(E,A),this._onCreateRequest.fire({requestId:E,...P});const b=new n.CancellationTokenSource;(0,k.timeout)(this._timeout,b.token).then(()=>T(`Request ${E} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(E,[(0,I.toDisposable)(()=>b.cancel())])})}acceptReply(P,A){const T=this._pendingRequests.get(P);T?(this._pendingRequests.delete(P),(0,I.dispose)(this._pendingRequestDisposables.get(P)||[]),this._pendingRequestDisposables.delete(P),T(A)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${P}`)}};D=Te([Oe(1,_.ILogService)],D),e.RequestStore=D}),define(me[101],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var w;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",f.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",f.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(w=e.TerminalSettingId||(e.TerminalSettingId={}));var I;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(I=e.PosixShellType||(e.PosixShellType={}));var _;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(_=e.WindowsShellType||(e.WindowsShellType={}));var D;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(D=e.TitleEventSource||(e.TitleEventSource={}));var v;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(v=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var P;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var A;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(A=e.HeartbeatConstants||(e.HeartbeatConstants={}));var T;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(T=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(f){f.TerminalView="view",f.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var b;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(b=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(me[216],ve([0,1,24,8,22,5,3,25,15,12,19]),function(ee,e,k,n,w,I,_,D,v,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function T(){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let c=0;return y&&y.length===4&&(c=parseInt(y[3])),c}e.getWindowsBuildNumber=T;async function E(y,c,o,l=D.env,i=A.Promises.exists){if(I.isAbsolute(y))return await i(y)?y:void 0;if(c===void 0&&(c=D.cwd()),I.dirname(y)!=="."){const a=I.join(c,y);return await i(a)?a:void 0}const r=(0,w.getCaseInsensitive)(l,"PATH");if(o===void 0&&(0,P.isString)(r)&&(o=r.split(I.delimiter)),o===void 0||o.length===0){const a=I.join(c,y);return await i(a)?a:void 0}for(let a of o){let m;if(I.isAbsolute(a)?m=I.join(a,y):m=I.join(c,a,y),await i(m))return m;if(_.isWindows){let p=m+".com";if(await i(p)||(p=m+".exe",await i(p)))return p}}const s=I.join(c,y);return await i(s)?s:void 0}e.findExecutable=E;function b(y,c){if(!c.enabled||!y.executable||y.isFeatureTerminal)return;const o=y.args,l=D.platform==="win32"?I.basename(y.executable).toLowerCase():I.basename(y.executable),i=I.dirname(n.FileAccess.asFileUri("",ee).fsPath);let t;if(_.isWindows){if(l==="pwsh.exe"){if(!o||g(o)?t=e.shellIntegrationArgs.get(u.WindowsPwsh):h(o)&&(t=e.shellIntegrationArgs.get(u.WindowsPwshLogin)),!t)return;if(t){const s=c.showWelcome?"":" -HideWelcome";t=[...t],t[t.length-1]=(0,v.format)(t[t.length-1],i,s)}return{newArgs:t}}return}const r={};switch(l){case"bash":return!o||o.length===0?t=e.shellIntegrationArgs.get(u.Bash):d(o)&&(r.VSCODE_SHELL_LOGIN="1",t=e.shellIntegrationArgs.get(u.Bash)),t?(t=[...t],t[t.length-1]=(0,v.format)(t[t.length-1],i),c.showWelcome||(r.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:t,envMixin:r}):void 0;case"pwsh":{if(!o||g(o)?t=e.shellIntegrationArgs.get(u.Pwsh):h(o)&&(t=e.shellIntegrationArgs.get(u.PwshLogin)),!t)return;const s=c.showWelcome?"":" -HideWelcome";return t=[...t],t[t.length-1]=(0,v.format)(t[t.length-1],i,s),{newArgs:t}}case"zsh":{if(!o||o.length===0?t=e.shellIntegrationArgs.get(u.Zsh):d(o)?t=e.shellIntegrationArgs.get(u.ZshLogin):(o===e.shellIntegrationArgs.get(u.Zsh)||o===e.shellIntegrationArgs.get(u.ZshLogin))&&(t=o),!t)return;t=[...t],t[t.length-1]=(0,v.format)(t[t.length-1],i);const s=I.join(k.tmpdir(),"vscode-zsh");r.ZDOTDIR=s;const a=[];return a.push({source:I.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration.zsh"),dest:I.join(s,".zshrc")}),c.showWelcome||(r.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:t,envMixin:r,filesToCopy:a}}}}e.getShellIntegrationInjection=b;var u;(function(y){y.WindowsPwsh="windows-pwsh",y.WindowsPwshLogin="windows-pwsh-login",y.Pwsh="pwsh",y.PwshLogin="pwsh-login",y.Zsh="zsh",y.ZshLogin="zsh-login",y.Bash="bash"})(u=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(u.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(u.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(u.Zsh,["-i"]),e.shellIntegrationArgs.set(u.ZshLogin,["-il"]),e.shellIntegrationArgs.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],f=["-nol","-nologo"];function h(y){return typeof y=="string"?S.includes(y.toLowerCase()):y.length===1&&S.includes(y[0].toLowerCase())||y.length===2&&(S.includes(y[0].toLowerCase())||S.includes(y[1].toLowerCase()))&&(f.includes(y[0].toLowerCase())||f.includes(y[1].toLowerCase()))}function g(y){return typeof y=="string"?f.includes(y.toLowerCase()):y.length===0||y?.length===1&&f.includes(y[0].toLowerCase())}function d(y){return y==="string"&&S.includes(y.toLowerCase())||typeof y!="string"&&y.length===1&&S.includes(y[0].toLowerCase())}}),define(me[217],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var k;(function(w){w.DARK="dark",w.LIGHT="light",w.HIGH_CONTRAST_DARK="hcDark",w.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function n(w){return w===k.HIGH_CONTRAST_DARK||w===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=n}),define(me[102],ve([0,1,38,7,2,6,34,217]),function(ee,e,k,n,w,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,I.createDecorator)("themeService");var v;(function(f){function h(g){return g&&typeof g=="object"&&typeof g.id=="string"}f.isThemeColor=h})(v=e.ThemeColor||(e.ThemeColor={}));function P(f){return{id:f}}e.themeColorFromId=P;var A;(function(f){function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||v.isThemeColor(t.color))}f.isThemeIcon=h;const g=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const r=g.exec(t);if(!r)return;let[,s]=r;return{id:s}}f.fromString=d;function y(t){return{id:t}}f.fromId=y;function c(t,r){let s=t.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),r&&(s=`${s}~${r}`),{id:s}}f.modify=c;function o(t){const r=t.id.lastIndexOf("~");if(r!==-1)return t.id.substring(r+1)}f.getModifier=o;function l(t,r){return t.id===r.id&&t.color?.id===r.color?.id}f.isEqual=l;function i(t,r){return{id:t.id,color:r?P(r):void 0}}f.asThemeIcon=i,f.asClassNameArray=k.CSSIcon.asClassNameArray,f.asClassName=k.CSSIcon.asClassName,f.asCSSSelector=k.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function T(f){switch(f){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case D.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,w.toDisposable)(()=>{const g=this.themingParticipants.indexOf(h);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new E;_.Registry.add(e.Extensions.ThemingContribution,b);function u(f){return b.onColorThemeChange(f)}e.registerThemingParticipant=u;class S extends w.Disposable{constructor(h){super();this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,g){let d=this.theme.getColor(h);return d&&g&&(d=g(d,this.theme)),d?d.toString():null}}e.Themable=S}),define(me[218],ve([0,1,38,4,102]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function I(T,E){const b=T.map(u=>({name:u.profileName,description:_(u)}));return E&&b.push(...E.map(u=>({name:u.title,description:D(u)}))),{values:b.map(u=>u.name),markdownDescriptions:b.map(u=>u.description)}}e.createProfileSchemaEnums=I;function _(T){let E=`$(${w.ThemeIcon.isThemeIcon(T.icon)?T.icon.id:T.icon?T.icon:k.Codicon.terminal.id}) ${T.profileName}
- path: ${T.path}`;return T.args&&(typeof T.args=="string"?E+=`
- args: "${T.args}"`:E+=`
- args: [${T.args.length===0?"":`'${T.args.join("','")}'`}]`),T.overrideName!==void 0&&(E+=`
- overrideName: ${T.overrideName}`),T.color&&(E+=`
- color: ${T.color}`),T.env&&(E+=`
- env: ${JSON.stringify(T.env)}`),E}function D(T){return`$(${w.ThemeIcon.isThemeIcon(T.icon)?T.icon.id:T.icon?T.icon:k.Codicon.terminal.id}) ${T.title}
- extensionIdenfifier: ${T.extensionIdentifier}`}function v(T,E){if(!T&&!E)return!0;if(typeof T=="string"&&typeof E=="string")return T===E;if(Array.isArray(T)&&Array.isArray(E)){if(T.length!==E.length)return!1;for(let b=0;b<T.length;b++)if(T[b]!==E[b])return!1;return!0}return!1}e.terminalProfileArgsMatch=v;function P(T,E){if(!T&&!E)return!0;if(!T||!E)return!1;if(w.ThemeIcon.isThemeIcon(T)&&w.ThemeIcon.isThemeIcon(E))return T.id===E.id&&T.color===E.color;if(typeof T=="object"&&T&&"light"in T&&"dark"in T&&typeof E=="object"&&E&&"light"in E&&"dark"in E){const b=T,u=E;if((n.URI.isUri(b.light)||A(b.light))&&(n.URI.isUri(b.dark)||A(b.dark))&&(n.URI.isUri(u.light)||A(u.light))&&(n.URI.isUri(u.dark)||A(u.dark)))return b.light.path===u.light.path&&b.dark.path===u.dark.path}if(n.URI.isUri(T)&&n.URI.isUri(E)||A(T)||A(E)){const b=T,u=E;return b.path===u.path&&b.scheme===u.scheme}return!1}e.terminalIconsEqual=P;function A(T){return T?typeof T.path=="string"&&typeof T.scheme=="string":!1}e.isUriComponents=A}),define(me[219],ve([0,1,38,164,46,34,218]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const D={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),y=>y.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),y=>`$(${y.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...D}},P={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...D}},A=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),T=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),b=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),u=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:A},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:A},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...D}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...D}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...D}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...D}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){I.Registry.as(w.Extensions.Configuration).registerConfiguration(f),d()}e.registerTerminalPlatformConfiguration=h;let g;function d(y,c){const o=I.Registry.as(w.Extensions.Configuration);let l;y&&(l=(0,_.createProfileSchemaEnums)(y?.profiles,c));const i=g;g={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:y?.os===3?l?.values:void 0,markdownEnumDescriptions:y?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:y?.os===2?l?.values:void 0,markdownEnumDescriptions:y?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:y?.os===1?l?.values:void 0,markdownEnumDescriptions:y?.os===1?l?.markdownDescriptions:void 0}}},o.updateConfigurations({add:[g],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=d}),define(me[220],ve([0,1,39,38,5,3,19,84,216,102]),function(ee,e,k,n,w,I,_,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let A,T=!0;function E(l,i,t,r,s=process.env,a,m,p,R){return a=a||{existsFile:_.SymlinkSupport.existsFile,readFile:_.Promises.readFile},I.isWindows?b(t,a,s,m,r.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),R,p):y(a,m,t,l&&typeof l=="object"?{...l}:r.getValue(I.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(I.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,p,s)}e.detectAvailableProfiles=E;async function b(l,i,t,r,s,a,m,p,R){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let G=!1;(0,v.getWindowsBuildNumber)()>=16299&&(G=!0),await f(p);const C=new Map;l&&(C.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),C.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),C.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),C.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),C.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),c(a,C);const z=await u(C.entries(),m,i,t,r,R);if(l||!l&&s)try{const M=await g(`${U}\\${G?"wsl":"bash"}.exe`,m);for(const q of M)(!a||!(q.profileName in a))&&z.push(q)}catch{T&&(r?.info("WSL is not installed, so could not detect WSL profiles"),T=!1)}return z}async function u(l,i,t,r=process.env,s,a){const m=[];for(const[p,R]of l){if(R===null)continue;let F,U,G;if("source"in R){const M=A?.get(R.source);if(!M)continue;F=M.paths,U=R.args||M.args,R.icon?G=S(R.icon):M.icon&&(G=M.icon)}else F=Array.isArray(R.path)?R.path:[R.path],U=I.isWindows||Array.isArray(R.args)?R.args:void 0,G=S(R.icon);const C=await a?.(F)||F.slice(),z=await o(p,i,C,t,r,U,R.env,R.overrideName,R.isAutoDetected,s);z?(z.isAutoDetected=R.isAutoDetected,z.icon=G,z.color=R.color,m.push(z)):s?.trace("profile not validated",p,F)}return m}function S(l){return typeof l=="string"?{id:l}:l}async function f(l){A&&!l||(A=new Map,A.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),A.set("PowerShell",{profileName:"PowerShell",paths:l||await h(),icon:P.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function h(){const l=[];for await(const i of(0,D.enumeratePowerShellInstallations)())l.push(i.exePath);return l}async function g(l,i){const t=[],r=await new Promise((m,p)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(R,F)=>{if(R)return p("Problem occurred when getting wsl distros");m(F)})});if(!r)return[];const s=new RegExp(/[\r?\n]/),a=r.split(s).filter(m=>m.trim().length>0&&m!=="");for(const m of a){if(m===""||m.startsWith("docker-desktop"))continue;const p=`${m} (WSL)`,R={profileName:p,path:l,args:["-d",`${m}`],isDefault:p===i,icon:d(m),isAutoDetected:!1};t.push(R)}return t}function d(l){return l.includes("Ubuntu")?P.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):l.includes("Debian")?P.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):P.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function y(l,i,t,r,s,a,m,p){const R=new Map;if(t){const F=(await l.readFile("/etc/shells")).toString(),U=a||F.split(`
`).filter(C=>C.trim().indexOf("#")!==0&&C.trim().length>0),G=new Map;for(const C of U){let z=(0,w.basename)(C),M=G.get(z)||0;M++,M>1&&(z=`${z} (${M})`),G.set(z,M),R.set(z,{path:C,isAutoDetected:!0})}}return c(r,R),await u(R.entries(),s,l,p,i,m)}function c(l,i){if(!!l)for(const[t,r]of Object.entries(l))r===null||!("path"in r)&&!("source"in r)?i.delete(t):(r.icon=r.icon||i.get(t)?.icon,i.set(t,r))}async function o(l,i,t,r,s,a,m,p,R,F){if(t.length===0)return Promise.resolve(void 0);const U=t.shift();if(U==="")return o(l,i,t,r,s,a,m,p,R);const G={profileName:l,path:U,args:a,env:m,overrideName:p,isAutoDetected:R,isDefault:l===i};if((0,w.basename)(U)===U){const z=s.PATH?s.PATH.split(w.delimiter):void 0,M=await(0,v.findExecutable)(U,void 0,z,void 0,r.existsFile);return M?(G.path=M,G.isFromPath=!0,G):o(l,i,t,r,s,a)}return await r.existsFile((0,w.normalize)(U))?G:o(l,i,t,r,s,a,m,p,R)}}),define(me[221],ve([0,1,7,2,8,3,40,88,26,29,89,70,13,94,215,101,219,220]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let d=0,y=class extends n.Disposable{constructor(o,l,i,t){super();this._reconnectConstants=o,this._configurationService=l,this._environmentService=i,this._logService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,f.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new u.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(I.isWindows)return process.env;try{return await(0,T.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(o){return this._logService.error("ptyHost was unable to resolve shell environment",o),{}}}_startPtyHost(){const o={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:d,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},l=(0,A.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);l&&(l.break&&l.port?o.debugBrk=l.port:!l.break&&l.port&&(o.debug=l.port));const i=new D.Client(w.FileAccess.asFileUri("bootstrap-fork",ee).fsPath,o);this._onPtyHostStart.fire(),_.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const r=i.getChannel(S.TerminalIpcChannels.Log);b.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{b.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const s=_.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(a=>this._onProcessData.fire(a))),this._register(s.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(s.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(s.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(s.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(s.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(s.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[i,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,l,i,t,r,s,a,m,p,R,F){const U=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),G=await this._proxy.createProcess(o,l,i,t,r,s,a,m,p,R,F);return clearTimeout(U),d=Math.max(d,G),G}updateTitle(o,l,i){return this._proxy.updateTitle(o,l,i)}updateIcon(o,l,i){return this._proxy.updateIcon(o,l,i)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,l){return this._proxy.shutdown(o,l)}input(o,l){return this._proxy.input(o,l)}processBinary(o,l){return this._proxy.processBinary(o,l)}resize(o,l,i){return this._proxy.resize(o,l,i)}acknowledgeDataEvent(o,l){return this._proxy.acknowledgeDataEvent(o,l)}setUnicodeVersion(o,l){return this._proxy.setUnicodeVersion(o,l)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}installAutoReply(o,l){return this._proxy.installAutoReply(o,l)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(o){return this._proxy.uninstallAutoReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,l,i,t=!1){const r=await this._shellEnv;return(0,h.detectAvailableProfiles)(l,i,t,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,l){return this._proxy.requestDetachInstance(o,l)}async acceptDetachInstanceReply(o,l){return this._proxy.acceptDetachInstanceReply(o,l)}async serializeTerminalState(o){return this._proxy.serializeTerminalState(o)}async reviveTerminalProcesses(o,l){return this._proxy.reviveTerminalProcesses(o,l)}async refreshProperty(o,l){return this._proxy.refreshProperty(o,l)}async updateProperty(o,l,i){return this._proxy.updateProperty(o,l,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,l){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:l})}async acceptPtyHostResolvedVariables(o,l){this._resolveVariablesRequestStore.acceptReply(o,l)}};y=Te([Oe(1,v.IConfigurationService),Oe(2,P.IEnvironmentService),Oe(3,E.ILogService)],y),e.PtyHostService=y}),define(me[48],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(me[222],ve([0,1,7,2,4,29,35,18,13,48]),function(ee,e,k,n,w,I,_,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let A=class extends n.Disposable{constructor(E,b,u,S,f){super();this.extensionsManagementService=E,this.logService=S,this.uriIdentityService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(E.onInstallExtension(g=>this.onInstallExtension(g))),this._register(E.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(E.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const h=w.URI.file(u.extensionsPath);this._register(b.watch(h)),this._register(k.Event.filter(b.onDidFilesChange,g=>g.rawChanges.some(d=>this.doesChangeAffects(d,h)))(()=>this.onDidChange()))}doesChangeAffects(E,b){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(E.resource),b)?this.uriIdentityService.extUri.isEqual(E.resource,this.uriIdentityService.extUri.joinPath(b,".obsolete"))?!0:!(E.type!==1&&E.type!==2||this.uriIdentityService.extUri.basename(E.resource).startsWith(".")):!1}onInstallExtension(E){this.addInstallingExtension(E.identifier)}onDidInstallExtensions(E){for(const b of E)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(E){E.error||this.removeInstalledExtension(E.identifier)}addInstallingExtension(E){this.removeInstallingExtension(E),this.installingExtensions.push(E)}removeInstallingExtension(E){this.installingExtensions=this.installingExtensions.filter(b=>!(0,_.areSameExtensions)(b,E))}addInstalledExtension(E){this.installedExtensions&&(this.removeInstalledExtension(E),this.installedExtensions.push(E))}removeInstalledExtension(E){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,_.areSameExtensions)(b,E)))}async onDidChange(){if(this.installedExtensions){const E=await this.extensionsManagementService.getInstalled(),b=E.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,_.areSameExtensions)(f,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),u=this.installedExtensions.filter(S=>this.installingExtensions.some(f=>(0,_.areSameExtensions)(f,S))?!1:E.every(f=>!(0,_.areSameExtensions)(f.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=E.map(S=>S.identifier),(b.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:u})}}};A=Te([Oe(1,D.IFileService),Oe(2,I.INativeEnvironmentService),Oe(3,v.ILogService),Oe(4,P.IUriIdentityService)],A),e.ExtensionsWatcher=A}),define(me[103],ve([0,1,48,180,18,20,122,7,2]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class P{constructor(E){this.uri=E,this.time=P._clock++}touch(){return this.time=P._clock++,this}}P._clock=0;let A=class{constructor(E){this._fileService=E,this._dispooables=new v.DisposableStore,this._limit=2**16;const b=new Map,u=S=>{let f=b.get(S.scheme);return f===void 0&&(f=E.hasProvider(S)&&!this._fileService.hasCapability(S,1024),b.set(S.scheme,f)),f};this._dispooables.add(D.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(S=>{b.delete(S.scheme)})),this.extUri=new I.ExtUri(u),this._canonicalUris=new _.SkipList((S,f)=>this.extUri.compare(S,f,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(E){this._fileService.hasProvider(E)&&(E=(0,I.normalizePath)(E));let b=this._canonicalUris.get(E);return b?b.touch().uri.with({fragment:E.fragment}):(this._canonicalUris.set(E,new P(E)),this._checkTrim(),E)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const E=[...this._canonicalUris.entries()].sort((u,S)=>u[1].touch<S[1].touch?1:u[1].touch>S[1].touch?-1:0);P._clock=0,this._canonicalUris.clear();const b=this._limit*.5;for(let u=0;u<b;u++)this._canonicalUris.set(E[u][0],E[u][1].touch())}};A=Te([Oe(0,w.IFileService)],A),e.UriIdentityService=A,(0,n.registerSingleton)(k.IUriIdentityService,A,!0)}),define(me[104],ve([0,1,165,5,31,20,4,6,8]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function P(i){const t=i;return typeof t?.id=="string"&&_.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=P;function A(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=A;function T(i){const t=i;return typeof t?.id=="string"&&_.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=T;function E(i){const t=i;if(t?.uri)return{id:t.id,uri:_.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=E;var b;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function u(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=u;function S(i){const t=i;return!!(t&&typeof t=="object"&&_.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=S;class f{constructor(t,r,s,a,m){this._id=t,this._transient=s,this._configuration=a,this._ignorePathCasing=m,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t.with({scheme:t.scheme,authority:t.authority,path:t.path}))||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class h{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,I.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function g(i){return new h({uri:i,index:0,name:(0,I.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(i,t){return I.extUriBiasedIgnorePathCase.isEqualOrParent(i,t.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function c(i){let t;return _.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=c;function o(i,t){return!y(i,t)&&!c(i)}e.isSavedWorkspace=o;function l(i){return(typeof i=="string"?(0,n.extname)(i):(0,I.extname)(i))===d}e.hasWorkspaceFileExtension=l}),define(me[105],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,k.createDecorator)("extensionHostStatusService");class n{constructor(){this._exitInfo=new Map}setExitInfo(I,_){this._exitInfo.set(I,_)}getExitInfo(I){return this._exitInfo.get(I)||null}}e.ExtensionHostStatusService=n}),define(me[223],ve([0,1,7,14]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function w(_){let D=0,v=0,P=0;_>=1e3&&(P=Math.floor(_/1e3),_-=P*1e3),P>=60&&(v=Math.floor(P/60),P-=v*60),v>=60&&(D=Math.floor(v/60),v-=D*60);const A=D?`${D}h`:"",T=v?`${v}m`:"",E=P?`${P}s`:"",b=_?`${_}ms`:"";return`${A}${T}${E}${b}`}e.printTime=w;class I{constructor(D,v,P,A){this._logService=D,this._reconnectionToken=v,this._onClose=new k.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=P,this.protocol=A,this._disposed=!1,this._disconnectRunner1=new n.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${w(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new n.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${w(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${w(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(D){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${D}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${w(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const D=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),D.end(),this._onClose.fire(void 0)}acceptReconnection(D,v,P){this._remoteAddress=D,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(v,P),this.protocol.endAcceptReconnection()}}e.ManagementConnection=I}),define(me[71],ve([0,1,28,8,5,130,45]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const D=w.join(n.FileAccess.asFileUri("",ee).fsPath,"nls.metadata.json"),v=new Map;function P(u){return new Promise(S=>k.exists(u,S))}function A(u,S){return P(D).then(f=>{if(!f||!_.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let h=`${u}||${S}`,g=v.get(h);return g||(g=I.getNLSConfiguration(_.default.commit,S,D,u).then(d=>(T.is(d)&&(d._languagePackSupport=!0),d.locale!=="en"&&d.locale!=="en-us"&&Object.keys(d.availableLanguages).length===0&&v.delete(h),d)),v.set(h,g)),g})}e.getNLSConfiguration=A;var T;(function(u){function S(f){let h=f;return h&&typeof h._languagePackId=="string"}u.is=S})(T=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const E=async u=>{try{const S=b(await k.promises.readFile(u,"utf8"));return JSON.parse(S).locale}catch(S){return S.code!=="ENOENT"&&console.warn(S),"en"}};e.getLocaleFromConfig=E;const b=u=>{const S=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return u.replace(S,(f,h,g,d,y)=>{if(d)return"";if(y){const c=y.length;return c>2&&y[c-1]===`
`?y[c-2]==="\r"?`\r
`:`
`:""}else return f})}}),define(me[224],ve([0,1,225,28,5,23,8,19]),function(ee,e,k,n,w,I,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z-]+$/;var P;(function(h){h[h.None=0]="None",h[h.Optional=1]="Optional",h[h.Mandatory=2]="Mandatory"})(P=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class A{constructor(){this.type=0}validate(g){return!0}}e.NoneServerConnectionToken=A;class T{constructor(g){this.value=g,this.type=1}validate(g){return g===this.value}}e.OptionalServerConnectionToken=T;class E{constructor(g){this.value=g,this.type=2}validate(g){return g===this.value}}e.MandatoryServerConnectionToken=E;class b{constructor(g){this.message=g}}e.ServerConnectionTokenParseError=b;async function u(h,g){const d=h["without-connection-token"],y=h["connection-token"],c=h["connection-token-file"],o=h.compatibility==="1.63";if(d)return typeof y!="undefined"||typeof c!="undefined"?new b("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new A;if(typeof c!="undefined"){if(typeof y!="undefined")return new b("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=n.readFileSync(c).toString().replace(/\r?\n$/,"")}catch{return new b(`Unable to read the connection token file at '${c}'.`)}return v.test(l)?new E(l):new b(`The connection token defined in '${c} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof y!="undefined"?v.test(y)?o?new T(y):new E(y):new b(`The connection token '${y} does not adhere to the characters 0-9, a-z, A-Z or -.`):o?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new T(await g())):new E(await g())}e.parseServerConnectionToken=u;async function S(h){return u(h,async()=>{if(!h["user-data-dir"])return(0,I.generateUuid)();const d=w.join(h["user-data-dir"],"token");try{const o=(await D.Promises.readFile(d)).toString().replace(/\r?\n$/,"");if(v.test(o))return o}catch{}const y=(0,I.generateUuid)();try{await D.Promises.writeFile(d,y,{mode:384})}catch{}return y})}e.determineServerConnectionToken=S;function f(h,g,d){if(h.validate(d.query[_.connectionTokenQueryName]))return!0;const y=k.parse(g.headers.cookie||"");return h.validate(y[_.connectionTokenCookieName])}e.requestHasValidConnectionToken=f}),define(me[37],ve([0,1,167,177,52,6,29]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},locale:{type:"string"},"disable-file-downloads":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:k.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:k.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:k.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:k.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:k.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:k.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:k.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:k.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:k.localize(8,null)},"user-data-dir":w.OPTIONS["user-data-dir"],driver:w.OPTIONS.driver,"disable-telemetry":w.OPTIONS["disable-telemetry"],"disable-workspace-trust":w.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:w.OPTIONS.log,logsPath:w.OPTIONS.logsPath,"force-disable-user-env":w.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:k.localize(9,null)},"default-workspace":{type:"string",description:k.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":w.OPTIONS["extensions-dir"],"extensions-download-dir":w.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":w.OPTIONS["builtin-extensions-dir"],"install-extension":w.OPTIONS["install-extension"],"install-builtin-extension":w.OPTIONS["install-builtin-extension"],"uninstall-extension":w.OPTIONS["uninstall-extension"],"list-extensions":w.OPTIONS["list-extensions"],"locate-extension":w.OPTIONS["locate-extension"],"show-versions":w.OPTIONS["show-versions"],category:w.OPTIONS.category,force:w.OPTIONS.force,"do-not-sync":w.OPTIONS["do-not-sync"],"pre-release":w.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:k.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:w.OPTIONS.help,version:w.OPTIONS.version,compatibility:{type:"string"},_:w.OPTIONS._},e.IServerEnvironmentService=(0,I.refineServiceDecorator)(_.IEnvironmentService);class D extends n.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=D}),define(me[226],ve([0,1,64,13,37,27,191,23,16]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let P=class extends _.BaseCredentialsMainService{constructor(T,E,b){super(T);this.environmentMainService=E,this.productService=b,this.environmentMainService.args["github-auth"]&&this.storeGitHubToken(this.environmentMainService.args["github-auth"]).catch(u=>{this.logService.error("Failed to store provided GitHub token",u)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new k.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((T,E)=>{ee(["keytar"],T,E)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(T){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${T.message??T}`),this._keytarCache=new k.InMemoryCredentialsProvider}return this._keytarCache}async storeGitHubToken(T){const E="vscode.github-authentication",b=`${await this.getSecretStoragePrefix()}${E}`,u="github.auth",f=[["read:user","user:email","repo"]].map(d=>({id:(0,D.generateUuid)(),scopes:d.sort(),accessToken:T})),h=await this.getPassword(b,u);let g;if(h)try{const d=JSON.parse(h);d.content=JSON.parse(d.content),g=d}catch(d){this.logService.error("Failed to parse existing GitHub credentials",d)}return g?.content&&(g.content=g.content.filter(d=>{const y=d.scopes.sort();return!f.find(c=>(0,v.equals)(y,c.scopes)&&c.account?.label===d.account?.label)})),this.setPassword(b,u,JSON.stringify({extensionId:E,...g||{},content:JSON.stringify([...f,...g?.content||[]])}))}};P=Te([Oe(0,n.ILogService),Oe(1,w.IServerEnvironmentService),Oe(2,I.IProductService)],P),e.CredentialsWebMainService=P}),define(me[227],ve([0,1,262,228,24]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class I{get _sender(){throw new Error("unimplemented")}get _buffer(){throw new Error("unimplemented")}setUseDiskRetryCaching(){throw new Error("unimplemented")}send(){throw new Error("unimplemented")}triggerSend(){throw new Error("unimplemented")}}class _{constructor(v){this.endpoint=v,this._telemetryProcessors=void 0,this.context=void 0,this.commonProperties=void 0,this.config={},this.quickPulseClient=void 0,this.channel=new I}addTelemetryProcessor(){throw new Error("unimplemented")}clearTelemetryProcessors(){this._telemetryProcessors&&(this._telemetryProcessors=void 0)}runTelemetryProcessors(){throw new Error("unimplemented")}trackTrace(){throw new Error("unimplemented")}trackMetric(){throw new Error("unimplemented")}trackException(){throw new Error("unimplemented")}trackRequest(){throw new Error("unimplemented")}trackDependency(){throw new Error("unimplemented")}track(){throw new Error("unimplemented")}trackNodeHttpRequestSync(){throw new Error("unimplemented")}trackNodeHttpRequest(){throw new Error("unimplemented")}trackNodeHttpDependency(){throw new Error("unimplemented")}trackEvent(v){v.properties||(v.properties={}),v.measurements||(v.measurements={});try{const P=w.cpus();v.measurements.cores=P.length,v.properties["common.cpuModel"]=P[0].model}catch{}try{v.measurements.memoryFree=w.freemem(),v.measurements.memoryTotal=w.totalmem()}catch{}try{v.properties["common.shell"]=w.userInfo().shell,v.properties["common.release"]=w.release(),v.properties["common.arch"]=w.arch()}catch{}try{const P=(/^http:/.test(this.endpoint)?n:k).request(this.endpoint,{method:"POST",headers:{"Content-Type":"application/json"}});P.on("error",()=>{}),P.write(JSON.stringify(v)),P.end()}catch{}}flush(v){v.callback&&v.callback("")}}e.TelemetryClient=_}),define(me[229],ve([0,1,28,81,69,132,225,68,33,60,3,13,37,5,8,23,27,47,21,4,17,12,71]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d,y,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.serveError=void 0;const l={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function i(F,U,G,C){U.writeHead(G,{"Content-Type":"text/plain"}),U.end(C)}e.serveError=i;async function t(F,U,G,C,z=Object.create(null)){try{const M=await I.promisify(k.stat)(C),q=`W/"${[M.ino,M.size,M.mtime.getTime()].join("-")}"`;if(U.headers["if-none-match"]===q)return G.writeHead(304),G.end();z["Content-Type"]=l[(0,b.extname)(C)]||(0,P.getMediaMime)(C)||"text/plain",z.Etag=q,G.writeHead(200,z),k.createReadStream(C).pipe(G)}catch(M){return M.code!=="ENOENT"&&(F.error(M),console.error(M.toString())),G.writeHead(404,{"Content-Type":"text/plain"}),G.end("Not found")}}e.serveFile=t;const r=(0,b.dirname)(u.FileAccess.asFileUri("",ee).fsPath);let s=class{constructor(U,G,C,z,M){this._connectionToken=U,this._environmentService=G,this._logService=C,this._requestService=z,this._productService=M,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?d.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0}async handle(U,G,C){try{const z=C.pathname;return z==="/favicon.ico"||z==="/manifest.json"||z==="/code-192.png"||z==="/code-512.png"?t(this._logService,U,G,(0,b.join)(r,"resources","server",z.substr(1))):/^\/static\//.test(z)?this._handleStatic(U,G,C):z==="/"?this._handleRoot(U,G,C):z==="/callback"?this._handleCallback(G):/^\/web-extension-resource\//.test(z)?this._handleWebExtensionResource(U,G,C):i(U,G,404,"Not found.")}catch(z){return this._logService.error(z),console.error(z.toString()),i(U,G,500,"Internal Server Error.")}}async _handleStatic(U,G,C){const z=Object.create(null),M=decodeURIComponent(C.pathname),q=(0,b.normalize)(M.substr("/static/".length)),Z=(0,b.join)(r,q);return(0,v.isEqualOrParent)(Z,r,!A.isLinux)?t(this._logService,U,G,Z,z):i(U,G,400,"Bad request.")}_getResourceURLTemplateAuthority(U){const G=U.authority.indexOf(".");return G!==-1?U.authority.substring(G+1):void 0}async _handleWebExtensionResource(U,G,C){if(!this._webExtensionResourceUrlTemplate)return i(U,G,500,"No extension gallery service configured.");const z=decodeURIComponent(C.pathname),M=(0,b.normalize)(z.substr("/web-extension-resource/".length)),q=d.URI.parse(M).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:M.substring(0,M.indexOf("/")),path:M.substring(M.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(q))return i(U,G,403,"Request Forbidden");const Z={},j=oe=>{const ue=U.headers[oe];ue&&((0,c.isString)(ue)||ue[0])?Z[oe]=(0,c.isString)(ue)?ue:ue[0]:oe!==oe.toLowerCase()&&j(oe.toLowerCase())};j("X-Client-Name"),j("X-Client-Version"),j("X-Machine-Id"),j("X-Client-Commit");const $=await this._requestService.request({type:"GET",url:q.toString(!0),headers:Z},g.CancellationToken.None),W=$.res.statusCode||500;if(W!==200){let oe=null;try{oe=await(0,h.asText)($)}catch{}return i(U,G,W,oe||`Request failed with status ${W}`)}const Y=Object.create(null),ie=oe=>{const ue=$.res.headers[oe];ue?Y[oe]=ue:oe!==oe.toLowerCase()&&ie(oe.toLowerCase())};ie("Cache-Control"),ie("Content-Type"),G.writeHead(200,Y);const re=await(0,y.streamToBuffer)($.stream);return G.end(re.buffer)}async _handleRoot(U,G,C){if(!U.headers.host)return i(U,G,400,"Bad request.");const z=C.query[u.connectionTokenQueryName];if(typeof z=="string"){const O=Object.create(null);O["Set-Cookie"]=_.serialize(u.connectionTokenCookieName,z,{sameSite:"lax",maxAge:60*60*24*7});const V=Object.create(null);for(let ae in C.query)ae!==u.connectionTokenQueryName&&(V[ae]=C.query[ae]);const J=w.format({pathname:"/",query:V});return O.Location=J,G.writeHead(302,O),G.end()}const M="remote";function q(O){return O.replace(/"/g,"&quot;")}let Z;this._environmentService.driverHandle&&(Z=!1);const j=O=>O&&d.URI.file(n.resolve(O)).with({scheme:u.Schemas.vscodeRemote,authority:M}),$=u.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",ee).fsPath,W=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,S.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,Y=(0,e.relativeRoot)((0,e.getOriginalUrl)(U)),ie=(0,e.relativePath)((0,e.getOriginalUrl)(U)),re=this._environmentService.args.locale||await(0,o.getLocaleFromConfig)(this._environmentService.argvResource.fsPath),oe=await(0,o.getNLSConfiguration)(re,this._environmentService.userDataPath),ue=(await I.promisify(k.readFile)($)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",q(JSON.stringify({remoteAuthority:M,webviewEndpoint:ie+"/static/out/vs/workbench/contrib/webview/browser/pre",_wrapWebWorkerExtHostInIframe:Z,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0,logLevel:this._logService.getLevel()},userDataPath:this._environmentService.userDataPath,isEnabledFileDownloads:!this._environmentService.args["disable-file-downloads"],settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:j(this._environmentService.args["default-folder"]),workspaceUri:j(this._environmentService.args["default-workspace"]),productConfiguration:{rootEndpoint:Y,updateEndpoint:this._environmentService.args["disable-update-check"]?void 0:Y+"/update/check",logoutEndpoint:this._environmentService.args.auth?Y+"/logout":void 0,proxyEndpointTemplate:Y+"/proxy/{{port}}",codeServerVersion:this._productService.codeServerVersion,enableTelemetry:this._productService.enableTelemetry,embedderIdentifier:"server-distro",serviceWorker:{scope:ie+"/",path:Y+"/_static/out/browser/serviceWorker.js"},extensionsGallery:{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate?this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:M,path:`web-extension-resource/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0):void 0}}}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>W?q(JSON.stringify(W)):"").replace(/{{BASE}}/g,Y).replace(/{{VS_BASE}}/g,ie).replace(/{{NLS_CONFIGURATION}}/g,()=>q(JSON.stringify(oe))),de=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(ue).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${M};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),H={"Content-Type":"text/html","Content-Security-Policy":de};return this._connectionToken.type!==0&&(H["Set-Cookie"]=_.serialize(u.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),G.writeHead(200,H),G.end(ue)}_getScriptCspHashes(U){const G=/<script>([\s\S]+?)<\/script>/img,C=[];let z;for(;z=G.exec(U);){const M=D.createHash("sha256"),q=z[1].replace(/\r\n/g,`
`),Z=M.update(Buffer.from(q)).digest().toString("base64");C.push(`'sha256-${Z}'`)}return C}async _handleCallback(U){const G=u.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",ee).fsPath,C=(await I.promisify(k.readFile)(G)).toString(),z=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(C).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return U.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":z}),U.end(C)}};s=Te([Oe(1,E.IServerEnvironmentService),Oe(2,T.ILogService),Oe(3,h.IRequestService),Oe(4,f.IProductService)],s),e.WebClientServer=s;const a=(F,U=!1)=>F.replace(/\/\/+/g,"/").replace(/\/+$/,U?"/":"");e.normalizeUrlPath=a;const m=F=>{const U=(F.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(U>1?"../".repeat(U-1):""))};e.relativeRoot=m;const p=F=>{const U=F.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+U[U.length-1])};e.relativePath=p;const R=F=>F.originalUrl||F.url;e.getOriginalUrl=R}),define(me[230],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,k.createDecorator)("IExtHostRpcService");class n{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=n}),define(me[106],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var k;(function(g){g[g.Upsert=0]="Upsert",g[g.RemoveChild=1]="RemoveChild",g[g.Invalidated=2]="Invalidated",g[g.SetProp=3]="SetProp",g[g.Bulk=4]="Bulk"})(k=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const n=new WeakMap,w=(g,d)=>{const y={controllerId:d};return n.set(g,y),y};e.createPrivateApiFor=w;const I=g=>n.get(g);e.getPrivateApiFor=I;const _=(g,d,y,c)=>{let o=y;return{enumerable:!0,configurable:!1,get(){return o},set(l){if(!c(o,l)){const i=o;o=l,g.listener?.({op:3,key:d,value:l,previous:i})}}}},D=(g,d)=>g===d,v={range:(g,d)=>g===d?!0:!g||!d?!1:g.isEqual(d),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(g,d)=>!(g.length!==d.length||g.some(y=>!d.find(c=>y.id===c.id)))},P=Object.keys(v),A=(g,d)=>({range:_(g,"range",void 0,v.range),label:_(g,"label",d,v.label),description:_(g,"description",void 0,v.description),sortText:_(g,"sortText",void 0,v.sortText),canResolveChildren:_(g,"canResolveChildren",!1,v.canResolveChildren),busy:_(g,"busy",!1,v.busy),error:_(g,"error",void 0,v.error),tags:_(g,"tags",[],v.tags)}),T=(g,d)=>{const y=new Map;for(const c of P)v[c](g[c],d[c])||y.set(c,d[c]);return y};e.diffTestItems=T;class E extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.DuplicateTestItemError=E;class b extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class u extends Error{constructor(d,y,c){super(`TestItem with ID "${d}" is from controller "${y}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=u;const S=g=>{const d=(0,e.getPrivateApiFor)(g);let y=new Map;return{get size(){return y.size},forEach(c,o){for(const l of y.values())c.call(o,l,this)},replace(c){const o=new Map,l=new Set(y.keys()),i={op:4,ops:[]};for(const t of c){if(!(t instanceof f))throw new b(t.id);const r=(0,e.getPrivateApiFor)(t).controllerId;if(r!==d.controllerId)throw new u(t.id,r,d.controllerId);if(o.has(t.id))throw new E(t.id);o.set(t.id,t),l.delete(t.id),i.ops.push({op:0,item:t})}for(const t of l.keys())i.ops.push({op:1,id:t});d.listener?.(i),y=o},add(c){if(!(c instanceof f))throw new b(c.id);y.set(c.id,c),d.listener?.({op:0,item:c})},delete(c){y.delete(c)&&d.listener?.({op:1,id:c})},get(c){return y.get(c)},toJSON(){return Array.from(y.values())},[Symbol.iterator](){return y.values()}}};class f{constructor(d,y,c,o){if(y.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(y)} symbol`);const l=(0,e.createPrivateApiFor)(this,d);Object.defineProperties(this,{id:{value:y,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof h?void 0:l.parent}},children:{value:S(this),enumerable:!0,writable:!1},...A(l,c)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=f;class h extends f{constructor(d,y){super(d,d,y,void 0)}}e.TestItemRootImpl=h});var St=this&&this.__classPrivateFieldSet||function(ee,e,k,n,w){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!w:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?w.call(ee,k):w?w.value=k:e.set(ee,k),k},et=this&&this.__classPrivateFieldGet||function(ee,e,k,n){if(k==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?n:k==="a"?n.call(ee):n?n.value:e.get(ee)};define(me[107],ve([0,1,16,9,79,31,60,15,12,4,23,18,97]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E){"use strict";var b,u,S,f,h,g,d,y,c,o,l,i,t,r,s,a,m,p,R,F;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function U(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let G=h=class{constructor(L){b.set(this,void 0),St(this,b,L,"f")}static from(...L){let te=L;return new h(function(){if(te){for(const Ce of te)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();te=void 0}})}dispose(){typeof et(this,b,"f")=="function"&&(et(this,b,"f").call(this),St(this,b,void 0,"f"))}};b=new WeakMap,G=h=Te([U],G),e.Disposable=G;let C=g=class{constructor(L,te){if(L<0)throw(0,n.illegalArgument)("line must be non-negative");if(te<0)throw(0,n.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ce=1;Ce<L.length;Ce++){const Be=L[Ce];Be.isBefore(te)&&(te=Be)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ce=1;Ce<L.length;Ce++){const Be=L[Ce];Be.isAfter(te)&&(te=Be)}return te}static isPosition(L){if(!L)return!1;if(L instanceof g)return!0;let{line:te,character:Ce}=L;return typeof te=="number"&&typeof Ce=="number"}static of(L){if(L instanceof g)return L;if(this.isPosition(L))return new g(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,n.illegalArgument)();let Ce;return typeof L=="undefined"?Ce=0:typeof L=="number"?Ce=L:(Ce=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Ce===0&&te===0?this:new g(this.line+Ce,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,n.illegalArgument)();let Ce;return typeof L=="undefined"?Ce=this.line:typeof L=="number"?Ce=L:(Ce=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Ce===this.line&&te===this.character?this:new g(Ce,te)}toJSON(){return{line:this.line,character:this.character}}};C=g=Te([U],C),e.Position=C;let z=d=class{constructor(L,te,Ce,Be){let Ye,Qe;if(typeof L=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Be=="number"?(Ye=new C(L,te),Qe=new C(Ce,Be)):C.isPosition(L)&&C.isPosition(te)&&(Ye=C.of(L),Qe=C.of(te)),!Ye||!Qe)throw new Error("Invalid arguments");Ye.isBefore(Qe)?(this._start=Ye,this._end=Qe):(this._start=Qe,this._end=Ye)}static isRange(L){return L instanceof d?!0:L?C.isPosition(L.start)&&C.isPosition(L.end):!1}static of(L){if(L instanceof d)return L;if(this.isRange(L))return new d(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(L){return d.isRange(L)?this.contains(L.start)&&this.contains(L.end):C.isPosition(L)?!(C.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=C.Max(L.start,this._start),Ce=C.Min(L.end,this._end);if(!te.isAfter(Ce))return new d(te,Ce)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=C.Min(L.start,this._start),Ce=C.Max(L.end,this.end);return new d(te,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,n.illegalArgument)();let Ce;return L?C.isPosition(L)?Ce=L:(Ce=L.start||this.start,te=L.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&te.isEqual(this.end)?this:new d(Ce,te)}toJSON(){return[this.start,this.end]}};z=d=Te([U],z),e.Range=z;let M=y=class extends z{constructor(L,te,Ce,Be){let Ye,Qe;if(typeof L=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Be=="number"?(Ye=new C(L,te),Qe=new C(Ce,Be)):C.isPosition(L)&&C.isPosition(te)&&(Ye=C.of(L),Qe=C.of(te)),!Ye||!Qe)throw new Error("Invalid arguments");super(Ye,Qe);this._anchor=Ye,this._active=Qe}static isSelection(L){return L instanceof y?!0:L?z.isRange(L)&&C.isPosition(L.anchor)&&C.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=y=Te([U],M),e.Selection=M;class q{constructor(L,te,Ce){if(typeof L!="string"||L.length===0)throw(0,n.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,n.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,n.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=Ce}}e.ResolvedAuthority=q;class Z extends Error{constructor(L,te=E.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(L);this._message=L,this._code=te,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Z.prototype)}static NotAvailable(L,te){return new Z(L,E.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new Z(L,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=Z;var j;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var $;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=c=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof c?!0:L?z.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new c(L,te)}static insert(L,te){return c.replace(new z(L,L),te)}static delete(L){return c.replace(L,"")}static setEndOfLine(L){const te=new c(new z(new C(0,0),new C(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!z.isRange(L))throw(0,n.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,n.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,n.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=c=Te([U],W),e.TextEdit=W;var Y;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(Y=e.FileEditType||(e.FileEditType={}));let ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,Ce,Be){this._edits.push({_type:1,from:L,to:te,options:Ce,metadata:Be})}createFile(L,te,Ce){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:Ce})}deleteFile(L,te,Ce){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:Ce})}replaceNotebookMetadata(L,te,Ce){this._edits.push({_type:3,metadata:Ce,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,Ce,Be,Ye){let Qe,Je,it=[],lt;if(Rt.isNotebookRange(te)&&Ct.isNotebookCellDataArray(Ce)&&!Ct.isNotebookCellDataArray(Be)?(Qe=te.start,Je=te.end,it=Ce,lt=Be):typeof te=="number"&&typeof Ce=="number"&&Ct.isNotebookCellDataArray(Be)&&(Qe=te,Je=Ce,it=Be,lt=Ye),Qe===void 0||Je===void 0)throw new Error("Invalid arguments");(Qe!==Je||it.length>0)&&this._edits.push({_type:5,uri:L,index:Qe,count:Je-Qe,cells:it,metadata:lt})}replaceNotebookCellMetadata(L,te,Ce,Be){this._edits.push({_type:3,metadata:Be,uri:L,edit:{editType:8,index:te,metadata:Ce}})}replace(L,te,Ce,Be){this._edits.push({_type:2,uri:L,edit:new W(te,Ce),metadata:Be})}insert(L,te,Ce,Be){this.replace(L,new z(te,te),Ce,Be)}delete(L,te,Ce){this.replace(L,te,"",Ce)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Ce of te)Ce&&this._edits.push({_type:2,uri:L,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Be=this._edits[Ce];Be._type===2&&Be.uri.toString()===L.toString()&&(this._edits[Ce]=void 0)}(0,k.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===L.toString()&&te.push(Ce.edit);return te}entries(){const L=new I.ResourceMap;for(let te of this._edits)if(te._type===2){let Ce=L.get(te.uri);Ce||(Ce=[te.uri,[]],L.set(te.uri,Ce)),Ce[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ie=Te([U],ie),e.WorkspaceEdit=ie;let re=o=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof o?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=o._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const Ce=new o;Ce._tabstop=this._tabstop,L(Ce),this._tabstop=Ce._tabstop,L=Ce.value}else L=o._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const Ce=L.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Ce=new o;Ce._tabstop=this._tabstop,te(Ce),this._tabstop=Ce._tabstop,te=Ce.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};re=o=Te([U],re),e.SnippetString=re;var oe;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=l=class{constructor(L,te){if(this.uri=L,te)if(z.isRange(te))this.range=z.of(te);else if(C.isPosition(te))this.range=new z(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof l?!0:L?z.isRange(L.range)&&P.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=l=Te([U],de),e.Location=de;let H=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&z.isRange(L.location.range)&&P.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};H=Te([U],H),e.DiagnosticRelatedInformation=H;let O=class{constructor(L,te,Ce=ue.Error){if(!z.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Ce}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,k.equals)(L.tags,te.tags)&&(0,k.equals)(L.relatedInformation,te.relatedInformation,H.isEqual)}};O=Te([U],O),e.Diagnostic=O;let V=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};V=Te([U],V),e.Hover=V;var J;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(J=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ae=class{constructor(L,te=J.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:J[this.kind]}}};ae=Te([U],ae),e.DocumentHighlight=ae;var ge;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(ge=e.SymbolKind||(e.SymbolKind={}));var he;(function(N){N[N.Deprecated=1]="Deprecated"})(he=e.SymbolTag||(e.SymbolTag={}));let le=i=class{constructor(L,te,Ce,Be,Ye){this.name=L,this.kind=te,this.containerName=Ye,typeof Ce=="string"&&(this.containerName=Ce),Be instanceof de?this.location=Be:Ce instanceof z&&(this.location=new de(Be,Ce)),i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};le=i=Te([U],le),e.SymbolInformation=le;let pe=t=class{constructor(L,te,Ce,Be,Ye){this.name=L,this.detail=te,this.kind=Ce,this.range=Be,this.selectionRange=Ye,this.children=[],t.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(t.validate)}};pe=t=Te([U],pe),e.DocumentSymbol=pe;var Q;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(Q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let B=class{constructor(L,te){this.title=L,this.kind=te}};B=Te([U],B),e.CodeAction=B;let x=r=class{constructor(L){this.value=L}append(L){return new r(this.value?this.value+r.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+r.sep)}};x.sep=".",x=r=Te([U],x),e.CodeActionKind=x,x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll");let X=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};X=Te([U],X),e.SelectionRange=X;class fe{constructor(L,te,Ce,Be,Ye,Qe){this.kind=L,this.name=te,this.detail=Ce,this.uri=Be,this.range=Ye,this.selectionRange=Qe}}e.CallHierarchyItem=fe;class ye{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=ye;class ke{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=ke;var Re;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Re=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ne=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};Ne=Te([U],Ne),e.CodeLens=Ne;let Ue=s=class{constructor(L,te=!1){u.set(this,void 0),St(this,u,new w.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof s?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return et(this,u,"f").value}set value(L){et(this,u,"f").value=L}get isTrusted(){return et(this,u,"f").isTrusted}set isTrusted(L){et(this,u,"f").isTrusted=L}get supportThemeIcons(){return et(this,u,"f").supportThemeIcons}set supportThemeIcons(L){et(this,u,"f").supportThemeIcons=L}get supportHtml(){return et(this,u,"f").supportHtml}set supportHtml(L){et(this,u,"f").supportHtml=L}get baseUri(){return et(this,u,"f").baseUri}set baseUri(L){et(this,u,"f").baseUri=L}appendText(L){return et(this,u,"f").appendText(L),this}appendMarkdown(L){return et(this,u,"f").appendMarkdown(L),this}appendCodeblock(L,te){return et(this,u,"f").appendCodeblock(te??"",L),this}};u=new WeakMap,Ue=s=Te([U],Ue),e.MarkdownString=Ue;let se=class{constructor(L,te){this.label=L,this.documentation=te}};se=Te([U],se),e.ParameterInformation=se;let we=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};we=Te([U],we),e.SignatureInformation=we;let Ee=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ee=Te([U],Ee),e.SignatureHelp=Ee;var Ae;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Ae=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let je=class{constructor(L){this.value=L}};je=Te([U],je),e.InlayHintLabelPart=je;let We=class{constructor(L,te,Ce){this.position=L,this.label=te,this.kind=Ce}};We=Te([U],We),e.InlayHint=We;var He;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(N){N[N.Deprecated=1]="Deprecated"})(ne=e.CompletionItemTag||(e.CompletionItemTag={}));let be=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};be=Te([U],be),e.CompletionItem=be;let Pe=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};Pe=Te([U],Pe),e.CompletionList=Pe;let Le=class{constructor(L,te,Ce){this.insertText=L,this.range=te,this.command=Ce}};Le=Te([U],Le),e.InlineSuggestion=Le;let Me=class{constructor(L){this.items=L}};Me=Te([U],Me),e.InlineSuggestions=Me;let Ve=class{constructor(L,te,Ce){this.insertText=L,this.range=te,this.command=Ce}};Ve=Te([U],Ve),e.InlineSuggestionNew=Ve;let ze=class{constructor(L){this.items=L}};ze=Te([U],ze),e.InlineSuggestionsNew=ze;var qe;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(qe=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ge;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ge=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ze;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(tt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var st;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ot;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ot=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var rt;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(rt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ht=class{constructor(L,te){if(te&&!P.URI.isUri(te))throw(0,n.illegalArgument)("target");if(!z.isRange(L)||L.isEmpty)throw(0,n.illegalArgument)("range");this.range=L,this.target=te}};ht=Te([U],ht),e.DocumentLink=ht;let at=class{constructor(L,te,Ce,Be){this.red=L,this.green=te,this.blue=Ce,this.alpha=Be}};at=Te([U],at),e.Color=at;let ft=class{constructor(L,te){if(te&&!(te instanceof at))throw(0,n.illegalArgument)("color");if(!z.isRange(L)||L.isEmpty)throw(0,n.illegalArgument)("range");this.range=L,this.color=te}};ft=Te([U],ft),e.ColorInformation=ft;let bt=class{constructor(L){if(!L||typeof L!="string")throw(0,n.illegalArgument)("label");this.label=L}};bt=Te([U],bt),e.ColorPresentation=bt;var Pt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Pt=e.ColorFormat||(e.ColorFormat={}));var kt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(kt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class _t{constructor(L,te,Ce){if(this.startIndex=L,this.length=te,this.tooltip=Ce,typeof L!="number"||L<0)throw(0,n.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,n.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,n.illegalArgument)("tooltip")}}e.TerminalLink=_t;var Se;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Se=e.TerminalLocation||(e.TerminalLocation={}));class Ie{constructor(L){this.options=L,typeof L!="object"&&(0,n.illegalArgument)("options")}}e.TerminalProfile=Ie;var ce;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let De=a=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,n.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};De.Clean=new a("clean","Clean"),De.Build=new a("build","Build"),De.Rebuild=new a("rebuild","Rebuild"),De.Test=new a("test","Test"),De=a=Te([U],De),e.TaskGroup=De;function _e(N){let L="";for(let te=0;te<N.length;te++)L+=N[te].replace(/,/g,",,")+",";return L}let $e=class{constructor(L,te,Ce){if(typeof L!="string")throw(0,n.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ce):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,n.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return _e(L)}};$e=Te([U],$e),e.ProcessExecution=$e;let xe=class{constructor(L,te,Ce){if(this._args=[],Array.isArray(te)){if(!L)throw(0,n.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,n.illegalArgument)("command");this._command=L,this._args=te,this._options=Ce}else{if(typeof L!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,n.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return _e(L)}};xe=Te([U],xe),e.ShellExecution=xe;var nt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(nt=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class yt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=yt;let ut=m=class{constructor(L,te,Ce,Be,Ye,Qe){this.__deprecated=!1,this._definition=this.definition=L;let Je;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ce,this.execution=Be,Je=Ye,this.__deprecated=!0):te===ct.Global||te===ct.Workspace?(this.target=te,this._name=this.name=Ce,this._source=this.source=Be,this.execution=Ye,Je=Qe):(this.target=te,this._name=this.name=Ce,this._source=this.source=Be,this.execution=Ye,Je=Qe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof $e?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,n.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,n.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(m.EmptyType===te||m.ProcessType===te||m.ShellType===te||m.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,n.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ut.ExtensionCallbackType="customExecution",ut.ProcessType="process",ut.ShellType="shell",ut.EmptyType="$empty",ut=m=Te([U],ut),e.Task=ut;var dt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor(L,te=hn.None){this.collapsibleState=te,P.URI.isUri(L)?this.resourceUri=L:this.label=L}};mt=Te([U],mt),e.TreeItem=mt;var hn;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(hn=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Nt=class{constructor(L){this.value=L}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};Nt=Te([U],Nt),e.DataTransferItem=Nt;let Mt=class{constructor(){this._items=new Map}get(L){return this._items.get(L)}set(L,te){this._items.set(L,te)}forEach(L){this._items.forEach(L)}};Mt=Te([U],Mt),e.DataTransfer=Mt;let Et=class{constructor(L,te){this.id=L,this.color=te}};Et=Te([U],Et),e.ThemeIcon=Et,Et.File=new Et("file"),Et.Folder=new Et("folder");let Ut=class{constructor(L){this.id=L}};Ut=Te([U],Ut),e.ThemeColor=Ut;var mn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(mn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Bt=class{constructor(L,te){if(typeof L!="string"&&(!L||!P.URI.isUri(L)&&!P.URI.isUri(L.uri)))throw(0,n.illegalArgument)("base");if(typeof te!="string")throw(0,n.illegalArgument)("pattern");typeof L=="string"?this.baseUri=P.URI.file(L):P.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}get base(){return this._base}set base(L){this._base=L,this._baseUri=P.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Bt=Te([U],Bt),e.RelativePattern=Bt;let It=class{constructor(L,te,Ce,Be){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};It=Te([U],It),e.Breakpoint=It;let zt=class extends It{constructor(L,te,Ce,Be,Ye){super(te,Ce,Be,Ye);if(L===null)throw(0,n.illegalArgument)("location");this.location=L}};zt=Te([U],zt),e.SourceBreakpoint=zt;let $t=class extends It{constructor(L,te,Ce,Be,Ye){super(te,Ce,Be,Ye);this.functionName=L}};$t=Te([U],$t),e.FunctionBreakpoint=$t;let Wt=class extends It{constructor(L,te,Ce,Be,Ye,Qe,Je){super(Be,Ye,Qe,Je);if(!te)throw(0,n.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=Ce}};Wt=Te([U],Wt),e.DataBreakpoint=Wt;let Ht=class{constructor(L,te,Ce){this.command=L,this.args=te||[],this.options=Ce}};Ht=Te([U],Ht),e.DebugAdapterExecutable=Ht;let jt=class{constructor(L,te){this.port=L,this.host=te}};jt=Te([U],jt),e.DebugAdapterServer=jt;let qt=class{constructor(L){this.path=L}};qt=Te([U],qt),e.DebugAdapterNamedPipeServer=qt;let Vt=class{constructor(L){this.implementation=L}};Vt=Te([U],Vt),e.DebugAdapterInlineImplementation=Vt;let Gt=class{constructor(L,te){this.range=L,this.expression=te}};Gt=Te([U],Gt),e.EvaluatableExpression=Gt;var gn;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(gn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var vn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(vn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let xt=class{constructor(L,te){this.range=L,this.text=te}};xt=Te([U],xt),e.InlineValueText=xt;let Kt=class{constructor(L,te,Ce=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Ce}};Kt=Te([U],Kt),e.InlineValueVariableLookup=Kt;let Yt=class{constructor(L,te){this.range=L,this.expression=te}};Yt=Te([U],Yt),e.InlineValueEvaluatableExpression=Yt;let Xt=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};Xt=Te([U],Xt),e.InlineValueContext=Xt;var pn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(pn=e.FileChangeType||(e.FileChangeType={}));let Qt=p=class extends Error{constructor(L,te=T.FileSystemProviderErrorCode.Unknown,Ce){super(P.URI.isUri(L)?L.toString(!0):L);this.code=Ce?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(L){return new p(L,T.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(L){return new p(L,T.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(L){return new p(L,T.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(L){return new p(L,T.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(L){return new p(L,T.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(L){return new p(L,T.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};Qt=p=Te([U],Qt),e.FileSystemError=Qt;let Jt=class{constructor(L,te,Ce){this.start=L,this.end=te,this.kind=Ce}};Jt=Te([U],Jt),e.FoldingRange=Jt;var wn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(wn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var yn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(yn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var En;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(En=e.CommentMode||(e.CommentMode={}));var Sn;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(Sn=e.CommentThreadState||(e.CommentThreadState={}));class bn{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=bn;function Cn(N){return typeof N=="undefined"||(0,v.isStringArray)(N)}class Zt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,Ce=L.tokenTypes.length;te<Ce;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,Ce=L.tokenModifiers.length;te<Ce;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,Ce,Be,Ye){if(typeof L=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Be=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(L,te,Ce,Be,Ye);if(z.isRange(L)&&typeof te=="string"&&Cn(Ce))return this._push(L,te,Ce);throw(0,n.illegalArgument)()}_push(L,te,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Be=L.start.line,Ye=L.start.character,Qe=L.end.character-L.start.character,Je=this._tokenTypeStrToInt.get(te);let it=0;if(Ce)for(const lt of Ce){if(!this._tokenModifierStrToInt.has(lt))throw new Error("`tokenModifier` is not in the provided legend");const vt=this._tokenModifierStrToInt.get(lt);it|=1<<vt>>>0}this._pushEncoded(Be,Ye,Qe,Je,it)}_pushEncoded(L,te,Ce,Be,Ye){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const it=this._data.length/5|0;let lt=0,vt=0;for(let pt=0;pt<it;pt++){let wt=this._data[5*pt],Tt=this._data[5*pt+1];wt===0?(wt=lt,Tt+=vt):wt+=lt,this._data[5*pt]=wt,this._data[5*pt+1]=Tt,lt=wt,vt=Tt}}let Qe=L,Je=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Qe-=this._prevLine,Qe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Be,this._data[this._dataLen++]=Ye,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const Ce=L.length/5|0;for(let Je=0;Je<Ce;Je++)te[Je]=Je;te.sort((Je,it)=>{const lt=L[5*Je],vt=L[5*it];if(lt===vt){const pt=L[5*Je+1],wt=L[5*it+1];return pt-wt}return lt-vt});const Be=new Uint32Array(L.length);let Ye=0,Qe=0;for(let Je=0;Je<Ce;Je++){const it=5*te[Je],lt=L[it+0],vt=L[it+1],pt=L[it+2],wt=L[it+3],Tt=L[it+4],dn=lt-Ye,ri=dn===0?vt-Qe:vt,At=5*Je;Be[At+0]=dn,Be[At+1]=ri,Be[At+2]=pt,Be[At+3]=wt,Be[At+4]=Tt,Ye=lt,Qe=vt}return Be}build(L){return this._dataIsSortedAndDeltaEncoded?new en(new Uint32Array(this._data),L):new en(Zt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Zt;class en{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=en;class In{constructor(L,te,Ce){this.start=L,this.deleteCount=te,this.data=Ce}}e.SemanticTokensEdit=In;class Dn{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=Dn;var Pn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Pn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Lt=class{constructor(){}};Lt.Back={iconPath:new Et("arrow-left")},Lt=Te([U],Lt),e.QuickInputButtons=Lt;var kn;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(kn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var _n;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(_n=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Rn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Rn=e.ExtensionKind||(e.ExtensionKind={}));class Tn{constructor(L,te,Ce){this.badge=L,this.tooltip=te,this.color=Ce}static validate(L){if(L.badge){let te=(0,D.nextCharLength)(L.badge,0);if(te<L.badge.length&&(te+=(0,D.nextCharLength)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Tn;let tn=class{constructor(L){this.kind=L}};tn=Te([U],tn),e.ColorTheme=tn;var An;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(An=e.ColorThemeKind||(e.ColorThemeKind={}));class Rt{constructor(L,te){if(L<0)throw(0,n.illegalArgument)("start must be positive");if(te<0)throw(0,n.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof Rt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,Ce=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Ce=L.end),te===this._start&&Ce===this._end?this:new Rt(te,Ce)}}e.NotebookRange=Rt;class Ct{constructor(L,te,Ce,Be,Ye,Qe,Je){this.kind=L,this.value=te,this.languageId=Ce,this.mime=Be,this.outputs=Ye??[],this.metadata=Qe,this.executionSummary=Je,Ct.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Ct.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Ct;class Ln{constructor(L){this.cells=L}}e.NotebookData=Ln;class gt{constructor(L,te){this.data=L,this.mime=te;const Ce=(0,_.normalizeMimeType)(te,!0);if(!Ce)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(L){return L instanceof gt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return gt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return gt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return gt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new gt(L,te)}static text(L,te=_.Mimes.text){const Ce=et(gt,S,"f",f).encode(String(L));return new gt(Ce,te)}static json(L,te="text/x-json"){const Ce=JSON.stringify(L,void 0,"	");return gt.text(Ce,te)}}e.NotebookCellOutputItem=gt,S=gt,f={value:new TextEncoder};class Ft{constructor(L,te,Ce){this.items=Ft.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Ce):(this.id=(0,A.generateUuid)(),this.metadata=te??Ce)}static isNotebookCellOutput(L){return L instanceof Ft?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,v.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Ce=new Set,Be=new Set;for(let Ye=0;Ye<L.length;Ye++){const Qe=L[Ye],Je=(0,_.normalizeMimeType)(Qe.mime);if(!Ce.has(Je)){Ce.add(Je);continue}Be.add(Ye),te&&console.warn(`DUPLICATED mime type '${Qe.mime}' will be dropped`)}return Be.size===0?L:L.filter((Ye,Qe)=>!Be.has(Qe))}}e.NotebookCellOutput=Ft;var Fn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Fn=e.NotebookCellKind||(e.NotebookCellKind={}));var On;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(On=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Nn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Nn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Mn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Mn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Un{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=Un;var Bn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Bn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class zn{constructor(L,te=[]){this.uri=L,this.provides=(0,k.asArray)(te)}}e.NotebookRendererScript=zn;let nn=class{constructor(L,te){this.label=L,this.timestamp=te}};nn=Te([U],nn),e.TimelineItem=nn;var $n;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})($n=e.ExtensionMode||(e.ExtensionMode={}));var Wn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Wn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Hn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(Hn=e.StandardTokenType||(e.StandardTokenType={}));class jn{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=jn;class qn{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=qn;var Vn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Vn=e.TestResultState||(e.TestResultState={}));var Gn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Gn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let rn=class{constructor(L=void 0,te=void 0,Ce=void 0){this.include=L,this.exclude=te,this.profile=Ce}};rn=Te([U],rn),e.TestRunRequest=rn;let sn=R=class{constructor(L){this.message=L}static diff(L,te,Ce){const Be=new R(L);return Be.expectedOutput=te,Be.actualOutput=Ce,Be}};sn=R=Te([U],sn),e.TestMessage=sn;let on=class{constructor(L){this.id=L}};on=Te([U],on),e.TestTag=on;let Dt=class{constructor(L,te){this.covered=L,this.total=te}};Dt=Te([U],Dt),e.CoveredCount=Dt;let an=F=class{constructor(L,te,Ce,Be){this.uri=L,this.statementCoverage=te,this.branchCoverage=Ce,this.functionCoverage=Be}static fromDetails(L,te){const Ce=new Dt(0,0),Be=new Dt(0,0),Ye=new Dt(0,0);for(const Je of te)if("branches"in Je){Ce.total+=1,Ce.covered+=Je.executionCount>0?1:0;for(const it of Je.branches)Be.total+=1,Be.covered+=it.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=Je.executionCount>0?1:0;const Qe=new F(L,Ce,Be.total>0?Be:void 0,Ye.total>0?Ye:void 0);return Qe.detailedCoverage=te,Qe}};an=F=Te([U],an),e.FileCoverage=an;let ln=class{constructor(L,te,Ce=[]){this.executionCount=L,this.location=te,this.branches=Ce}};ln=Te([U],ln),e.StatementCoverage=ln;let cn=class{constructor(L,te){this.executionCount=L,this.location=te}};cn=Te([U],cn),e.BranchCoverage=cn;let un=class{constructor(L,te){this.executionCount=L,this.location=te}};un=Te([U],un),e.FunctionCoverage=un;var xn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(xn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Kn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Kn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Yn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Yn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Xn{constructor(L,te,Ce,Be,Ye,Qe){this.kind=L,this.name=te,this.detail=Ce,this.uri=Be,this.range=Ye,this.selectionRange=Qe}}e.TypeHierarchyItem=Xn;class Qn{constructor(L){this.uri=L}}e.TextTabInput=Qn;class Jn{constructor(L,te){this.original=L,this.modified=te}}e.TextDiffTabInput=Jn;class Zn{constructor(L,te){this.uri=L,this.viewType=te}}e.CustomEditorTabInput=Zn;class ei{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=ei;class ti{constructor(L,te){this.uri=L,this.notebookType=te}}e.NotebookEditorTabInput=ti;class ni{constructor(L,te,Ce){this.original=L,this.modified=te,this.notebookType=Ce}}e.NotebookDiffEditorTabInput=ni;class ii{constructor(){}}e.TerminalEditorTabInput=ii}),define(me[57],ve([0,1,61]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function n(I){return{transformIncoming:_=>_.scheme==="vscode-remote"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="file"?{scheme:"vscode-local",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoing:_=>_.scheme==="file"?{scheme:"vscode-remote",authority:I,path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="vscode-local"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoingScheme:_=>_==="file"?"vscode-remote":_==="vscode-local"?"file":_}}function w(I){return new k.URITransformer(n(I))}e.createURITransformer=w}),define(me[231],ve([0,1,4,57,55,5,194]),function(ee,e,k,n,w,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class D extends _.AbstractDiskFileSystemProviderChannel{constructor(A,T){super(new w.DiskFileSystemProvider(A),A);this.environmentService=T,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(A){let T=this.uriTransformerCache.get(A.remoteAuthority);return T||(T=(0,n.createURITransformer)(A.remoteAuthority),this.uriTransformerCache.set(A.remoteAuthority,T)),T}transformIncoming(A,T,E=!1){if(E&&T.path==="/vscode-resource"&&T.query){const b=JSON.parse(T.query).requestResourcePath;return k.URI.from({scheme:"file",path:b})}return k.URI.revive(A.transformIncoming(T))}createSessionFileWatcher(A,T){return new v(A,T,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=D;class v extends _.AbstractSessionFileWatcher{constructor(A,T,E,b){super(A,T,E,b)}getRecursiveWatcherOptions(A){const T=A.args["file-watcher-polling"];if(T){const E=T.split(I.delimiter),b=Number(E[0]);if(b>0)return{usePolling:E.length>1?E.slice(1):!0,pollingInterval:b}}}getExtraExcludes(A){if(A.extensionsPath)return[I.posix.join(A.extensionsPath,"**")]}}}),define(me[108],ve([0,1,168,12,4,2,6,34,18,16,8]),function(ee,e,k,n,w,I,_,D,v,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,k.localize)(0,null),providerDisplayName:(0,k.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var T;(function(j){j[j.PROGRAMMATIC=1]="PROGRAMMATIC",j[j.USER=2]="USER",j[j.EDIT=3]="EDIT",j[j.NAVIGATION=4]="NAVIGATION",j[j.JUMP=5]="JUMP"})(T=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(j){j[j.IDENTICAL=1]="IDENTICAL",j[j.SIMILAR=2]="SIMILAR",j[j.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function b(j){const $=j;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=b;function u(j,$,W){for(const Y of W.visibleEditorPanes)if(Y.group.id===$&&j.matches(Y.input))return Y.getViewState()}e.findViewStateForEditor=u;function S(j){if(i(j))return!1;const $=j;return w.URI.isUri($?.resource)}e.isResourceEditorInput=S;function f(j){if(i(j))return!1;const $=j;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=f;function h(j){if(i(j)||f(j))return!1;const $=j;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=h;function g(j){if(i(j))return!1;const $=j;return $?$.resource===void 0||$.resource.scheme===A.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;var d;(function(j){j[j.SHORT=0]="SHORT",j[j.MEDIUM=1]="MEDIUM",j[j.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var y;(function(j){j[j.EXPLICIT=1]="EXPLICIT",j[j.AUTO=2]="AUTO",j[j.FOCUS_CHANGE=3]="FOCUS_CHANGE",j[j.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(y=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource($,W){let Y=this.mapIdToSaveSource.get($);return Y||(Y={source:$,label:W},this.mapIdToSaveSource.set($,Y)),Y.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new c;var o;(function(j){j[j.None=0]="None",j[j.Readonly=2]="Readonly",j[j.Untitled=4]="Untitled",j[j.Singleton=8]="Singleton",j[j.RequiresTrust=16]="RequiresTrust",j[j.CanSplitInGroup=32]="CanSplitInGroup",j[j.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends I.Disposable{}e.AbstractEditorInput=l;function i(j){return j instanceof l}e.isEditorInput=i;function t(j){const $=j;return w.URI.isUri($?.preferredResource)}function r(j){const $=j;return i($?.primary)&&i($?.secondary)}e.isSideBySideEditorInput=r;function s(j){const $=j;return i($?.modified)&&i($?.original)}e.isDiffEditorInput=s;function a(j){return i(j?.editor)}e.isEditorInputWithOptions=a;function m(j){const $=j;return a(j)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=m;function p(j){const $=j;return typeof $?.groupId=="number"&&i($.editor)}e.isEditorIdentifier=p;var R;(function(j){j[j.UNKNOWN=0]="UNKNOWN",j[j.REPLACE=1]="REPLACE",j[j.MOVE=2]="MOVE",j[j.UNPIN=3]="UNPIN"})(R=e.EditorCloseContext||(e.EditorCloseContext={}));var F;(function(j){j[j.GROUP_ACTIVE=0]="GROUP_ACTIVE",j[j.GROUP_INDEX=1]="GROUP_INDEX",j[j.GROUP_LOCKED=2]="GROUP_LOCKED",j[j.EDITOR_OPEN=3]="EDITOR_OPEN",j[j.EDITOR_CLOSE=4]="EDITOR_CLOSE",j[j.EDITOR_MOVE=5]="EDITOR_MOVE",j[j.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",j[j.EDITOR_LABEL=7]="EDITOR_LABEL",j[j.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",j[j.EDITOR_PIN=9]="EDITOR_PIN",j[j.EDITOR_STICKY=10]="EDITOR_STICKY",j[j.EDITOR_DIRTY=11]="EDITOR_DIRTY",j[j.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(F=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(j){j[j.PRIMARY=1]="PRIMARY",j[j.SECONDARY=2]="SECONDARY",j[j.BOTH=3]="BOTH",j[j.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class G{getOriginalUri($,W){if(!$)return;if(W?.supportSideBySide){const{primary:ie,secondary:re}=this.getSideEditors($);if(ie&&re){if(W?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ie,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===U.ANY)return this.getOriginalUri(ie,{filterByScheme:W.filterByScheme})??this.getOriginalUri(re,{filterByScheme:W.filterByScheme});$=W.supportSideBySide===U.PRIMARY?ie:re}}if(f($)||h($))return;const Y=t($)?$.preferredResource:$.resource;return!Y||!W||!W.filterByScheme?Y:this.filterUri(Y,W.filterByScheme)}getSideEditors($){return r($)||h($)?{primary:$.primary,secondary:$.secondary}:s($)||f($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,W){if(!$)return;if(W?.supportSideBySide){const{primary:ie,secondary:re}=this.getSideEditors($);if(ie&&re){if(W?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ie,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===U.ANY)return this.getCanonicalUri(ie,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:W.filterByScheme});$=W.supportSideBySide===U.PRIMARY?ie:re}}if(f($)||h($))return;const Y=$.resource;return!Y||!W||!W.filterByScheme?Y:this.filterUri(Y,W.filterByScheme)}filterUri($,W){if(Array.isArray(W)){if(W.some(Y=>$.scheme===Y))return $}else if(W===$.scheme)return $}}e.EditorResourceAccessor=new G;var C;(function(j){j[j.LEFT=0]="LEFT",j[j.RIGHT=1]="RIGHT"})(C=e.CloseDirection||(e.CloseDirection={}));class z{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const W=this.instantiationService=$.get(_.IInstantiationService);for(const[Y,ie]of this.editorSerializerConstructors)this.createEditorSerializer(Y,ie,W);this.editorSerializerConstructors.clear()}createEditorSerializer($,W,Y){const ie=Y.createInstance(W);this.editorSerializerInstances.set($,ie)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,n.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,W){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,W,this.instantiationService):this.editorSerializerConstructors.set($,W),(0,I.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new z);async function M(j,$){if(!j||!j.length)return[];const W=await Promise.all(j.map(async Y=>{const ie=w.URI.revive(Y.fileUri);if(!ie||!await $.canHandleResource(ie))return;let oe=Y.exists,ue=Y.type;if(typeof oe!="boolean"||typeof ue!="number")try{ue=(await $.stat(ie)).isDirectory?v.FileType.Directory:v.FileType.Unknown,oe=!0}catch{oe=!1}if(!oe&&Y.openOnlyIfExists||ue===v.FileType.Directory)return;const de={selection:oe?Y.selection:void 0,pinned:!0,override:Y.editorOverrideId};let H;return oe?H={resource:ie,options:de}:H={resource:ie,options:de,forceUntitled:!0},H}));return(0,P.coalesce)(W)}e.pathsToEditors=M;var q;(function(j){j[j.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",j[j.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}));function Z(j){const $=j;if(!$)return!1;const W=$;if(W.modified)return Z(W.modified);const Y=$;return!!(Y.contributionsState&&Y.viewState&&Array.isArray(Y.cursorState))}e.isTextEditorViewState=Z}),define(me[232],ve([0,1,78,49,60,8,5,3,90]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var P;(function(s){s[s.Markup=1]="Markup",s[s.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(s){s[s.Running=1]="Running",s[s.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var T;(function(s){s[s.Unconfirmed=1]="Unconfirmed",s[s.Pending=2]="Pending",s[s.Executing=3]="Executing"})(T=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(s){s[s.WithHardKernelDependency=0]="WithHardKernelDependency",s[s.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",s[s.Pure=2]="Pure",s[s.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(s){s.Always="always",s.Never="never",s.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var u;(function(s){s[s.ModelChange=1]="ModelChange",s[s.Move=2]="Move",s[s.ChangeLanguage=5]="ChangeLanguage",s[s.Initialize=6]="Initialize",s[s.ChangeCellMetadata=7]="ChangeCellMetadata",s[s.Output=8]="Output",s[s.OutputItem=9]="OutputItem",s[s.ChangeCellContent=10]="ChangeCellContent",s[s.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",s[s.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",s[s.ChangeCellMime=13]="ChangeCellMime",s[s.Unknown=100]="Unknown"})(u=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var S;(function(s){s[s.Handle=0]="Handle",s[s.Index=1]="Index"})(S=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(s){s[s.Replace=1]="Replace",s[s.Output=2]="Output",s[s.Metadata=3]="Metadata",s[s.CellLanguage=4]="CellLanguage",s[s.DocumentMetadata=5]="DocumentMetadata",s[s.Move=6]="Move",s[s.OutputItems=7]="OutputItems",s[s.PartialMetadata=8]="PartialMetadata",s[s.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var h;(function(s){s.scheme=I.Schemas.vscodeNotebookCell;const a=/^ch(\d{7,})/;function m(C,z){return C.with({scheme:s.scheme,fragment:`ch${z.toString().padStart(7,"0")}${C.scheme!==I.Schemas.file?C.scheme:""}`})}s.generate=m;function p(C){if(C.scheme!==s.scheme)return;const z=a.exec(C.fragment);return z?{handle:Number(z[1]),notebook:C.with({scheme:C.fragment.substring(z[0].length)||I.Schemas.file,fragment:null})}:void 0}s.parse=p;function R(C,z){return C.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${z??""},${C.scheme!==I.Schemas.file?C.scheme:""}`})}s.generateCellOutputUri=R;function F(C){if(C.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(C.fragment);if(!z)return;const M=z[1]&&z[1]!==""?z[1]:void 0,q=z[2];return{outputId:M,notebook:C.with({scheme:q||I.Schemas.file,fragment:null})}}s.parseCellOutputUri=F;function U(C,z,M){return C.with({scheme:M,fragment:`ch${z.toString().padStart(7,"0")}${C.scheme!==I.Schemas.file?C.scheme:""}`})}s.generateCellUri=U;function G(C,z){if(C.scheme!==z)return;const M=a.exec(C.fragment);return M?{handle:Number(M[1]),notebook:C.with({scheme:C.fragment.substring(M[0].length)||I.Schemas.file,fragment:null})}:void 0}s.parseCellUri=G})(h=e.CellUri||(e.CellUri={}));const g=s=>D.isWindows?s.replace(/\//g,"\\"):s;class d{constructor(a=[],m=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=m,this.order=[...new Set(a)].map(p=>({pattern:p,matches:k.parse(g(p))}))}sort(a){const m=new Map(n.Iterable.map(a,R=>[R,g(R)]));let p=[];for(const{matches:R}of this.order)for(const[F,U]of m)if(R(U)){p.push(F),m.delete(F);break}return m.size&&(p=p.concat([...m.keys()].sort((R,F)=>this.defaultOrder.indexOf(R)-this.defaultOrder.indexOf(F)))),p}prioritize(a,m){const p=this.findIndex(a);if(p===-1){this.order.unshift({pattern:a,matches:k.parse(g(a))});return}const R=new Set(m.map(U=>this.findIndex(U,p)));R.delete(-1);const F=Array.from(R).sort();this.order.splice(p+1,0,...F.map(U=>this.order[U]));for(let U=F.length-1;U>=0;U--)this.order.splice(F[U],1)}toArray(){return this.order.map(a=>a.pattern)}findIndex(a,m=this.order.length){const p=g(a);for(let R=0;R<m;R++)if(this.order[R].matches(p))return R;return-1}}e.MimeTypeDisplayOrder=d;function y(s,a,m,p=(R,F)=>R===F){const R=[];function F(C,z,M){if(z===0&&M.length===0)return;const q=R[R.length-1];q&&q.start+q.deleteCount===C?(q.deleteCount+=z,q.toInsert.push(...M)):R.push({start:C,deleteCount:z,toInsert:M})}let U=0,G=0;for(;;){if(U===s.length){F(U,0,a.slice(G));break}if(G===a.length){F(U,s.length-U,[]);break}const C=s[U],z=a[G];if(p(C,z)){U+=1,G+=1;continue}m(z)?(F(U,1,[]),U+=1):(F(U,0,[z]),G+=1)}return R}e.diff=y,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none");var c;(function(s){s.default="default",s.option="option"})(c=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(s){const a=s;return!!((typeof a.include=="string"||k.isRelativePattern(a.include))&&(typeof a.exclude=="string"||k.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=o;function l(s,a,m){if(Array.isArray(s.viewType)&&s.viewType.indexOf(a)>=0||s.viewType===a)return!0;if(s.filenamePattern){const p=o(s.filenamePattern)?s.filenamePattern.include:s.filenamePattern,R=o(s.filenamePattern)?s.filenamePattern.exclude:void 0;if(k.match(p,(0,_.basename)(m.fsPath).toLowerCase()))return!(R&&k.match(R,(0,_.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class i{constructor(a){this.textModel=a}getElements(){const a=new Int32Array(this.textModel.cells.length);for(let m=0;m<this.textModel.cells.length;m++)a[m]=this.textModel.cells[m].getHashValue();return a}}e.CellSequence=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var t;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(t=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(a){return`${r._prefix}${a}`}static parse(a){if(a.startsWith(r._prefix))return a.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(me[109],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,k.createDecorator)("environmentVariableService");var n;(function(w){w[w.Replace=1]="Replace",w[w.Append=2]="Append",w[w.Prepend=3]="Prepend"})(n=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(me[233],ve([0,1,3,109]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class w{constructor(v){this.map=new Map,v.forEach((P,A)=>{const T=P.map.entries();let E=T.next();for(;!E.done;){const b=E.value[0];let u=this.map.get(b);if(u||(u=[],this.map.set(b,u)),u.length>0&&u[0].type===n.EnvironmentVariableMutatorType.Replace){E=T.next();continue}const S=E.value[1];u.unshift({extensionIdentifier:A,value:S.value,type:S.type}),E=T.next()}})}applyToProcessEnvironment(v,P){let A;k.isWindows&&(A={},Object.keys(v).forEach(T=>A[T.toLowerCase()]=T)),this.map.forEach((T,E)=>{const b=k.isWindows&&A[E.toLowerCase()]||E;T.forEach(u=>{const S=P?P(u.value):u.value;switch(u.type){case n.EnvironmentVariableMutatorType.Append:v[b]=(v[b]||"")+S;break;case n.EnvironmentVariableMutatorType.Prepend:v[b]=S+(v[b]||"");break;case n.EnvironmentVariableMutatorType.Replace:v[b]=S;break}})})}diff(v){const P=new Map,A=new Map,T=new Map;if(v.map.forEach((E,b)=>{const u=this.map.get(b),S=I(E,u);S&&P.set(b,S)}),this.map.forEach((E,b)=>{const u=v.map.get(b),S=I(E,u);S&&T.set(b,S)}),this.map.forEach((E,b)=>{const u=v.map.get(b),S=_(E,u);S&&A.set(b,S)}),!(P.size===0&&A.size===0&&T.size===0))return{added:P,changed:A,removed:T}}}e.MergedEnvironmentVariableCollection=w;function I(D,v){if(!v)return D;const P=new Set;v.forEach(T=>P.add(T.extensionIdentifier));const A=[];return D.forEach(T=>{P.has(T.extensionIdentifier)||A.push(T)}),A.length===0?void 0:A}function _(D,v){if(!v)return;const P=new Map;v.forEach(T=>P.set(T.extensionIdentifier,T));const A=[];return D.forEach(T=>{const E=P.get(T.extensionIdentifier);E&&(T.type!==E.type||T.value!==E.value)&&A.push(E)}),A.length===0?void 0:A}}),define(me[110],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function k(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=k;function n(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=n}),define(me[234],ve([0,1,5,75,3]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function I(y,c){if(!!c)if(w.isWindows)for(const o in c){let l=o;for(const t in y)if(o.toLowerCase()===t.toLowerCase()){l=t;break}const i=c[o];i!==void 0&&_(y,l,i)}else Object.keys(c).forEach(o=>{const l=c[o];l!==void 0&&_(y,o,l)})}e.mergeEnvironments=I;function _(y,c,o){typeof o=="string"?y[c]=o:delete y[c]}function D(y,c,o,l){y.TERM_PROGRAM="vscode",c&&(y.TERM_PROGRAM_VERSION=c),A(y,l)&&(y.LANG=T(o)),y.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=D;function v(y,c){if(!!c)for(const o of Object.keys(c)){const l=c[o];l&&(y[o]=l)}}function P(y,c){return Object.keys(c).forEach(o=>{const l=c[o];if(typeof l=="string")try{c[o]=y(l)}catch{c[o]=l}}),c}function A(y,c){if(c==="on")return!0;if(c==="auto"){const o=y.LANG;return!o||o.search(/\.UTF\-8$/)===-1&&o.search(/\.utf8$/)===-1&&o.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=A;function T(y){const c=y?y.split("-"):[],o=c.length;if(o===0)return"en_US.UTF-8";if(o===1){const l={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};c[0]in l&&c.push(l[c[0]])}else c[1]=c[1].toUpperCase();return c.join("_")+".UTF-8"}e.getLangEnvVariable=T;function E(y,c,o,l,i,t){if(y.cwd){const s=typeof y.cwd=="object"?y.cwd.fsPath:y.cwd,a=b(s,o);return u(a||s)}let r;return!y.ignoreConfigurationCwd&&i&&(o&&(i=b(i,o,t)),i&&(k.isAbsolute(i)?r=i:l&&(r=k.join(l.fsPath,i)))),r||(r=l?l.fsPath:c||""),u(r)}e.getCwd=E;function b(y,c,o){if(c)try{return c(y)}catch(l){o?.error("Could not resolve terminal cwd",l);return}return y}function u(y){return w.OS===1&&y&&y[1]===":"?y[0].toUpperCase()+y.substr(1):y}function S(y,c,o){if(!!o)return l=>o.resolveWithEnvironment(c,y,l)}e.createVariableResolver=S;function f(y,c,o,l,i,t,r,s=w.platform){let a;r&&(a=g(y,"automationShell",s)),a||(a=g(y,"shell",s));let m=a||c;if(s===3&&!o&&l){const p=k.join(l,"Sysnative").replace(/\//g,"\\").toLowerCase();m&&m.toLowerCase().indexOf(p)===0&&(m=k.join(l,"System32",m.substr(p.length+1)))}if(m&&s===3&&(m=m.replace(/\//g,"\\")),i)try{m=i(m)}catch(p){t.error("Could not resolve shell",p)}return m}e.getDefaultShell=f;function h(y,c,o,l,i=w.platform){if(c&&g(y,"automationShell",i))return[];const t=i===3?"windows":i===1?"osx":"linux";let r=y(`terminal.integrated.shellArgs.${t}`);if(!r)return[];if(typeof r=="string"&&i===3)return o?o(r):r;if(o){const s=[];for(const a of r)try{s.push(o(a))}catch(m){l.error(`Could not resolve terminal.integrated.shellArgs.${t}`,m),s.push(a)}r=s}return r}e.getDefaultShellArgs=h;function g(y,c,o=w.platform){return y(`terminal.integrated.${c}.${o===3?"windows":o===1?"osx":"linux"}`)}function d(y,c,o,l,i,t){const r={};if(y.strictEnv)v(r,y.env);else{v(r,t);const s={...c};o&&(s&&P(o,s),y.env&&P(o,y.env)),(0,n.sanitizeProcessEnvironment)(r,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),I(r,s),I(r,y.env),D(r,l,w.locale,i)}return r}e.createTerminalEnvironment=d}),define(me[235],ve([0,1,4,51]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var w;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(w=e.TestResultState||(e.TestResultState={}));var I;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(r){r.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),r.deserialize=s=>({range:n.Range.lift(s.range),uri:k.URI.revive(s.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var D;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var v;(function(r){r.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&_.serialize(s.location)}),r.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&_.deserialize(s.location)})})(v=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(r){r.serialize=s=>({message:s.message,type:1,offset:s.offset,location:s.location&&_.serialize(s.location)}),r.deserialize=s=>({message:s.message,type:1,offset:s.offset,location:s.location&&_.deserialize(s.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var A;(function(r){r.serialize=s=>s.type===0?v.serialize(s):P.serialize(s),r.deserialize=s=>s.type===0?v.deserialize(s):P.deserialize(s)})(A=e.ITestMessage||(e.ITestMessage={}));var T;(function(r){r.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(A.serialize)}),r.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(A.deserialize)})})(T=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",b=(r,s)=>r+E+s;e.namespaceTestTag=b;const u=r=>{const s=r.indexOf(E);return{ctrlId:r.slice(0,s),tagId:r.slice(s+1)}};e.denamespaceTestTag=u;var S;(function(r){r.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),r.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?k.URI.revive(s.uri):void 0,range:s.range?n.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(S=e.ITestItem||(e.ITestItem={}));var f;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(f=e.TestItemExpandState||(e.TestItemExpandState={}));var h;(function(r){r.serialize=s=>({controllerId:s.controllerId,expand:s.expand,parent:s.parent,item:S.serialize(s.item)}),r.deserialize=s=>({controllerId:s.controllerId,expand:s.expand,parent:s.parent,item:S.deserialize(s.item)})})(h=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(r){r.serialize=s=>{let a;return s.item&&(a={},s.item.label!==void 0&&(a.label=s.item.label),s.item.tags!==void 0&&(a.tags=s.item.tags),s.item.busy!==void 0&&(a.busy=s.item.busy),s.item.uri!==void 0&&(a.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(a.range=s.item.range?.toJSON()),s.item.description!==void 0&&(a.description=s.item.description),s.item.error!==void 0&&(a.error=s.item.error),s.item.sortText!==void 0&&(a.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:a}},r.deserialize=s=>{let a;return s.item&&(a={},s.item.label!==void 0&&(a.label=s.item.label),s.item.tags!==void 0&&(a.tags=s.item.tags),s.item.busy!==void 0&&(a.busy=s.item.busy),s.item.range!==void 0&&(a.range=s.item.range?n.Range.lift(s.item.range):null),s.item.description!==void 0&&(a.description=s.item.description),s.item.error!==void 0&&(a.error=s.item.error),s.item.sortText!==void 0&&(a.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:a}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const d=(r,s)=>{s.expand!==void 0&&(r.expand=s.expand),s.item!==void 0&&(r.item=r.item?Object.assign(r.item,s.item):s.item)};e.applyTestItemUpdate=d;var y;(function(r){r.serialize=(s,a)=>({...h.serialize(s),children:a,ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(T.serialize)})})(y=e.TestResultItem||(e.TestResultItem={}));var c;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(c=e.DetailType||(e.DetailType={}));var o;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(r){r.deserialize=s=>s.op===0?{op:s.op,item:h.deserialize(s.item)}:s.op===1?{op:s.op,item:g.deserialize(s.item)}:s,r.serialize=s=>s.op===0?{op:s.op,item:h.serialize(s.item)}:s.op===1?{op:s.op,item:g.serialize(s.item)}:s})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(s){}update(s){}remove(s,a){}complete(){}}e.IncrementalChangeCollector=i;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(s){const a=this.createChangeCollector();for(const m of s)switch(m.op){case 0:{const p=h.deserialize(m.item);if(p.parent){if(this.items.has(p.parent)){const R=this.items.get(p.parent);R.children.add(p.item.extId);const F=this.createItem(p,R);this.items.set(p.item.extId,F),a.add(F)}}else{const R=this.createItem(p);this.roots.add(R),this.items.set(p.item.extId,R),a.add(R)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=g.deserialize(m.item),R=this.items.get(p.extId);if(!R)break;p.expand!==void 0&&(R.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(R,p),a.update(R);break}case 2:{const p=this.items.get(m.itemId);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const R=[[m.itemId]];for(;R.length;)for(const F of R.pop()){const U=this.items.get(F);U&&(R.push(U.children),this.items.delete(F),a.remove(U,U!==p),U.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}a.complete()}retireTest(s){}updatePendingRoots(s){this.pendingRootCount+=s}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=t}),define(me[236],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var k;(function(I){I.Delimiter="\0"})(k=e.TestIdPathParts||(e.TestIdPathParts={}));var n;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(n=e.TestPosition||(e.TestPosition={}));class w{constructor(_,D=_.length){if(this.path=_,this.viewEnd=D,_.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(_,D,v=_.parent){if(_.id===D)return new w([D]);let P=[_.id];for(let A=v;A&&A.id!==D;A=A.parent)P.push(A.id);return P.push(D),new w(P.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const D=_.indexOf("\0");return D===-1?_:_.slice(0,D)}static fromString(_){return new w(_.split("\0"))}static join(_,D){return new w([..._.path,D])}static joinToString(_,D){return _.toString()+"\0"+D}static compare(_,D){return _===D?0:D.startsWith(_+"\0")?2:_.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new w(this.path,_)}compare(_){if(typeof _=="string")return w.compare(this.toString(),_);for(let D=0;D<_.viewEnd&&D<this.viewEnd;D++)if(_.path[D]!==this.path[D])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=w}),define(me[237],ve([0,1,26,6]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,n.refineServiceDecorator)(k.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(me[238],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,k.createDecorator)("configurationResolverService")}),define(me[239],ve([0,1,5,25,12,22,3,80,169]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(T,E,b,u){this._contributedVariables=new Map,this._context=T,this._labelService=E,this._userHomePromise=b,u&&(this._envVariablesPromise=u.then(S=>this.prepareEnv(S)))}prepareEnv(T){if(_.isWindows){const E=Object.create(null);return Object.keys(T).forEach(b=>{E[b.toLowerCase()]=T[b]}),E}return T}resolveWithEnvironment(T,E,b){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},E?E.uri:void 0,b)}async resolveAsync(T,E){const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,T?T.uri:void 0,E)}async resolveAnyBase(T,E,b,u){const S=I.deepClone(E);_.isWindows&&S.windows?Object.keys(S.windows).forEach(h=>S[h]=S.windows[h]):_.isMacintosh&&S.osx?Object.keys(S.osx).forEach(h=>S[h]=S.osx[h]):_.isLinux&&S.linux&&Object.keys(S.linux).forEach(h=>S[h]=S.linux[h]),delete S.windows,delete S.osx,delete S.linux;const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,T?T.uri:void 0,S,b,u)}async resolveAnyAsync(T,E,b){return this.resolveAnyBase(T,E,b)}async resolveAnyMap(T,E,b){const u=new Map;return{newConfig:await this.resolveAnyBase(T,E,b,u),resolvedVariables:u}}resolveWithInteractionReplace(T,E,b,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,E,b,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,E){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,E)}recursiveResolve(T,E,b,u,S){if(w.isString(b))return this.resolveString(T,E,b,u,S);if(w.isArray(b))return b.map(f=>this.recursiveResolve(T,E,f,u,S));if(w.isObject(b)){let f=Object.create(null);return Object.keys(b).forEach(h=>{const g=this.resolveString(T,E,h,u,S);f[g]=this.recursiveResolve(T,E,b[h],u,S)}),f}return b}resolveString(T,E,b,u,S){return b.replace(P.VARIABLE_REGEXP,(h,g)=>{if(g.includes(P.VARIABLE_LHS))return h;let d=this.evaluateSingleVariable(T,h,g,E,u);return S&&S.set(g,d),d!==h&&w.isString(d)&&d.match(P.VARIABLE_REGEXP)&&(d=this.resolveString(T,E,d,u,S)),d})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}evaluateSingleVariable(T,E,b,u,S){let f;const h=b.split(":");h.length>1&&(b=h[0],f=h[1]);const g=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,v.localize)(0,null,E))},d=()=>{const c=g();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,v.localize)(1,null,E,k.basename(c)))},y=()=>{if(f){const c=this._context.getFolderUri(f);if(c)return c;throw new Error((0,v.localize)(2,null,E,f))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,v.localize)(3,null,E)):new Error((0,v.localize)(4,null,E))};switch(b){case"env":if(f){if(T.env){const c=T.env[_.isWindows?f.toLowerCase():f];if(w.isString(c))return c}return""}throw new Error((0,v.localize)(5,null,E));case"config":if(f){const c=this._context.getConfigurationValue(u,f);if(w.isUndefinedOrNull(c))throw new Error((0,v.localize)(6,null,E,f));if(w.isObject(c))throw new Error((0,v.localize)(7,null,E,f));return c}throw new Error((0,v.localize)(8,null,E));case"command":return this.resolveFromMap(E,f,S,"command");case"input":return this.resolveFromMap(E,f,S,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(y()));case"cwd":return u||f?(0,D.normalizeDriveLetter)(this.fsPath(y())):n.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return k.basename(this.fsPath(y()));case"userHome":{if(T.userHome)return T.userHome;throw new Error((0,v.localize)(9,null,E))}case"lineNumber":{const c=this._context.getLineNumber();if(c)return c;throw new Error((0,v.localize)(10,null,E))}case"selectedText":{const c=this._context.getSelectedText();if(c)return c;throw new Error((0,v.localize)(11,null,E))}case"file":return g();case"fileWorkspaceFolder":return d();case"relativeFile":return u||f?k.relative(this.fsPath(y()),g()):g();case"relativeFileDirname":{const c=k.dirname(g());if(u||f){const o=k.relative(this.fsPath(y()),c);return o.length===0?".":o}return c}case"fileDirname":return k.dirname(g());case"fileExtname":return k.extname(g());case"fileBasename":return k.basename(g());case"fileBasenameNoExtension":{const c=k.basename(g());return c.slice(0,c.length-k.extname(c).length)}case"fileDirnameBasename":return k.basename(k.dirname(g()));case"execPath":{const c=this._context.getExecPath();return c||E}case"execInstallFolder":{const c=this._context.getAppRoot();return c||E}case"pathSeparator":return k.sep;default:try{const c=f?`${b}:${f}`:b;return this.resolveFromMap(E,c,S,void 0)}catch{return E}}}}resolveFromMap(T,E,b,u){if(E&&b){const S=u===void 0?b[E]:b[u+":"+E];if(typeof S=="string")return S;throw new Error((0,v.localize)(12,null,T))}return T}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[240],ve([0,1,6,108]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,k.createDecorator)("editorGroupsService");var w;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var I;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var D;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var v;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(v=e.MergeGroupMode||(e.MergeGroupMode={}));function P(u){const S=u;return(0,n.isEditorInput)(S?.editor)&&(0,n.isEditorInput)(S?.replacement)}e.isEditorReplacement=P;var A;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function E(u){const S=u;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=E;function b(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(me[111],ve([0,1,6,240]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,k.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(I){const _=I;return typeof I=="number"||(0,n.isEditorGroup)(_)}e.isPreferredGroup=w}),define(me[241],ve([0,1,16,17,79,121,50,22,12,4,51,137,173,195,106,232,235,236,111,107]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var y;(function(Se){function Ie(K){const{selectionStartLineNumber:De,selectionStartColumn:_e,positionLineNumber:$e,positionColumn:xe}=K,nt=new d.Position(De-1,_e-1),ct=new d.Position($e-1,xe-1);return new d.Selection(nt,ct)}Se.to=Ie;function ce(K){const{anchor:De,active:_e}=K;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:_e.line+1,positionColumn:_e.character+1}}Se.from=ce})(y=e.Selection||(e.Selection={}));var c;(function(Se){function Ie(K){if(!K)return;const{start:De,end:_e}=K;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:_e.line+1,endColumn:_e.character+1}}Se.from=Ie;function ce(K){if(!K)return;const{startLineNumber:De,startColumn:_e,endLineNumber:$e,endColumn:xe}=K;return new d.Range(De-1,_e-1,$e-1,xe-1)}Se.to=ce})(c=e.Range||(e.Range={}));var o;(function(Se){function Ie(ce){switch(ce){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}Se.to=Ie})(o=e.TokenType||(e.TokenType={}));var l;(function(Se){function Ie(K){return new d.Position(K.lineNumber-1,K.column-1)}Se.to=Ie;function ce(K){return{lineNumber:K.line+1,column:K.character+1}}Se.from=ce})(l=e.Position||(e.Position={}));var i;(function(Se){function Ie(De,_e){return(0,k.coalesce)((0,k.asArray)(De).map($e=>ce($e,_e)))}Se.from=Ie;function ce(De,_e){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:K(De.scheme,_e),pattern:ne.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType}}function K(De,_e){return _e&&typeof De=="string"?_e.transformOutgoingScheme(De):De}})(i=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Se){function Ie(K){switch(K){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function ce(K){switch(K){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}Se.to=ce})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(Se){function Ie(K){let De;return K.code&&((0,v.isString)(K.code)||(0,v.isNumber)(K.code)?De=String(K.code):De={value:String(K.code.value),target:K.code.target}),{...c.from(K.range),message:K.message,source:K.source,code:De,severity:a.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(s.from),tags:Array.isArray(K.tags)?(0,k.coalesce)(K.tags.map(t.from)):void 0}}Se.from=Ie;function ce(K){const De=new d.Diagnostic(c.to(K),K.message,a.to(K.severity));return De.source=K.source,De.code=(0,v.isString)(K.code)?K.code:K.code?.value,De.relatedInformation=K.relatedInformation&&K.relatedInformation.map(s.to),De.tags=K.tags&&(0,k.coalesce)(K.tags.map(t.to)),De}Se.to=ce})(r=e.Diagnostic||(e.Diagnostic={}));var s;(function(Se){function Ie(K){return{...c.from(K.location.range),message:K.message,resource:K.location.uri}}Se.from=Ie;function ce(K){return new d.DiagnosticRelatedInformation(new d.Location(K.resource,c.to(K)),K.message)}Se.to=ce})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(Se){function Ie(K){switch(K){case d.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}Se.from=Ie;function ce(K){switch(K){case b.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}Se.to=ce})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(Se){function Ie(K){return typeof K=="number"&&K>=d.ViewColumn.One?K-1:K===d.ViewColumn.Beside?g.SIDE_GROUP:g.ACTIVE_GROUP}Se.from=Ie;function ce(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=ce})(m=e.ViewColumn||(e.ViewColumn={}));function p(Se){return typeof Se.range!="undefined"}function R(Se){return Se.length===0?!0:!!p(Se[0])}e.isDecorationOptionsArr=R;var F;(function(Se){function Ie(xe){return xe.map(Se.from)}Se.fromMany=Ie;function ce(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function K(xe){let nt;if(ce(xe)){const{language:dt,value:mt}=xe;nt={value:"```"+dt+`
`+mt+"\n```\n"}}else d.MarkdownString.isMarkdownString(xe)?nt={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml,baseUri:xe.baseUri}:typeof xe=="string"?nt={value:xe}:nt={value:""};const ct=Object.create(null);nt.uris=ct;const yt=dt=>{try{let mt=P.URI.parse(dt,!0);mt=mt.with({query:De(mt.query,ct)}),ct[dt]=mt}catch{}return""},ut=new I.marked.Renderer;return ut.link=yt,ut.image=dt=>typeof dt=="string"?yt(w.parseHrefAndDimensions(dt).href):"",(0,I.marked)(nt.value,{renderer:ut}),nt}Se.from=K;function De(xe,nt){if(!xe)return xe;let ct;try{ct=(0,_.parse)(xe)}catch{}if(!ct)return xe;let yt=!1;return ct=(0,D.cloneAndChange)(ct,ut=>{if(P.URI.isUri(ut)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[dt]=ut,yt=!0,dt}else return}),yt?JSON.stringify(ct):xe}function _e(xe){const nt=new d.MarkdownString(xe.value,xe.supportThemeIcons);return nt.isTrusted=xe.isTrusted,nt.supportHtml=xe.supportHtml,nt.baseUri=xe.baseUri?P.URI.from(xe.baseUri):void 0,nt}Se.to=_e;function $e(xe){if(!!xe)return typeof xe=="string"?xe:Se.from(xe)}Se.fromStrict=$e})(F=e.MarkdownString||(e.MarkdownString={}));function U(Se){return R(Se)?Se.map(Ie=>({range:c.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?F.fromMany(Ie.hoverMessage):Ie.hoverMessage?F.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:c.from(Ie)}))}e.fromRangeOrRangeWithMessage=U;function G(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?P.URI.file(Se):Se}e.pathOrURIToURI=G;var C;(function(Se){function Ie(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?G(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}Se.from=Ie})(C=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(Se){function Ie(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?G(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?C.from(ce.before):void 0,after:ce.after?C.from(ce.after):void 0}}Se.from=Ie})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(Se){function Ie(ce){if(typeof ce=="undefined")return ce;switch(ce){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(Se){function Ie(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?M.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?z.from(ce.light):void 0,dark:ce.dark?z.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?G(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?C.from(ce.before):void 0,after:ce.after?C.from(ce.after):void 0}}Se.from=Ie})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Z;(function(Se){function Ie(K){return{text:K.newText,eol:K.newEol&&Fe.from(K.newEol),range:c.from(K.range)}}Se.from=Ie;function ce(K){const De=new d.TextEdit(c.to(K.range),K.text);return De.newEol=typeof K.eol=="undefined"?void 0:Fe.to(K.eol),De}Se.to=ce})(Z=e.TextEdit||(e.TextEdit={}));var j;(function(Se){function Ie(K,De){const _e={edits:[]};if(K instanceof d.WorkspaceEdit)for(let $e of K._allEntries())$e._type===1?_e.edits.push({_type:1,oldUri:$e.from,newUri:$e.to,options:$e.options,metadata:$e.metadata}):$e._type===2?_e.edits.push({_type:2,resource:$e.uri,edit:Z.from($e.edit),modelVersionId:De?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?_e.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,edit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&_e.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,notebookVersionId:De?.getNotebookDocumentVersion($e.uri),edit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(qe.from)}});return _e}Se.from=Ie;function ce(K){const De=new d.WorkspaceEdit;for(const _e of K.edits)_e.edit?De.replace(P.URI.revive(_e.resource),c.to(_e.edit.range),_e.edit.text):De.renameFile(P.URI.revive(_e.oldUri),P.URI.revive(_e.newUri),_e.options);return De}Se.to=ce})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(Se){const Ie=Object.create(null);Ie[d.SymbolKind.File]=0,Ie[d.SymbolKind.Module]=1,Ie[d.SymbolKind.Namespace]=2,Ie[d.SymbolKind.Package]=3,Ie[d.SymbolKind.Class]=4,Ie[d.SymbolKind.Method]=5,Ie[d.SymbolKind.Property]=6,Ie[d.SymbolKind.Field]=7,Ie[d.SymbolKind.Constructor]=8,Ie[d.SymbolKind.Enum]=9,Ie[d.SymbolKind.Interface]=10,Ie[d.SymbolKind.Function]=11,Ie[d.SymbolKind.Variable]=12,Ie[d.SymbolKind.Constant]=13,Ie[d.SymbolKind.String]=14,Ie[d.SymbolKind.Number]=15,Ie[d.SymbolKind.Boolean]=16,Ie[d.SymbolKind.Array]=17,Ie[d.SymbolKind.Object]=18,Ie[d.SymbolKind.Key]=19,Ie[d.SymbolKind.Null]=20,Ie[d.SymbolKind.EnumMember]=21,Ie[d.SymbolKind.Struct]=22,Ie[d.SymbolKind.Event]=23,Ie[d.SymbolKind.Operator]=24,Ie[d.SymbolKind.TypeParameter]=25;function ce(De){return typeof Ie[De]=="number"?Ie[De]:6}Se.from=ce;function K(De){for(const _e in Ie)if(Ie[_e]===De)return Number(_e);return d.SymbolKind.Property}Se.to=K})($=e.SymbolKind||(e.SymbolKind={}));var W;(function(Se){function Ie(K){switch(K){case d.SymbolTag.Deprecated:return 1}}Se.from=Ie;function ce(K){switch(K){case 1:return d.SymbolTag.Deprecated}}Se.to=ce})(W=e.SymbolTag||(e.SymbolTag={}));var Y;(function(Se){function Ie(K){return{name:K.name,kind:$.from(K.kind),tags:K.tags&&K.tags.map(W.from),containerName:K.containerName,location:de.from(K.location)}}Se.from=Ie;function ce(K){const De=new d.SymbolInformation(K.name,$.to(K.kind),K.containerName,de.to(K.location));return De.tags=K.tags&&K.tags.map(W.to),De}Se.to=ce})(Y=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ie;(function(Se){function Ie(K){const De={name:K.name||"!!MISSING: name!!",detail:K.detail,range:c.from(K.range),selectionRange:c.from(K.selectionRange),kind:$.from(K.kind),tags:K.tags?.map(W.from)??[]};return K.children&&(De.children=K.children.map(Ie)),De}Se.from=Ie;function ce(K){const De=new d.DocumentSymbol(K.name,K.detail,$.to(K.kind),c.to(K.range),c.to(K.selectionRange));return(0,k.isNonEmptyArray)(K.tags)&&(De.tags=K.tags.map(W.to)),K.children&&(De.children=K.children.map(ce)),De}Se.to=ce})(ie=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(Se){function Ie(K){const De=new d.CallHierarchyItem($.to(K.kind),K.name,K.detail||"",P.URI.revive(K.uri),c.to(K.range),c.to(K.selectionRange));return De._sessionId=K._sessionId,De._itemId=K._itemId,De}Se.to=Ie;function ce(K,De,_e){if(De=De??K._sessionId,_e=_e??K._itemId,De===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:_e,name:K.name,detail:K.detail,kind:$.from(K.kind),uri:K.uri,range:c.from(K.range),selectionRange:c.from(K.selectionRange),tags:K.tags?.map(W.from)}}Se.from=ce})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(Se){function Ie(ce){return new d.CallHierarchyIncomingCall(re.to(ce.from),ce.fromRanges.map(K=>c.to(K)))}Se.to=Ie})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ue;(function(Se){function Ie(ce){return new d.CallHierarchyOutgoingCall(re.to(ce.to),ce.fromRanges.map(K=>c.to(K)))}Se.to=Ie})(ue=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var de;(function(Se){function Ie(K){return{range:K.range&&c.from(K.range),uri:K.uri}}Se.from=Ie;function ce(K){return new d.Location(P.URI.revive(K.uri),c.to(K.range))}Se.to=ce})(de=e.location||(e.location={}));var H;(function(Se){function Ie(K){const De=K,_e=K;return{originSelectionRange:De.originSelectionRange?c.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:_e.uri,range:c.from(De.targetRange?De.targetRange:_e.range),targetSelectionRange:De.targetSelectionRange?c.from(De.targetSelectionRange):void 0}}Se.from=Ie;function ce(K){return{targetUri:P.URI.revive(K.uri),targetRange:c.to(K.range),targetSelectionRange:K.targetSelectionRange?c.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?c.to(K.originSelectionRange):void 0}}Se.to=ce})(H=e.DefinitionLink||(e.DefinitionLink={}));var O;(function(Se){function Ie(K){return{range:c.from(K.range),contents:F.fromMany(K.contents)}}Se.from=Ie;function ce(K){return new d.Hover(K.contents.map(F.to),c.to(K.range))}Se.to=ce})(O=e.Hover||(e.Hover={}));var V;(function(Se){function Ie(K){return{range:c.from(K.range),expression:K.expression}}Se.from=Ie;function ce(K){return new d.EvaluatableExpression(c.to(K.range),K.expression)}Se.to=ce})(V=e.EvaluatableExpression||(e.EvaluatableExpression={}));var J;(function(Se){function Ie(K){if(K instanceof d.InlineValueText)return{type:"text",range:c.from(K.range),text:K.text};if(K instanceof d.InlineValueVariableLookup)return{type:"variable",range:c.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function ce(K){switch(K.type){case"text":return{range:c.to(K.range),text:K.text};case"variable":return{range:c.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:c.to(K.range),expression:K.expression}}}Se.to=ce})(J=e.InlineValue||(e.InlineValue={}));var ae;(function(Se){function Ie(K){return{frameId:K.frameId,stoppedLocation:c.from(K.stoppedLocation)}}Se.from=Ie;function ce(K){return new d.InlineValueContext(K.frameId,c.to(K.stoppedLocation))}Se.to=ce})(ae=e.InlineValueContext||(e.InlineValueContext={}));var ge;(function(Se){function Ie(K){return{range:c.from(K.range),kind:K.kind}}Se.from=Ie;function ce(K){return new d.DocumentHighlight(c.to(K.range),K.kind)}Se.to=ce})(ge=e.DocumentHighlight||(e.DocumentHighlight={}));var he;(function(Se){function Ie(ce){switch(ce){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}Se.to=Ie})(he=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(Se){function Ie(ce){return{triggerKind:he.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}Se.to=Ie})(le=e.CompletionContext||(e.CompletionContext={}));var pe;(function(Se){function Ie(K){switch(K){case d.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function ce(K){switch(K){case 1:return d.CompletionItemTag.Deprecated}}Se.to=ce})(pe=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(Se){const Ie=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ce(_e){return Ie.get(_e)??9}Se.from=ce;const K=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function De(_e){return K.get(_e)??d.CompletionItemKind.Property}Se.to=De})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var B;(function(Se){function Ie(ce,K){const De=new d.CompletionItem(ce.label);return De.insertText=ce.insertText,De.kind=Q.to(ce.kind),De.tags=ce.tags?.map(pe.to),De.detail=ce.detail,De.documentation=w.isMarkdownString(ce.documentation)?F.to(ce.documentation):ce.documentation,De.sortText=ce.sortText,De.filterText=ce.filterText,De.preselect=ce.preselect,De.commitCharacters=ce.commitCharacters,A.Range.isIRange(ce.range)?De.range=c.to(ce.range):typeof ce.range=="object"&&(De.range={inserting:c.to(ce.range.insert),replacing:c.to(ce.range.replace)}),De.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?De.insertText=new d.SnippetString(ce.insertText):(De.insertText=ce.insertText,De.textEdit=De.range instanceof d.Range?new d.TextEdit(De.range,De.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(De.additionalTextEdits=ce.additionalTextEdits.map(_e=>Z.to(_e))),De.command=K&&ce.command?K.fromInternal(ce.command):void 0,De}Se.to=Ie})(B=e.CompletionItem||(e.CompletionItem={}));var x;(function(Se){function Ie(K){return{label:K.label,documentation:F.fromStrict(K.documentation)}}Se.from=Ie;function ce(K){return{label:K.label,documentation:w.isMarkdownString(K.documentation)?F.to(K.documentation):K.documentation}}Se.to=ce})(x=e.ParameterInformation||(e.ParameterInformation={}));var X;(function(Se){function Ie(K){return{label:K.label,documentation:F.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(x.from):[],activeParameter:K.activeParameter}}Se.from=Ie;function ce(K){return{label:K.label,documentation:w.isMarkdownString(K.documentation)?F.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(x.to):[],activeParameter:K.activeParameter}}Se.to=ce})(X=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(Se){function Ie(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(X.from):[]}}Se.from=Ie;function ce(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(X.to):[]}}Se.to=ce})(fe=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(Se){function Ie(ce,K){const De=new d.InlayHint(l.to(K.position),typeof K.label=="string"?K.label:K.label.map(ke.to.bind(void 0,ce)),K.kind&&Re.to(K.kind));return De.textEdits=K.textEdits&&K.textEdits.map(Z.to),De.tooltip=w.isMarkdownString(K.tooltip)?F.to(K.tooltip):K.tooltip,De.paddingLeft=K.paddingLeft,De.paddingRight=K.paddingRight,De}Se.to=Ie})(ye=e.InlayHint||(e.InlayHint={}));var ke;(function(Se){function Ie(ce,K){const De=new d.InlayHintLabelPart(K.label);return De.tooltip=w.isMarkdownString(K.tooltip)?F.to(K.tooltip):K.tooltip,T.Command.is(K.command)&&(De.command=ce.fromInternal(K.command)),K.location&&(De.location=de.to(K.location)),De}Se.to=Ie})(ke=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Re;(function(Se){function Ie(K){return K}Se.from=Ie;function ce(K){return K}Se.to=ce})(Re=e.InlayHintKind||(e.InlayHintKind={}));var Ne;(function(Se){function Ie(K){return{range:c.from(K.range),url:K.target,tooltip:K.tooltip}}Se.from=Ie;function ce(K){let De;if(K.url)try{De=typeof K.url=="string"?P.URI.parse(K.url,!0):P.URI.revive(K.url)}catch{}return new d.DocumentLink(c.to(K.range),De)}Se.to=ce})(Ne=e.DocumentLink||(e.DocumentLink={}));var Ue;(function(Se){function Ie(K){const De=new d.ColorPresentation(K.label);return K.textEdit&&(De.textEdit=Z.to(K.textEdit)),K.additionalTextEdits&&(De.additionalTextEdits=K.additionalTextEdits.map(_e=>Z.to(_e))),De}Se.to=Ie;function ce(K){return{label:K.label,textEdit:K.textEdit?Z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(De=>Z.from(De)):void 0}}Se.from=ce})(Ue=e.ColorPresentation||(e.ColorPresentation={}));var se;(function(Se){function Ie(K){return new d.Color(K[0],K[1],K[2],K[3])}Se.to=Ie;function ce(K){return[K.red,K.green,K.blue,K.alpha]}Se.from=ce})(se=e.Color||(e.Color={}));var we;(function(Se){function Ie(K){return{range:c.from(K.range)}}Se.from=Ie;function ce(K){return new d.SelectionRange(c.to(K.range))}Se.to=ce})(we=e.SelectionRange||(e.SelectionRange={}));var Ee;(function(Se){function Ie(ce){switch(ce){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(Ee=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ae;(function(Se){function Ie(K){switch(K){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function ce(K){switch(K){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}Se.to=ce})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Fe;(function(Se){function Ie(K){if(K===d.EndOfLine.CRLF)return 1;if(K===d.EndOfLine.LF)return 0}Se.from=Ie;function ce(K){if(K===1)return d.EndOfLine.CRLF;if(K===0)return d.EndOfLine.LF}Se.to=ce})(Fe=e.EndOfLine||(e.EndOfLine={}));var je;(function(Se){function Ie(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(je=e.ProgressLocation||(e.ProgressLocation={}));var We;(function(Se){function Ie(ce){const K={start:ce.start+1,end:ce.end+1};return ce.kind&&(K.kind=He.from(ce.kind)),K}Se.from=Ie})(We=e.FoldingRange||(e.FoldingRange={}));var He;(function(Se){function Ie(ce){if(ce)switch(ce){case d.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}Se.from=Ie})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ke;(function(Se){function Ie(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?c.from(ce.selection):void 0,override:typeof ce.override=="boolean"?E.EditorResolution.DISABLED:void 0}}Se.from=Ie})(Ke=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ne;(function(Se){function Ie(_e){return _e instanceof d.RelativePattern?_e.toJSON():typeof _e=="string"?_e:ce(_e)||K(_e)?new d.RelativePattern(_e.baseUri??_e.base,_e.pattern).toJSON():_e}Se.from=Ie;function ce(_e){const $e=_e;return $e?P.URI.isUri($e.baseUri)&&typeof $e.pattern=="string":!1}function K(_e){const $e=_e;return $e?typeof $e.base=="string"&&typeof $e.pattern=="string":!1}function De(_e){return typeof _e=="string"?_e:new d.RelativePattern(P.URI.revive(_e.baseUri),_e.pattern)}Se.to=De})(ne=e.GlobPattern||(e.GlobPattern={}));var be;(function(Se){function Ie(ce){if(ce){if(Array.isArray(ce))return ce.map(Ie);if(typeof ce=="string")return ce;{const K=ce;return{language:K.language,scheme:K.scheme,pattern:ne.from(K.pattern),exclusive:K.exclusive}}}else return}Se.from=Ie})(be=e.LanguageSelector||(e.LanguageSelector={}));var Pe;(function(Se){function Ie(K){return{start:K.start,end:K.end}}Se.from=Ie;function ce(K){return new d.NotebookRange(K.start,K.end)}Se.to=ce})(Pe=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Se){function Ie(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Se.to=Ie;function ce(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Se.from=ce})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Me;(function(Se){function Ie(ce){if(ce===S.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;if(ce===S.NotebookCellExecutionState.Pending)return d.NotebookCellExecutionState.Pending;if(ce===S.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${ce}`)}Se.to=Ie})(Me=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(Se){function Ie(K){switch(K){case d.NotebookCellKind.Markup:return S.CellKind.Markup;case d.NotebookCellKind.Code:default:return S.CellKind.Code}}Se.from=Ie;function ce(K){switch(K){case S.CellKind.Markup:return d.NotebookCellKind.Markup;case S.CellKind.Code:default:return d.NotebookCellKind.Code}}Se.to=ce})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var ze;(function(Se){function Ie(K){const De={metadata:K.metadata??Object.create(null),cells:[]};for(let _e of K.cells)d.NotebookCellData.validate(_e),De.cells.push(qe.from(_e));return De}Se.from=Ie;function ce(K){const De=new d.NotebookData(K.cells.map(qe.to));return(0,v.isEmptyObject)(K.metadata)||(De.metadata=K.metadata),De}Se.to=ce})(ze=e.NotebookData||(e.NotebookData={}));var qe;(function(Se){function Ie(K){return{cellKind:Ve.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Le.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Ge.from):[]}}Se.from=Ie;function ce(K){return new d.NotebookCellData(Ve.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Ge.to):void 0,K.metadata,K.internalMetadata?Le.to(K.internalMetadata):void 0)}Se.to=ce})(qe=e.NotebookCellData||(e.NotebookCellData={}));var Xe;(function(Se){function Ie(K){return{mime:K.mime,valueBytes:n.VSBuffer.wrap(K.data)}}Se.from=Ie;function ce(K){return new d.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}Se.to=ce})(Xe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ge;(function(Se){function Ie(K){return{outputId:K.id,items:K.items.map(Xe.from),metadata:K.metadata}}Se.from=Ie;function ce(K){const De=K.items.map(Xe.to);return new d.NotebookCellOutput(De,K.outputId,K.metadata)}Se.to=ce})(Ge=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ze;(function(Se){function Ie(De){return K(De)?{include:(0,v.withNullAsUndefined)(ne.from(De.include)),exclude:(0,v.withNullAsUndefined)(ne.from(De.exclude))}:(0,v.withNullAsUndefined)(ne.from(De))}Se.from=Ie;function ce(De){return K(De)?{include:ne.to(De.include),exclude:ne.to(De.exclude)}:ne.to(De)}Se.to=ce;function K(De){const _e=De;return _e?!!_e.include&&!!_e.exclude:!1}})(Ze=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var tt;(function(Se){function Ie(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?C.from(ce.top):void 0}}Se.from=Ie})(tt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var st;(function(Se){function Ie(ce,K,De){const _e=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(_e,De),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}Se.from=Ie})(st=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ot;(function(Se){function Ie(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}Se.from=Ie})(ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(Se){function Ie(K){return{uri:K.uri,provides:K.provides}}Se.from=Ie;function ce(K){return new d.NotebookRendererScript(P.URI.revive(K.uri),K.provides)}Se.to=ce})(rt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ht;(function(Se){function Ie(K){return{message:F.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:c.from(K.location.range),uri:K.location.uri}}}Se.from=Ie;function ce(K){const De=new d.TestMessage(typeof K.message=="string"?K.message:F.to(K.message));return De.actualOutput=K.actual,De.expectedOutput=K.expected,De.location=K.location?de.to(K.location):void 0,De}Se.to=ce})(ht=e.TestMessage||(e.TestMessage={}));var at;(function(Se){Se.namespace=f.namespaceTestTag,Se.denamespace=f.denamespaceTestTag})(at=e.TestTag||(e.TestTag={}));var ft;(function(Se){function Ie(_e){const $e=(0,u.getPrivateApiFor)(_e).controllerId;return{extId:h.TestId.fromExtHostTestItem(_e,$e).toString(),label:_e.label,uri:P.URI.revive(_e.uri),busy:!1,tags:_e.tags.map(xe=>at.namespace($e,xe.id)),range:A.Range.lift(c.from(_e.range)),description:_e.description||null,sortText:_e.sortText||null,error:_e.error&&F.fromStrict(_e.error)||null}}Se.from=Ie;function ce(_e){return{parent:void 0,error:void 0,id:h.TestId.fromString(_e.extId).localId,label:_e.label,uri:P.URI.revive(_e.uri),tags:(_e.tags||[]).map($e=>{const{tagId:xe}=at.denamespace($e);return new d.TestTag(xe)}),range:c.to(_e.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:_e.description||void 0,sortText:_e.sortText||void 0}}Se.toPlain=ce;function K(_e){const $e=h.TestId.fromString(_e.extId),xe=new u.TestItemImpl($e.controllerId,$e.localId,_e.label,P.URI.revive(_e.uri)||void 0);return xe.range=c.to(_e.range||void 0),xe.description=_e.description||void 0,xe.sortText=_e.sortText||void 0,xe}function De(_e){let $e;for(const xe of _e.tests){const nt=K(xe.item);(0,u.getPrivateApiFor)(nt).parent=$e,$e=nt}return $e}Se.toItemFromContext=De})(ft=e.TestItem||(e.TestItem={})),function(Se){function Ie(K){return{id:K.id}}Se.from=Ie;function ce(K){return new d.TestTag(K.id)}Se.to=ce}(at=e.TestTag||(e.TestTag={}));var bt;(function(Se){const Ie=(K,De)=>{const _e={...ft.toPlain(K.item),parent:void 0,taskStates:K.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(xe=>xe.type===0).map(ht.to)})),children:K.children.map($e=>De.get($e)).filter(v.isDefined).map($e=>Ie($e,De))};for(const $e of _e.children)$e.parent=_e;return _e};function ce(K){const De=[],_e=new Map;for(const $e of K.items)_e.set($e.item.extId,$e),K.request.targets.some(xe=>xe.controllerId===$e.controllerId&&xe.testIds.includes($e.item.extId))&&De.push($e);return{completedAt:K.completedAt,results:De.map($e=>Ie($e,_e))}}Se.to=ce})(bt=e.TestResults||(e.TestResults={}));var Pt;(function(Se){function Ie(_e){return{covered:_e.covered,total:_e.covered}}function ce(_e){return"line"in _e?l.from(_e):c.from(_e)}function K(_e){return"branches"in _e?{count:_e.executionCount,location:ce(_e.location),type:1,branches:_e.branches.length?_e.branches.map($e=>({count:$e.executionCount,location:$e.location&&ce($e.location)})):void 0}:{type:0,count:_e.executionCount,location:ce(_e.location)}}Se.fromDetailed=K;function De(_e){return{uri:_e.uri,statement:Ie(_e.statementCoverage),branch:_e.branchCoverage&&Ie(_e.branchCoverage),function:_e.functionCoverage&&Ie(_e.functionCoverage),details:_e.detailedCoverage?.map(K)}}Se.fromFile=De})(Pt=e.TestCoverage||(e.TestCoverage={}));var kt;(function(Se){function Ie(ce){switch(ce){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}Se.to=Ie})(kt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var _t;(function(Se){function Ie(K){const De=new d.TypeHierarchyItem($.to(K.kind),K.name,K.detail||"",P.URI.revive(K.uri),c.to(K.range),c.to(K.selectionRange));return De._sessionId=K._sessionId,De._itemId=K._itemId,De}Se.to=Ie;function ce(K,De,_e){if(De=De??K._sessionId,_e=_e??K._itemId,De===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:_e,kind:$.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:c.from(K.range),selectionRange:c.from(K.selectionRange),tags:K.tags?.map(W.from)}}Se.from=ce})(_t=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[242],ve([0,1,12,237,13,97,104,110,238,108,111,8,190,109]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let u=class{constructor(f,h,g,d,y,c,o,l,i,t){this._remoteAuthority=f,this._channel=h,this._configurationService=g,this._workspaceContextService=d,this._resolverService=y,this._environmentVariableService=c,this._remoteAuthorityResolverService=o,this._logService=l,this._editorService=i,this._labelService=t}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(f,h,g,d,y,c,o,l){await this._configurationService.whenRemoteConfigurationLoaded();const i=Object.create(null),t=g?(0,k.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(g)):void 0;let r;try{r=(await this._resolverService.resolveAnyMap(t,{shellLaunchConfig:f,configuration:h})).resolvedVariables}catch(C){this._logService.error(C)}if(r)for(const[C,z]of r.entries())(/^config:/.test(C)||C==="selectedText"||C==="lineNumber")&&(i[C]=z);const s=[];for(const[C,z]of this._environmentVariableService.collections.entries())s.push([C,(0,D.serializeEnvironmentVariableCollection)(z.map)]);const a=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),m=a.options&&a.options.extensionHostEnv,p=this._workspaceContextService.getWorkspace(),R=p.folders,F=g?this._workspaceContextService.getWorkspaceFolder(g):null,U=P.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:P.SideBySideEditor.PRIMARY,filterByScheme:[T.Schemas.file,T.Schemas.vscodeUserData,T.Schemas.vscodeRemote]}),G={configuration:h,resolvedVariables:i,envVariableCollections:s,shellLaunchConfig:f,workspaceId:p.id,workspaceName:this._labelService.getWorkspaceLabel(p),workspaceFolders:R,activeWorkspaceFolder:F,activeFileResource:U,shouldPersistTerminal:y,options:d,cols:c,rows:o,unicodeVersion:l,resolverEnv:m};return await this._channel.call("$createProcess",G)}requestDetachInstance(f,h){return this._channel.call("$requestDetachInstance",[f,h])}acceptDetachInstanceReply(f,h){return this._channel.call("$acceptDetachInstanceReply",[f,h])}attachToProcess(f){return this._channel.call("$attachToProcess",[f])}detachFromProcess(f){return this._channel.call("$detachFromProcess",[f])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(f,h){return this._channel.call("$processBinary",[f,h])}start(f){return this._channel.call("$start",[f])}input(f,h){return this._channel.call("$input",[f,h])}acknowledgeDataEvent(f,h){return this._channel.call("$acknowledgeDataEvent",[f,h])}setUnicodeVersion(f,h){return this._channel.call("$setUnicodeVersion",[f,h])}shutdown(f,h){return this._channel.call("$shutdown",[f,h])}resize(f,h,g){return this._channel.call("$resize",[f,h,g])}getInitialCwd(f){return this._channel.call("$getInitialCwd",[f])}getCwd(f){return this._channel.call("$getCwd",[f])}orphanQuestionReply(f){return this._channel.call("$orphanQuestionReply",[f])}sendCommandResult(f,h,g){return this._channel.call("$sendCommandResult",[f,h,g])}installAutoReply(f,h){return this._channel.call("$installAutoReply",[f,h])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(f){return this._channel.call("$getDefaultSystemShell",[f])}getProfiles(f,h,g){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,f,h,g])}acceptPtyHostResolvedVariables(f,h){return this._channel.call("$acceptPtyHostResolvedVariables",[f,h])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(f){return this._channel.call("$getWslPath",[f])}setTerminalLayoutInfo(f){const g={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:f?f.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",g)}updateTitle(f,h,g){return this._channel.call("$updateTitle",[f,h,g])}updateIcon(f,h,g){return this._channel.call("$updateIcon",[f,h,g])}refreshProperty(f,h){return this._channel.call("$refreshProperty",[f,h])}updateProperty(f,h,g){return this._channel.call("$updateProperty",[f,h,g])}getTerminalLayoutInfo(){const h={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",h)}reviveTerminalProcesses(f,h){return this._channel.call("$reviveTerminalProcesses",[f,h])}serializeTerminalState(f){return this._channel.call("$serializeTerminalState",[f])}};u=Te([Oe(2,n.IWorkbenchConfigurationService),Oe(3,_.IWorkspaceContextService),Oe(4,v.IConfigurationResolverService),Oe(5,b.IEnvironmentVariableService),Oe(6,I.IRemoteAuthorityResolverService),Oe(7,w.ILogService),Oe(8,A.IEditorService),Oe(9,E.ILabelService)],u),e.RemoteTerminalChannelClient=u}),define(me[243],ve([0,1,170,5,20,56,59,16,142,12,4,35,63,41,18]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=e.ExtensionManifestValidator=e.Translations=void 0;const S="package.json";var f;(function(s){function a(m,p){if(m===p)return!0;let R=Object.keys(m),F=new Set;for(let U of Object.keys(p))F.add(U);if(R.length!==F.size)return!1;for(let U of R){if(m[U]!==p[U])return!1;F.delete(U)}return F.size===0}s.equals=a})(f=e.Translations||(e.Translations={}));class h{constructor(a,m,p,R,F,U,G){this._ourVersion=a,this._ourProductDate=m,this._absoluteFolderPath=p,this._isBuiltin=R,this._isUnderDevelopment=F,this._log=U,this._fileService=G,this._absoluteManifestPath=n.join(this._absoluteFolderPath,S)}_error(a,m){this._log.error(`[${a}]: ${m}`)}_warn(a,m){this._log.warn(`[${a}]: ${m}`)}}class g extends h{static _fastParseJSON(a,m){try{return JSON.parse(a)}catch{return _.parse(a,m)}}parse(){return i(this._fileService,this._absoluteManifestPath).then(a=>{const m=[],p=g._fastParseJSON(a,m);if(_.getNodeType(p)!=="object")this._error(this._absoluteFolderPath,k.localize(0,null,this._absoluteManifestPath));else{if(m.length===0)return p.uuid=p.__metadata?.id,p.targetPlatform=p.__metadata?.targetPlatform??"undefined",p.isUserBuiltin=!!p.__metadata?.isBuiltin,delete p.__metadata,p;m.forEach(R=>{this._error(this._absoluteFolderPath,k.localize(1,null,this._absoluteManifestPath,R.offset,R.length,(0,v.getParseErrorMessage)(R.error)))})}return null},a=>(a.code==="ENOENT"||this._error(this._absoluteFolderPath,k.localize(2,null,this._absoluteManifestPath,a.message)),null))}}class d extends h{constructor(a,m,p,R,F,U,G,C){super(a,m,p,R,F,G,C);this._nlsConfig=U}replaceNLS(a){const m=(z,M)=>{M.forEach(q=>{this._error(this._absoluteFolderPath,k.localize(3,null,z,(0,v.getParseErrorMessage)(q.error)))})},p=z=>{this._error(this._absoluteFolderPath,k.localize(4,null,z))};let R=n.extname(this._absoluteManifestPath),F=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-R.length);const U=`${a.publisher}.${a.name}`;let G=this._nlsConfig.translations[U],C;return G?C=i(this._fileService,G).then(z=>{let M=[],q=_.parse(z,M);return M.length>0?(m(G,M),{values:void 0,default:`${F}.nls.json`}):_.getNodeType(q)!=="object"?(p(G),{values:void 0,default:`${F}.nls.json`}):{values:q.contents?q.contents.package:void 0,default:`${F}.nls.json`}},z=>({values:void 0,default:`${F}.nls.json`})):C=t(this._fileService,F+".nls"+R).then(z=>{if(!!z)return d.findMessageBundles(this._nlsConfig,F,this._fileService).then(M=>M.localized?i(this._fileService,M.localized).then(q=>{let Z=[],j=_.parse(q,Z);return Z.length>0?(m(M.localized,Z),{values:void 0,default:M.original}):_.getNodeType(j)!=="object"?(p(M.localized),{values:void 0,default:M.original}):{values:j,default:M.original}},q=>({values:void 0,default:M.original})):{values:void 0,default:M.original},M=>{})}),C.then(z=>{if(z===void 0)return a;let M=[];return this.resolveOriginalMessageBundle(z.default,M).then(q=>{if(M.length>0)return m(z.default,M),a;if(_.getNodeType(z)!=="object")return p(z.default),a;const Z=z.values||Object.create(null);return d._replaceNLStrings(this._nlsConfig,a,Z,q,this._absoluteFolderPath,this._log),a})},z=>a)}resolveOriginalMessageBundle(a,m){return new Promise((p,R)=>{a?i(this._fileService,a).then(F=>{p(_.parse(F,m))},F=>{p(null)}):p(null)})}static findMessageBundles(a,m,p){return new Promise((R,F)=>{function U(G,C){let z=`${G}.nls.${C}.json`;t(p,z).then(M=>{M&&R({localized:z,original:`${G}.nls.json`});let q=C.lastIndexOf("-");q===-1?R({localized:`${G}.nls.json`,original:null}):(C=C.substring(0,q),U(G,C))})}if(a.devMode||a.pseudo||!a.locale)return R({localized:m+".nls.json",original:null});U(m,a.locale)})}static _replaceNLStrings(a,m,p,R,F,U){function G(C,z,M){const q=C[z];if(P.isString(q)){const Z=q,j=Z.length;if(j>1&&Z[0]==="%"&&Z[j-1]==="%"){const $=Z.substr(1,j-2);let W=p[$];W===void 0&&R&&(W=R[$]);let Y=typeof W=="string"?W:typeof W?.message=="string"?W.message:void 0;if(Y!==void 0)a.pseudo&&(Y="\uFF3B"+Y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),C[z]=M&&(z==="title"||z==="category")&&R?{value:Y,original:R[$]}:Y;else{const ie=k.localize(5,null,$);U.warn(`[${F}]: ${ie}`)}}}else if(P.isObject(q))for(let Z in q)q.hasOwnProperty(Z)&&(Z==="commands"?G(q,Z,!0):G(q,Z,M));else if(P.isArray(q))for(let Z=0;Z<q.length;Z++)G(q,Z,M)}for(let C in m)m.hasOwnProperty(C)&&G(m,C)}}class y extends h{validate(a){let m=a;m.isBuiltin=this._isBuiltin,m.isUserBuiltin=!this._isBuiltin&&!!m.isUserBuiltin,m.isUnderDevelopment=this._isUnderDevelopment;let p=[];return y.isValidExtensionManifest(this._ourVersion,this._ourProductDate,A.URI.file(this._absoluteFolderPath),m,m.isBuiltin,p)?(p.forEach(R=>{this._warn(this._absoluteFolderPath,R)}),m.publisher||(m.publisher=b.UNDEFINED_PUBLISHER),m.id=(0,T.getExtensionId)(m.publisher,m.name),m.identifier=new b.ExtensionIdentifier(m.id),m.extensionLocation=A.URI.file(this._absoluteFolderPath),m):(p.forEach(R=>{this._error(this._absoluteFolderPath,R)}),null)}static isValidExtensionManifest(a,m,p,R,F,U){return y.baseIsValidExtensionManifest(p,R,U)?I.valid(R.version)?(0,E.isValidExtensionVersion)(a,m,R,F,U):(U.push(k.localize(6,null)),!1):!1}static baseIsValidExtensionManifest(a,m,p){if(!m)return p.push(k.localize(7,null)),!1;if(typeof m.publisher!="undefined"&&typeof m.publisher!="string")return p.push(k.localize(8,null)),!1;if(typeof m.name!="string")return p.push(k.localize(9,null,"name")),!1;if(typeof m.version!="string")return p.push(k.localize(10,null,"version")),!1;if(!m.engines)return p.push(k.localize(11,null,"engines")),!1;if(typeof m.engines.vscode!="string")return p.push(k.localize(12,null,"engines.vscode")),!1;if(typeof m.extensionDependencies!="undefined"&&!y._isStringArray(m.extensionDependencies))return p.push(k.localize(13,null,"extensionDependencies")),!1;if(typeof m.activationEvents!="undefined"){if(!y._isStringArray(m.activationEvents))return p.push(k.localize(14,null,"activationEvents")),!1;if(typeof m.main=="undefined"&&typeof m.browser=="undefined")return p.push(k.localize(15,null,"activationEvents","main")),!1}if(typeof m.extensionKind!="undefined"&&typeof m.main=="undefined"&&p.push(k.localize(16,null,"extensionKind")),typeof m.main!="undefined"){if(typeof m.main!="string")return p.push(k.localize(17,null,"main")),!1;{const R=w.joinPath(a,m.main);w.isEqualOrParent(R,a)||p.push(k.localize(18,null,R.path,a.path))}if(typeof m.activationEvents=="undefined")return p.push(k.localize(19,null,"activationEvents","main")),!1}if(typeof m.browser!="undefined"){if(typeof m.browser!="string")return p.push(k.localize(20,null,"browser")),!1;{const R=w.joinPath(a,m.browser);w.isEqualOrParent(R,a)||p.push(k.localize(21,null,R.path,a.path))}if(typeof m.activationEvents=="undefined")return p.push(k.localize(22,null,"activationEvents","browser")),!1}return!0}static _isStringArray(a){if(!Array.isArray(a))return!1;for(let m=0,p=a.length;m<p;m++)if(typeof a[m]!="string")return!1;return!0}}e.ExtensionManifestValidator=y;class c{constructor(a,m,p,R,F,U,G,C,z,M){this.ourVersion=a,this.ourProductDate=m,this.commit=p,this.locale=R,this.devMode=F,this.absoluteFolderPath=U,this.isBuiltin=G,this.isUnderDevelopment=C,this.targetPlatform=z,this.translations=M}static createNLSConfig(a){return{devMode:a.devMode,locale:a.locale,pseudo:a.locale==="pseudo",translations:a.translations}}static equals(a,m){return a.ourVersion===m.ourVersion&&a.ourProductDate===m.ourProductDate&&a.commit===m.commit&&a.locale===m.locale&&a.devMode===m.devMode&&a.absoluteFolderPath===m.absoluteFolderPath&&a.isBuiltin===m.isBuiltin&&a.isUnderDevelopment===m.isUnderDevelopment&&a.mtime===m.mtime&&a.targetPlatform===m.targetPlatform&&f.equals(a.translations,m.translations)}}e.ExtensionScannerInput=c;class o{constructor(a,m){this.root=a,this._fileService=m}resolveExtensions(){return r(this._fileService,this.root).then(a=>a.map(m=>({name:m,path:n.join(this.root,m)})))}}class l{static scanExtension(a,m,p,R,F,U,G,C){return p=n.normalize(p),new g(a,m,p,R,F,G,C).parse().then(M=>M===null?null:new d(a,m,p,R,F,U,G,C).replaceNLS(M)).then(M=>M===null?null:new y(a,m,p,R,F,G,C).validate(M))}static async scanExtensions(a,m,p,R=null){const F=a.absoluteFolderPath,U=a.isBuiltin,G=a.isUnderDevelopment;R||(R=new o(F,p));try{let C={};if(!U)try{const j=await i(p,n.join(F,".obsolete"));C=JSON.parse(j)}catch{}let z=await R.resolveExtensions();z.sort((j,$)=>j.name<$.name?-1:1),U||(z=z.filter(j=>j.name.indexOf(".")!==0));const M=c.createNLSConfig(a);let q=await Promise.all(z.map(j=>this.scanExtension(a.ourVersion,a.ourProductDate,j.path,U,G,M,m,p))),Z=D.coalesce(q);return Z=Z.filter(j=>j!==null&&!C[new T.ExtensionKey({id:(0,T.getGalleryExtensionId)(j.publisher,j.name)},j.version,j.targetPlatform).toString()]),U||(Z=this.filterOutdatedExtensions(Z,a.targetPlatform)),Z.sort((j,$)=>j.extensionLocation.fsPath<$.extensionLocation.fsPath?-1:1),Z}catch(C){return m.error(`Error scanning extensions at ${F}:`),m.error(C),[]}}static scanOneOrMultipleExtensions(a,m,p){const R=a.absoluteFolderPath,F=a.isBuiltin,U=a.isUnderDevelopment;return t(p,n.join(R,S)).then(G=>{if(G){const C=c.createNLSConfig(a);return this.scanExtension(a.ourVersion,a.ourProductDate,R,F,U,C,m,p).then(z=>z===null?[]:[z])}return this.scanExtensions(a,m,p)},G=>(m.error(`Error scanning extensions at ${R}:`),m.error(G),[]))}static scanSingleExtension(a,m,p){const R=a.absoluteFolderPath,F=a.isBuiltin,U=a.isUnderDevelopment,G=c.createNLSConfig(a);return this.scanExtension(a.ourVersion,a.ourProductDate,R,F,U,G,m,p)}static mergeBuiltinExtensions(a,m){return Promise.all([a,m]).then(([p,R])=>{let F=Object.create(null);for(let G=0,C=p.length;G<C;G++)F[b.ExtensionIdentifier.toKey(p[G].identifier)]=p[G];for(let G=0,C=R.length;G<C;G++)F[b.ExtensionIdentifier.toKey(R[G].identifier)]=R[G];let U=Object.keys(F).map(G=>F[G]);return U.sort((G,C)=>{const z=n.basename(G.extensionLocation.fsPath),M=n.basename(C.extensionLocation.fsPath);return z<M?-1:z>M?1:0}),U})}static filterOutdatedExtensions(a,m){const p=new Map;for(const R of a){const F=R.identifier.value,U=p.get(F);U&&(I.gt(U.version,R.version)||I.eq(U.version,R.version)&&U.targetPlatform===m)||p.set(F,R)}return[...p.values()]}}e.ExtensionScanner=l;async function i(s,a){try{return(await s.readFile(A.URI.file(a),{atomic:!0})).value.toString()}catch(m){if((0,u.toFileOperationResult)(m)===1){const p=new Error("File not found");throw p.code="ENOENT",p}throw m}}async function t(s,a){try{return(await s.resolve(A.URI.file(a))).isFile}catch{return!1}}async function r(s,a){const m=await s.resolve(A.URI.file(a)),p=[];for(const R of m.children||[])R.isDirectory&&p.push(R.name);return p}}),define(me[244],ve([0,1,3,44,4,57,166,8,243,41,61,71,90,85,208,5,25,19]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let g=null;function d(){return g||(g=(0,S.normalize)((0,S.join)(D.FileAccess.asFileUri("",ee).fsPath,"..","extensions"))),g}let y=null;function c(){return y||(y=(0,S.normalize)((0,S.join)(D.FileAccess.asFileUri("",ee).fsPath,"..",".build","builtInExtensions"))),y}class o{constructor(i,t,r,s,a,m,p,R){if(this._connectionToken=i,this.environmentService=t,this._extensionManagementService=s,this.logService=a,this.productService=m,this.extensionHostStatusService=p,this._fileService=R,t.args["install-builtin-extension"]){const U={isMachineScoped:!!t.args["do-not-sync"],installPreReleaseVersion:!!t.args["pre-release"]};this.whenExtensionsReady=r.installExtensions([],t.args["install-builtin-extension"],U,!!t.args.force).then(null,G=>{a.error(G)})}else this.whenExtensionsReady=Promise.resolve();const F=t.args["install-extension"];if(F){const U=F.map(G=>/\.vsix$/i.test(G)?w.URI.file((0,S.isAbsolute)(G)?G:(0,S.join)((0,f.cwd)(),G)):G);this.whenExtensionsReady.then(()=>r.installExtensions(U,[],{isMachineScoped:!!t.args["do-not-sync"],installPreReleaseVersion:!!t.args["pre-release"]},!!t.args.force)).then(null,G=>{a.error(G)})}}async call(i,t,r){switch(t){case"getEnvironmentData":{const s=r,a=(0,I.createURITransformer)(s.remoteAuthority);let m=await this._getEnvironmentData();return m=(0,A.transformOutgoingURIs)(m,a),m}case"getExtensionHostExitInfo":{const s=r;return this.extensionHostStatusService.getExitInfo(s.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const s=r,a=s.language;this.logService.trace(`Scanning extensions using UI language: ${a}`);const m=(0,I.createURITransformer)(s.remoteAuthority),p=s.extensionDevelopmentPath&&s.extensionDevelopmentPath.map(U=>w.URI.revive(m.transformIncoming(U))),R=p?p.filter(U=>U.scheme===D.Schemas.file).map(U=>U.fsPath):void 0;let F=await this._scanExtensions(a,R);return F=(0,A.transformOutgoingURIs)(F,m),this.logService.trace("Scanned Extensions",F),o._massageWhenConditions(F),F}case"scanSingleExtension":{await this.whenExtensionsReady;const s=r,a=s.language,m=s.isBuiltin,p=(0,I.createURITransformer)(s.remoteAuthority),R=w.URI.revive(p.transformIncoming(s.extensionLocation)),F=R.scheme===D.Schemas.file?R.fsPath:null;if(!F)return null;const U=await this._getTranslations(a);let G=await this._scanSingleExtension(F,m,a,U);return G?(G=(0,A.transformOutgoingURIs)(G,p),o._massageWhenConditions([G]),G):null}case"getDiagnosticInfo":{const s=r,a={machineInfo:(0,u.getMachineInfo)()},m=s.includeProcesses?(0,b.listProcesses)(process.pid):Promise.resolve();let p=[];const R={};if(s.folders){const F=(0,I.createURITransformer)("");p=s.folders.map(G=>w.URI.revive(F.transformIncoming(G))).filter(G=>G.scheme==="file").map(G=>(0,u.collectWorkspaceStats)(G.fsPath,["node_modules",".git"]).then(C=>{R[(0,S.basename)(G.fsPath)]=C}))}return Promise.all([m,...p]).then(([F,U])=>(a.processes=F||void 0,a.workspaceMetadata=s.folders?R:void 0,a))}}throw new Error(`IPC Command ${t} not found`)}listen(i,t,r){throw new Error("Not supported")}static _massageWhenConditions(i){const t=(R,F)=>R.replace(/file/g,"vscode-remote"),r=R=>{let F="";return F+=R.global?"g":"",F+=R.ignoreCase?"i":"",F+=R.multiline?"m":"",new RegExp(t(R.source,!0),F)},s=new class{mapDefined(R){return E.ContextKeyDefinedExpr.create(R)}mapNot(R){return E.ContextKeyNotExpr.create(R)}mapEquals(R,F){return R==="resourceScheme"&&typeof F=="string"?E.ContextKeyEqualsExpr.create(R,t(F,!1)):E.ContextKeyEqualsExpr.create(R,F)}mapNotEquals(R,F){return R==="resourceScheme"&&typeof F=="string"?E.ContextKeyNotEqualsExpr.create(R,t(F,!1)):E.ContextKeyNotEqualsExpr.create(R,F)}mapGreater(R,F){return E.ContextKeyGreaterExpr.create(R,F)}mapGreaterEquals(R,F){return E.ContextKeyGreaterEqualsExpr.create(R,F)}mapSmaller(R,F){return E.ContextKeySmallerExpr.create(R,F)}mapSmallerEquals(R,F){return E.ContextKeySmallerEqualsExpr.create(R,F)}mapRegex(R,F){return R==="resourceScheme"&&F?E.ContextKeyRegexExpr.create(R,r(F)):E.ContextKeyRegexExpr.create(R,F)}mapIn(R,F){return E.ContextKeyInExpr.create(R,F)}},a=R=>{if(!R||!R.when||!/resourceScheme/.test(R.when))return;const F=E.ContextKeyExpr.deserialize(R.when);if(!F)return;const U=F.map(s);R.when=U.serialize()},m=R=>{if(Array.isArray(R))for(let F of R)a(F);else a(R)},p=R=>{for(let F in R)m(R[F])};i.forEach(R=>{R.contributes&&(R.contributes.menus&&p(R.contributes.menus),R.contributes.keybindings&&m(R.contributes.keybindings),R.contributes.views&&p(R.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:w.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:w.URI.file(this.environmentService.logsPath),extensionsPath:w.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:w.URI.file((0,S.join)(this.environmentService.logsPath,`exthost${o._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,localHistoryHome:this.environmentService.localHistoryHome,userHome:this.environmentService.userHome,os:k.OS,arch:process.arch,marks:n.getMarks(),useHostProxy:!!this.environmentService.args["use-host-proxy"]}}async _getTranslations(i){const t=await(0,T.getNLSConfiguration)(i,this.environmentService.userDataPath);if(T.InternalNLSConfiguration.is(t))try{const r=await h.Promises.readFile(t._translationsConfigFile,"utf8");return JSON.parse(r)}catch{return Object.create(null)}else return Object.create(null)}async _scanExtensions(i,t){const r=await this._getTranslations(i),[s,a,m]=await Promise.all([this._scanBuiltinExtensions(i,r),this._scanInstalledExtensions(i,r),this._scanDevelopedExtensions(i,r,t)]);let p=new Map;s.forEach(F=>{!F||p.set(P.ExtensionIdentifier.toKey(F.identifier),F)}),a.forEach(F=>{!F||(p.has(P.ExtensionIdentifier.toKey(F.identifier))&&console.warn(_.localize(0,null,p.get(P.ExtensionIdentifier.toKey(F.identifier)).extensionLocation.fsPath,F.extensionLocation.fsPath)),p.set(P.ExtensionIdentifier.toKey(F.identifier),F))}),m.forEach(F=>{!F||p.set(P.ExtensionIdentifier.toKey(F.identifier),F)});const R=[];return p.forEach(F=>R.push(F)),R}async _scanDevelopedExtensions(i,t,r){if(r){const s=await this._extensionManagementService.getTargetPlatform(),a=r.map(R=>v.ExtensionScanner.scanOneOrMultipleExtensions(new v.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,!0,R,!1,!0,s,t),this.logService,this._fileService)),m=await Promise.all(a);let p=[];for(let R of m)p=p.concat(R);return p}return[]}async _scanBuiltinExtensions(i,t){const r=this.productService.version,s=this.productService.commit,a=this.productService.date,m=!!process.env.VSCODE_DEV,p=await this._extensionManagementService.getTargetPlatform(),R=new v.ExtensionScannerInput(r,a,s,i,m,d(),!0,!1,p,t),F=v.ExtensionScanner.scanExtensions(R,this.logService,this._fileService);let U=F;if(m){class G{constructor(Z){this.builtInExtensions=Z}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(Z=>({name:Z.name,path:(0,S.join)(c(),Z.name)})))}}const C=Promise.resolve(this.productService.builtInExtensions||[]),z=new v.ExtensionScannerInput(r,a,s,i,m,c(),!0,!1,p,{}),M=C.then(q=>new G(q)).then(q=>v.ExtensionScanner.scanExtensions(z,this.logService,this._fileService,q));U=v.ExtensionScanner.mergeBuiltinExtensions(F,M)}return U}async _scanInstalledExtensions(i,t){const r=await this._extensionManagementService.getTargetPlatform(),s=!!process.env.VSCODE_DEV,a=new v.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,s,this.environmentService.extensionsPath,!1,!1,r,t);return v.ExtensionScanner.scanExtensions(a,this.logService,this._fileService)}async _scanSingleExtension(i,t,r,s){const a=await this._extensionManagementService.getTargetPlatform(),m=!!process.env.VSCODE_DEV,p=new v.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,r,m,i,t,!1,a,s);return v.ExtensionScanner.scanSingleExtension(p,this.logService,this._fileService)}}e.RemoteAgentEnvironmentChannel=o,o._namePool=1}),define(me[112],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class k{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++k.count}}e.ProxyIdentifier=k,k.count=0;const n=[];function w(D){const v=new k(D);return n[v.nid]=v,v}e.createProxyIdentifier=w;function I(D){return n[D].sid}e.getStringIdentifierForProxy=I;class _{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=_}),define(me[245],ve([0,1,50,4,112]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabInputKind=e.TextEditorRevealType=void 0;var I;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.NotebookInput=3]="NotebookInput",g[g.NotebookDiffInput=4]="NotebookDiffInput",g[g.CustomEditorInput=5]="CustomEditorInput",g[g.WebviewEditorInput=6]="WebviewEditorInput",g[g.TerminalEditorInput=7]="TerminalEditorInput"})(_=e.TabInputKind||(e.TabInputKind={}));var D;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var v;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(v=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));class E{static mixin(d){return d._id=E._n++,d}}e.IdObject=E,E._n=0;var b;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.command="m",g.kindModifier="n"})(b=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(g){g[g.File=1]="File",g[g.Text=2]="Text",g[g.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function f(g){if(g&&g.edits)for(const d of g.edits)typeof d.resource=="object"?d.resource=n.URI.revive(d.resource):(d.newUri=n.URI.revive(d.newUri),d.oldUri=n.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,k.revive)(d.metadata));return g}e.reviveWorkspaceEditDto=f;var h;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(h=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry")}});var St=this&&this.__classPrivateFieldSet||function(ee,e,k,n,w){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!w:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?w.call(ee,k):w?w.value=k:e.set(ee,k),k},et=this&&this.__classPrivateFieldGet||function(ee,e,k,n){if(k==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?n:k==="a"?n.call(ee):n?n.value:e.get(ee)};define(me[246],ve([0,1,12,107,241,22,245,16,13,50,51,87,4,2,6,230,106,17,112,36]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(s,a){y.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,St(this,y,s.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=a,this.converter=new o(this,m=>{const p=this._apiCommands.get(m);return p?.result===i.Void?p:void 0},a),this._argumentProcessors=[{processArgument(m){return(0,P.revive)(m)}},{processArgument(m){return(0,I.cloneAndChange)(m,function(p){if(A.Range.isIRange(p))return w.Range.to(p);if(T.Position.isIPosition(p))return w.Position.to(p);if(A.Range.isIRange(p.range)&&E.URI.isUri(p.uri))return w.location.to(p);if(p instanceof h.VSBuffer)return p.buffer.buffer;if(!Array.isArray(p))return p})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const a=this.registerCommand(!1,s.id,async(...m)=>{const p=s.args.map((F,U)=>{if(!F.validate(m[U]))throw new Error(`Invalid argument '${F.name}' when running '${s.id}', received: ${m[U]}`);return F.convert(m[U])}),R=await this.executeCommand(s.internalId,...p);return s.result.convert(R,m,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new n.Disposable(()=>{a.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,a,m,p,R,F){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:m,thisArg:p,description:R,extension:F}),s&&et(this,y,"f").$registerCommand(a),new n.Disposable(()=>{this._commands.delete(a)&&s&&et(this,y,"f").$unregisterCommand(a)})}executeCommand(s,...a){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,a,!0)}async _doExecuteCommand(s,a,m){if(this._commands.has(s))return this._executeContributedCommand(s,a,!1);{let p=!1;const R=(0,I.cloneAndChange)(a,function(F){if(F instanceof n.Position)return w.Position.from(F);if(F instanceof n.Range)return w.Range.from(F);if(F instanceof n.Location)return w.location.from(F);if(n.NotebookRange.isNotebookRange(F))return w.NotebookRange.from(F);if(F instanceof ArrayBuffer)return p=!0,h.VSBuffer.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return p=!0,h.VSBuffer.wrap(F);if(!Array.isArray(F))return F});try{const F=await et(this,y,"f").$executeCommand(s,p?new g.SerializableObjectWithBuffers(R):R,m);return(0,P.revive)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this._doExecuteCommand(s,a,!1);throw F}}}async _executeContributedCommand(s,a,m){const p=this._commands.get(s);if(!p)throw new Error("Unknown command");let{callback:R,thisArg:F,description:U}=p;if(U)for(let G=0;G<U.args.length;G++)try{(0,k.validateConstraint)(a[G],U.args[G].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${U.args[G].name}' - ${U.args[G].description}`)}try{return await R.apply(F,a)}catch(G){if(s===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...a);C&&(s=C.command)}throw this._logService.error(G,s,p.extension?.identifier),m?new class extends Error{constructor(){super((0,d.toErrorMessage)(G));this.id=s,this.source=p.extension?.displayName??p.extension?.name}}:G}}$executeContributedCommand(s,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(a=a.map(m=>this._argumentProcessors.reduce((p,R)=>R.processArgument(p),m)),this._executeContributedCommand(s,a,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),et(this,y,"f").$getCommands().then(a=>(s&&(a=a.filter(m=>m[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[a,m]of this._commands){let{description:p}=m;p&&(s[a]=p)}return Promise.resolve(s)}};y=new WeakMap,c=Te([Oe(0,S.IExtHostRpcService),Oe(1,v.ILogService)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class o{constructor(s,a,m){this._commands=s,this._lookupApiCommand=a,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,a){if(!s)return;const m={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return m;const p=this._lookupApiCommand(s.command);if(p)m.id=p.internalId,m.arguments=p.args.map((R,F)=>R.convert(s.arguments&&s.arguments[F]));else if((0,D.isNonEmptyArray)(s.arguments)){const R=++this._cachIdPool;this._cache.set(R,s),a.add((0,b.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),m.$ident=R,m.id=this.delegatingCommandId,m.arguments=[R],this._logService.trace("CommandsConverter#CREATE",s.command,R)}return m}fromInternal(s){return typeof s.$ident=="number"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const a=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class l{constructor(s,a,m,p){this.name=s,this.description=a,this.validate=m,this.convert=p}optional(){return new l(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,a){return new l(s??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",r=>E.URI.isUri(r),r=>r),l.Position=new l("position","A position in a text document",r=>n.Position.isPosition(r),w.Position.from),l.Range=new l("range","A range in a text document",r=>n.Range.isRange(r),w.Range.from),l.Selection=new l("selection","A selection in a text document",r=>n.Selection.isSelection(r),w.Selection.from),l.Number=new l("number","",r=>typeof r=="number",r=>r),l.String=new l("string","",r=>typeof r=="string",r=>r),l.CallHierarchyItem=new l("item","A call hierarchy item",r=>r instanceof n.CallHierarchyItem,w.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",r=>r instanceof n.TypeHierarchyItem,w.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",r=>r instanceof f.TestItemImpl,w.TestItem.from);class i{constructor(s,a){this.description=s,this.convert=a}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class t{constructor(s,a,m,p,R){this.id=s,this.internalId=a,this.description=m,this.args=p,this.result=R}}e.ApiCommand=t}),define(me[247],ve([0,1,77]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logRemoteEntryIfError=e.logRemoteEntry=void 0;function n(I,_,D=null){const v=(0,k.parse)(_).args;let P=v.shift();if(typeof P=="string")switch(_.severity||(_.severity="info"),D&&(/^\[/.test(D)||(D=`[${D}]`),/ $/.test(D)||(D=`${D} `),P=D+P),_.severity){case"log":case"info":I.info(P,...v);break;case"warn":I.warn(P,...v);break;case"error":I.error(P,...v);break}}e.logRemoteEntry=n;function w(I,_,D){const v=(0,k.parse)(_).args,P=v.shift();typeof P!="string"||_.severity!=="error"||(/^\[/.test(D)||(D=`[${D}]`),/ $/.test(D)||(D=`${D} `),I.error(D+P,...v))}e.logRemoteEntryIfError=w}),define(me[113],ve([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,k.createDecorator)("remoteAgentService")}),define(me[248],ve([0,1,9,2,8,185]),function(ee,e,k,n,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class _ extends I.DiskFileSystemProviderClient{static register(v,P,A){const T=v.getConnection();if(!T)return n.Disposable.None;const E=new n.DisposableStore,b=(async()=>{try{const u=await v.getRawEnvironment();u?P.registerProvider(w.Schemas.vscodeRemote,E.add(new _(u,T))):A.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(u){A.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,k.getErrorMessage)(u))}})();return E.add(P.onWillActivateFileSystemProvider(u=>{u.scheme===w.Schemas.vscodeRemote&&u.join(b)})),E}constructor(v,P){super(P.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=_}),define(me[72],ve([0,1,28,14,5,12,19,145,263,264]),function(ee,e,k,n,w,I,_,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class A extends Error{constructor(o,l){let i=l.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=o,this.cause=l}}e.ExtractError=A;function T(c){const o=c.externalFileAttributes>>16||33188;return[448,56,7].map(l=>o&l).reduce((l,i)=>l+i,o&61440)}function E(c){if(c instanceof A)return c;let o;return/end of central directory record signature not found/.test(c.message)&&(o="CorruptZip"),new A(o,c)}function b(c,o,l,i,t,r){const s=w.dirname(o),a=w.join(i,s);if(!a.startsWith(i))return Promise.reject(new Error(D.localize(0,null,o)));const m=w.join(i,o);let p;return r.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(_.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((R,F)=>{if(!r.isCancellationRequested)try{p=(0,k.createWriteStream)(m,{mode:l}),p.once("close",()=>R()),p.once("error",F),c.once("error",F),c.pipe(p)}catch(U){F(U)}}))}function u(c,o,l,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{t.cancel(),c.close()}),new Promise((s,a)=>{const m=new n.Sequencer,p=R=>{R.isCancellationRequested||(r++,c.readEntry())};c.once("error",a),c.once("close",()=>t.then(()=>{i.isCancellationRequested||c.entryCount===r?s():a(new A("Incomplete",new Error(D.localize(1,null,r,c.entryCount))))},a)),c.readEntry(),c.on("entry",R=>{if(i.isCancellationRequested)return;if(!l.sourcePathRegex.test(R.fileName)){p(i);return}const F=R.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(F)){const C=w.join(o,F);t=(0,n.createCancelablePromise)(z=>_.Promises.mkdir(C,{recursive:!0}).then(()=>p(z)).then(void 0,a));return}const U=f(c,R),G=T(R);t=(0,n.createCancelablePromise)(C=>m.queue(()=>U.then(z=>b(z,F,G,o,l,C).then(()=>p(C)))).then(null,a))})})}function S(c,o=!1){return new Promise((l,i)=>{(0,v.open)(c,o?{lazyEntries:!0}:void 0,(t,r)=>{t?i(E(t)):l((0,I.assertIsDefined)(r))})})}function f(c,o){return new Promise((l,i)=>{c.openReadStream(o,(t,r)=>{t?i(E(t)):l((0,I.assertIsDefined)(r))})})}function h(c,o){return new Promise((l,i)=>{const t=new P.ZipFile;o.forEach(s=>{s.contents?t.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&t.addFile(s.localPath,s.path)}),t.end();const r=(0,k.createWriteStream)(c);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>l(c))})}e.zip=h;function g(c,o,l={},i){const t=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let r=S(c,!0);return l.overwrite&&(r=r.then(s=>_.Promises.rm(o).then(()=>s))),r.then(s=>u(s,o,{sourcePathRegex:t},i))}e.extract=g;function d(c,o){return S(c).then(l=>new Promise((i,t)=>{l.on("entry",r=>{r.fileName===o&&f(l,r).then(s=>i(s),s=>t(s))}),l.once("close",()=>t(new Error(D.localize(2,null,o))))}))}function y(c,o){return d(c,o).then(l=>new Promise((i,t)=>{const r=[];l.once("error",t),l.on("data",s=>r.push(s)),l.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=y}),define(me[249],ve([0,1,72,153]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function w(I){return(0,k.buffer)(I,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=w}),define(me[250],ve([0,1,16,14,9,2,8,5,3,20,56,4,23,19,72,154,29,30,35,178,41,18,13,27]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d,y,c,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let i=class extends I.Disposable{constructor(r,s,a,m,p,R){super();this.beforeRemovingExtension=r,this.targetPlatform=s,this.fileService=a,this.logService=m,this.environmentService=p,this.productService=R,this._devSystemExtensionsLocation=null,this.systemExtensionsLocation=T.URI.file(p.builtinExtensionsPath),this.userExtensionsLocation=T.URI.file(p.extensionsPath),this.uninstalledPath=(0,P.joinPath)(this.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(r){const s=[];r===null||r===0?(s.push(this.scanDefaultSystemExtensions()),s.push(this.environmentService.isBuilt?Promise.resolve([]):this.scanDevSystemExtensions())):(s.push(Promise.resolve([])),s.push(Promise.resolve([]))),s.push(this.scanUserExtensions(!1));try{const[a,m,p]=await Promise.all(s),R=this.dedupExtensions([...a,...m,...p],await this.targetPlatform);return r!==null?R.filter(F=>F.type===r):R}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(r){this.logService.trace("Started scanning user extensions");let[s,a]=await Promise.all([this.getUninstalledExtensions(),this.scanFromUserExtensionsLocation()]);return a=a.filter(m=>!s[g.ExtensionKey.create(m).toString()]),a=r?this.dedupExtensions(a,await this.targetPlatform):a,this.logService.trace("Scanned user extensions:",a.length),a}async extractUserExtension(r,s,a,m){const p=r.toString(),R=D.join(this.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),F=D.join(this.userExtensionsLocation.fsPath,p);try{await b.Promises.rm(F)}catch{throw new h.ExtensionManagementError((0,S.localize)(0,null,F,r.id),h.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(r,s,R,m);let U=await this.scanExtension(T.URI.file(R),1);if(!U)throw new Error((0,S.localize)(1,null,R));await this.storeMetadata(U,{...a,installedTimestamp:Date.now()});try{await this.rename(r,R,F,Date.now()+2*60*1e3),this.logService.info("Renamed to",F)}catch(G){try{await b.Promises.rm(R)}catch{}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",r.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(G)}. Deleted from extracted location`,R),G}try{U=await this.scanExtension(T.URI.file(F),1)}catch{}if(U)return U;throw new Error((0,S.localize)(2,null,this.userExtensionsLocation.fsPath))}async saveMetadataForLocalExtension(r,s){return this.setMetadata(r,s),await this.storeMetadata(r,{...s,installedTimestamp:r.installedTimestamp}),r}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...r){const s=r.map(a=>g.ExtensionKey.create(a));await this.withUninstalledExtensions(a=>{s.forEach(m=>a[m.toString()]=!0)})}async setInstalled(r){await this.withUninstalledExtensions(m=>delete m[r.toString()]);const a=(await this.scanUserExtensions(!0)).find(m=>g.ExtensionKey.create(m).equals(r))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,a.type)):null}async removeExtension(r,s){this.logService.trace(`Deleting ${s} extension from disk`,r.identifier.id,r.location.fsPath),await b.Promises.rm(r.location.fsPath),this.logService.info("Deleted from disk",r.identifier.id,r.location.fsPath)}async removeUninstalledExtension(r){await this.removeExtension(r,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[g.ExtensionKey.create(r).toString()])}async storeMetadata(r,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const a=D.join(r.location.fsPath,"package.json"),m=await b.Promises.readFile(a,"utf8"),{manifest:p}=await this.parseManifest(m);return p.__metadata=s,await b.Promises.writeFile(a,JSON.stringify(p,null,"	")),r}async withUninstalledExtensions(r){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(m){if(m.code!=="ENOENT")throw m}let a={};if(s)try{a=JSON.parse(s)}catch{}return r&&(r(a),Object.keys(a).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await b.Promises.rm(this.uninstalledPath)),a})}async extractAtLocation(r,s,a,m){this.logService.trace(`Started extracting the extension from ${s} to ${a}`);try{await b.Promises.rm(a)}catch(p){throw new h.ExtensionManagementError(this.joinErrors(p).message,h.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(s,a,{sourcePath:"extension",overwrite:!0},m),this.logService.info(`Extracted extension to ${a}:`,r.id)}catch(p){try{await b.Promises.rm(a)}catch{}let R=h.ExtensionManagementErrorCode.Extract;throw p instanceof u.ExtractError&&(p.type==="CorruptZip"?R=h.ExtensionManagementErrorCode.CorruptZip:p.type==="Incomplete"&&(R=h.ExtensionManagementErrorCode.IncompleteZip)),new h.ExtensionManagementError(p.message,R)}}async rename(r,s,a,m){try{await b.Promises.rename(s,a)}catch(p){if(v.isWindows&&p&&p.code==="EPERM"&&Date.now()<m)return this.logService.info(`Failed renaming ${s} to ${a} with 'EPERM' error. Trying again...`,r.id),this.rename(r,s,a,m);throw new h.ExtensionManagementError(p.message||(0,S.localize)(3,null,s,a),p.code||h.ExtensionManagementErrorCode.Rename)}}async scanExtensionsInLocation(r,s){const a=new n.Limiter(10),m=await this.fileService.resolve(r);return m.children?(await Promise.all(m.children.filter(R=>R.isDirectory).map(R=>a.queue(async()=>(0,P.isEqualOrParent)(R.resource,this.userExtensionsLocation)&&(0,P.basename)(R.resource).indexOf(".")===0?null:this.scanExtension(R.resource,s))))).filter(R=>R&&R.identifier):[]}async scanExtension(r,s){try{const a=await this.fileService.resolve(r);if(a.children){const{manifest:m,metadata:p}=await this.readManifest(r.fsPath),R=a.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,F=a.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource,U={id:(0,g.getGalleryExtensionId)(m.publisher,m.name)},G=p?.isSystem?0:s,C={type:G,identifier:U,manifest:m,location:r,readmeUrl:R,changelogUrl:F,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:G===0};return this.setMetadata(C,p),C}}catch(a){s!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){this.logService.trace("Started scanning system extensions");const r=await this.scanExtensionsInLocation(this.systemExtensionsLocation,0);return this.logService.trace("Scanned system extensions:",r.length),r}async scanDevSystemExtensions(){this.logService.trace("Started scanning dev system extensions");const r=this.getDevSystemExtensionsList();if(r.length){const s=await this.scanExtensionsInLocation(this.devSystemExtensionsLocation,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(a=>r.some(m=>(0,g.areSameExtensions)(a.identifier,{id:m})))}else return[]}async scanFromUserExtensionsLocation(){return this.scanExtensionsInLocation(this.userExtensionsLocation,1)}dedupExtensions(r,s){const a=new Map;for(const m of r){const p=y.ExtensionIdentifier.toKey(m.identifier.id),R=a.get(p);if(R){if(A.gt(R.manifest.version,m.manifest.version)){this.logService.debug(`Skipping extension ${m.location.fsPath} with lower version ${m.manifest.version}.`);continue}if(A.eq(R.manifest.version,m.manifest.version)&&R.targetPlatform===s){this.logService.debug(`Skipping extension ${m.location.fsPath} from different target platform ${m.targetPlatform}`);continue}R.type===0?this.logService.debug(`Overwriting system extension ${R.location.fsPath} with ${m.location.fsPath}.`):this.logService.warn(`Overwriting user extension ${R.location.fsPath} with ${m.location.fsPath}.`)}a.set(p,m)}return[...a.values()]}setMetadata(r,s){r.publisherDisplayName=s?.publisherDisplayName||null,r.publisherId=s?.publisherId||null,r.identifier.uuid=s?.id,r.isMachineScoped=!!s?.isMachineScoped,r.isPreReleaseVersion=!!s?.isPreReleaseVersion,r.preRelease=!!s?.preRelease,r.isBuiltin=r.type===0||!!s?.isBuiltin,r.installedTimestamp=s?.installedTimestamp,r.targetPlatform=s?.targetPlatform??"undefined",r.updated=!!s?.updated}async removeUninstalledExtensions(){const r=await this.getUninstalledExtensions(),s=await this.scanFromUserExtensionsLocation(),a=new Set;for(const R of s)r[g.ExtensionKey.create(R).toString()]||a.add(R.identifier.id.toLowerCase());const m=(0,g.groupByExtension)(s,R=>R.identifier);await n.Promises.settled(m.map(async R=>{const F=R.sort((U,G)=>A.rcompare(U.manifest.version,G.manifest.version))[0];a.has(F.identifier.id.toLowerCase())||await this.beforeRemovingExtension(F)}));const p=s.filter(R=>r[g.ExtensionKey.create(R).toString()]);await n.Promises.settled(p.map(R=>this.removeUninstalledExtension(R)))}async removeOutdatedExtensions(){const r=await this.scanFromUserExtensionsLocation(),s=[],a=await this.targetPlatform,m=(0,g.groupByExtension)(r,p=>p.identifier);s.push(...(0,k.flatten)(m.map(p=>p.sort((R,F)=>{const U=A.rcompare(R.manifest.version,F.manifest.version);return U!==0?U:R.targetPlatform===a?-1:1}).slice(1)))),await n.Promises.settled(s.map(p=>this.removeExtension(p,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(r=>r.name)}joinErrors(r){const s=Array.isArray(r)?r:[r];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((a,m)=>new Error(`${a.message}${a.message?",":""}${m instanceof Error?m.message:m}`),new Error(""))}get devSystemExtensionsLocation(){return this._devSystemExtensionsLocation||(this._devSystemExtensionsLocation=T.URI.file(D.normalize(D.join(_.FileAccess.asFileUri("",ee).fsPath,"..",".build","builtInExtensions")))),this._devSystemExtensionsLocation}async readManifest(r){const s=[b.Promises.readFile(D.join(r,"package.json"),"utf8").then(R=>this.parseManifest(R)),b.Promises.readFile(D.join(r,"package.nls.json"),"utf8").then(void 0,R=>R.code!=="ENOENT"?Promise.reject(R):"{}").then(R=>JSON.parse(R))],[{manifest:a,metadata:m},p]=await Promise.all(s);return{manifest:(0,d.localizeManifest)(a,p),metadata:m}}parseManifest(r){return new Promise((s,a)=>{try{const m=JSON.parse(r);m.publisher||(m.publisher=y.UNDEFINED_PUBLISHER);const p=m.__metadata||null;s({manifest:m,metadata:p})}catch{a(new Error((0,S.localize)(4,null)))}})}};i=Te([Oe(2,c.IFileService),Oe(3,o.ILogService),Oe(4,f.INativeEnvironmentService),Oe(5,l.IProductService)],i),e.ExtensionsScanner=i}),define(me[114],ve([0,1,36,9,8,5,3,20,56,12,4,23,19,72,152,65,29,209,30,35,199,192,249,200,250,222,63,18,6,13,27,32,48]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d,y,c,o,l,i,t,r,s,a,m,p,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let U=class extends h.AbstractExtensionManagementService{constructor(Z,j,$,W,Y,ie,re,oe,ue){super(Z,j,$,oe);this.environmentService=W,this.downloadService=Y,this.fileService=re;const de=this._register(ie.createInstance(c.ExtensionsLifecycle));this.extensionsScanner=this._register(ie.createInstance(i.ExtensionsScanner,O=>de.postUninstall(O),this.getTargetPlatform())),this.manifestCache=this._register(new l.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(ie.createInstance(y.ExtensionsDownloader));const H=this._register(new t.ExtensionsWatcher(this,re,W,$,ue));this._register(H.onDidChangeExtensionsByAnotherSource(({added:O,removed:V})=>{O.length&&this._onDidInstallExtensions.fire(O.map(J=>({identifier:J.identifier,operation:1,local:J}))),V.forEach(J=>this._onDidUninstallExtension.fire({identifier:J}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(Z){this.logService.trace("ExtensionManagementService#zip",Z.identifier.id);const j=await this.collectFiles(Z),$=await(0,b.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,T.generateUuid)()).fsPath,j);return A.URI.file($)}async unzip(Z){return this.logService.trace("ExtensionManagementService#unzip",Z.toString()),(await this.install(Z)).identifier}async getManifest(Z){const j=await this.downloadVsix(Z),$=I.resolve(j.fsPath);return(0,o.getManifest)($)}getInstalled(Z=null){return this.extensionsScanner.scanExtensions(Z)}async install(Z,j={}){this.logService.trace("ExtensionManagementService#install",Z.toString());const $=await this.downloadVsix(Z),W=await(0,o.getManifest)(I.resolve($.fsPath));if(W.engines&&W.engines.vscode&&!(0,r.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,d.getGalleryExtensionId)(W.publisher,W.name),this.productService.version));return this.installExtension(W,$,j)}async updateMetadata(Z,j){this.logService.trace("ExtensionManagementService#updateMetadata",Z.identifier.id);const $={...Z.manifest.__metadata||{},...j};return j.isPreReleaseVersion&&($.preRelease=!0),Z=await this.extensionsScanner.saveMetadataForLocalExtension(Z,$),this.manifestCache.invalidate(),Z}async updateExtensionScope(Z,j){return this.logService.trace("ExtensionManagementService#updateExtensionScope",Z.identifier.id),Z=await this.extensionsScanner.saveMetadataForLocalExtension(Z,{...Z.manifest.__metadata||{},isMachineScoped:j}),this.manifestCache.invalidate(),Z}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(Z){if(Z.scheme===w.Schemas.file)return Z;const j=(0,D.joinPath)(this.environmentService.tmpDir,(0,T.generateUuid)());return await this.downloadService.download(Z,j),j}createInstallExtensionTask(Z,j,$){return A.URI.isUri(j)?new z(Z,j,$,this.galleryService,this.extensionsScanner,this.logService):new C(j,$,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(Z,j){return new M(Z,j,this.extensionsScanner)}async collectFiles(Z){const j=async W=>{let Y=await E.Promises.readdir(W);Y=Y.map(oe=>I.join(W,oe));const ie=await Promise.all(Y.map(oe=>E.Promises.stat(oe)));let re=Promise.resolve([]);return ie.forEach((oe,ue)=>{const de=Y[ue];oe.isFile()&&(re=re.then(H=>[...H,de])),oe.isDirectory()&&(re=re.then(H=>j(de).then(O=>[...H,...O])))}),re};return(await j(Z.location.fsPath)).map(W=>({path:`extension/${I.relative(Z.location.fsPath,W)}`,localPath:W}))}};U=Te([Oe(0,g.IExtensionGalleryService),Oe(1,R.ITelemetryService),Oe(2,m.ILogService),Oe(3,f.INativeEnvironmentService),Oe(4,S.IDownloadService),Oe(5,a.IInstantiationService),Oe(6,s.IFileService),Oe(7,p.IProductService),Oe(8,F.IUriIdentityService)],U),e.ExtensionManagementService=U;class G extends h.AbstractExtensionTask{constructor(Z,j,$,W,Y){super();this.identifier=Z,this.source=j,this.options=$,this.extensionsScanner=W,this.logService=Y,this._operation=2}get operation(){return(0,P.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(Z,j){try{const $=await this.unsetUninstalledAndGetLocal(Z.key);if($)return Z.metadata?this.extensionsScanner.saveMetadataForLocalExtension($,{...$.manifest.__metadata||{},...Z.metadata}):$}catch{throw _.isMacintosh?new g.ExtensionManagementError(u.localize(1,null),g.ExtensionManagementErrorCode.Internal):new g.ExtensionManagementError(u.localize(2,null),g.ExtensionManagementErrorCode.Internal)}return this.extract(Z,j)}async unsetUninstalledAndGetLocal(Z){if(!await this.isUninstalled(Z))return null;this.logService.trace("Removing the extension from uninstalled list:",Z.id);const $=await this.extensionsScanner.setInstalled(Z);return this.logService.info("Removed the extension from uninstalled list:",Z.id),$}async isUninstalled(Z){return!!(await this.extensionsScanner.getUninstalledExtensions())[Z.toString()]}async extract({zipPath:Z,key:j,metadata:$},W){let Y=await this.extensionsScanner.extractUserExtension(j,Z,$,W);return this.logService.info("Extracting completed.",j.id),Y}}class C extends G{constructor(Z,j,$,W,Y){super(Z.identifier,Z,j,W,Y);this.gallery=Z,this.extensionsDownloader=$}async doRun(Z){const $=(await this.extensionsScanner.scanExtensions(null)).find(Y=>(0,d.areSameExtensions)(Y.identifier,this.gallery.identifier));$&&(this._operation=3);const W=await this.downloadInstallableExtension(this.gallery,this._operation);W.metadata.isMachineScoped=this.options.isMachineScoped||$?.isMachineScoped,W.metadata.isBuiltin=this.options.isBuiltin||$?.isBuiltin,W.metadata.isSystem=$?.type===0?!0:void 0,W.metadata.updated=!!$,W.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,W.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:$?.preRelease);try{const Y=await this.installExtension(W,Z);return $&&($.targetPlatform!==Y.targetPlatform||v.neq($.manifest.version,Y.manifest.version))&&await this.extensionsScanner.setUninstalled($),Y}catch(Y){throw await this.deleteDownloadedVSIX(W.zipPath),Y}}async deleteDownloadedVSIX(Z){try{await this.extensionsDownloader.delete(A.URI.file(Z))}catch(j){this.logService.warn("Error while deleting the downloaded vsix",Z.toString(),(0,n.getErrorMessage)(j))}}async downloadInstallableExtension(Z,j){const $={id:Z.identifier.uuid,publisherId:Z.publisherId,publisherDisplayName:Z.publisherDisplayName,targetPlatform:Z.properties.targetPlatform};let W;try{this.logService.trace("Started downloading extension:",Z.identifier.id),W=(await this.extensionsDownloader.downloadExtension(Z,j)).fsPath,this.logService.info("Downloaded extension:",Z.identifier.id,W)}catch(Y){throw new g.ExtensionManagementError((0,h.joinErrors)(Y).message,g.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(W),{zipPath:W,key:d.ExtensionKey.create(Z),metadata:$}}catch(Y){throw await this.deleteDownloadedVSIX(W),new g.ExtensionManagementError((0,h.joinErrors)(Y).message,g.ExtensionManagementErrorCode.Invalid)}}}class z extends G{constructor(Z,j,$,W,Y,ie){super({id:(0,d.getGalleryExtensionId)(Z.publisher,Z.name)},j,$,Y,ie);this.manifest=Z,this.location=j,this.galleryService=W}async doRun(Z){const j=new d.ExtensionKey(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1)).find(ie=>(0,d.areSameExtensions)(this.identifier,ie.identifier)),Y=await this.getMetadata(this.identifier.id,this.manifest.version,Z);if(Y.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,Y.isBuiltin=this.options.isBuiltin||W?.isBuiltin,W)if(this._operation=3,j.equals(new d.ExtensionKey(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else v.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const ie=await this.unsetUninstalledAndGetLocal(j);if(ie)try{await this.extensionsScanner.removeExtension(ie,"existing")}catch{throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),key:j,metadata:Y},Z)}async getMetadata(Z,j,$){try{let[W]=await this.galleryService.getExtensions([{id:Z,version:j}],$);if(W||([W]=await this.galleryService.getExtensions([{id:Z}],$)),W)return{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId,isPreReleaseVersion:W.properties.isPreReleaseVersion,preRelease:W.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class M extends h.AbstractExtensionTask{constructor(Z,j,$){super();this.extension=Z,this.options=j,this.extensionsScanner=$}async doRun(Z){const j=[],$=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const W=d.ExtensionKey.create(this.extension);j.push(...$.filter(Y=>W.equals(d.ExtensionKey.create(Y))))}else j.push(...$.filter(W=>(0,d.areSameExtensions)(W.identifier,this.extension.identifier)));if(!j.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...j),this.options.remove)for(const W of j)try{Z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(W)}catch(Y){throw new Error(u.localize(6,null,(0,k.toErrorMessage)(Y)))}}}}),define(me[58],ve([0,1,68,83,24,17,9,7,2,5,3,23,40,86,251]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(R,F=""){this.debugLabel=F,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,_.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,F){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,F)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const F=U=>{this.traceSocketEvent("read",U),R(I.VSBuffer.wrap(U))};return this.socket.on("data",F),{dispose:()=>this.socket.off("data",F)}}onClose(R){const F=U=>{this.traceSocketEvent("close",{hadError:U}),R({type:0,hadError:U,error:void 0})};return this.socket.on("close",F),{dispose:()=>this.socket.off("close",F)}}onEnd(R){const F=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",F),{dispose:()=>this.socket.off("end",F)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,F=>{if(F){if(F.code==="EPIPE")return;(0,_.onUnexpectedError)(F)}})}catch(F){if(F.code==="EPIPE")return;(0,_.onUnexpectedError)(F)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,F)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=S;var f;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var h;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(h||(h={}));class g extends v.Disposable{constructor(R,F,U,G){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:F,inflateBytesLength:U?.byteLength||0,recordInflateBytes:G}),this._flowManager=this._register(new d(this,F,U,G,this._onData,(C,z)=>this._write(C,z))),this._register(this._flowManager.onError(C=>{console.error(C),(0,_.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,F){this.socket.traceSocketEvent(R,F)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,F){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let U=2;R.byteLength<126?U+=0:R.byteLength<2**16?U+=2:U+=8;const G=I.VSBuffer.alloc(U);if(F?G.writeUInt8(194,0):G.writeUInt8(130,0),R.byteLength<126)G.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){G.writeUInt8(126,1);let C=1;G.writeUInt8(R.byteLength>>>8&255,++C),G.writeUInt8(R.byteLength>>>0&255,++C)}else{G.writeUInt8(127,1);let C=1;G.writeUInt8(0,++C),G.writeUInt8(0,++C),G.writeUInt8(0,++C),G.writeUInt8(0,++C),G.writeUInt8(R.byteLength>>>24&255,++C),G.writeUInt8(R.byteLength>>>16&255,++C),G.writeUInt8(R.byteLength>>>8&255,++C),G.writeUInt8(R.byteLength>>>0&255,++C)}this.socket.write(I.VSBuffer.concat([G,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const F=this._incomingData.peek(this._state.readLen),U=F.readUInt8(0),G=(U&128)>>>7,C=(U&64)>>>6,z=F.readUInt8(1),M=(z&128)>>>7,q=z&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=G,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(C)),this._state.firstFrameOfMessage=Boolean(G),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const F=this._incomingData.read(this._state.readLen),U=F.readUInt8(1),G=(U&128)>>>7;let C=U&127,z=1;C===126?C=F.readUInt8(++z)*2**8+F.readUInt8(++z):C===127&&(C=F.readUInt8(++z)*0+F.readUInt8(++z)*0+F.readUInt8(++z)*0+F.readUInt8(++z)*0+F.readUInt8(++z)*2**24+F.readUInt8(++z)*2**16+F.readUInt8(++z)*2**8+F.readUInt8(++z));let M=0;G&&(M=F.readUInt8(++z)*2**24+F.readUInt8(++z)*2**16+F.readUInt8(++z)*2**8+F.readUInt8(++z)),this._state.state=3,this._state.readLen=C,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const F=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",F),o(F,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",F),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(F,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class d extends v.Disposable{constructor(R,F,U,G,C,z){super();this._tracer=R,this._onData=C,this._writeFn=z,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,F?(this._zlibInflateStream=this._register(new y(this._tracer,G,U,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:I.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const F=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(F,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,F){return new Promise((U,G)=>{R.write(F),R.flush(C=>U(C))})}acceptFrame(R,F,U){this._readQueue.push({data:R,isCompressed:F,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const F=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(F)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,F,U){return new Promise((G,C)=>{R.write(F),U&&R.write(I.VSBuffer.fromByteArray([0,0,255,255])),R.flush(z=>G(z))})}}class y extends v.Disposable{constructor(R,F,U,G){super();this._tracer=R,this._recordInflateBytes=F,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=u.createInflateRaw(G),this._zlibInflate.on("error",C=>{this._tracer.traceSocketEvent("zlibInflateError",{message:C?.message,code:C?.code}),this._onError.fire(C)}),this._zlibInflate.on("data",C=>{this._tracer.traceSocketEvent("zlibInflateData",C),this._pendingInflateData.push(I.VSBuffer.wrap(C))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.concat(this._recordedInflateBytes):I.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const F=I.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(F)})}}class c extends v.Disposable{constructor(R,F){super();this._tracer=R,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(I.VSBuffer.wrap(U))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let F=I.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,F=F.slice(0,F.byteLength-4),R(F)})}}function o(p,R){if(R===0)return;let F=p.byteLength>>>2;for(let q=0;q<F;q++){const Z=p.readUInt32BE(q*4);p.writeUInt32BE(Z^R,q*4)}let U=F*4,G=p.byteLength-U;const C=R>>>24&255,z=R>>>16&255,M=R>>>8&255;G>=1&&p.writeUInt8(p.readUInt8(U)^C,U),G>=2&&p.writeUInt8(p.readUInt8(U+1)^z,U+1),G>=3&&p.writeUInt8(p.readUInt8(U+2)^M,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function i(){const p=(0,T.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):R=(0,P.join)((0,w.tmpdir)(),`vscode-ipc-${p}.sock`),r(R),R}e.createRandomIPCHandle=i;function t(p,R,F){const U=(0,k.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${F}-${R}-sock`;let G;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?G=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${F}-${R}.sock`):G=(0,P.join)(p,`${F}-${R}.sock`),r(G),G}e.createStaticIPCHandle=t;function r(p){const R=l[A.platform];typeof R=="number"&&p.length>=R&&console.warn(`WARNING: IPC handle "${p}" is longer than ${R} chars, try a shorter --user-data-dir`)}class s extends E.IPCServer{constructor(R){super(s.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const F=D.Event.fromNodeEventEmitter(R,"connection");return D.Event.map(F,U=>({protocol:new b.Protocol(new S(U,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(p){return new Promise((R,F)=>{const U=(0,n.createServer)();U.on("error",F),U.listen(p,()=>{U.removeListener("error",F),R(new s(U))})})}e.serve=a;function m(p,R){return new Promise((F,U)=>{const G=(0,n.createConnection)(p,()=>{G.removeListener("error",U),F(b.Client.fromSocket(new S(G,`ipc-client${R}`),R))});G.once("error",U)})}e.connect=m}),define(me[115],ve([0,1,69,14,17,9,2,12,26,29,70,13,203,251]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let u=class extends _.Disposable{constructor(f,h,g){super();this.environmentService=h,this.logService=g,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,h){this.logService.trace("RequestService#request",f.url);const{proxyUrl:g,strictSSL:d}=this;let y;try{y=await(0,A.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",l))}const c={...process.env,...y},o=f.agent?f.agent:await(0,E.getProxyAgent)(f.url||"",c,{proxyUrl:g,strictSSL:d});return f.agent=o,f.strictSSL=d,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this._request(f,h)}async getNodeRequest(f){return((0,k.parse)(f.url).protocol==="https:"?await new Promise((d,y)=>{ee(["https"],d,y)}):await new Promise((d,y)=>{ee(["http"],d,y)})).request}_request(f,h){return n.Promises.withAsyncBody(async(g,d)=>{let y;const c=(0,k.parse)(f.url),o=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),l={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,D.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(l.auth=f.user+":"+f.password),y=o(l,i=>{const t=(0,D.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&t>0&&i.headers.location)this._request({...f,url:i.headers.location,followRedirects:t-1},h).then(g,d);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,b.createGunzip)())),g({res:i,stream:(0,w.streamToBufferReadableStream)(r)})}}),y.on("error",d),f.timeout&&y.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&y.write(f.data),y.end(),h.onCancellationRequested(()=>{y.abort(),d((0,I.canceled)())})})}async resolveProxy(f){}};u=Te([Oe(0,v.IConfigurationService),Oe(1,P.INativeEnvironmentService),Oe(2,T.ILogService)],u),e.RequestService=u}),define(me[116],ve([0,1,39,71,8,5,17,7,58,70,13,37,3,247,62,105]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function f(o={},l,i,t,r,s){const a=await(0,n.getNLSConfiguration)(i,r.userDataPath);let m={};if(l)try{m=await(0,P.getResolvedShellEnv)(s,r.args,process.env)}catch(C){s.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",C)}const R={...process.env,...m,VSCODE_LOG_NATIVE:String(t),VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(a,void 0,0),...o},F=r.isBuilt?(0,I.join)(r.appRoot,"bin"):(0,I.join)(r.appRoot,"resources","server","bin-dev"),U=(0,I.join)(F,"remote-cli");let G=d(R,"PATH");return G?G=U+I.delimiter+G:G=U,y(R,"PATH",G),r.args["without-browser-env-var"]||(R.BROWSER=(0,I.join)(F,"helpers",E.isWindows?"browser.cmd":"browser.sh")),c(R),R}e.buildUserEnvironment=f;class h{constructor(l,i,t,r,s,a){this.socket=l,this.socketDrain=i,this.initialDataChunk=t,this.skipWebSocketFrames=r,this.permessageDeflate=s,this.inflateBytes=a}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}let g=class fn{constructor(l,i,t,r,s,a,m){this._reconnectionToken=l,this._environmentService=s,this._logService=a,this._extensionHostStatusService=m,this._onClose=new D.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=i,this._extensionHostProcess=null,this._connectionData=fn._toConnectionData(t,r),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(l){this._logService.info(`${this._logPrefix}${l}`)}_logError(l){this._logService.error(`${this._logPrefix}${l}`)}static _toConnectionData(l,i){return l instanceof v.NodeSocket?new h(l.socket,l.drain(),i,!0,!1,_.VSBuffer.alloc(0)):new h(l.socket.socket,l.drain(),i,!1,l.permessageDeflate,l.recordedInflateBytes)}async _sendSocketToExtensionHost(l,i){await i.socketDrain;const t=i.toIExtHostSocketMessage();l.send(t,i.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const l={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(l)}acceptReconnection(l,i,t){this._remoteAddress=l,this._log("The client has reconnected.");const r=fn._toConnectionData(i,t);if(!this._extensionHostProcess){this._connectionData=r;return}this._sendSocketToExtensionHost(this._extensionHostProcess,r)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(l){try{let i=[];l.port&&!process.pkg&&(i=[`--inspect${l.break?"-brk":""}=${l.port}`]);const t=await f(l.env,!0,l.language,!!l.debugId,this._environmentService,this._logService);(0,u.removeDangerousEnvVariables)(t);const r={env:t,execArgv:i,silent:!0},s=["--type=extensionHost","--transformURIs"],a=this._environmentService.args["use-host-proxy"];s.push(`--useHostProxy=${a?"true":"false"}`),this._extensionHostProcess=k.fork(w.FileAccess.asFileUri("bootstrap-fork",ee).fsPath,s,r);const m=this._extensionHostProcess.pid;this._log(`<${m}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const p=D.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),R=D.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");p(U=>this._log(`<${m}> ${U}`)),R(U=>this._log(`<${m}><stderr> ${U}`)),this._extensionHostProcess.on("message",U=>{U&&U.type==="__$console"&&(0,b.logRemoteEntry)(this._logService,U,`${this._logPrefix}<${m}>`)}),this._extensionHostProcess.on("error",U=>{this._logError(`<${m}> Extension Host Process had an error`),this._logService.error(U),this._cleanResources()}),this._extensionHostProcess.on("exit",(U,G)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:U,signal:G}),this._log(`<${m}> Extension Host Process exited with code: ${U}, signal: ${G}.`),this._cleanResources()});const F=U=>{U.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",F),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",F)}catch(i){console.error("ExtensionHostConnection errored"),i&&console.error(i)}}};g=Te([Oe(4,T.IServerEnvironmentService),Oe(5,A.ILogService),Oe(6,S.IExtensionHostStatusService)],g),e.ExtensionHostConnection=g;function d(o,l){const i=Object.keys(o).filter(r=>r.toLowerCase()===l.toLowerCase()),t=i.length>0?i[0]:l;return o[t]}function y(o,l,i){const t=Object.keys(o).filter(s=>s.toLowerCase()===l.toLowerCase()),r=t.length>0?t[0]:l;o[r]=i}function c(o){for(let l of Object.keys(o))o[l]===null&&delete o[l]}}),define(me[252],ve([0,1,66,13,53,96,26,47,115,42,32,30,100,114,92,45,2,93,55,8,18,27,95,113,37,98,67,99,9,4,5,25,201,65,48,103,52,3]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d,y,c,o,l,i,t,r,s,a,m,p,R,F,U,G,C,z,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class q extends f.Disposable{constructor(W,Y){super();this.args=W,this.remoteDataFolder=Y,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async Y=>{const ie=Y.get(n.ILogService),re=Y.get(T.IExtensionManagementCLIService);try{await this.doRun(re)}catch(oe){throw ie.error(oe),console.error((0,a.getErrorMessage)(oe)),oe}})}async initServices(){const W=new k.ServiceCollection,Y={_serviceBrand:void 0,...S.default};W.set(c.IProductService,Y);const ie=new i.ServerEnvironmentService(this.args,Y);W.set(i.IServerEnvironmentService,ie);const re=new n.LogService(new o.SpdLogLogger(l.RemoteExtensionLogFileName,(0,p.join)(ie.logsPath,`${l.RemoteExtensionLogFileName}.log`),!0,!1,(0,n.getLogLevel)(ie)));W.set(n.ILogService,re),re.trace(`Remote configuration data at ${this.remoteDataFolder}`),re.trace("process arguments:",this.args);const oe=this._register(new h.FileService(re));W.set(y.IFileService,oe),oe.registerProvider(d.Schemas.file,this._register(new g.DiskFileSystemProvider(re)));const ue=this._register(new I.ConfigurationService(ie.settingsResource,oe));return await ue.initialize(),W.set(_.IConfigurationService,ue),W.set(G.IUriIdentityService,new C.UriIdentityService(oe)),W.set(D.IRequestService,new w.SyncDescriptor(v.RequestService)),W.set(U.IDownloadService,new w.SyncDescriptor(F.DownloadService)),W.set(A.ITelemetryService,P.NullTelemetryService),W.set(T.IExtensionGalleryService,new w.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),W.set(T.IExtensionManagementService,new w.SyncDescriptor(b.ExtensionManagementService)),W.set(T.IExtensionManagementCLIService,new w.SyncDescriptor(t.ExtensionManagementCLIService)),W.set(r.ILocalizationsService,new w.SyncDescriptor(s.LocalizationsService)),new u.InstantiationService(W)}async doRun(W){if(this.args["list-extensions"])return W.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const Y={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return W.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],Y,!!this.args.force)}else{if(this.args["uninstall-extension"])return W.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return W.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(W){return W.map(Y=>/\.vsix$/i.test(Y)?m.URI.file((0,p.isAbsolute)(Y)?Y:(0,p.join)((0,R.cwd)(),Y)):Y)}}function Z($){setTimeout(()=>process.exit($),0)}async function j($,W,Y){if($.help){const re=S.default.serverApplicationName+(M.isWindows?".cmd":"");console.log((0,z.buildHelpMessage)(S.default.nameLong,re,S.default.version,Y,{noInputFiles:!0,noPipe:!0}));return}if($.version){console.log((0,z.buildVersionMessage)(S.default.version,S.default.commit));return}const ie=new q($,W);try{await ie.run(),Z(0)}catch{Z(1)}finally{ie.dispose()}}e.run=j}),define(me[253],ve([0,1,58,228,28,246,4,13,104]),function(ee,e,k,n,w,I,_,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(E,b,u){this._commands=E,this.logService=b,this._ipcHandlePath=u,this._server=n.createServer((S,f)=>this.onRequest(S,f)),this.setup().catch(S=>(b.error(S),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,b){const u=(f,h)=>{b.writeHead(f,{"content-type":"application/json"}),b.end(JSON.stringify(h||null),g=>g&&this.logService.error(g))},S=[];E.setEncoding("utf8"),E.on("data",f=>S.push(f)),E.on("end",async()=>{try{const f=JSON.parse(S.join(""));let h;switch(f.type){case"open":h=await this.open(f);break;case"openExternal":h=await this.openExternal(f);break;case"status":h=await this.getStatus(f);break;case"extensionManagement":h=await this.manageExtensions(f);break;default:u(404,`Unknown message type: ${f.type}`);break}u(200,h)}catch(f){const h=f instanceof Error?f.message:JSON.stringify(f);u(500,h),this.logService.error("Error while processing pipe request",f)}})}async open(E){const{fileURIs:b,folderURIs:u,forceNewWindow:S,diffMode:f,addMode:h,forceReuseWindow:g,gotoLineMode:d,waitMarkerFilePath:y,remoteAuthority:c}=E,o=[];if(Array.isArray(u))for(const r of u)try{o.push({folderUri:_.URI.parse(r)})}catch{}if(Array.isArray(b))for(const r of b)try{(0,v.hasWorkspaceFileExtension)(r)?o.push({workspaceUri:_.URI.parse(r)}):o.push({fileUri:_.URI.parse(r)})}catch{}const l=y?_.URI.file(y):void 0,t={forceNewWindow:S,diffMode:f,addMode:h,gotoLineMode:d,forceReuseWindow:g,preferNewWindow:!g&&!l&&!h,waitMarkerFileURI:l,remoteAuthority:c};return this._commands.executeCommand("_remoteCLI.windowOpen",o,t),""}async openExternal(E){for(const b of E.uris){const u=_.URI.parse(b),S=u.scheme==="file"?u:b;await this._commands.executeCommand("_remoteCLI.openExternal",S)}}async manageExtensions(E){const b=S=>S?.map(f=>/\.vsix$/i.test(f)?_.URI.parse(f):f),u={list:E.list,install:b(E.install),uninstall:b(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",u)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&w.existsSync(this._ipcHandlePath)&&w.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let A=class extends P{constructor(E,b){super(E,b,(0,k.createRandomIPCHandle)())}};A=Te([Oe(0,I.IExtHostCommands),Oe(1,D.ILogService)],A),e.CLIServer=A}),define(me[254],ve([0,1,24,7,22,2,5,3,4,58,57,253,233,110,234,239,116]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class h extends S.AbstractVariableResolverService{constructor(y,c,o,l){super({getFolderUri:i=>{const t=c.filter(r=>r.name===i);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(i,t)=>l[`config:${t}`],getExecPath:()=>y.VSCODE_EXEC_PATH,getAppRoot:()=>y.VSCODE_CWD,getFilePath:()=>{if(o)return _.normalize(o.fsPath)},getSelectedText:()=>l.selectedText,getLineNumber:()=>l.lineNumber},void 0,Promise.resolve(k.homedir()),Promise.resolve(y))}}class g extends I.Disposable{constructor(y,c,o,l){super();this._environmentService=y,this._logService=c,this._ptyService=o,this._productService=l,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new n.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(y,c,o){switch(c){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,o);case"$createProcess":{const l=(0,A.createURITransformer)(y.remoteAuthority);return this._createProcess(l,o)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,o);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,o);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,o);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,o);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,o);case"$start":return this._ptyService.start.apply(this._ptyService,o);case"$input":return this._ptyService.input.apply(this._ptyService,o);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,o);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,o);case"$resize":return this._ptyService.resize.apply(this._ptyService,o);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,o);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,o);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,o);case"$sendCommandResult":return this._sendCommandResult(o[0],o[1],o[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,o);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,o);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,o);case"$getProfiles":return this._getProfiles.apply(this,o);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(o[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(o);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(o);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,o);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,o);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,o);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,o);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,o);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,o);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,o);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(o[0],o[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(o[0],o[1])}throw new Error(`IPC Command ${c} not found`)}listen(y,c,o){switch(c){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||n.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||n.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||n.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||n.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||n.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||n.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(y,c){const o={name:c.shellLaunchConfig.name,executable:c.shellLaunchConfig.executable,args:c.shellLaunchConfig.args,cwd:typeof c.shellLaunchConfig.cwd=="string"||typeof c.shellLaunchConfig.cwd=="undefined"?c.shellLaunchConfig.cwd:v.URI.revive(y.transformIncoming(c.shellLaunchConfig.cwd)),env:c.shellLaunchConfig.env,useShellEnvironment:c.shellLaunchConfig.useShellEnvironment},l=await(0,f.buildUserEnvironment)(c.resolverEnv,!!c.shellLaunchConfig.useShellEnvironment,D.language,!1,this._environmentService,this._logService);this._logService.trace("baseEnv",l);const i=q=>({uri:v.URI.revive(y.transformIncoming(q.uri)),name:q.name,index:q.index,toResource:()=>{throw new Error("Not implemented")}}),t=c.workspaceFolders.map(i),r=c.activeWorkspaceFolder?i(c.activeWorkspaceFolder):void 0,s=c.activeFileResource?v.URI.revive(y.transformIncoming(c.activeFileResource)):void 0,a=new h(l,t,s,c.resolvedVariables),m=u.createVariableResolver(r,process.env,a),p=u.getCwd(o,k.homedir(),m,r?.uri,c.configuration["terminal.integrated.cwd"],this._logService);o.cwd=p;const R=D.isWindows?"terminal.integrated.env.windows":D.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",F=c.configuration[R],U=u.createTerminalEnvironment(o,F,m,this._productService.version,c.configuration["terminal.integrated.detectLocale"],l);if(!o.strictEnv){const q=[];for(const[$,W]of c.envVariableCollections)q.push([$,{map:(0,b.deserializeEnvironmentVariableCollection)(W)}]);const Z=new Map(q);new E.MergedEnvironmentVariableCollection(Z).applyToProcessEnvironment(U)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:o,initialCwd:p,cols:c.cols,rows:c.rows,env:U});const G=(0,P.createRandomIPCHandle)();U.VSCODE_IPC_HOOK_CLI=G;const C={executeCommand:(q,...Z)=>this._executeCommand(q,Z,y)},z=new T.CLIServerBase(C,this._logService,G),M=await this._ptyService.createProcess(o,p,c.cols,c.rows,c.unicodeVersion,U,l,c.options,c.shouldPersistTerminal,c.workspaceId,c.workspaceName);return this._ptyService.onProcessExit(q=>q.id===M&&z.dispose()),{persistentTerminalId:M,resolvedShellLaunchConfig:o}}_executeCommand(y,c,o){let l,i;const t=new Promise((a,m)=>{l=a,i=m}),r=++this._lastReqId;this._pendingCommands.set(r,{resolve:l,reject:i,uriTransformer:o});const s=(0,w.cloneAndChange)(c,a=>{if(a&&a.$mid===1)return o.transformOutgoing(a);if(a&&a instanceof v.URI)return o.transformOutgoingURI(a)});return this._onExecuteCommand.fire({reqId:r,commandId:y,commandArgs:s}),t}_sendCommandResult(y,c,o){const l=this._pendingCommands.get(y);if(!l)return;this._pendingCommands.delete(y);const i=(0,w.cloneAndChange)(o,t=>{if(t&&t.$mid===1)return l.uriTransformer.transformIncoming(t)});c?l.reject(i):l.resolve(i)}_getDefaultSystemShell(y){return this._ptyService.getDefaultSystemShell(y)}async _getProfiles(y,c,o,l){return this._ptyService.getProfiles?.(y,c,o,l)||[]}_getEnvironment(){return{...process.env}}_getWslPath(y){return this._ptyService.getWslPath(y)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=g}),define(me[255],ve([0,1,24,7,2,8,5,82,19,40,26,96,64,226,171,65,172,183,174,29,100,30,98,184,114,18,93,55,53,92,66,67,99,13,94,95,45,27,47,202,115,205,32,42,213,214,101,221,48,103,244,231,207,212,254,57,37,242,113,248,105,227]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d,y,c,o,l,i,t,r,s,a,m,p,R,F,U,G,C,z,M,q,Z,j,$,W,Y,ie,re,oe,ue,de,H,O,V,J,ae,ge,he,le,pe,Q,B,x,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const fe="monacoworkbench";async function ye(Ae,Fe,je,We){const He=new p.ServiceCollection,Ke=new Ne,ne={_serviceBrand:void 0,...z.default};He.set(M.IProductService,ne);const be=new le.ServerEnvironmentService(Fe,ne);He.set(d.IEnvironmentService,be),He.set(d.INativeEnvironmentService,be);const Pe=new U.LogService(new C.SpdLogLogger(Q.RemoteExtensionLogFileName,_.join(be.logsPath,`${Q.RemoteExtensionLogFileName}.log`),!0,!1,(0,U.getLogLevel)(be))),Le=new U.MultiplexLogService([new Ue((0,U.getLogLevel)(be)),Pe]);He.set(U.ILogService,Le),setTimeout(()=>Ee(be.logsPath).then(null,rt=>Le.error(rt)),1e4),Le.trace(`Remote configuration data at ${je}`),Le.trace("process arguments:",be.args),Array.isArray(ne.serverGreeting)&&Pe.info(`

${ne.serverGreeting.join(`
`)}

`),Ke.registerChannel(u.ExtensionHostDebugBroadcastChannel.ChannelName,new u.ExtensionHostDebugBroadcastChannel);const Me=new P.StaticRouter(rt=>rt.clientId==="renderer");Ke.registerChannel("logger",new G.LogLevelChannel(Le));const Ve=We.add(new r.FileService(Le));He.set(t.IFileService,Ve),Ve.registerProvider(I.Schemas.file,We.add(new s.DiskFileSystemProvider(Le)));const ze=new T.ConfigurationService(be.machineSettingsResource,Ve);He.set(A.IConfigurationService,ze);const qe=new x.ExtensionHostStatusService;He.set(x.IExtensionHostStatusService,qe),He.set(de.IUriIdentityService,new H.UriIdentityService(Ve)),He.set(q.IRequestService,new a.SyncDescriptor(j.RequestService));let Xe=Y.NullAppender;const Ge=await(0,D.getMachineId)();if((0,Y.supportsTelemetry)(ne,be)){const rt=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";rt?(Xe=new ie.AppInsightsAppender(fe,null,()=>new X.TelemetryClient(rt)),We.add((0,w.toDisposable)(()=>Xe.flush()))):ne.aiConfig&&ne.aiConfig.asimovKey&&(Xe=new ie.AppInsightsAppender(fe,null,ne.aiConfig.asimovKey),We.add((0,w.toDisposable)(()=>Xe.flush())));const ht={appenders:[Xe],commonProperties:(0,$.resolveCommonProperties)(Ve,(0,k.release)(),(0,k.hostname)(),process.arch,ne.commit,ne.version+"-remote",Ge,ne.msftInternalDomains,be.installSourcePath,"remoteAgent"),piiPaths:(0,Y.getPiiPathsFromEnvironment)(be)},at=be.args["telemetry-level"];let ft;at==="all"?ft=3:at==="error"?ft=2:at==="crash"?ft=1:at!==void 0&&(ft=0),He.set(ae.IServerTelemetryService,new a.SyncDescriptor(ae.ServerTelemetryService,[ht,ft]))}else He.set(ae.IServerTelemetryService,ae.ServerNullTelemetryService);He.set(c.IExtensionGalleryService,new a.SyncDescriptor(y.ExtensionGalleryServiceWithNoStorageService));const Ze=Ke.getChannel("download",Me);He.set(S.IDownloadService,new f.DownloadServiceChannelClient(Ze,()=>Re("renderer"))),He.set(c.IExtensionManagementService,new a.SyncDescriptor(i.ExtensionManagementService));const tt=new m.InstantiationService(He);He.set(R.ILocalizationsService,tt.createInstance(F.LocalizationsService));const st=tt.createInstance(o.ExtensionManagementCLIService);He.set(c.IExtensionManagementCLIService,st);const ot=tt.createInstance(ue.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:ze.getValue("terminal.integrated.persistentSessionScrollback")??100});return He.set(oe.IPtyService,ot),He.set(h.IEncryptionMainService,new a.SyncDescriptor(g.EncryptionMainService,[Ge])),He.set(E.ICredentialsMainService,new a.SyncDescriptor(b.CredentialsWebMainService)),tt.invokeFunction(rt=>{const ht=rt.get(c.IExtensionManagementService),at=new O.RemoteAgentEnvironmentChannel(Ae,be,st,ht,Le,ne,qe,Ve);Ke.registerChannel("remoteextensionsenvironment",at);const ft=new J.ServerTelemetryChannel(rt.get(ae.IServerTelemetryService),Xe);Ke.registerChannel("telemetry",ft),Ke.registerChannel(pe.REMOTE_TERMINAL_CHANNEL_NAME,new ge.RemoteTerminalChannel(be,Le,ot,ne));const bt=new V.RemoteAgentFileSystemProviderChannel(Le,be);Ke.registerChannel(B.REMOTE_FILE_SYSTEM_CHANNEL_NAME,bt),Ke.registerChannel("request",new Z.RequestChannel(rt.get(q.IRequestService)));const Pt=new l.ExtensionManagementChannel(ht,Ie=>Re(Ie.remoteAuthority));Ke.registerChannel("extensions",Pt);const kt=P.ProxyChannel.fromService(rt.get(R.ILocalizationsService));Ke.registerChannel("localizations",kt);const _t=P.ProxyChannel.fromService(rt.get(h.IEncryptionMainService));Ke.registerChannel("encryption",_t);const Se=P.ProxyChannel.fromService(rt.get(E.ICredentialsMainService));return Ke.registerChannel("credentials",Se),ht.removeDeprecatedExtensions(),We.add(new re.default(rt.get(W.ITelemetryService))),{telemetryService:rt.get(W.ITelemetryService)}}),{socketServer:Ke,instantiationService:tt}}e.setupServerServices=ye;const ke=Object.create(null);function Re(Ae){return ke[Ae]||(ke[Ae]=(0,he.createURITransformer)(Ae)),ke[Ae]}class Ne extends P.IPCServer{constructor(){const Fe=new n.Emitter;super(Fe.event);this._onDidConnectEmitter=Fe}acceptConnection(Fe,je){this._onDidConnectEmitter.fire({protocol:Fe,onDidClientDisconnect:je})}}e.SocketServer=Ne;class Ue extends U.AbstractLogger{constructor(Fe=U.DEFAULT_LOG_LEVEL){super();this.setLevel(Fe),this.useColors=Boolean(process.stdout.isTTY)}trace(Fe,...je){this.getLevel()<=U.LogLevel.Trace&&(this.useColors?console.log(`[90m[${se()}][0m`,Fe,...je):console.log(`[${se()}]`,Fe,...je))}debug(Fe,...je){this.getLevel()<=U.LogLevel.Debug&&(this.useColors?console.log(`[90m[${se()}][0m`,Fe,...je):console.log(`[${se()}]`,Fe,...je))}info(Fe,...je){this.getLevel()<=U.LogLevel.Info&&(this.useColors?console.log(`[90m[${se()}][0m`,Fe,...je):console.log(`[${se()}]`,Fe,...je))}warn(Fe,...je){this.getLevel()<=U.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${se()}][0m`,Fe,...je):console.warn(`[${se()}]`,Fe,...je))}error(Fe,...je){this.getLevel()<=U.LogLevel.Error&&(this.useColors?console.error(`[91m[${se()}][0m`,Fe,...je):console.error(`[${se()}]`,Fe,...je))}critical(Fe,...je){this.getLevel()<=U.LogLevel.Critical&&(this.useColors?console.error(`[90m[${se()}][0m`,Fe,...je):console.error(`[${se()}]`,Fe,...je))}dispose(){}flush(){}}function se(){const Ae=new Date;return`${we(Ae.getHours())}:${we(Ae.getMinutes())}:${we(Ae.getSeconds())}`}function we(Ae){return Ae<10?`0${Ae}`:String(Ae)}async function Ee(Ae){const Fe=_.basename(Ae),je=_.dirname(Ae),Ke=(await v.Promises.readdir(je)).filter(be=>/^\d{8}T\d{6}$/.test(be)).sort().filter(be=>be!==Fe),ne=Ke.slice(0,Math.max(0,Ke.length-9));await Promise.all(ne.map(be=>v.Promises.rm(_.join(je,be))))}}),define(me[256],ve([0,1,68,28,83,257,69,117,17,9,33,2,8,5,44,3,15,4,23,134,86,58,6,13,27,32,116,223,224,37,255,229]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E,b,u,S,f,h,g,d,y,c,o,l,i,t,r,s,a,m,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const F=5*60*1e3;let U=class extends T.Disposable{constructor(M,q,Z,j,$,W,Y,ie){super();this._socketServer=M,this._connectionToken=q,this._vsdaMod=Z,this._environmentService=$,this._productService=W,this._logService=Y,this._instantiationService=ie,this._webEndpointOriginChecker=C.create(this._productService),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=j?this._instantiationService.createInstance(R.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(M,q){if(M.method!=="GET")return(0,R.serveError)(M,q,405,`Unsupported method ${M.method}`);if(!M.url)return(0,R.serveError)(M,q,400,"Bad request.");const Z=_.parse(M.url,!0),j=Z.pathname;if(!j)return(0,R.serveError)(M,q,400,"Bad request.");if(j==="/version")return q.writeHead(200,{"Content-Type":"text/plain"}),q.end(this._productService.commit||"");if(j==="/delay-shutdown")return this._delayShutdown(),q.writeHead(200),q.end("OK");if(!(0,a.requestHasValidConnectionToken)(this._connectionToken,M,Z))return(0,R.serveError)(M,q,403,"Forbidden.");if(j==="/vscode-remote-resource"){const $=Z.query.path;if(typeof $!="string")return(0,R.serveError)(M,q,400,"Bad request.");let W;try{W=h.URI.from({scheme:E.Schemas.file,path:$}).fsPath}catch{return(0,R.serveError)(M,q,400,"Bad request.")}const Y=Object.create(null);this._environmentService.isBuilt&&((0,A.isEqualOrParent)(W,this._environmentService.builtinExtensionsPath,!S.isLinux)||(0,A.isEqualOrParent)(W,this._environmentService.extensionsPath,!S.isLinux))&&(Y["Cache-Control"]="public, max-age=31536000"),Y.Vary="Origin";const ie=M.headers.origin;return ie&&this._webEndpointOriginChecker.matches(ie)&&(Y["Access-Control-Allow-Origin"]=ie),(0,R.serveFile)(this._logService,M,q,W,Y)}if(this._webClientServer){this._webClientServer.handle(M,q,Z);return}return q.writeHead(404,{"Content-Type":"text/plain"}),q.end("Not found")}handleUpgrade(M,q){let Z=(0,g.generateUuid)(),j=!1,$=!1;if(M.url){const ue=_.parse(M.url,!0).query;typeof ue.reconnectionToken=="string"&&(Z=ue.reconnectionToken),ue.reconnection==="true"&&(j=!0),ue.skipWebSocketFrames==="true"&&($=!0)}if(M.headers.upgrade!=="websocket"){q.end("HTTP/1.1 400 Bad Request");return}const W=M.headers["sec-websocket-key"],Y=k.createHash("sha1");Y.update(W+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ie=Y.digest("base64"),re=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ie}`];let oe=!1;if(!$&&!this._environmentService.args["disable-websocket-compression"]&&M.headers["sec-websocket-extensions"]){const ue=Array.isArray(M.headers["sec-websocket-extensions"])?M.headers["sec-websocket-extensions"]:[M.headers["sec-websocket-extensions"]];for(const de of ue)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(de)){if(/\b(permessage-deflate)\b/.test(de)){oe=!0,re.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(de)){oe=!0,re.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}q.write(re.join(`\r
`)+`\r
\r
`),q.setTimeout(0),q.setNoDelay(!0),$?this._handleWebSocketConnection(new c.NodeSocket(q,`server-connection-${Z}`),j,Z):this._handleWebSocketConnection(new c.WebSocketNodeSocket(new c.NodeSocket(q,`server-connection-${Z}`),oe,null,!0),j,Z)}handleServerError(M){this._logService.error("Error occurred in server"),this._logService.error(M)}_getRemoteAddress(M){let q;return M instanceof c.NodeSocket?q=M.socket:q=M.socket.socket,q.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(M,q,Z){const j=q.getSocket();this._logService.error(`${M} ${Z}.`);const $={type:"error",reason:Z};q.sendControl(v.VSBuffer.fromString(JSON.stringify($))),q.dispose(),await j.drain(),j.dispose()}_handleWebSocketConnection(M,q,Z){const j=this._getRemoteAddress(M),$=`[${j}][${Z.substr(0,8)}]`,W=new y.PersistentProtocol(M),Y=this._vsdaMod?new this._vsdaMod.validator:null,ie=this._vsdaMod?new this._vsdaMod.signer:null;let re;(function(H){H[H.WaitingForAuth=0]="WaitingForAuth",H[H.WaitingForConnectionType=1]="WaitingForConnectionType",H[H.Done=2]="Done",H[H.Error=3]="Error"})(re||(re={}));let oe=0;const ue=H=>{oe=3,de.dispose(),this._rejectWebSocketConnection($,W,H)},de=W.onControlMessage(H=>{if(oe===0){let O;try{O=JSON.parse(H.toString())}catch{return ue("Malformed first message")}if(O.type!=="auth")return ue("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(O.auth))return ue("Unauthorized client refused: auth mismatch");let V=(0,g.generateUuid)();if(ie)try{V=ie.sign(O.data)}catch{}let J=(0,g.generateUuid)();if(Y)try{J=Y.createNewMessage(J)}catch{}const ae={type:"sign",data:J,signedData:V};W.sendControl(v.VSBuffer.fromString(JSON.stringify(ae))),oe=1}else if(oe===1){let O;try{O=JSON.parse(H.toString())}catch{return ue("Malformed second message")}if(O.type!=="connectionType")return ue("Invalid second message");if(typeof O.signedData!="string")return ue("Invalid second message field type");const V=O.commit,J=this._productService.commit;if(V&&J&&V!==J)return ue("Client refused: version mismatch");let ae=!1;if(!Y)ae=!0;else if(this._connectionToken.validate(O.signedData))ae=!0;else try{ae=Y.validate(O.signedData)==="ok"}catch{}if(!ae){if(this._environmentService.isBuilt)return ue("Unauthorized client refused");this._logService.error(`${$} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let ge in this._managementConnections)this._managementConnections[ge].shortenReconnectionGraceTimeIfNecessary();for(let ge in this._extHostConnections)this._extHostConnections[ge].shortenReconnectionGraceTimeIfNecessary();oe=2,de.dispose(),this._handleConnectionType(j,$,W,M,q,Z,O)}})}async _handleConnectionType(M,q,Z,j,$,W,Y){const ie=Y.desiredConnectionType===1?`${q}[ManagementConnection]`:Y.desiredConnectionType===2?`${q}[ExtensionHostConnection]`:q;if(Y.desiredConnectionType===1)if($){if(!this._managementConnections[W])return this._allReconnectionTokens.has(W)?this._rejectWebSocketConnection(ie,Z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ie,Z,"Unknown reconnection token (never seen)");Z.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const re=Z.readEntireBuffer();Z.dispose(),this._managementConnections[W].acceptReconnection(M,j,re)}else{if(this._managementConnections[W])return this._rejectWebSocketConnection(ie,Z,"Duplicate reconnection token");Z.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const re=new s.ManagementConnection(this._logService,W,M,Z);this._socketServer.acceptConnection(re.protocol,re.onClose),this._managementConnections[W]=re,this._allReconnectionTokens.add(W),re.onClose(()=>{delete this._managementConnections[W]})}else if(Y.desiredConnectionType===2){const re=Y.args||{language:"en"},oe=await this._updateWithFreeDebugPort(re);if(oe.port&&this._logService.trace(`${ie} - startParams debug port ${oe.port}`),this._logService.trace(`${ie} - startParams language: ${oe.language}`),this._logService.trace(`${ie} - startParams env: ${JSON.stringify(oe.env)}`),$){if(!this._extHostConnections[W])return this._allReconnectionTokens.has(W)?this._rejectWebSocketConnection(ie,Z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ie,Z,"Unknown reconnection token (never seen)");Z.sendPause(),Z.sendControl(v.VSBuffer.fromString(JSON.stringify(oe.port?{debugPort:oe.port}:{})));const ue=Z.readEntireBuffer();Z.dispose(),this._extHostConnections[W].acceptReconnection(M,j,ue)}else{if(this._extHostConnections[W])return this._rejectWebSocketConnection(ie,Z,"Duplicate reconnection token");Z.sendPause(),Z.sendControl(v.VSBuffer.fromString(JSON.stringify(oe.port?{debugPort:oe.port}:{})));const ue=Z.readEntireBuffer();Z.dispose();const de=this._instantiationService.createInstance(r.ExtensionHostConnection,W,M,j,ue);this._extHostConnections[W]=de,this._allReconnectionTokens.add(W),de.onClose(()=>{delete this._extHostConnections[W],this._onDidCloseExtHostConnection()}),de.start(oe)}}else if(Y.desiredConnectionType===3){const re=Y.args;this._createTunnel(Z,re)}else return this._rejectWebSocketConnection(ie,Z,"Unknown initial data received")}async _createTunnel(M,q){const Z=M.getSocket().socket,j=M.readEntireBuffer();M.dispose(),Z.pause();const $=await this._connectTunnelSocket(q.host,q.port);j.byteLength>0&&$.write(j.buffer),$.on("end",()=>Z.end()),$.on("close",()=>Z.end()),$.on("error",()=>Z.destroy()),Z.on("end",()=>$.end()),Z.on("close",()=>$.end()),Z.on("error",()=>$.destroy()),$.pipe(Z),Z.pipe($)}_connectTunnelSocket(M,q){return new Promise((Z,j)=>{const $=w.createConnection({host:M,port:q},()=>{$.removeListener("error",j),$.pause(),Z($)});$.once("error",j)})}_updateWithFreeDebugPort(M){return typeof M.port=="number"?(0,d.findFreePort)(M.port,10,5e3).then(q=>(M.port=q,M)):(M.debugId=void 0,M.port=void 0,M.break=void 0,Promise.resolve(M))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},F))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};U=Te([Oe(4,m.IServerEnvironmentService),Oe(5,i.IProductService),Oe(6,l.ILogService),Oe(7,o.IInstantiationService)],U),e.RemoteExtensionHostAgentServer=U;async function G(z,M,q){const Z=await(0,a.determineServerConnectionToken)(M);Z instanceof a.ServerConnectionTokenParseError&&(console.warn(Z.message),process.exit(1));const j=new T.DisposableStore,{socketServer:$,instantiationService:W}=await(0,p.setupServerServices)(Z,M,q,j);W.invokeFunction(O=>{const V=O.get(l.ILogService);(0,P.setUnexpectedErrorHandler)(J=>{J&&J.code==="EPIPE"&&J.syscall==="write"&&J.stack&&/unexpectedErrorHandler/.test(J.stack)||V.error(J)})}),W.invokeFunction(O=>{const V=O.get(l.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const J=(0,b.join)(process.env.HOMEDRIVE,"node_modules"),ae=(0,b.dirname)((0,b.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),ge=(0,b.join)(ae,"node_modules");if(n.existsSync(J)||n.existsSync(ge)){const he=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${J}
* ${ge}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;V.warn(he),console.warn(he),process.exit(0)}}});const Y=W.invokeFunction(O=>{const V=O.get(l.ILogService);if(n.existsSync((0,b.join)(E.FileAccess.asFileUri("",ee).fsPath,"../node_modules/vsda")))try{return ee.__$__nodeRequire("vsda")}catch(ae){V.error(ae)}return null}),ie=n.existsSync(E.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",ee).fsPath);if(ie&&z&&typeof z!="string"){const O=Z.type!==0?`?${E.connectionTokenQueryName}=${Z.value}`:"";console.log(`Web UI available at http://localhost${z.port===80?"":`:${z.port}`}/${O}`)}const re=W.createInstance(U,$,Z,Y,ie);u.mark("code/server/ready");const oe=I.performance.now(),ue=global.vscodeServerStartTime,de=global.vscodeServerListenTime,H=global.vscodeServerCodeLoadedTime;if(W.invokeFunction(O=>{O.get(t.ITelemetryService).publicLog2("serverStart",{startTime:ue,startedTime:de,codeLoadedTime:H,readyTime:oe})}),M["print-startup-performance"]){const O=D.LoaderStats.get();let V="";V+=`

### Load AMD-module
`,V+=D.LoaderStats.toMarkdownTable(["Module","Duration"],O.amdLoad),V+=`

### Load commonjs-module
`,V+=D.LoaderStats.toMarkdownTable(["Module","Duration"],O.nodeRequire),V+=`

### Invoke AMD-module factory
`,V+=D.LoaderStats.toMarkdownTable(["Module","Duration"],O.amdInvoke),V+=`

### Invoke commonjs-module
`,V+=D.LoaderStats.toMarkdownTable(["Module","Duration"],O.nodeEval),V+=`Start-up time: ${de-ue}
`,V+=`Code loading time: ${H-ue}
`,V+=`Initialized time: ${oe-ue}
`,V+=`
`,console.log(V)}return re}e.createServer=G;class C{constructor(M){this._originRegExp=M}static create(M){const q=M.webEndpointUrlTemplate,Z=M.commit,j=M.quality;if(!q||!Z||!j)return new C(null);const $=(0,g.generateUuid)(),Y=new URL(q.replace("{{uuid}}",$).replace("{{commit}}",Z).replace("{{quality}}",j)).origin,ie=(0,f.escapeRegExpCharacters)(Y).replace($,"[a-zA-Z0-9-]+");try{const re=(0,f.createRegExp)(`^${ie}$`,!0,{matchCase:!1});return new C(re)}catch{return new C(null)}}matches(M){return this._originRegExp?this._originRegExp.test(M):!1}}}),define(me[265],ve([0,1,24,28,8,252,256,52,5,257,37,45,44]),function(ee,e,k,n,w,I,_,D,v,P,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,E.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=P.performance.now();const b={onMultipleValues:(g,d)=>{console.error(`Option ${g} can only be defined once. Using value ${d}.`)},onUnknownOption:g=>{console.error(`Ignoring option ${g}: not supported for server.`)},onDeprecatedOption:(g,d)=>{console.warn(`Option '${g}' is deprecated: ${d}`)}};function u(){return(0,D.parseArgs)(process.argv.slice(2),A.serverOptions,b)}function S(g){const d=g["server-data-dir"]||g["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(k.homedir(),T.default.serverDataFolderName||".vscode-remote"),y=g["user-data-dir"]||(0,v.join)(d,"data"),c=(0,v.join)(y,"User"),o=(0,v.join)(c,"globalStorage"),l=(0,v.join)(c,"History"),i=(0,v.join)(y,"Machine");g["user-data-dir"]=y;const t=(0,v.dirname)(w.FileAccess.asFileUri("",ee).fsPath),r=g["builtin-extensions-dir"]||(0,v.join)(t,"extensions");return g["builtin-extensions-dir"]=r,g["extensions-dir"]=g["extensions-dir"]||(0,v.join)(d,"extensions"),[d,g["extensions-dir"],y,c,i,o,l].forEach(s=>{try{n.existsSync(s)||n.mkdirSync(s,{mode:448})}catch(a){console.error(a)}}),d}function f(g=u()){return(0,I.run)(g,S(g),A.serverOptions)}e.spawnCli=f;function h(g,d=u()){return(0,_.createServer)(g,d,S(d))}e.createServer=h})}).call(this);

//# sourceMappingURL=server.main.js.map
